package esi.examwh.bl;

import java.util.List;

import esi.examwh.dao.ExamTimesDAO;
import esi.examwh.dao.ExamYearDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormItem;
import esi.examwh.model.ExamTimes;
import esi.examwh.model.ExamYear;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;
import esi.examwh.policy.core.PolicyController;

import org.hibernate.Query;
import org.hibernate.Session;

import com.plw.util.DataNotFoundException;

public class ExamFormItemBL {

	public static String GenSQLByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus(int ai_CommandType,Session MyHSs, Integer ai_ExamItemID,Integer ai_CurrentExamYearID,Integer ai_CurrentExamSemesterID,Integer ai_CurrentExamRoundID,List<TYPE_EXAMINATION_STATUS> ae_ListExaminationStatus,Integer SUID, Integer SGID,int... StatusList) {
			
		if(ai_CurrentExamYearID != null && ai_CurrentExamRoundID != null && ai_CurrentExamSemesterID != null){
				try {
					TimesBean lo_Times = GetTimesInfo(MyHSs,ai_CurrentExamYearID,ai_CurrentExamSemesterID,ai_CurrentExamRoundID,SUID,SGID);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			
			StringBuffer sb_SQLCommand = new StringBuffer();
			if (ai_CommandType == 10) {
				sb_SQLCommand.append("SELECT COUNT(*) ");
			} else {
				sb_SQLCommand.append("SELECT EFI.* ");
			}
			sb_SQLCommand.append("FROM ExamFormItem EFI ");
			sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EFI.EFI_ExamFormID ");
			sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
			sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			if(ai_ExamItemID != null){
				sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID = "+ai_ExamItemID+" " );
			}
			if(ae_ListExaminationStatus!= null){
				if(ae_ListExaminationStatus.size() == 1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus = "+ae_ListExaminationStatus.get(0)+" ");
				}else if(ae_ListExaminationStatus.size() > 1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN ( ");
					sb_SQLCommand.append(ae_ListExaminationStatus.get(0).getValue());
					if (ae_ListExaminationStatus.size() > 0) {
						for (int i = 1; i < ae_ListExaminationStatus.size(); i++) {
							sb_SQLCommand.append(", ");
							sb_SQLCommand.append(ae_ListExaminationStatus.get(i).getValue());
						}
					}
					sb_SQLCommand.append(") ");
				}
			}
			if (ai_CommandType != 10) {
				sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				
			}
			return sb_SQLCommand.toString();
		}
		
		public static int GetSizeByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus(Session MyHSs, Integer ai_ExamItemID,Integer ai_CurrentExamYearID,Integer ai_CurrentExamSemesterID,Integer ai_CurrentExamRoundID,List<TYPE_EXAMINATION_STATUS> ae_ListExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", "[BEGIN] @@@");
			String ls_SQLCommand = GenSQLByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus(10,MyHSs,ai_ExamItemID,ai_CurrentExamYearID,ai_CurrentExamSemesterID,ai_CurrentExamRoundID,ae_ListExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", ls_SQLCommand);
			Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamItemIDInExamScheduleExaminationStatus ["+ai_ExamItemID+"] [END] @@@");
			return RowCount.intValue();
		}
		
		public static List<ExamFormItem> FindByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus(Session MyHSs, Integer ai_ExamItemID,Integer ai_CurrentExamYearID,Integer ai_CurrentExamSemesterID,Integer ai_CurrentExamRoundID,List<TYPE_EXAMINATION_STATUS> ae_ListExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
			assert BeginRow < 0 : "BeginRow is less than 0";
			assert MaxRow < 0 : "MaxRow is less than 0";
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", "[START] @@@");
			try {
				String ls_SQLCommand =  GenSQLByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus(20,MyHSs,ai_ExamItemID,ai_CurrentExamYearID,ai_CurrentExamSemesterID,ai_CurrentExamRoundID,ae_ListExaminationStatus,SUID,SGID,StatusList);
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", ls_SQLCommand);
				Query query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
				query.setFirstResult(BeginRow);
				if (MaxRow > 0) {
					query.setMaxResults(MaxRow); 
				}
				List<ExamFormItem> ExamFormItemList = query.list();
				if (ExamFormItemList.isEmpty() != true) {
					return ExamFormItemList;
				} else {
					CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus", "[Not Found] @@@");
					throw new DataNotFoundException("Find ExamFormItem By ExamItemIDCurrentExamYearIDCurrentExamSemesterIDExamRoundIDInExamScheduleExaminationStatus is not found.");
				}
			} catch (Exception ex) {
				ex.printStackTrace();
				throw ex;
			} finally {
			}
	}

	public static TimesBean GetTimesInfo(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID,Integer SGID)throws Exception{
		TimesBean lo_TimesBean = new TimesBean();
		ExamYear lo_ExamYear = ExamYearDAO.GetByID(MyHSs, ai_ExamYearID, SUID, SGID);
		ExamTimes lo_ExamTimes = ExamTimesDAO.GetByID(MyHSs, ai_ExamSemesterID, ai_ExamRoundID, SUID, SGID);
		Integer li_ExamTimesPerYear = PolicyController.ExamTimesPerYear;
		if(li_ExamTimesPerYear != null){
			lo_TimesBean.setYear(lo_ExamYear.getYear());
			lo_TimesBean.setSemester( lo_ExamTimes.getOExamSemesterID().getNumber());
			lo_TimesBean.setRound(lo_ExamTimes.getOExamRoundID().getNumber());
		}else{
			throw new DataNotFoundException("Find ExamAnalysis By All is not found.");
		}
		
		return lo_TimesBean;
	}	
		
}
