package esi.examwh.bl.curriculum;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class CurriculumAttributeGenerator {
	public static String GenSQLCurriculumAttributeByCurriculumIDExamItemID(int ai_CommandType,Integer ai_CurriculumID,Integer ai_ExamItemID, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT CA.CurriculumAttributeID as CurriculumAttributeID ,CA.CA_Order as AttributeOrder,ISNULL(EIA.ExamItemAttributeID,-1) as ExamItemAttributeID, ISNULL(EIA.EIA_IndicatorLevel,0) as IndicatorLevel ,A.AttributeID as AttributeID,A.A_NOFIndicators as NOFIndicators,A.A_Name as AttributeName ");
		}
		sb_SQLCommand.append("FROM CurriculumAttribute CA ");
		sb_SQLCommand.append("Left Join ExamItemAttribute EIA ON CA.CA_AttributeID = EIA.EIA_AttributeID ");
		sb_SQLCommand.append("AND EIA.EIA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIA.EIA_ExamItemID = "+ai_ExamItemID+" ");
		}
		sb_SQLCommand.append("JOIN Attributes a ON a.AttributeID = CA.CA_AttributeID ");
		sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY CA.CA_Order ");
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamAttributeResult> FindCurriculumAttributeByCurriculumIDExamItemID(Session MyHSs,Integer ai_CurriculumID,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		List<ExamAttributeResult> io_RPRL = new ArrayList<ExamAttributeResult>(0);
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "FindCurriculumAttributeByCurriculumID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLCurriculumAttributeByCurriculumIDExamItemID(20,ai_CurriculumID,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.curriculum.ExamAttributeResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamAttributeResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAttributeGenerator", "FindCurriculumAttributeByCurriculumID", "[Not Found] @@@");
				throw new DataNotFoundException("FindExamFormItemAndExamFormItemGroupByExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeCurriculumAttributeByCurriculumIDExamItemID(Session MyHSs,Integer ai_CurriculumID,Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "GetSizeCurriculumAttributeByCurriculumID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLCurriculumAttributeByCurriculumIDExamItemID(10,ai_CurriculumID,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "GetSizeCurriculumAttributeByCurriculumID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "GetSizeCurriculumAttributeByCurriculumID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
}
