package esi.examwh.bl.examform;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class ExamFormItemChoiceGenerator {
	public static String GenSQLByExamFormItemID(int ai_CommandType,Integer ai_ExamFormItemID,List<String> as_QueryColumn, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ");
			if (as_QueryColumn != null) {
				sb_SQLCommand.append(as_QueryColumn.get(0));
				for (int i = 1; i < as_QueryColumn.size(); i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(as_QueryColumn.get(i));
				}
				sb_SQLCommand.append(" ");
			}
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormItemID != null){
			sb_SQLCommand.append("AND EFIC.EFIC_ExamFormItemID = "+ai_ExamFormItemID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFIC.EFIC_Order ");
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamFormItemChoiceResult> FindByExamFormItemID(Session MyHSs,Integer ai_ExamFormItemID,List<String> as_QueryColumn,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormItemID(20,ai_ExamFormItemID,as_QueryColumn,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamFormItemChoiceResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamFormItemChoiceResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", "[Not Found] @@@");
				throw new DataNotFoundException("FindByExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeByExamFormItemID(Session MyHSs,Integer ai_ExamFormItemID,List<String> as_QueryColumn,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormItemID(10,ai_ExamFormItemID,as_QueryColumn,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
	public static void main(String[] args) {
		try{
			Session MyHSs = ExamWHDaoUtil.getSession();
			List<String> column = new ArrayList();
			column.add("EFIC_ExamItemChoiceID ExamItemChoiceID");
			column.add("EFIC_AnswerStatus AnswerStatus");
			column.add("EFIC_DisplayOrder DisplayOrder");
			column.add("EFIC_Code Code");
			System.out.println(GenSQLByExamFormItemID(20, 263,column, null, null));
			List<ExamFormItemChoiceResult> o_ExamFormItemChoiceResult = ExamFormItemChoiceGenerator.FindByExamFormItemID(MyHSs, 263, column, null, null, 0, 0);
			for(int i=0;i<o_ExamFormItemChoiceResult.size();i++){
				System.out.println(o_ExamFormItemChoiceResult.get(i).toString());
			}
		}catch(Exception ex){
			
		}
	}
}
