package esi.examwh.bl.examform;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class ExamFormItemGenerator {
	
	public static String GenSQLExamFormItemAndExamFormItemGroupByExamFormID(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT SUM (nof) FROM ( ");
			sb_SQLCommand.append("SELECT COUNT(EFI.ExamFormItemID) nof ");
		} else {
			sb_SQLCommand.append("SELECT ISNULL(EFI.EFI_ExamFormItemGroupID,-1) ExamFormItemGroupID ,EFI.ExamFormItemID ExamFormItemID , ");
			sb_SQLCommand.append("EFI.EFI_Order ExamFormItemOrder , UN.UN_Order UnitOrder,ST.ST_Order SectionOrder,OJ.OJ_Order ObjectiveOrder , ");
			sb_SQLCommand.append("EFI.EFI_Code Code,EFI.EFI_QuestionText Name,EFI.EFI_ExamType ExamType ,  ");
			sb_SQLCommand.append("EFI.EFI_GroupOrder GroupOrder ,EFI.EFI_DataStatus DataStatus , EFI.EFI_ExamStatus ExamStatus , EFI.EFI_ReOrderChoiceStatus ReOrderChoiceStatus , ");
			sb_SQLCommand.append("CASE ");
			sb_SQLCommand.append("WHEN  EFI.EFI_ExamFormItemGroupID IS NULL THEN "+TYPE_EXAM_GROUP.TYPE_SINGLE_QUESTION.getValue()+" ");
			sb_SQLCommand.append("ELSE "+TYPE_EXAM_GROUP.TYPE_SUB_QUESTION.getValue()+"  ");
			sb_SQLCommand.append("END ExamGroupType ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		sb_SQLCommand.append("Union  All ");
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(EFIG.ExamFormItemGroupID) nof ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.ExamFormItemGroupID ExamFormItemGroupID ,-1 ExamFormItemID , ");
			sb_SQLCommand.append("-1 ExamFormItemOrder,UN.UN_Order UnitOrder,ST.ST_Order SectionOrder,-1 ObjectiveOrder, ");
			sb_SQLCommand.append("EFIG.EFIG_Code Code,EFIG.EFIG_QuestionText Name ,-1 ExamType , "); 
			sb_SQLCommand.append("-1 GroupOrder ,EFIG.EFIG_DataStatus DataStatus , -1 ExamStatus , -1 ReOrderChoiceStatus , ");
			sb_SQLCommand.append(TYPE_EXAM_GROUP.TYPE_GROUP_QUESTION.getValue()+" ExamGroupType ");
		}
		
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("JOIN ExamItemGroup EIG ON EIG.ExamItemGroupID = EFIG.EFIG_CopiedExamItemGroupID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID  ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ai_ExamFormID+" ");
		}
		if (ai_CommandType == 10) {
			sb_SQLCommand.append(") AS nof ");
		}else{
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order , ExamFormItemOrder ");
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamFormItemResult> FindExamFormItemAndExamFormItemGroupByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLExamFormItemAndExamFormItemGroupByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamFormItemResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamFormItemResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("FindExamFormItemAndExamFormItemGroupByExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeExamFormItemAndExamFormItemGroupByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLExamFormItemAndExamFormItemGroupByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
}
