package esi.examwh.bl.examform;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamForm;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_DISABLE_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;
import esi.examwh.model.common.TYPE_EXAM_STATUS;
import esi.examwh.model.common.TYPE_FLAG;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class ExamItemGroupGenerator {
	public static String GenSQLBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(int ai_CommandType, Integer ai_SubjectID, Integer ai_UnitID, Integer ai_ItemFromUnitID, Integer ai_SectionID,String as_ExamItemGroupCode,String as_QuestionText,List<TYPE_EXAM_STATUS> ae_ExamItemStatus,Double ad_PMinValue,Double ad_PMaxValue,TYPE_FLAG ae_ExamItemFlag,TYPE_FLAG ae_ExamFormFlag ,TYPE_FLAG ae_WalkinFlag,Integer ai_FilterExamFormID,Integer ai_NOFChoice,Integer ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ISNULL(EIG.ExamItemGroupID,-1) ExamItemGroupID , ");
			sb_SQLCommand.append("SJ.SubjectID SubjectID , SJ.SJ_Code SubjectCode , UN.UN_Order UnitOrder,ST.ST_Order SectionOrder, ");
			sb_SQLCommand.append("EIG.EIG_Code Code,EIG.EIG_QuestionText Name,  ");
			sb_SQLCommand.append("EIG.EIG_DataStatus DataStatus , ");
			/////////////////////
			sb_SQLCommand.append("( SELECT COUNT(*) ");
			sb_SQLCommand.append("FROM ExamItem EI ");
			sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EI.EI_UnitID ");
			sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EI.EI_SectionID ");
			sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EI.EI_ObjectiveID ");
			sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EI.EI_SubjectID ");
			sb_SQLCommand.append("JOIN ExamItemGroup EIG2 ON EIG2.ExamItemGroupID = EI.EI_ExamGroupID ");
			sb_SQLCommand.append("WHERE EI.EI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append("AND EI.EI_ExamGroupID = EIG.ExamItemGroupID ");
			if(ai_SubjectID != null){
				sb_SQLCommand.append("AND EI.EI_SubjectID = "+ai_SubjectID+" ");
			}
			if(ai_UnitID != null){
				if(ai_ItemFromUnitID != null){
					sb_SQLCommand.append("AND ( EI.EI_UnitID = "+ai_UnitID+" ");
					sb_SQLCommand.append("OR EI.EI_UnitID = "+ai_ItemFromUnitID+") ");
				}else{
					sb_SQLCommand.append("AND EI.EI_UnitID = "+ai_UnitID+" ");
				}
			}
			if(ai_SectionID != null && ai_SectionID > 0){
				sb_SQLCommand.append("AND EI.EI_SectionID = "+ai_SectionID+" ");
			}else{
//				sb_SQLCommand.append("AND (EI.EI_SectionID = 0 OR EI.EI_SectionID IS NULL) ");
			}
			
			if(ad_PMinValue != null && ad_PMaxValue != null){
				sb_SQLCommand.append("AND EI.EI_PValue >= "+ad_PMinValue+" AND EI.EI_PValue <= "+ad_PMaxValue+" ");
			}
			
			if(ae_ExamItemFlag != null){
				sb_SQLCommand.append("AND EI.EI_ExamItemFlag = "+ae_ExamItemFlag.getValue()+" ");
			}
			if(ae_ExamFormFlag != null){
				sb_SQLCommand.append("AND EI.EI_ExamFormFlag = "+ae_ExamFormFlag.getValue()+" ");
			}
			if(ae_WalkinFlag != null){
				sb_SQLCommand.append("AND EI.EI_WalkinFlag = "+ae_WalkinFlag.getValue()+" ");
			}
			if(ai_FilterExamFormID != null){
				sb_SQLCommand.append("AND EI.ExamItemID NOT IN ( ");
					sb_SQLCommand.append("SELECT EFI.EFI_CopiedExamItemID ");
					sb_SQLCommand.append("FROM ExamFormItem EFI ");
					sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_FilterExamFormID+" ");
					sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID IS NOT NULL ");
				sb_SQLCommand.append(" ) ");
			}
			if(ai_NOFChoice != null){
				sb_SQLCommand.append("AND EI.EI_NOFChoice = "+ai_NOFChoice+" ");
			}
			if(ai_LastUsedYear != null){
				sb_SQLCommand.append("AND EI.EI_LastUsedYear = "+ai_LastUsedYear+" ");
			}
			
			if(ai_LastUsedSemester != null){
				sb_SQLCommand.append("AND EI.EI_LastUsedSemester = "+ai_LastUsedSemester+" ");
			}
			if(ai_LastUsedRound != null){
				sb_SQLCommand.append("AND EI.EI_LastUsedRound = "+ai_LastUsedRound+" ");
			}
			if(ai_LastUsedTerm != null){
				sb_SQLCommand.append("AND EI.EI_LastUsedTerm = "+ai_LastUsedTerm+" ");
			}
			if(ae_DisableStatus != null){
				sb_SQLCommand.append("AND EI.EI_DisableStatus = "+ae_DisableStatus.getValue()+" ");
			}
			sb_SQLCommand.append(" ) NOFExamItem ");
			//////////////////
			
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND (EIG.EIG_DisableStatus = 10 OR EIG.EIG_DisableStatus IS NULL) ");
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND EIG.EIG_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_UnitID != null){
			if(ai_ItemFromUnitID != null){
				sb_SQLCommand.append("AND ( EIG.EIG_UnitID = "+ai_UnitID+" ");
				sb_SQLCommand.append("OR EIG.EIG_UnitID = "+ai_ItemFromUnitID+") ");
			}else{
				sb_SQLCommand.append("AND EIG.EIG_UnitID = "+ai_UnitID+" ");
			}
		}
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND EIG.EIG_SectionID = "+ai_SectionID+" ");
		}
		if(as_ExamItemGroupCode != null){
			sb_SQLCommand.append("AND EIG.EIG_Code = '"+as_ExamItemGroupCode+"' ");
		}
		if(as_QuestionText != null){
			sb_SQLCommand.append("AND EIG.EIG_QuestionText LIKE '%"+as_QuestionText+"%' ");
		}
		
		if(ai_FilterExamFormID != null){
			sb_SQLCommand.append("AND EIG.ExamItemGroupID NOT IN ( ");
				sb_SQLCommand.append("SELECT EFIG.EFIG_CopiedExamItemGroupID ");
				sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
				sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ai_FilterExamFormID+" ");
				sb_SQLCommand.append("AND EFIG.EFIG_CopiedExamItemGroupID IS NOT NULL ");
			sb_SQLCommand.append(" ) ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code, UN.UN_Order , ST.ST_Order , EIG.EIG_Code ");
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamItemGroupResult> FindBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(Session MyHSs,Integer ai_SubjectID, Integer ai_UnitID, Integer ai_ItemFromUnitID, Integer ai_SectionID,String as_ExamItemGroupCode,String as_QuestionText,List<TYPE_EXAM_STATUS> ae_ExamItemStatus,Double ad_PMinValue,Double ad_PMaxValue,TYPE_FLAG ae_ExamItemFlag,TYPE_FLAG ae_ExamFormFlag ,TYPE_FLAG ae_WalkinFlag,Integer ai_FilterExamFormID,Integer ai_NOFChoice,Integer ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(20,ai_SubjectID,ai_UnitID,ai_ItemFromUnitID, ai_SectionID,as_ExamItemGroupCode, as_QuestionText,ae_ExamItemStatus, ad_PMinValue, ad_PMaxValue, ae_ExamItemFlag,ae_ExamFormFlag ,ae_WalkinFlag, ai_FilterExamFormID, ai_NOFChoice, ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,ai_LastUsedTerm, ae_DisableStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamItemGroupResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamItemGroupResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("FindBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(Session MyHSs,Integer ai_SubjectID, Integer ai_UnitID, Integer ai_ItemFromUnitID, Integer ai_SectionID,String as_ExamItemGroupCode,String as_QuestionText,List<TYPE_EXAM_STATUS> ae_ExamItemStatus,Double ad_PMinValue,Double ad_PMaxValue,TYPE_FLAG ae_ExamItemFlag,TYPE_FLAG ae_ExamFormFlag ,TYPE_FLAG ae_WalkinFlag,Integer ai_FilterExamFormID,Integer ai_NOFChoice,Integer ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(10,ai_SubjectID,ai_UnitID,ai_ItemFromUnitID, ai_SectionID,as_ExamItemGroupCode, as_QuestionText,ae_ExamItemStatus, ad_PMinValue, ad_PMaxValue, ae_ExamItemFlag,ae_ExamFormFlag ,ae_WalkinFlag, ai_FilterExamFormID, ai_NOFChoice, ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,ai_LastUsedTerm, ae_DisableStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
	public static void main(String[] args) {
		try{
			Session MyHSs = ExamWHDaoUtil.getSession();
			TYPE_FLAG kwExamItemFlag = null;
			TYPE_FLAG kwWalkinFlag = null;
			TYPE_FLAG kwExamFormFlag = null;
			TYPE_EXAMINATION_STATUS[] le_examinationStatus = new TYPE_EXAMINATION_STATUS[2];
			le_examinationStatus[0] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_CREATE_EXAM;
			le_examinationStatus[1] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW;
			List<TYPE_EXAM_STATUS> kwExamItemStatus = new ArrayList();
//			kwExamItemStatus = null;
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_READY);
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_NEW);
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF1);
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF2);
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF3);
			kwExamItemStatus.add(TYPE_EXAM_STATUS.STATUS_EXAM_DRAF4);
			ExamForm lo_examForm = ExamFormDAO.GetByID(MyHSs, 124, null, null);
			if(lo_examForm.getExaminationType() == TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER){
				kwExamItemFlag = TYPE_FLAG.TYPE_YES;
				kwExamFormFlag = null;
				kwWalkinFlag =  TYPE_FLAG.TYPE_NO;
			}else if(lo_examForm.getExaminationType() == TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN){
				kwExamItemFlag = null;
				kwExamFormFlag = null;
				kwWalkinFlag = TYPE_FLAG.TYPE_YES;
			}
			int kwSubjectID = lo_examForm.getOExamScheduleDetail().getOSubject().getSubjectID();
//			System.out.println(GenSQLBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTime(20, kwSubjectID, null, null, null, "C000003", null, kwExamItemStatus, null, null, kwExamItemFlag, kwExamFormFlag, kwWalkinFlag, lo_examForm.getExamFormID(), lo_examForm.getNOFItemChoice(), null, null, null, null, null, 0, 0));
			List<ExamItemGroupResult> ExamItemGroupResult =  ExamItemGroupGenerator.FindBySubjectIDUnitIDItemFromUnitIDSectionIDExamItemGroupCodeQuestionTextExamItemStatusPMinValuePMaxValueExamItemFlagExamFormFlagWalkinFlagFilterExamFormIDNOFChoiceLastUsedYearLastUsedSemesterLastUsedRoundUnUsedNOFTimeDisableStatus(MyHSs, kwSubjectID, null, null, null, null, null, kwExamItemStatus, null, null, kwExamItemFlag, kwExamFormFlag, kwWalkinFlag, lo_examForm.getExamFormID(), lo_examForm.getNOFItemChoice(), null, null, null, null,null, null,null, 0, 0);
			for(int i=0;i<ExamItemGroupResult.size();i++){
				System.out.println(ExamItemGroupResult.get(i).toString());
			}
			MyHSs.close();
		}catch(Exception ex){
			
		}
	}
}
