package esi.examwh.bl.examscheduledetail;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class Report13Generator {
	public static String GenSQLExamYearIDExamSemesterIDExamRoundIDExamTermIDSubjectCode(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_ExamTermID,String as_SubjectCode, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJ.SubjectID as SubjectID , SJ.SJ_Code as SubjectCode , SJ.SJ_Name as SubjectName,COUNT(EF.ExamFormID) as NumberOfExamForm ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.EF_ExamScheduleDetailID = ESD.ExamScheduleDetailID AND EF.EF_DataStatus NOT IN(411,511)");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ_Code = '"+as_SubjectCode+"' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("GROUP BY SJ.SubjectID ,SJ.SJ_Code ,SJ.SJ_Name ");
			sb_SQLCommand.append("ORDER BY SJ.SubjectID ,SJ.SJ_Code ,SJ.SJ_Name ");
		}
		return sb_SQLCommand.toString();
	}
	public static List<Report13Result> FindExamYearIDExamSemesterIDExamRoundIDExamTermIDSubjectCode(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_ExamTermID,String as_SubjectCode,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		List<Report13Result> io_RPRL = new ArrayList<Report13Result>(0);
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "FindExamYearIDExamSemesterIDExamRoundIDSubjectCode", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLExamYearIDExamSemesterIDExamRoundIDExamTermIDSubjectCode(20,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,ai_ExamTermID,as_SubjectCode,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "FindExamYearIDExamSemesterIDExamRoundIDSubjectCode", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examscheduledetail.Report13Result.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new Report13Result());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "Report13Generator", "FindExamYearIDExamSemesterIDExamRoundIDSubjectCode", "[Not Found] @@@");
				throw new DataNotFoundException("FindExamYearIDExamSemesterIDExamRoundIDSubjectCode is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
//	public static int GetSizeExamYearIDExamSemesterIDExamRoundIDSubjectCode(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "GetSizeExamYearIDExamSemesterIDExamRoundIDSubjectCode", "[BEGIN] @@@");
//		String ls_SQLCommand = GenSQLExamYearIDExamSemesterIDExamRoundIDSubjectCode(10,ai_SubjectFormPolicyDetailID,SUID,SGID,StatusList);
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "GetSizeExamYearIDExamSemesterIDExamRoundIDSubjectCode", ls_SQLCommand);
//		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "GetSizeExamYearIDExamSemesterIDExamRoundIDSubjectCode", "[" + RowCount.intValue() + "]  [END] @@@");
//		return RowCount.intValue();
//	}
}
