package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ActionType;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ActionTypeDAO {

	public static ActionType Add(Session MyHSs,ActionType ao_ActionType, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ActionType.getOwnerSUID(), ao_ActionType.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ActionType.setModifyTime(Common.GetCurrTime());
			ao_ActionType.setModifyUser(as_UserName);
			ao_ActionType.setCreateTime(Common.GetCurrTime());
			ao_ActionType.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ActionType);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Add", "[Ready][ID:" + ao_ActionType.getActionTypeID() + "]");
			return ao_ActionType;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "Add", "[ID:" + ao_ActionType.getActionTypeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static ActionType Disable(Session MyHSs, ActionType ao_ActionType, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ActionType.getOwnerSUID(), ao_ActionType.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ActionType.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ActionType.setDeletedUser(as_UserName);
			ao_ActionType.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ActionType);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Disable", "[Ready][ID:" + ao_ActionType.getActionTypeID() + "]");
			return ao_ActionType;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "Disable", "[ID:" +ao_ActionType.getActionTypeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static ActionType Delete(Session MyHSs, ActionType ao_ActionType, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ActionType.getOwnerSUID(), ao_ActionType.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ActionType);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Delete", "[ID:" + ao_ActionType.getActionTypeID() + "]");
			return ao_ActionType;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "Delete", "[ID:" + ao_ActionType.getActionTypeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static ActionType Modify(Session MyHSs, ActionType ao_ActionType, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ActionType.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ActionType.setModifyTime(Common.GetCurrTime());
			ao_ActionType.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ActionType);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "Modify", "[ID:" + ao_ActionType.getActionTypeID() + "]");
			return ao_ActionType;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "Modify", "[ID:" + ao_ActionType.getActionTypeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static ActionType GetByID(Session MyHSs, Integer ai_ActionTypeID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ActionType theActionType = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ActionType> criteria = builder.createQuery(ActionType.class);
		criteria.where(builder.equal(criteria.from(ActionType.class).get("actionTypeID"), ai_ActionTypeID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theActionType = (ActionType) query.getSingleResult();
			if (theActionType != null) {
				return theActionType;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ActionTypeID + "]");
				throw new DataNotFoundException("ActionType [" + ai_ActionTypeID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ActionTypeID + "]");
			throw new DataNotFoundException("ActionType [" + ai_ActionTypeID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT AT.* ");
		}
		sb_SQLCommand.append("FROM ActionType AT ");
		sb_SQLCommand.append("WHERE AT.AT_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ActionType By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ActionType> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ActionType> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ActionType.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ActionType> ActionTypeList = query.list();
			if (ActionTypeList.isEmpty() != true) {
				return ActionTypeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ActionType By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
