package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Attributes;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class AttributesDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Attributes Add(Session MyHSs,Attributes ao_Attributes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Attributes.getOwnerSUID(), ao_Attributes.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Attributes.setModifyTime(Common.GetCurrTime());
			ao_Attributes.setModifyUser(as_UserName);
			ao_Attributes.setCreateTime(Common.GetCurrTime());
			ao_Attributes.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_Attributes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Add", "[Ready][ID:" + ao_Attributes.getAttributeID() + "]");
			return ao_Attributes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "Add", "[ID:" + ao_Attributes.getAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Attributes
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Attributes Disable(Session MyHSs, Attributes ao_Attributes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Attributes.getOwnerSUID(), ao_Attributes.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Attributes.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Attributes.setDeletedUser(as_UserName);
			ao_Attributes.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Attributes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Disable", "[Ready][ID:" + ao_Attributes.getAttributeID() + "]");
			return ao_Attributes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "Disable", "[ID:" +ao_Attributes.getAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Attributes
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Attributes Delete(Session MyHSs, Attributes ao_Attributes, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Attributes.getOwnerSUID(), ao_Attributes.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Attributes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Delete", "[ID:" + ao_Attributes.getAttributeID() + "]");
			return ao_Attributes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "Delete", "[ID:" + ao_Attributes.getAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Attributes
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Attributes Modify(Session MyHSs, Attributes ao_Attributes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Attributes.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Attributes.setModifyTime(Common.GetCurrTime());
			ao_Attributes.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Attributes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "Modify", "[ID:" + ao_Attributes.getAttributeID() + "]");
			return ao_Attributes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "Modify", "[ID:" + ao_Attributes.getAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_AttributesID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Attributes GetByID(Session MyHSs, Integer ai_AttributesID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Attributes theAttributes = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Attributes> criteria = builder.createQuery(Attributes.class);
		criteria.where(builder.equal(criteria.from(Attributes.class).get("attributeID"), ai_AttributesID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theAttributes = (Attributes) query.getSingleResult();
			if (theAttributes != null) {
				return theAttributes;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "GetByID", "[Not Found][ID:" + ai_AttributesID + "]");
				throw new DataNotFoundException("Attributes [" + ai_AttributesID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "GetByID", "[Not Found][ID:" + ai_AttributesID + "]");
			throw new DataNotFoundException("Attributes [" + ai_AttributesID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT A.* ");
		}
		sb_SQLCommand.append("FROM Attributes A ");
		sb_SQLCommand.append("WHERE A.A_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Attributes By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Attributes> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Attributes> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Attributes.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Attributes> AttributesList = query.list();
			if (AttributesList.isEmpty() != true) {
				return AttributesList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Attributes By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCurriculumID(int ai_CommandType, Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT A.* ");
		}
		sb_SQLCommand.append("FROM Attributes A ");
		sb_SQLCommand.append("JOIN CurriculumAttribute CA ON CA.CA_AttributeID = A.AttributeID ");
		sb_SQLCommand.append("WHERE A.A_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY A.A_Code , A.A_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumID(Session MyHSs,Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumID(10,ai_CurriculumID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumID", "[" + RowCount.intValue() + "] Of Attributes By AttributesGroupID[CurriculumID :"+ai_CurriculumID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Attributes> FindByCurriculumID(Session MyHSs,Integer ai_CurriculumID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByCurriculumID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumID(20,ai_CurriculumID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByCurriculumID", ls_SQLCommand);
			NativeQuery<Attributes> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Attributes.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Attributes> AttributesList = query.list();
			if (AttributesList.isEmpty() != true) {
				return AttributesList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "FindByCurriculumID", "[Not Found] @@@");
				throw new DataNotFoundException("Find Attributes By FindByCurriculumID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByAttributeCodeAttributeNameAttributeDetail(int ai_CommandType, String ai_AttributeCode, String ai_AttributeName, String ai_AttributeDetail,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT A.* ");
		}
		sb_SQLCommand.append("FROM Attributes A ");
		sb_SQLCommand.append("WHERE A.A_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_AttributeCode != null){
			sb_SQLCommand.append("AND A.A_Code = '"+ai_AttributeCode+"' ");
		}
		if(ai_AttributeName != null){
			sb_SQLCommand.append("AND A.A_Name LIKE '%"+ai_AttributeName+"%' ");
		}
		if(ai_AttributeDetail != null){
			sb_SQLCommand.append("AND A.A_Detail LIKE '%"+ai_AttributeDetail+"%' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY A.A_Code , A.A_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByAttributeCodeAttributeNameAttributeDetail(Session MyHSs, String ai_AttributeCode, String ai_AttributeName, String ai_AttributeDetail,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByAttributeCodeAttributeNameAttributeDetail", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByAttributeCodeAttributeNameAttributeDetail(10,ai_AttributeCode,ai_AttributeName,ai_AttributeDetail,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByAttributeCodeAttributeNameAttributeDetail", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByAttributeCodeAttributeNameAttributeDetail", "[" + RowCount.intValue() + "] Of Attributes By GetSizeByAttributeCodeAttributeNameAttributeDetail[ai_AttributeCode :"+ai_AttributeCode +"][ai_AttributeCode :"+ai_AttributeName +"][ai_AttributeCode :"+ai_AttributeDetail +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Attributes> FindByAttributeCodeAttributeNameAttributeDetail(Session MyHSs, String ai_AttributeCode, String ai_AttributeName, String ai_AttributeDetail,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByAttributeCodeAttributeNameAttributeDetail", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByAttributeCodeAttributeNameAttributeDetail(20,ai_AttributeCode,ai_AttributeName,ai_AttributeDetail,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByCurriculumID", ls_SQLCommand);
			NativeQuery<Attributes> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Attributes.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Attributes> AttributesList = query.list();
			if (AttributesList.isEmpty() != true) {
				return AttributesList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "FindByAttributeCodeAttributeNameAttributeDetail", "[Not Found] @@@");
				throw new DataNotFoundException("Find Attributes By FindByAttributeCodeAttributeNameAttributeDetail is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByCurriculumIDAttributesNotInCurriculumAttributes(int ai_CommandType, Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT A.* ");
		}
		sb_SQLCommand.append("FROM Attributes A ");
		sb_SQLCommand.append("WHERE A.A_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND A.AttributeID NOT IN( Select CA.CA_AttributeID ");
			sb_SQLCommand.append("FROM CurriculumAttribute CA ");
			sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( 411,511) ");
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" )");
			
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY A.A_Code , A.A_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumIDAttributesNotInCurriculumAttributes(Session MyHSs, Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumIDAttributesNotInCurriculumAttributes", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumIDAttributesNotInCurriculumAttributes(10,ai_CurriculumID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumIDAttributesNotInCurriculumAttributes", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "GetSizeByCurriculumIDAttributesNotInCurriculumAttributes", "[" + RowCount.intValue() + "] Of Attributes By GetSizeByCurriculumIDAttributesNotInCurriculumAttributes[ai_CurriculumID :"+ai_CurriculumID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Attributes> FindByCurriculumIDAttributesNotInCurriculumAttributes(Session MyHSs, Integer ai_CurriculumID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByCurriculumIDAttributesNotInCurriculumAttributes", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumIDAttributesNotInCurriculumAttributes(20,ai_CurriculumID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "AttributesDAO", "FindByCurriculumIDAttributesNotInCurriculumAttributes", ls_SQLCommand);
			NativeQuery<Attributes> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Attributes.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Attributes> AttributesList = query.list();
			if (AttributesList.isEmpty() != true) {
				return AttributesList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AttributesDAO", "FindByCurriculumIDAttributesNotInCurriculumAttributes", "[Not Found] @@@");
				throw new DataNotFoundException("Find Attributes By FindByCurriculumIDAttributesNotInCurriculumAttributes is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
