package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.BehaviorLevel;
import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class BehaviorLevelDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static BehaviorLevel Add(Session MyHSs,BehaviorLevel ao_BehaviorLevel, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_BehaviorLevel.getOwnerSUID(), ao_BehaviorLevel.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_BehaviorLevel.setModifyTime(Common.GetCurrTime());
			ao_BehaviorLevel.setModifyUser(as_UserName);
			ao_BehaviorLevel.setCreateTime(Common.GetCurrTime());
			ao_BehaviorLevel.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_BehaviorLevel);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Add", "[Ready][ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]");
			return ao_BehaviorLevel;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "Add", "[ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static BehaviorLevel Disable(Session MyHSs, BehaviorLevel ao_BehaviorLevel, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_BehaviorLevel.getOwnerSUID(), ao_BehaviorLevel.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_BehaviorLevel.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_BehaviorLevel.setDeletedUser(as_UserName);
			ao_BehaviorLevel.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_BehaviorLevel);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Disable", "[Ready][ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]");
			return ao_BehaviorLevel;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "Disable", "[ID:" +ao_BehaviorLevel.getBehaviorLevelID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static BehaviorLevel Delete(Session MyHSs, BehaviorLevel ao_BehaviorLevel, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_BehaviorLevel.getOwnerSUID(), ao_BehaviorLevel.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_BehaviorLevel);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Delete", "[ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]");
			return ao_BehaviorLevel;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "Delete", "[ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static BehaviorLevel Modify(Session MyHSs, BehaviorLevel ao_BehaviorLevel, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_BehaviorLevel.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_BehaviorLevel.setModifyTime(Common.GetCurrTime());
			ao_BehaviorLevel.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_BehaviorLevel);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "Modify", "[ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]");
			return ao_BehaviorLevel;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "Modify", "[ID:" + ao_BehaviorLevel.getBehaviorLevelID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_BehaviorLevelID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static BehaviorLevel GetByID(Session MyHSs, Integer ai_BehaviorLevelID, Integer SUID, Integer SGID) throws DataNotFoundException {
		BehaviorLevel theBehaviorLevel = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<BehaviorLevel> criteria = builder.createQuery(BehaviorLevel.class);
		criteria.where(builder.equal(criteria.from(BehaviorLevel.class).get("behaviorLevelID"), ai_BehaviorLevelID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theBehaviorLevel = (BehaviorLevel) query.getSingleResult();
			if (theBehaviorLevel != null) {
				return theBehaviorLevel;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "GetByID", "[Not Found][ID:" + ai_BehaviorLevelID + "]");
				throw new DataNotFoundException("BehaviorLevel [" + ai_BehaviorLevelID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "GetByID", "[Not Found][ID:" + ai_BehaviorLevelID + "]");
			throw new DataNotFoundException("BehaviorLevel [" + ai_BehaviorLevelID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT BL.* ");
		}
		sb_SQLCommand.append("FROM BehaviorLevel BL ");
		sb_SQLCommand.append("WHERE BL.BL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of BehaviorLevel By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<BehaviorLevel> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<BehaviorLevel> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(BehaviorLevel.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<BehaviorLevel> BehaviorLevelList = query.list();
			if (BehaviorLevelList.isEmpty() != true) {
				return BehaviorLevelList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find BehaviorLevel By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByFilterBehaviorLevelIDList(int ai_CommandType,List<Integer> ai_BehaviorLevelIDList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT BL.* ");
		}
		sb_SQLCommand.append("FROM BehaviorLevel BL ");
		sb_SQLCommand.append("WHERE BL.BL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_BehaviorLevelIDList != null && ai_BehaviorLevelIDList.size() > 0){
			sb_SQLCommand.append("AND BL.BehaviorLevelID NOT IN ( ");
			for(int i=0;i<ai_BehaviorLevelIDList.size();i++){
				if(i != 0){
					sb_SQLCommand.append(", ");
				}
				sb_SQLCommand.append(ai_BehaviorLevelIDList.get(i));
			}
			sb_SQLCommand.append(") ");
		}
		return sb_SQLCommand.toString();
	}

	public static int GetSizeByFilterBehaviorLevelIDList(Session MyHSs,List<Integer> ai_BehaviorLevelIDList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByFilterBehaviorLevelIDList", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByFilterBehaviorLevelIDList(10,ai_BehaviorLevelIDList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByFilterBehaviorLevelIDList", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByFilterBehaviorLevelIDList", "[" + RowCount.intValue() + "] Of BehaviorLevel By All [END] @@@");
		return RowCount.intValue();
	}

	public static List<BehaviorLevel> FindByFilterBehaviorLevelIDList(Session MyHSs,List<Integer> ai_BehaviorLevelIDList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByFilterBehaviorLevelIDList", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByFilterBehaviorLevelIDList(20,ai_BehaviorLevelIDList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByFilterBehaviorLevelIDList", ls_SQLCommand);
			NativeQuery<BehaviorLevel> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(BehaviorLevel.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<BehaviorLevel> BehaviorLevelList = query.list();
			if (BehaviorLevelList.isEmpty() != true) {
				return BehaviorLevelList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "FindByFilterBehaviorLevelIDList", "[Not Found] @@@");
				throw new DataNotFoundException("Find BehaviorLevel By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByBehaviorCodeBehaviorNameBehaviorDetail(int ai_CommandType,String as_BehaviorCode,String as_BehaviorName,String as_BehaviorDetail, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT BL.* ");
		}
		sb_SQLCommand.append("FROM BehaviorLevel BL ");
		sb_SQLCommand.append("WHERE BL.BL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_BehaviorCode != null){
			sb_SQLCommand.append("AND BL.BL_Code = '"+as_BehaviorCode+"' ");
		}
		if(as_BehaviorName != null){
			sb_SQLCommand.append("AND BL.BL_Name LIKE '%"+as_BehaviorName+"%' ");
		}
		if(as_BehaviorDetail != null){
			sb_SQLCommand.append("AND BL.BL_Detail LIKE '%"+as_BehaviorDetail+"%' ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByBehaviorCodeBehaviorNameBehaviorDetail(Session MyHSs,String as_BehaviorCode,String as_BehaviorName,String as_BehaviorDetail,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByBehaviorCodeBehaviorNameBehaviorDetail", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByBehaviorCodeBehaviorNameBehaviorDetail(10,as_BehaviorCode,as_BehaviorName,as_BehaviorDetail,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByBehaviorCodeBehaviorNameBehaviorDetail", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByBehaviorCodeBehaviorNameBehaviorDetail", "[" + RowCount.intValue() + "] Of BehaviorLevel By BehaviorCode["+as_BehaviorCode+"] BehaviorName["+as_BehaviorName+"] BehaviorDetail["+as_BehaviorDetail+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<BehaviorLevel> FindByBehaviorCodeBehaviorNameBehaviorDetail(Session MyHSs,String as_BehaviorCode,String as_BehaviorName,String as_BehaviorDetail,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByBehaviorCodeBehaviorNameBehaviorDetail", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByBehaviorCodeBehaviorNameBehaviorDetail(20,as_BehaviorCode,as_BehaviorName,as_BehaviorDetail,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByBehaviorCodeBehaviorNameBehaviorDetail", ls_SQLCommand);
			NativeQuery<BehaviorLevel> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(BehaviorLevel.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<BehaviorLevel> BehaviorLevelList = query.list();
			if (BehaviorLevelList.isEmpty() != true) {
				return BehaviorLevelList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "FindByBehaviorCodeBehaviorNameBehaviorDetail", "[Not Found] @@@");
				throw new DataNotFoundException("Find BehaviorLevel ByBehaviorCode BehaviorName BehaviorDetail is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static BehaviorLevel GetByCode(Session MyHSs, String as_BehaviorCode,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		BehaviorLevel theBehavior = null;
//		List<BehaviorLevel> BehaviorLevelList;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetByCode", "[START] @@@");
//		Criteria MyHC;
//		MyHC = MyHSs.createCriteria(BehaviorLevel.class).add(Restrictions.eq("code", as_BehaviorCode));
//		MyHC.setFirstResult(0);
//		MyHC.setMaxResults(1);
//		BehaviorLevelList = MyHC.list();
//		if (BehaviorLevelList.isEmpty() != true) {
//			theBehavior = BehaviorLevelList.get(0);
//			return theBehavior;
//		} else {
//			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "GetByCode", "[Not Found] @@@");
//			throw new DataNotFoundException("BehaviorLevel [" + as_BehaviorCode + "] is not found.");
//		}
		
		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT BL.* ");
			sb_SQLCommand.append("FROM BehaviorLevel BL ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("BL.BL_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE BL.BL_CreateTime IS NOT NULL ");
			if(as_BehaviorCode != null){
				sb_SQLCommand.append("AND BL.BL_Code = '" + as_BehaviorCode+"' ");
			}
			
			sb_SQLCommand.append("AND BL.BL_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("BL.BL_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetByCode", sb_SQLCommand.toString());
			NativeQuery<BehaviorLevel> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(BehaviorLevel.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<BehaviorLevel> BehaviorLevelList = query.list();
			if (BehaviorLevelList.isEmpty() != true) {
				return BehaviorLevelList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetByCode", "[Not Found] @@@");
				throw new DataNotFoundException("Get BehaviorLevel By Code ["+as_BehaviorCode+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionID(int ai_CommandType,Integer ai_ExamFormConditionID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT BL.* ");
		}
		sb_SQLCommand.append("FROM BehaviorLevel BL ");
		sb_SQLCommand.append("WHERE BL.BL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if((ai_ExamFormConditionID != null)){
			sb_SQLCommand.append("AND BL.BehaviorLevelID IN ( ");
				sb_SQLCommand.append("SELECT EICD.EICD_BehaviorLevelID ");
				sb_SQLCommand.append("FROM ExamItemCondition EICD ");
				sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
				sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+TYPE_CONDITION.TYPE_OBJECTIVE.getValue()+" ");
				
			sb_SQLCommand.append(" ) ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionID(Session MyHSs,Integer ai_ExamFormConditionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByExamFormConditionID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionID(10,ai_ExamFormConditionID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByExamFormConditionID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "GetSizeByExamFormConditionID", "[" + RowCount.intValue() + "] Of BehaviorLevel By ExamFormConditionID["+ai_ExamFormConditionID+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<BehaviorLevel> FindByExamFormConditionID(Session MyHSs,Integer ai_ExamFormConditionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByExamFormConditionID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionID(20,ai_ExamFormConditionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelDAO", "FindByExamFormConditionID", ls_SQLCommand);
			NativeQuery<BehaviorLevel> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(BehaviorLevel.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<BehaviorLevel> BehaviorLevelList = query.list();
			if (BehaviorLevelList.isEmpty() != true) {
				return BehaviorLevelList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "BehaviorLevelDAO", "FindByExamFormConditionID", "[Not Found] @@@");
				throw new DataNotFoundException("Find BehaviorLevel ByBehaviorCode BehaviorName BehaviorDetail is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}