package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.CurriculumAttribute;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class CurriculumAttributeDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static CurriculumAttribute Add(Session MyHSs,CurriculumAttribute ao_CurriculumAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_CurriculumAttribute.getOwnerSUID(), ao_CurriculumAttribute.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_CurriculumAttribute.setModifyTime(Common.GetCurrTime());
			ao_CurriculumAttribute.setModifyUser(as_UserName);
			ao_CurriculumAttribute.setCreateTime(Common.GetCurrTime());
			ao_CurriculumAttribute.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_CurriculumAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Add", "[Ready][ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]");
			return ao_CurriculumAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "Add", "[ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_CurriculumAttribute
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static CurriculumAttribute Disable(Session MyHSs, CurriculumAttribute ao_CurriculumAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_CurriculumAttribute.getOwnerSUID(), ao_CurriculumAttribute.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_CurriculumAttribute.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_CurriculumAttribute.setDeletedUser(as_UserName);
			ao_CurriculumAttribute.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_CurriculumAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Disable", "[Ready][ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]");
			return ao_CurriculumAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "Disable", "[ID:" +ao_CurriculumAttribute.getCurriculumAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_CurriculumAttribute
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static CurriculumAttribute Delete(Session MyHSs, CurriculumAttribute ao_CurriculumAttribute, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_CurriculumAttribute.getOwnerSUID(), ao_CurriculumAttribute.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_CurriculumAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Delete", "[ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]");
			return ao_CurriculumAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "Delete", "[ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_CurriculumAttribute
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static CurriculumAttribute Modify(Session MyHSs, CurriculumAttribute ao_CurriculumAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_CurriculumAttribute.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_CurriculumAttribute.setModifyTime(Common.GetCurrTime());
			ao_CurriculumAttribute.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_CurriculumAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "Modify", "[ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]");
			return ao_CurriculumAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "Modify", "[ID:" + ao_CurriculumAttribute.getCurriculumAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_CurriculumAttributeID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static CurriculumAttribute GetByID(Session MyHSs, Integer ai_CurriculumAttributeID, Integer SUID, Integer SGID) throws DataNotFoundException {
		CurriculumAttribute theCurriculumAttribute = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<CurriculumAttribute> criteria = builder.createQuery(CurriculumAttribute.class);
		criteria.where(builder.equal(criteria.from(CurriculumAttribute.class).get("curriculumAttributeID"), ai_CurriculumAttributeID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theCurriculumAttribute = (CurriculumAttribute) query.getSingleResult();
			if (theCurriculumAttribute != null) {
				return theCurriculumAttribute;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "GetByID", "[Not Found][ID:" + ai_CurriculumAttributeID + "]");
				throw new DataNotFoundException("CurriculumAttribute [" + ai_CurriculumAttributeID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "GetByID", "[Not Found][ID:" + ai_CurriculumAttributeID + "]");
			throw new DataNotFoundException("CurriculumAttribute [" + ai_CurriculumAttributeID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT CA.* ");
		}
		sb_SQLCommand.append("FROM CurriculumAttribute CA ");
		sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of CurriculumAttribute By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<CurriculumAttribute> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<CurriculumAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(CurriculumAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<CurriculumAttribute> CurriculumAttributeList = query.list();
			if (CurriculumAttributeList.isEmpty() != true) {
				return CurriculumAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find CurriculumAttribute By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCurriculumIDAttributeID(int ai_CommandType, Integer ai_CurriculumID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT CA.* ");
		}
		sb_SQLCommand.append("FROM CurriculumAttribute CA ");
		sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND CA.CA_AttributeID = "+ai_AttributeID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY CA.CA_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumIDAttributeID(Session MyHSs, Integer ai_CurriculumID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumIDAttributeID(10,ai_CurriculumID,ai_AttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", "[" + RowCount.intValue() + "] Of CurriculumAttribute By CurriculumAttributeGroupID[ai_CurriculumID :"+ai_CurriculumID +"] [ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<CurriculumAttribute> FindByCurriculumIDAttributeID(Session MyHSs, Integer ai_CurriculumID, Integer ai_AttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumIDAttributeID(20,ai_CurriculumID,ai_AttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDAttributeID", ls_SQLCommand);
			NativeQuery<CurriculumAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(CurriculumAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<CurriculumAttribute> CurriculumAttributeList = query.list();
			if (CurriculumAttributeList.isEmpty() != true) {
				return CurriculumAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find CurriculumAttribute By FindByCurriculumIDAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByCurriculumIDExamItemID(int ai_CommandType, Integer ai_CurriculumID, Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT CA.* ");
		}
		sb_SQLCommand.append("FROM CurriculumAttribute CA ");
		sb_SQLCommand.append("Join ExamItemAttribute EIA ON CA.CA_AttributeID = EIA.EIA_AttributeID ");
		sb_SQLCommand.append("JOIN Attributes a ON a.AttributeID = CA.CA_AttributeID ");
		sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("EIA.EIA_DataStatus NOT IN ( 411,511) ");
		sb_SQLCommand.append("AND a.A_DataStatus NOT IN ( 411,511) ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIA.EIA_ExamItemID = "+ai_ExamItemID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY CA.CA_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumIDDExamItemID(Session MyHSs, Integer ai_CurriculumID, Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumIDExamItemID(10,ai_CurriculumID,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByCurriculumIDAttributeID", "[" + RowCount.intValue() + "] Of CurriculumAttribute By CurriculumAttributeGroupID[ai_CurriculumID :"+ai_CurriculumID +"] [ai_ExamItemID :"+ai_ExamItemID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<CurriculumAttribute> FindByCurriculumIDDExamItemID(Session MyHSs, Integer ai_CurriculumID, Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDDExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumIDExamItemID(20,ai_CurriculumID,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDDExamItemID", ls_SQLCommand);
			NativeQuery<CurriculumAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(CurriculumAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<CurriculumAttribute> CurriculumAttributeList = query.list();
			if (CurriculumAttributeList.isEmpty() != true) {
				return CurriculumAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "FindByCurriculumIDDExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find CurriculumAttribute By FindByCurriculumIDDExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByAttributeID(int ai_CommandType, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT CA.* ");
		}
		sb_SQLCommand.append("FROM CurriculumAttribute CA ");
		sb_SQLCommand.append("WHERE CA.CA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND CA.CA_AttributeID = "+ai_AttributeID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY CA.CA_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByAttributeID(Session MyHSs, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByAttributeID(10,ai_AttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "GetSizeByAttributeID", "[" + RowCount.intValue() + "] Of CurriculumAttribute By FindByAttributeID[ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<CurriculumAttribute> FindByAttributeID(Session MyHSs, Integer ai_AttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByAttributeID(20,ai_AttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumAttributeDAO", "FindByAttributeID", ls_SQLCommand);
			NativeQuery<CurriculumAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(CurriculumAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<CurriculumAttribute> CurriculumAttributeList = query.list();
			if (CurriculumAttributeList.isEmpty() != true) {
				return CurriculumAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumAttributeDAO", "FindByAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find CurriculumAttribute By FindByAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
