package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Curriculum;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class CurriculumDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Curriculum Add(Session MyHSs,Curriculum ao_Curriculum, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Curriculum.getOwnerSUID(), ao_Curriculum.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Curriculum.setModifyTime(Common.GetCurrTime());
			ao_Curriculum.setModifyUser(as_UserName);
			ao_Curriculum.setCreateTime(Common.GetCurrTime());
			ao_Curriculum.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_Curriculum);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Add", "[Ready][ID:" + ao_Curriculum.getCurriculumID() + "]");
			return ao_Curriculum;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "Add", "[ID:" + ao_Curriculum.getCurriculumID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Curriculum
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Curriculum Disable(Session MyHSs, Curriculum ao_Curriculum, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Curriculum.getOwnerSUID(), ao_Curriculum.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Curriculum.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Curriculum.setDeletedUser(as_UserName);
			ao_Curriculum.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Curriculum);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Disable", "[Ready][ID:" + ao_Curriculum.getCurriculumID() + "]");
			return ao_Curriculum;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "Disable", "[ID:" +ao_Curriculum.getCurriculumID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Curriculum
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Curriculum Delete(Session MyHSs, Curriculum ao_Curriculum, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Curriculum.getOwnerSUID(), ao_Curriculum.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Curriculum);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Delete", "[ID:" + ao_Curriculum.getCurriculumID() + "]");
			return ao_Curriculum;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "Delete", "[ID:" + ao_Curriculum.getCurriculumID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Curriculum
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Curriculum Modify(Session MyHSs, Curriculum ao_Curriculum, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Curriculum.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Curriculum.setModifyTime(Common.GetCurrTime());
			ao_Curriculum.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Curriculum);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "Modify", "[ID:" + ao_Curriculum.getCurriculumID() + "]");
			return ao_Curriculum;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "Modify", "[ID:" + ao_Curriculum.getCurriculumID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_CurriculumID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Curriculum GetByID(Session MyHSs, Integer ai_CurriculumID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Curriculum theCurriculum = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Curriculum> criteria = builder.createQuery(Curriculum.class);
		criteria.where(builder.equal(criteria.from(Curriculum.class).get("curriculumID"), ai_CurriculumID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theCurriculum = (Curriculum) query.getSingleResult();
			if (theCurriculum != null) {
				return theCurriculum;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "GetByID", "[Not Found][ID:" + ai_CurriculumID + "]");
				throw new DataNotFoundException("Curriculum [" + ai_CurriculumID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "GetByID", "[Not Found][ID:" + ai_CurriculumID + "]");
			throw new DataNotFoundException("Curriculum [" + ai_CurriculumID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT C.* ");
		}
		sb_SQLCommand.append("FROM Curriculum C ");
		sb_SQLCommand.append("WHERE C.C_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Curriculum By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Curriculum> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Curriculum> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Curriculum.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Curriculum> CurriculumList = query.list();
			if (CurriculumList.isEmpty() != true) {
				return CurriculumList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Curriculum By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByCurriculumCodeCurriculumNameCurriculumDetail(int ai_CommandType,String as_CurriculumCode,String as_CurriculumName,String as_CurriculumDetail, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT C.* ");
		}
		sb_SQLCommand.append("FROM Curriculum C ");
		sb_SQLCommand.append("WHERE C.C_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_CurriculumCode != null){
			sb_SQLCommand.append("AND C.C_Code = '"+as_CurriculumCode+"' ");
		}
		if(as_CurriculumName != null){
			sb_SQLCommand.append("AND C.C_Name LIKE '%"+as_CurriculumName+"%' ");
		}
		if(as_CurriculumDetail != null){
			sb_SQLCommand.append("AND C.C_Detail LIKE '%"+as_CurriculumDetail+"%' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY C.C_Code , C.C_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumCodeCurriculumNameCurriculumDetail(Session MyHSs,String as_CurriculumCode,String as_CurriculumName,String as_CurriculumDetail,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeByCurriculumCodeCurriculumNameCurriculumDetail", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumCodeCurriculumNameCurriculumDetail(10,as_CurriculumCode,as_CurriculumName,as_CurriculumDetail,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeByCurriculumCodeCurriculumNameCurriculumDetail", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "GetSizeByCurriculumCodeCurriculumNameCurriculumDetail", "[" + RowCount.intValue() + "] Of Curriculum By CurriculumCode["+as_CurriculumCode+"] CurriculumName["+as_CurriculumName+"] CurriculumDetail["+as_CurriculumDetail+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Curriculum> FindByCurriculumCodeCurriculumNameCurriculumDetail(Session MyHSs,String as_CurriculumCode,String as_CurriculumName,String as_CurriculumDetail,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "FindByCurriculumCodeCurriculumNameCurriculumDetail", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumCodeCurriculumNameCurriculumDetail(20,as_CurriculumCode,as_CurriculumName,as_CurriculumDetail,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "CurriculumDAO", "FindByCurriculumCodeCurriculumNameCurriculumDetail", ls_SQLCommand);
			NativeQuery<Curriculum> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Curriculum.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Curriculum> CurriculumList = query.list();
			if (CurriculumList.isEmpty() != true) {
				return CurriculumList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "CurriculumDAO", "FindByCurriculumCodeCurriculumNameCurriculumDetail", "[Not Found] @@@");
				throw new DataNotFoundException("Find Curriculum ByCurriculumCode CurriculumName CurriculumDetail is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
