package esi.examwh.dao;
import java.util.List;

import javax.persistence.Query;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Attributes;
import esi.examwh.model.DocumentNumber;
import esi.examwh.model.common.TYPE_DATA_STATUS;
public class DocumentNumberDAO extends ObjectDAO {
	
	//private static MaxIDGenerator KeyGenerator = new MaxIDGenerator("DocumentNumber", "DocumentNumberID");
	
	public static DocumentNumber Add(Session MyHSs, DocumentNumber ao_DocumentNumber, String as_UserName) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Add", "[START][ID:" + ao_DocumentNumber.getPK() + "]");
		try {
			ao_DocumentNumber.setModifyTime(Common.GetCurrTime());
			ao_DocumentNumber.setModifyUser(as_UserName);
			ao_DocumentNumber.setCreateTime(Common.GetCurrTime());
			ao_DocumentNumber.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_DocumentNumber);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Add", "[Ready][ID:" + ao_DocumentNumber.getPK() + "]");
			return ao_DocumentNumber;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumberDAO", "Add", "[ID:" + ao_DocumentNumber.getPK() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static DocumentNumber Disable(Session MyHSs, DocumentNumber ao_DocumentNumber, String as_UserName) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Disable", "[START] @@@");
		try {			
				ao_DocumentNumber.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);

				ao_DocumentNumber.setDeletedUser(as_UserName);
				ao_DocumentNumber.setDeletedTime(Common.GetCurrTime());
				ObjectDAO.Disable(MyHSs, ao_DocumentNumber);
				return ao_DocumentNumber;
			
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumber", "Disable",ex.toString());
			throw ex;
		} finally {
		}
	}

	public static DocumentNumber Delete(Session MyHSs, DocumentNumber ao_DocumentNumber) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Delete", "[START] @@@");
		try {
			ObjectDAO.Delete(MyHSs, ao_DocumentNumber);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Delete", "[ID:" + ao_DocumentNumber.getPK() + "]");
			return ao_DocumentNumber;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumberDAO", "Delete", "[ID:" + ao_DocumentNumber.getPK() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static DocumentNumber Modify(Session MyHSs, DocumentNumber ao_DocumentNumber, String as_UserName) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Modify", "[START] @@@");
		try {
			ao_DocumentNumber.setModifyTime(Common.GetCurrTime());
			ao_DocumentNumber.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_DocumentNumber);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Modify", "[ID:" + ao_DocumentNumber.getPK() + "]");
			return ao_DocumentNumber;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumberDAO", "Modify", "[ID:" + ao_DocumentNumber.getPK() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static DocumentNumber GetById(Session MyHSs,Integer ai_YearNum, String as_PrefixType) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetByID", "[START] @@@");
		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT DN.* FROM DocumentNumber DN ");
			sb_SQLCommand.append("WHERE DN.DN_CreateTime IS NOT NULL ");
			sb_SQLCommand.append("AND DN.YearNum = " + ai_YearNum + " ");
			sb_SQLCommand.append("AND DN.PrefixDocumentType = '" + as_PrefixType + "' ");
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetByID", sb_SQLCommand.toString());
			NativeQuery<DocumentNumber> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(DocumentNumber.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<DocumentNumber> DocumentNumberList = query.list();
			if (DocumentNumberList.isEmpty() != true) {
				return DocumentNumberList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumberDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("Find DocumentNumber By ID[Search By : YearNum:" + ai_YearNum + ", PrefixType:"+as_PrefixType+" ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}


	public static String GenSQLALL(int ai_CommandType,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DN.* ");
		}
		sb_SQLCommand.append("FROM DocumentNumber DN ");
		sb_SQLCommand.append("WHERE DN.DN_CreateTime IS NOT NULL  ");
	
		sb_SQLCommand.append("AND DN.DN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	public static int GetSizeAll(Session MyHSs,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeBy All", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeBy All", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeBy All", "[" + RowCount.intValue() + "] Of DocumentNumber By All [END] @@@");
		return RowCount.intValue();
	}

	public static List<DocumentNumber> FindAll(Session MyHSs,Integer BeginRow, Integer MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeBy All", "[START] @@@");
		try {
			String ls_SQLCommand = GenSQLALL(20,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "Find By All",ls_SQLCommand);
			NativeQuery<DocumentNumber> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(DocumentNumber.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<DocumentNumber> DocumentNumberList = query.list();
			if (DocumentNumberList.isEmpty() != true) {
				return DocumentNumberList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "DocumentNumberDAO", "FindBy All", "[Not Found] @@@");
				throw new DataNotFoundException("Find DocumentNumber By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	public static String GenSQLByYearNumPrefixType(int ai_CommandType, Integer ai_YearNum,String as_PrefixType ,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DN.* ");
		}
		sb_SQLCommand.append("FROM DocumentNumber DN ");
		sb_SQLCommand.append("WHERE DN.DN_CreateTime IS NOT NULL ");
		
		if(ai_YearNum != null && ai_YearNum != -1){
			sb_SQLCommand.append("AND DN.YearNum = " + ai_YearNum + " ");
		}
		if(as_PrefixType != null){
			sb_SQLCommand.append("AND DN.PrefixDocumentType = '" + as_PrefixType + "' ");
		}
		sb_SQLCommand.append("AND DN.DN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}

	public static int GetSizeByYearNumPrefixType(Session MyHSs,Integer ai_YearNum,String as_PrefixType,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeByYearNumPrefixType", "[BEGIN]");
		String ls_SQLCommand = GenSQLByYearNumPrefixType(10,ai_YearNum,as_PrefixType, StatusList);
		Integer RowCount = ObjectDAO.GetSizeBySQL(MyHSs, ls_SQLCommand);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "GetSizeByYearNumPrefixType", "[END]");
		return RowCount.intValue();
	}

	public static List<DocumentNumber> FindAllByYearNumPrefixType(Session MyHSs, Integer ai_YearNum,String as_PrefixType, int... StatusList) throws DataNotFoundException, Exception {
		return FindByYearNumPrefixType(MyHSs,ai_YearNum,as_PrefixType, 0, 0, StatusList);
	}

	public static List<DocumentNumber> FindByYearNumPrefixType(Session MyHSs,Integer ai_YearNum,String as_PrefixType, Integer BeginRow, Integer MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "FindByYearNumPrefixType", "[START]");
		String ls_SQLCommand = GenSQLByYearNumPrefixType(20, ai_YearNum,as_PrefixType, StatusList);
		List<DocumentNumber> DocumentNumberList = ObjectDAO.FindBySQL(MyHSs, DocumentNumber.class, ls_SQLCommand, BeginRow, MaxRow);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "DocumentNumberDAO", "FindByYearNumPrefixType", "[End]");
		return DocumentNumberList;
	}
}
