package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ESDItemSelector;
import esi.examwh.model.EsdformCollator;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

public class ESDItemSelectorDAO {
	/**
	 * @param MyHSs
	 * @param ao_ESDItemSelector
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ESDItemSelector Add(Session MyHSs,ESDItemSelector ao_ESDItemSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ESDItemSelector.getOwnerSUID(), ao_ESDItemSelector.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ESDItemSelector.setModifyTime(Common.GetCurrTime());
			ao_ESDItemSelector.setModifyUser(as_UserName);
			ao_ESDItemSelector.setCreateTime(Common.GetCurrTime());
			ao_ESDItemSelector.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ESDItemSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Add", "[Ready][ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]");
			return ao_ESDItemSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "Add", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ESDItemSelector
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ESDItemSelector Disable(Session MyHSs, ESDItemSelector ao_ESDItemSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ESDItemSelector.getOwnerSUID(), ao_ESDItemSelector.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ESDItemSelector.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ESDItemSelector.setDeletedUser(as_UserName);
			ao_ESDItemSelector.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ESDItemSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Disable", "[Ready][ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]");
			return ao_ESDItemSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "Disable", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ESDItemSelector
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ESDItemSelector Delete(Session MyHSs, ESDItemSelector ao_ESDItemSelector, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ESDItemSelector.getOwnerSUID(), ao_ESDItemSelector.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ESDItemSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Delete", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]");
			return ao_ESDItemSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "Delete", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ESDItemSelector
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ESDItemSelector Modify(Session MyHSs, ESDItemSelector ao_ESDItemSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ESDItemSelector.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ESDItemSelector.setModifyTime(Common.GetCurrTime());
			ao_ESDItemSelector.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ESDItemSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "Modify", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]");
			return ao_ESDItemSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "Modify", "[ExamScheduleDetailID:" + ao_ESDItemSelector.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_ESDItemSelector.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ESDItemSelectorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ESDItemSelector GetByID(Session MyHSs, Integer ai_ExamScheduleDetailID,Integer ai_PersonID,Integer ai_ExamLevel, Integer SUID, Integer SGID) throws DataNotFoundException {
		ESDItemSelector theESDItemSelector = null;
		List<ESDItemSelector> ESDItemSelectorList;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ESDItemSelector> criteria = builder.createQuery(ESDItemSelector.class);
		Root<ESDItemSelector> root = criteria.from(ESDItemSelector.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("examScheduleDetailID"), ai_ExamScheduleDetailID),
						builder.equal(root.get("PK").get("personID"), ai_PersonID),
						builder.equal(root.get("PK").get("examLevel"), ai_ExamLevel)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theESDItemSelector =  (ESDItemSelector) query.getSingleResult();
			if (theESDItemSelector != null) {
				return theESDItemSelector;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+"] ,ExamLevel ["+ai_ExamLevel+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+"] ,ExamLevel ["+ai_ExamLevel+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ESDItemSelector By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ESDItemSelector> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID ,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDIS.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDIS.PersonID ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of ESDItemSelector By ExamScheduleID ["+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ESDItemSelector> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID ,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By ExamScheduleID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(int ai_CommandType,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDIS.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDIS.PersonID ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND PS.PersonID = "+ai_PersonID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(10,ai_ExamScheduleID,as_SubjectCode , as_SubjectName ,  ai_PersonID ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[" + RowCount.intValue() + "] Of ESDItemSelector By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] PersonID ["+ai_PersonID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ESDItemSelector> FindByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(20,ai_ExamScheduleID ,as_SubjectCode , as_SubjectName ,  ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(int ai_CommandType ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDIS.ExamScheduleDetailID  ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID  ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID AND SJ.SJ_DataStatus NOT IN (411,511)");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDIS.PersonID  ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_ExaminationType != null){
			sb_SQLCommand.append("AND  ES.ES_ExaminationType = "+ai_ExaminationType.getValue()+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_PersonName != null){
			sb_SQLCommand.append("AND PS.PS_Name LIKE '%"+as_PersonName+"%' ");
		}
		if(as_PersonLastName != null){
			sb_SQLCommand.append("AND PS.PS_LastName LIKE '%"+as_PersonLastName+"%' ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(10,as_SubjectCode , as_SubjectName ,  ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[" + RowCount.intValue() + "] Of ESDItemSelector By  SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"] ExamRoundID ["+ai_ExamRoundID+"] ExaminationType ["+ai_ExaminationType+"] PersonName ["+as_PersonName+"] PersonLastName ["+as_PersonLastName+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ESDItemSelector> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(20,as_SubjectCode , as_SubjectName ,  ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleIDSubjectID(int ai_CommandType,Integer ai_ExamScheduleID , Integer ai_SubjectID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDIS.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDIS.PersonID ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = '"+ai_SubjectID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectID(10,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleIDSubjectID", "[" + RowCount.intValue() + "] Of ESDItemSelector By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectID["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ESDItemSelector> FindByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectID(20,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectID", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By ExamScheduleID SubjectID");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleDetailIDExamLevel(int ai_CommandType,Integer ai_ExamScheduleDetailID ,Integer ai_ExamLevel,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDIS.* ");
		}
		sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
		sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID != null){
			sb_SQLCommand.append("AND  ESDIS.ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND  ESDIS.ExamLevel = "+ai_ExamLevel+" ");
		}
		
//		if(ai_CommandType != 10){
//			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
//		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDExamLevel(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ExamLevel,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleDetailIDExamLevel", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDExamLevel(10,ai_ExamScheduleDetailID,ai_ExamLevel ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleDetailIDExamLevel", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "GetSizeByExamScheduleDetailIDExamLevel", "[" + RowCount.intValue() + "] Of ESDItemSelector By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ESDItemSelector> FindByExamScheduleDetailIDExamLevel(Session MyHSs,Integer ai_ExamScheduleDetailID ,Integer ai_ExamLevel,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleDetailIDExamLevel", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDExamLevel(20,ai_ExamScheduleDetailID,ai_ExamLevel ,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleDetailIDExamLevel", ls_SQLCommand);
			NativeQuery<ESDItemSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ESDItemSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ESDItemSelector> ESDItemSelectorList = query.list();
			if (ESDItemSelectorList.isEmpty() != true) {
				return ESDItemSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ESDItemSelectorDAO", "FindByExamScheduleDetailID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ESDItemSelector By ExamScheduleDetailID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
