package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.EsdformCollator;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

public class EsdformCollatorDAO {
	/**
	 * @param MyHSs
	 * @param ao_EsdformCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformCollator Add(Session MyHSs,EsdformCollator ao_EsdformCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformCollator.getOwnerSUID(), ao_EsdformCollator.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_EsdformCollator.setModifyTime(Common.GetCurrTime());
			ao_EsdformCollator.setModifyUser(as_UserName);
			ao_EsdformCollator.setCreateTime(Common.GetCurrTime());
			ao_EsdformCollator.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_EsdformCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Add", "[Ready][ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]");
			return ao_EsdformCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "Add", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformCollator Disable(Session MyHSs, EsdformCollator ao_EsdformCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformCollator.getOwnerSUID(), ao_EsdformCollator.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_EsdformCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_EsdformCollator.setDeletedUser(as_UserName);
			ao_EsdformCollator.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_EsdformCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Disable", "[Ready][ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]");
			return ao_EsdformCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "Disable", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformCollator
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformCollator Delete(Session MyHSs, EsdformCollator ao_EsdformCollator, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformCollator.getOwnerSUID(), ao_EsdformCollator.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_EsdformCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Delete", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]");
			return ao_EsdformCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "Delete", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformCollator Modify(Session MyHSs, EsdformCollator ao_EsdformCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformCollator.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_EsdformCollator.setModifyTime(Common.GetCurrTime());
			ao_EsdformCollator.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_EsdformCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "Modify", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]");
			return ao_EsdformCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "Modify", "[ExamScheduleDetailID:" + ao_EsdformCollator.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformCollator.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_EsdformCollatorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static EsdformCollator GetByID(Session MyHSs, Integer ai_ExamScheduleDetailID,Integer ai_PersonID, Integer SUID, Integer SGID) throws DataNotFoundException {
		EsdformCollator theEsdformCollator = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<EsdformCollator> criteria = builder.createQuery(EsdformCollator.class);
		Root<EsdformCollator> root = criteria.from(EsdformCollator.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("examScheduleDetailID"), ai_ExamScheduleDetailID),
						builder.equal(root.get("PK").get("personID"), ai_PersonID)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theEsdformCollator =  (EsdformCollator) query.getSingleResult();
			if (theEsdformCollator != null) {
				return theEsdformCollator;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of EsdformCollator By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<EsdformCollator> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDPersonID(int ai_CommandType,Integer ai_ExamScheduleID , Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFC.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_PersonID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDPersonID(Session MyHSs,Integer ai_ExamScheduleID , Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDPersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDPersonID(10,ai_ExamScheduleID ,ai_PersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDPersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDPersonID", "[" + RowCount.intValue() + "] Of EsdformCollator By ExamScheduleID ["+ai_ExamScheduleID+"] PersonID["+ai_PersonID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformCollator> FindByExamScheduleIDPersonID(Session MyHSs,Integer ai_ExamScheduleID , Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDPersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDPersonID(20,ai_ExamScheduleID ,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDPersonID", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDPersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By ExamScheduleID PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDSubjectCodeSubjectName(int ai_CommandType,Integer ai_ExamScheduleID , String as_SubjectCode , String as_SubjectName, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFC.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFC.PersonID ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectCodeSubjectName(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectCodeSubjectName(10,ai_ExamScheduleID ,as_SubjectCode, as_SubjectName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectName", "[" + RowCount.intValue() + "] Of EsdformCollator By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectCode["+as_SubjectCode+"] SubjectName["+as_SubjectName+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformCollator> FindByExamScheduleIDSubjectCodeSubjectName(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectCodeSubjectName(20,ai_ExamScheduleID ,as_SubjectCode, as_SubjectName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectName", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectName", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By ExamScheduleID SubjectCode SubjectName is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(int ai_CommandType,Integer ai_ExamScheduleID , String as_SubjectCode , String as_SubjectName,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFC.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFC.PersonID ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectCode+"%' ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_PersonID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(10,ai_ExamScheduleID ,as_SubjectCode, as_SubjectName,ai_PersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[" + RowCount.intValue() + "] Of EsdformCollator By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectCode["+as_SubjectCode+"] SubjectName["+as_SubjectName+"] PersonID ["+ai_PersonID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformCollator> FindByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(20,ai_ExamScheduleID ,as_SubjectCode, as_SubjectName,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "PersonID", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDSubjectID(int ai_CommandType,Integer ai_ExamScheduleID , Integer ai_SubjectID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFC.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFC.PersonID ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = '"+ai_SubjectID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectID(10,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamScheduleIDSubjectID", "[" + RowCount.intValue() + "] Of EsdformCollator By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectID["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformCollator> FindByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectID(20,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectID", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By ExamScheduleID SubjectID");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(int ai_CommandType ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFC.* ");
		}
		sb_SQLCommand.append("FROM EsdformCollator ESDFC ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFC.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID  ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID  AND SJ.SJ_DataStatus NOT IN (411,511)");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFC.PersonID  ");
		sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_ExaminationType != null){
			sb_SQLCommand.append("AND  ES.ES_ExaminationType = "+ai_ExaminationType.getValue()+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_PersonName != null){
			sb_SQLCommand.append("AND PS.PS_Name LIKE '%"+as_PersonName+"%' ");
		}
		if(as_PersonLastName != null){
			sb_SQLCommand.append("AND PS.PS_LastName LIKE '%"+as_PersonLastName+"%' ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(10,as_SubjectCode , as_SubjectName ,  ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[" + RowCount.intValue() + "] Of EsdformCollator By  SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"] ExamRoundID ["+ai_ExamRoundID+"] ExaminationType ["+ai_ExaminationType+"] PersonName ["+as_PersonName+"] PersonLastName ["+as_PersonLastName+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformCollator> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(20,as_SubjectCode , as_SubjectName ,  ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
			NativeQuery<EsdformCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformCollator> EsdformCollatorList = query.list();
			if (EsdformCollatorList.isEmpty() != true) {
				return EsdformCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformCollatorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformCollator By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}