package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.EsdformEditor;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

public class EsdformEditorDAO {
	/**
	 * @param MyHSs
	 * @param ao_EsdformEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformEditor Add(Session MyHSs,EsdformEditor ao_EsdformEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformEditor.getOwnerSUID(), ao_EsdformEditor.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_EsdformEditor.setModifyTime(Common.GetCurrTime());
			ao_EsdformEditor.setModifyUser(as_UserName);
			ao_EsdformEditor.setCreateTime(Common.GetCurrTime());
			ao_EsdformEditor.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_EsdformEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Add", "[Ready][ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]");
			return ao_EsdformEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "Add", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformEditor Disable(Session MyHSs, EsdformEditor ao_EsdformEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformEditor.getOwnerSUID(), ao_EsdformEditor.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_EsdformEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_EsdformEditor.setDeletedUser(as_UserName);
			ao_EsdformEditor.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_EsdformEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Disable", "[Ready][ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]");
			return ao_EsdformEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "Disable", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformEditor
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformEditor Delete(Session MyHSs, EsdformEditor ao_EsdformEditor, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformEditor.getOwnerSUID(), ao_EsdformEditor.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_EsdformEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Delete", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]");
			return ao_EsdformEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "Delete", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_EsdformEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static EsdformEditor Modify(Session MyHSs, EsdformEditor ao_EsdformEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_EsdformEditor.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_EsdformEditor.setModifyTime(Common.GetCurrTime());
			ao_EsdformEditor.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_EsdformEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "Modify", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]");
			return ao_EsdformEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "Modify", "[ExamScheduleDetailID:" + ao_EsdformEditor.getPK().getExamScheduleDetailID() + "] PersonID:" + ao_EsdformEditor.getPK().getPersonID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_EsdformEditorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static EsdformEditor GetByID(Session MyHSs, Integer ai_ExamScheduleDetailID,Integer ai_PersonID, Integer SUID, Integer SGID) throws DataNotFoundException {
		EsdformEditor theEsdformEditor = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<EsdformEditor> criteria = builder.createQuery(EsdformEditor.class);
		Root<EsdformEditor> root = criteria.from(EsdformEditor.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("examScheduleDetailID"), ai_ExamScheduleDetailID),
						builder.equal(root.get("PK").get("personID"), ai_PersonID)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theEsdformEditor =  (EsdformEditor) query.getSingleResult();
			if (theEsdformEditor != null) {
				return theEsdformEditor;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("ExamScheduleDetailID [" + ai_ExamScheduleDetailID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFE.* ");
		}
		sb_SQLCommand.append("FROM EsdformEditor ESDFE ");
		sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of EsdformEditor By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<EsdformEditor> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<EsdformEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformEditor> EsdformEditorList = query.list();
			if (EsdformEditorList.isEmpty() != true) {
				return EsdformEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformEditor By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID ,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFE.* ");
		}
		sb_SQLCommand.append("FROM EsdformEditor ESDFE ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFE.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFE.PersonID ");
		sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of EsdformEditor By ExamScheduleID ["+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformEditor> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID ,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<EsdformEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformEditor> EsdformEditorList = query.list();
			if (EsdformEditorList.isEmpty() != true) {
				return EsdformEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "FindByExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformEditor By ExamScheduleID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(int ai_CommandType,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFE.* ");
		}
		sb_SQLCommand.append("FROM EsdformEditor ESDFE ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFE.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFE.PersonID ");
		sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND PS.PersonID = "+ai_PersonID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(10,ai_ExamScheduleID,as_SubjectCode , as_SubjectName ,  ai_PersonID ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID", "[" + RowCount.intValue() + "] Of EsdformEditor By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] PersonID ["+ai_PersonID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformEditor> FindByExamScheduleIDSubjectCodeSubjectNamePersonID(Session MyHSs,Integer ai_ExamScheduleID ,String as_SubjectCode , String as_SubjectName , Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectCodeSubjectNamePersonID(20,ai_ExamScheduleID ,as_SubjectCode , as_SubjectName ,  ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
			NativeQuery<EsdformEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformEditor> EsdformEditorList = query.list();
			if (EsdformEditorList.isEmpty() != true) {
				return EsdformEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformEditor By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(int ai_CommandType ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFE.* ");
		}
		sb_SQLCommand.append("FROM EsdformEditor ESDFE ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFE.ExamScheduleDetailID  ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID  ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID AND SJ.SJ_DataStatus NOT IN (411,511)");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFE.PersonID  ");
		sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND  ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_ExaminationType != null){
			sb_SQLCommand.append("AND  ES.ES_ExaminationType = "+ai_ExaminationType.getValue()+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_PersonName != null){
			sb_SQLCommand.append("AND PS.PS_Name LIKE '%"+as_PersonName+"%' ");
		}
		if(as_PersonLastName != null){
			sb_SQLCommand.append("AND PS.PS_LastName LIKE '%"+as_PersonLastName+"%' ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(10,as_SubjectCode , as_SubjectName ,  ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName", "[" + RowCount.intValue() + "] Of EsdformEditor By  SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"] ExamRoundID ["+ai_ExamRoundID+"] ExaminationType ["+ai_ExaminationType+"] PersonName ["+as_PersonName+"] PersonLastName ["+as_PersonLastName+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformEditor> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(Session MyHSs ,String as_SubjectCode , String as_SubjectName, Integer ai_ExamYearID, Integer ai_ExamSemesterID, Integer ai_ExamRoundID,TYPE_EXAMINATION ai_ExaminationType, String as_PersonName, String as_PersonLastName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(20,as_SubjectCode , as_SubjectName ,  ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,ai_ExaminationType,as_PersonName,as_PersonLastName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", ls_SQLCommand);
			NativeQuery<EsdformEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformEditor> EsdformEditorList = query.list();
			if (EsdformEditorList.isEmpty() != true) {
				return EsdformEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectCodeSubjectNamePersonID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformEditor By ExamScheduleID SubjectCode SubjectName PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleIDSubjectID(int ai_CommandType,Integer ai_ExamScheduleID , Integer ai_SubjectID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDFE.* ");
		}
		sb_SQLCommand.append("FROM EsdformEditor ESDFE ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = ESDFE.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = ESDFE.PersonID ");
		sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND  ESD.ESD_CopiedExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = '"+ai_SubjectID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDSubjectID(10,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "GetSizeByExamScheduleIDSubjectID", "[" + RowCount.intValue() + "] Of EsdformEditor By ExamScheduleID ["+ai_ExamScheduleID+"] SubjectID["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<EsdformEditor> FindByExamScheduleIDSubjectID(Session MyHSs,Integer ai_ExamScheduleID ,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDSubjectID(20,ai_ExamScheduleID ,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectID", ls_SQLCommand);
			NativeQuery<EsdformEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(EsdformEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<EsdformEditor> EsdformEditorList = query.list();
			if (EsdformEditorList.isEmpty() != true) {
				return EsdformEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "EsdformEditorDAO", "FindByExamScheduleIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find EsdformEditor By ExamScheduleID SubjectID");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}