package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamAnalysisCtt;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_USED_STATUS;

public class ExamAnalysisCttDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisCtt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisCtt Add(Session MyHSs,ExamAnalysisCtt ao_ExamAnalysisCtt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisCtt.getOwnerSUID(), ao_ExamAnalysisCtt.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamAnalysisCtt.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisCtt.setModifyUser(as_UserName);
			ao_ExamAnalysisCtt.setCreateTime(Common.GetCurrTime());
			ao_ExamAnalysisCtt.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamAnalysisCtt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Add", "[Ready][ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]");
			return ao_ExamAnalysisCtt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "Add", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisCtt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisCtt Disable(Session MyHSs, ExamAnalysisCtt ao_ExamAnalysisCtt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisCtt.getOwnerSUID(), ao_ExamAnalysisCtt.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamAnalysisCtt.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamAnalysisCtt.setDeletedUser(as_UserName);
			ao_ExamAnalysisCtt.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamAnalysisCtt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Disable", "[Ready][ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]");
			return ao_ExamAnalysisCtt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "Disable", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisCtt
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisCtt Delete(Session MyHSs, ExamAnalysisCtt ao_ExamAnalysisCtt, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisCtt.getOwnerSUID(), ao_ExamAnalysisCtt.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamAnalysisCtt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Delete", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]");
			return ao_ExamAnalysisCtt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "Delete", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisCtt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisCtt Modify(Session MyHSs, ExamAnalysisCtt ao_ExamAnalysisCtt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisCtt.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamAnalysisCtt.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisCtt.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamAnalysisCtt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "Modify", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]");
			return ao_ExamAnalysisCtt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "Modify", "[ExamAnalysisCttID:" + ao_ExamAnalysisCtt.getExamAnalysisCTTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamAnalysisCttID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamAnalysisCtt GetByID(Session MyHSs, Integer ai_ExamAnalysisCttID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamAnalysisCtt theExamAnalysisCtt = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamAnalysisCtt> criteria = builder.createQuery(ExamAnalysisCtt.class);
		criteria.where(builder.equal(criteria.from(ExamAnalysisCtt.class).get("examAnalysisCttID"), ai_ExamAnalysisCttID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamAnalysisCtt = (ExamAnalysisCtt) query.getSingleResult();
			if (theExamAnalysisCtt != null) {
				return theExamAnalysisCtt;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisCttID + "]");
				throw new DataNotFoundException("ExamAnalysisCtt [" + ai_ExamAnalysisCttID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisCttID + "]");
			throw new DataNotFoundException("ExamAnalysisCtt [" + ai_ExamAnalysisCttID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamAnalysisCtt> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType, Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAC.EAC_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESD ON ESD.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESD.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESD.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESD.ES_ExamRoundID ");
		
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAC.EAC_ExamItemID = "+ai_ExamItemID +" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By ExamItemID [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLByExamItemIDUsedStatus(int ai_CommandType, Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAC.EAC_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESD ON EA.EA_ExamScheduleID = ESD.ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESD.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESD.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESD.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAC.EAC_ExamItemID = "+ai_ExamItemID +" ");
		}
		if(ae_UsedStatus != null){
			sb_SQLCommand.append("AND EAC.EAC_UsedStatus = "+ae_UsedStatus.getValue()+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemIDUsedStatus(Session MyHSs,Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemIDUsedStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemIDUsedStatus(10,ai_ExamItemID,ae_UsedStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemIDUsedStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamItemIDUsedStatus", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By ExamItemID ["+ai_ExamItemID+"] UsedStatus ["+ae_UsedStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindByExamItemIDUsedStatus(Session MyHSs,Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemIDUsedStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemIDUsedStatus(20,ai_ExamItemID,ae_UsedStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemIDUsedStatus", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByExamItemIDUsedStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By ExamItemID UsedStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(int ai_CommandType, String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAC.EAC_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EA.EA_ExamFormID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESH ON ESH.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamItem EI ON EI.ExamItemID = EAC.EAC_ExamItemID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EI.EI_SubjectID ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode +"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName +"%' ");
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND EY.ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ER.ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ae_TypeExamination != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_TypeExamination.getValue()+" ");
		}
		if(as_ExamFormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_ExamFormName+"%' ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(10, as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID, ae_TypeExamination, as_ExamFormName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By  SubjectCode="+as_SubjectCode+",SubjectName = "+as_SubjectName+",ExamYearID = "+ai_ExamYearID+",ExamSemesterID = "+ai_ExamSemesterID+",ExamRoundID="+ai_ExamRoundID+",ExaminationType="+ae_TypeExamination+",ExamFormName="+as_ExamFormName+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(20,as_SubjectCode, as_SubjectName, ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID, ae_TypeExamination,as_ExamFormName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By SubjectCode SubjectName ExamYearID ExamSemesterID ExamRoundID ExaminationType ExamFormName is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(int ai_CommandType, String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName,Integer ai_UnitOrder ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAC.EAC_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EA.EA_ExamFormID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESH ON ESH.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamItem EI ON EI.ExamItemID = EAC.EAC_ExamItemID ");
		sb_SQLCommand.append("JOIN Unit UNT ON UNT.UnitID = EI.EI_UnitID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EI.EI_SubjectID ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode +"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName +"%' ");
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND EY.ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ER.ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ae_TypeExamination != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_TypeExamination.getValue()+" ");
		}
		if(as_ExamFormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_ExamFormName+"%' ");
		}
		if(ai_UnitOrder != null){
			sb_SQLCommand.append("AND UNT.UN_Order = "+ai_UnitOrder+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName,Integer ai_UnitOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(10, as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID, ae_TypeExamination, as_ExamFormName,ai_UnitOrder,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By SubjectCode="+as_SubjectCode+",SubjectName = "+as_SubjectName+",ExamYearID = "+ai_ExamYearID+",ExamSemesterID = "+ai_ExamSemesterID+",ExamRoundID="+ai_ExamRoundID+",ExaminationType="+ae_TypeExamination+",ExamFormName="+as_ExamFormName+", UnitOrder = "+ai_UnitOrder+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName,Integer ai_UnitOrder ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(20,as_SubjectCode, as_SubjectName, ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID, ae_TypeExamination,as_ExamFormName,ai_UnitOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By SubjectCode SubjectName ExamYearID ExamSemesterID ExamRoundID ExaminationType ExamFormName is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamAnalysisID(int ai_CommandType,Integer ai_ExamAnalysisID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCTT EAC ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAC.EAC_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisID(Session MyHSs,Integer ai_ExamAnalysisID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisID(10,ai_ExamAnalysisID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisID", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindByExamAnalysisID(Session MyHSs,Integer ai_ExamAnalysisID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisID(20,ai_ExamAnalysisID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisID", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisID[ExamAnalysisID:"+ai_ExamAnalysisID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCtt EAC ");
		sb_SQLCommand.append("Join ExamAnalysis EA ON EA.ExamAnalysisID = EAC.EAC_ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By ExamScheduleID [ExamScheduleID:"+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByExamScheduleID[ExamScheduleID:"+ai_ExamScheduleID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamAnalysisIDExamFormIDExamItemID(int ai_CommandType,Integer ai_ExamAnalysisID,Integer ai_ExamFormID,Integer ai_ExamItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAC.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisCTT EAC ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EAC.EAC_ExamAnalysisID = EA.ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAC.EAC_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAC.EAC_ExamItemID = "+ai_ExamItemID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisIDExamFormIDExamItemID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID,Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisIDExamFormIDExamItemID(10,ai_ExamAnalysisID,ai_ExamFormID,ai_ExamItemID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", "[" + RowCount.intValue() + "] Of ExamAnalysisCtt By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisCtt> FindByExamAnalysisIDExamFormIDExamItemID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisIDExamFormIDExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisIDExamFormIDExamItemID(20,ai_ExamAnalysisID,ai_ExamFormID,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisIDExamFormIDExamItemID", ls_SQLCommand);
			NativeQuery<ExamAnalysisCtt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisCtt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisCtt> ExamAnalysisCttList = query.list();
			if (ExamAnalysisCttList.isEmpty() != true) {
				return ExamAnalysisCttList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisCttDAO", "FindByExamAnalysisIDExamFormIDExamItemID[ExamAnalysisID:"+ai_ExamAnalysisID+"][ExamFormID:"+ai_ExamFormID+"][ExamItemID:"+ai_ExamItemID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisCtt By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}