package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamAnalysis;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

public class ExamAnalysisDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysis
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysis Add(Session MyHSs,ExamAnalysis ao_ExamAnalysis, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysis.getOwnerSUID(), ao_ExamAnalysis.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamAnalysis.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysis.setModifyUser(as_UserName);
			ao_ExamAnalysis.setCreateTime(Common.GetCurrTime());
			ao_ExamAnalysis.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_ExamAnalysis);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Add", "[Ready][ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]");
			return ao_ExamAnalysis;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "Add", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysis
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysis Disable(Session MyHSs, ExamAnalysis ao_ExamAnalysis, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysis.getOwnerSUID(), ao_ExamAnalysis.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamAnalysis.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamAnalysis.setDeletedUser(as_UserName);
			ao_ExamAnalysis.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamAnalysis);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Disable", "[Ready][ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]");
			return ao_ExamAnalysis;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "Disable", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysis
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysis Delete(Session MyHSs, ExamAnalysis ao_ExamAnalysis, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysis.getOwnerSUID(), ao_ExamAnalysis.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamAnalysis);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Delete", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]");
			return ao_ExamAnalysis;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "Delete", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysis
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysis Modify(Session MyHSs, ExamAnalysis ao_ExamAnalysis, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysis.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamAnalysis.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysis.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamAnalysis);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "Modify", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]");
			return ao_ExamAnalysis;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "Modify", "[ExamAnalysisID:" + ao_ExamAnalysis.getExamAnalysisID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamAnalysisID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamAnalysis GetByID(Session MyHSs, Integer ai_ExamAnalysisID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamAnalysis theExamAnalysis = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamAnalysis> criteria = builder.createQuery(ExamAnalysis.class);
		criteria.where(builder.equal(criteria.from(ExamAnalysis.class).get("examAnalysisID"), ai_ExamAnalysisID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamAnalysis = (ExamAnalysis) query.getSingleResult();
			if (theExamAnalysis != null) {
				return theExamAnalysis;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisID + "]");
				throw new DataNotFoundException("ExamAnalysis [" + ai_ExamAnalysisID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisID + "]");
			throw new DataNotFoundException("ExamAnalysis [" + ai_ExamAnalysisID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamAnalysis By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamAnalysis> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("JOIN ExamSchedule ESC ON ESC.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESC.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESC.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESC.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Number , ER.ER_Number");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByScheduleID", "[" + RowCount.intValue() + "] Of ExamAnalysis By ExamScheduleID : "+ai_ExamScheduleID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysis> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormID(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("JOIN ExamSchedule ESC ON ESC.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESC.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESC.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESC.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Number , ER.ER_Number");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamAnalysis By ExamFormID : "+ai_ExamFormID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysis> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType,Integer ai_ExamItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("JOIN ExamSchedule ESC ON ESC.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESC.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESC.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESC.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND (  ");
			sb_SQLCommand.append(" EA.ExamAnalysisID IN  ( ");
				sb_SQLCommand.append("SELECT EAI.EAI_ExamAnalysisID  ");
				sb_SQLCommand.append("FROM ExamAnalysisIRT EAI ");
				sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND EAI.EAI_ExamItemID = "+ai_ExamItemID+" ");
				sb_SQLCommand.append(" )  ");
			sb_SQLCommand.append(" OR ");
				sb_SQLCommand.append(" EA.ExamAnalysisID IN  ( ");
				sb_SQLCommand.append("SELECT EAC.EAC_ExamAnalysisID  ");
				sb_SQLCommand.append("FROM ExamAnalysisCTT EAC ");
				sb_SQLCommand.append("WHERE EAC.EAC_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND EAC.EAC_ExamItemID = "+ai_ExamItemID+" ");
				sb_SQLCommand.append(" ) ");
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Number , ER.ER_Number");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamAnalysis By ExamItemID : "+ai_ExamItemID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysis> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamitemID", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By ExamITemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleIDExamFormID(int ai_CommandType,Integer ai_ExamScheduleID,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("JOIN ExamSchedule ESC ON ESC.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESC.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESC.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESC.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Number , ER.ER_Number");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleIDExamFormID(Session MyHSs,Integer ai_ExamScheduleID,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamScheduleIDExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleIDExamFormID(10,ai_ExamScheduleID,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamScheduleIDExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeByExamScheduleIDExamFormID", "[" + RowCount.intValue() + "] Of ExamAnalysis By ExamFormID : "+ai_ExamFormID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysis> FindByExamScheduleIDExamFormID(Session MyHSs,Integer ai_ExamScheduleID,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleIDExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleIDExamFormID(20,ai_ExamScheduleID,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleIDExamFormID", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindByExamScheduleIDExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By ExamScheduleID ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
//	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(int ai_CommandType, String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) {
//		StringBuffer sb_SQLCommand = new StringBuffer();
//		if (ai_CommandType == 10) {
//			sb_SQLCommand.append("SELECT COUNT(DISTINCT EA.ExamAnalysisID) ");
//		} else {
//			sb_SQLCommand.append("SELECT DISTINCT EA.* ");
//		}
//		sb_SQLCommand.append("FROM ExamAnalysis EA ");
//		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EA.EA_ExamFormID ");
//		sb_SQLCommand.append("JOIN ExamSchedule ESH ON ESH.ExamScheduleID = EA.EA_ExamScheduleID ");
//		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESH.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
//		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
//		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
//		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
//		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
//		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
//		sb_SQLCommand.append(", ");
//		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
//		if (StatusList.length > 0) {
//			for (int i = 0; i < StatusList.length; i++) {
//				sb_SQLCommand.append(", ");
//				sb_SQLCommand.append(StatusList[i]);
//			}
//		}
//		sb_SQLCommand.append(") ");
//		if(as_SubjectCode != null){
//			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode +"' ");
//		}
//		if(as_SubjectName != null){
//			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName +"%' ");
//		}
//		if(ai_ExamYearID != null){
//			sb_SQLCommand.append("AND EY.ExamYearID = "+ai_ExamYearID+" ");
//		}
//		if(ai_ExamSemesterID != null){
//			sb_SQLCommand.append("AND ES.ExamSemesterID = "+ai_ExamSemesterID+" ");
//		}
//		if(ai_ExamRoundID != null){
//			sb_SQLCommand.append("AND ER.ExamRoundID = "+ai_ExamRoundID+" ");
//		}
//		if(ae_TypeExamination != null){
//			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_TypeExamination.getValue()+" ");
//		}
//		if(as_ExamFormName != null){
//			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_ExamFormName+"%' ");
//		}
//		
//		if(ai_CommandType != 10){
////			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
//			sb_SQLCommand.append("ORDER BY EA.EA_ExamScheduleID Desc ");
//		}
//		return sb_SQLCommand.toString();
//	}
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExamTermIDExaminationTypeExamFormCodeExamFormName(int ai_CommandType, String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_ExamTermID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormCode,String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(DISTINCT EA.ExamAnalysisID) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT EA.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysis EA ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EA.EA_ExamFormID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESH ON ESH.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESH.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EA.EA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		sb_SQLCommand.append("AND EA.EA_ExamFormID IN ( SELECT EF2.ExamFormID FROM ExamForm EF2 ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD2 ON EF2.EF_ExamScheduleDetailID = ESD2.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESH2 ON ESH2.ExamScheduleID = ESD2.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN Subject SJ2 ON SJ2.SubjectID = ESD2.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EF2.EF_DataStatus NOT IN (411,511) ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH2.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ESH2.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ESH2.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_ExamTermID != null){
			sb_SQLCommand.append("AND ESH2.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		if(ae_TypeExamination != null){
			sb_SQLCommand.append("AND ESH2.ES_ExaminationType = "+ae_TypeExamination.getValue()+" ");
		}
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ2.SJ_Code = '"+as_SubjectCode +"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ2.SJ_Name LIKE '%"+as_SubjectName +"%' ");
		}
		
		if(as_ExamFormName != null){
			sb_SQLCommand.append("AND EF2.EF_Name LIKE '%"+as_ExamFormName+"%' ");
		}
		if(as_ExamFormCode != null){
			sb_SQLCommand.append("AND EF2.EF_Code = '"+as_ExamFormCode+"' ");
		}
		sb_SQLCommand.append(") ");
		if(ai_CommandType != 10){
//			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
			sb_SQLCommand.append("ORDER BY EA.EA_ExamScheduleID Desc ");
		}
		return sb_SQLCommand.toString();
	}
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExamTermIDExaminationTypeExamFormCodeExamFormName(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_ExamTermID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormCode,String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExamTermIDExaminationTypeExamFormCodeExamFormName(10, as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ai_ExamTermID, ae_TypeExamination,as_ExamFormCode, as_ExamFormName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[" + RowCount.intValue() + "] Of ExamAnalysis By SubjectCode="+as_SubjectCode+",SubjectName = "+as_SubjectName+",ExamYearID = "+ai_ExamYearID+",ExamSemesterID = "+ai_ExamSemesterID+",ExamRoundID="+ai_ExamRoundID+",ExaminationType="+ae_TypeExamination+",ExamFormName="+as_ExamFormName+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysis> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExamTermIDExaminationTypeExamFormCodeExamFormName(Session MyHSs,String as_SubjectCode, String as_SubjectName,Integer ai_ExamYearID, Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_ExamTermID,TYPE_EXAMINATION ae_TypeExamination,String as_ExamFormCode,String as_ExamFormName ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExamTermIDExaminationTypeExamFormCodeExamFormName(20,as_SubjectCode, as_SubjectName, ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ai_ExamTermID, ae_TypeExamination,as_ExamFormCode,as_ExamFormName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
			NativeQuery<ExamAnalysis> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysis.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysis> ExamAnalysisList = query.list();
			if (ExamAnalysisList.isEmpty() != true) {
				return ExamAnalysisList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysis By SubjectCode SubjectName ExamYearID ExamSemesterID ExamRoundID ExaminationType ExamFormName is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}