package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamAnalysisHistogram;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamAnalysisHistogramDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisHistogram
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisHistogram Add(Session MyHSs,ExamAnalysisHistogram ao_ExamAnalysisHistogram, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisHistogram.getOwnerSUID(), ao_ExamAnalysisHistogram.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamAnalysisHistogram.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisHistogram.setModifyUser(as_UserName);
			ao_ExamAnalysisHistogram.setCreateTime(Common.GetCurrTime());
			ao_ExamAnalysisHistogram.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamAnalysisHistogram);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Add", "[Ready][ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]");
			return ao_ExamAnalysisHistogram;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "Add", "[ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisHistogram
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisHistogram Disable(Session MyHSs, ExamAnalysisHistogram ao_ExamAnalysisHistogram, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisHistogram.getOwnerSUID(), ao_ExamAnalysisHistogram.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamAnalysisHistogram.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamAnalysisHistogram.setDeletedUser(as_UserName);
			ao_ExamAnalysisHistogram.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamAnalysisHistogram);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Disable", "[Ready][ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]");
			return ao_ExamAnalysisHistogram;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "Disable", "[ID:" +ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisHistogram
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisHistogram Delete(Session MyHSs, ExamAnalysisHistogram ao_ExamAnalysisHistogram, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisHistogram.getOwnerSUID(), ao_ExamAnalysisHistogram.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamAnalysisHistogram);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Delete", "[ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]");
			return ao_ExamAnalysisHistogram;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "Delete", "[ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisHistogram
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisHistogram Modify(Session MyHSs, ExamAnalysisHistogram ao_ExamAnalysisHistogram, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisHistogram.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamAnalysisHistogram.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisHistogram.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamAnalysisHistogram);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "Modify", "[ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]");
			return ao_ExamAnalysisHistogram;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "Modify", "[ID:" + ao_ExamAnalysisHistogram.getExamAnalysisHistogramID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamAnalysisHistogramID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamAnalysisHistogram GetByID(Session MyHSs, Integer ai_ExamAnalysisHistogramID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamAnalysisHistogram theExamAnalysisHistogram = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamAnalysisHistogram> criteria = builder.createQuery(ExamAnalysisHistogram.class);
		criteria.where(builder.equal(criteria.from(ExamAnalysisHistogram.class).get("examAnalysisHistogramID"), ai_ExamAnalysisHistogramID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamAnalysisHistogram = (ExamAnalysisHistogram) query.getSingleResult();
			if (theExamAnalysisHistogram != null) {
				return theExamAnalysisHistogram;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisHistogramID + "]");
				throw new DataNotFoundException("ExamAnalysisHistogram [" + ai_ExamAnalysisHistogramID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisHistogramID + "]");
			throw new DataNotFoundException("ExamAnalysisHistogram [" + ai_ExamAnalysisHistogramID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAH.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisHistogram EAH ");
		sb_SQLCommand.append("WHERE EAH.EAH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamAnalysisHistogram By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamAnalysisHistogram> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamAnalysisHistogram> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisHistogram.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisHistogram> ExamAnalysisHistogramList = query.list();
			if (ExamAnalysisHistogramList.isEmpty() != true) {
				return ExamAnalysisHistogramList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisHistogram By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamAnalysisID(int ai_CommandType,Integer ai_ExamAnalysisID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAH.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisHistogram EAH ");
		sb_SQLCommand.append("WHERE EAH.EAH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAH.EAH_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisID(Session MyHSs,Integer ai_ExamAnalysisID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisID(10,ai_ExamAnalysisID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisID", "[" + RowCount.intValue() + "] Of ExamAnalysisHistogram By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisHistogram> FindByExamAnalysisID(Session MyHSs,Integer ai_ExamAnalysisID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisID(20,ai_ExamAnalysisID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisID", ls_SQLCommand);
			NativeQuery<ExamAnalysisHistogram> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisHistogram.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisHistogram> ExamAnalysisHistogramList = query.list();
			if (ExamAnalysisHistogramList.isEmpty() != true) {
				return ExamAnalysisHistogramList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisID[ExamAnalysisID:"+ai_ExamAnalysisID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisHistogram By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAH.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisHistogram EAH ");
		sb_SQLCommand.append("Join ExamAnalysis EA ON EA.ExamAnalysisID = EAH.EAH_ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAH.EAH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of ExamAnalysisHistogram By ExamScheduleID [ExamScheduleID:"+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisHistogram> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamAnalysisHistogram> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisHistogram.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisHistogram> ExamAnalysisHistogramList = query.list();
			if (ExamAnalysisHistogramList.isEmpty() != true) {
				return ExamAnalysisHistogramList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamScheduleID[ExamScheduleID:"+ai_ExamScheduleID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisHistogram By ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamAnalysisIDExamFormID(int ai_CommandType,Integer ai_ExamAnalysisID,Integer ai_ExamFormID , Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAH.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisHistogram EAH ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EAH.EAH_ExamAnalysisID = EA.ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAH.EAH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAH.EAH_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisIDExamFormID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisIDExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisIDExamFormID(10,ai_ExamAnalysisID,ai_ExamFormID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisIDExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "GetSizeByExamAnalysisIDExamFormID", "[" + RowCount.intValue() + "] Of ExamAnalysisHistogram By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisHistogram> FindByExamAnalysisIDExamFormID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisIDExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisIDExamFormID(20,ai_ExamAnalysisID,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisIDExamFormID", ls_SQLCommand);
			NativeQuery<ExamAnalysisHistogram> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisHistogram.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisHistogram> ExamAnalysisHistogramList = query.list();
			if (ExamAnalysisHistogramList.isEmpty() != true) {
				return ExamAnalysisHistogramList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisHistogramDAO", "FindByExamAnalysisIDExamFormIDExamItemID[ExamAnalysisID:"+ai_ExamAnalysisID+"][ExamFormID:"+ai_ExamFormID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisHistogram By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
