package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamAnalysisIrt;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_USED_STATUS;

public class ExamAnalysisIrtDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisIrt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisIrt Add(Session MyHSs,ExamAnalysisIrt ao_ExamAnalysisIrt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisIrt.getOwnerSUID(), ao_ExamAnalysisIrt.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamAnalysisIrt.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisIrt.setModifyUser(as_UserName);
			ao_ExamAnalysisIrt.setCreateTime(Common.GetCurrTime());
			ao_ExamAnalysisIrt.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_ExamAnalysisIrt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Add", "[Ready][ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]");
			return ao_ExamAnalysisIrt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "Add", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisIrt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisIrt Disable(Session MyHSs, ExamAnalysisIrt ao_ExamAnalysisIrt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisIrt.getOwnerSUID(), ao_ExamAnalysisIrt.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamAnalysisIrt.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamAnalysisIrt.setDeletedUser(as_UserName);
			ao_ExamAnalysisIrt.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamAnalysisIrt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Disable", "[Ready][ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]");
			return ao_ExamAnalysisIrt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "Disable", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisIrt
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisIrt Delete(Session MyHSs, ExamAnalysisIrt ao_ExamAnalysisIrt, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisIrt.getOwnerSUID(), ao_ExamAnalysisIrt.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamAnalysisIrt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Delete", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]");
			return ao_ExamAnalysisIrt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "Delete", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisIrt
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisIrt Modify(Session MyHSs, ExamAnalysisIrt ao_ExamAnalysisIrt, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisIrt.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamAnalysisIrt.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisIrt.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamAnalysisIrt);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "Modify", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]");
			return ao_ExamAnalysisIrt;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "Modify", "[ExamAnalysisIrtID:" + ao_ExamAnalysisIrt.getExamAnalysisIRTID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamAnalysisIrtID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamAnalysisIrt GetByID(Session MyHSs, Integer ai_ExamAnalysisIrtID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamAnalysisIrt theExamAnalysisIrt = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamAnalysisIrt> criteria = builder.createQuery(ExamAnalysisIrt.class);
		criteria.where(builder.equal(criteria.from(ExamAnalysisIrt.class).get("examAnalysisIrtID"), ai_ExamAnalysisIrtID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamAnalysisIrt = (ExamAnalysisIrt) query.getSingleResult();
			if (theExamAnalysisIrt != null) {
				return theExamAnalysisIrt;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisIrtID + "]");
				throw new DataNotFoundException("ExamAnalysisIrt [" + ai_ExamAnalysisIrtID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisIrtID + "]");
			throw new DataNotFoundException("ExamAnalysisIrt [" + ai_ExamAnalysisIrtID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAI.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisIrt EAI ");
		sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamAnalysisIrt By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamAnalysisIrt> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamAnalysisIrt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisIrt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisIrt> ExamAnalysisIrtList = query.list();
			if (ExamAnalysisIrtList.isEmpty() != true) {
				return ExamAnalysisIrtList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisIrt By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType, Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAI.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisIrt EAI ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAI.EAI_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESD ON EA.EA_ExamScheduleID = ESD.ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESD.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESD.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESD.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAI.EAI_ExamItemID = "+ai_ExamItemID +" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamAnalysisIrt By ExamItemID [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisIrt> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamAnalysisIrt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisIrt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisIrt> ExamAnalysisIrtList = query.list();
			if (ExamAnalysisIrtList.isEmpty() != true) {
				return ExamAnalysisIrtList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisIrt By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemIDUsedStatus(int ai_CommandType, Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAI.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisIrt EAI ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EA.ExamAnalysisID = EAI.EAI_ExamAnalysisID ");
		sb_SQLCommand.append("JOIN ExamSchedule ESD ON ESD.ExamScheduleID = EA.EA_ExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESD.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESD.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESD.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAI.EAI_ExamItemID = "+ai_ExamItemID +" ");
		}
		if(ae_UsedStatus != null){
			sb_SQLCommand.append("AND EAI.EAI_UsedStatus = "+ae_UsedStatus.getValue()+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Code , ER.ER_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemIDUsedStatus(Session MyHSs,Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemIDUsedStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemIDUsedStatus(10,ai_ExamItemID,ae_UsedStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemIDUsedStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamItemIDUsedStatus", "[" + RowCount.intValue() + "] Of ExamAnalysisIrt By ExamItemID ["+ai_ExamItemID+"] UsedStatus ["+ae_UsedStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisIrt> FindByExamItemIDUsedStatus(Session MyHSs,Integer ai_ExamItemID,TYPE_USED_STATUS ae_UsedStatus ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemIDUsedStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemIDUsedStatus(20,ai_ExamItemID,ae_UsedStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemIDUsedStatus", ls_SQLCommand);
			NativeQuery<ExamAnalysisIrt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisIrt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisIrt> ExamAnalysisIrtList = query.list();
			if (ExamAnalysisIrtList.isEmpty() != true) {
				return ExamAnalysisIrtList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "FindByExamItemIDUsedStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisIrt By ExamItemID UsedStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAI.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisIrt EAI ");
		sb_SQLCommand.append("Join ExamAnalysis EA ON EA.ExamAnalysisID = EAI.EAI_ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of ExamAnalysisIrt By ExamScheduleID [ExamScheduleID:"+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisIrt> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamAnalysisIrt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisIrt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisIrt> ExamAnalysisIrtList = query.list();
			if (ExamAnalysisIrtList.isEmpty() != true) {
				return ExamAnalysisIrtList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "FindByExamScheduleID[ExamScheduleID:"+ai_ExamScheduleID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisIrt By ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamAnalysisIDExamFormIDExamItemID(int ai_CommandType, Integer ai_ExamAnalysisID,Integer ai_ExamFormID, Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAI.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisIrt EAI ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EAI.EAI_ExamAnalysisID = EA.ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAI.EAI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EAI.EAI_ExamItemID = "+ai_ExamItemID +" ");
		}
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAI.EAI_ExamAnalysisID = "+ai_ExamAnalysisID +" ");
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisIDExamFormIDExamItemID(Session MyHSs, Integer ai_ExamAnalysisID,Integer ai_ExamFormID,Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisIDExamFormIDExamItemID(10,ai_ExamAnalysisID,ai_ExamFormID,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "GetSizeByExamAnalysisIDExamFormIDExamItemID", "[" + RowCount.intValue() + "] Of ExamAnalysisIrt By ExamItemID [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisIrt> FindByExamAnalysisIDExamFormIDExamItemID(Session MyHSs, Integer ai_ExamAnalysisID,Integer ai_ExamFormID,Integer ai_ExamItemID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamAnalysisIDExamFormIDExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisIDExamFormIDExamItemID(20,ai_ExamAnalysisID,ai_ExamFormID,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtDAO", "FindByExamAnalysisIDExamFormIDExamItemID", ls_SQLCommand);
			NativeQuery<ExamAnalysisIrt> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisIrt.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamAnalysisIrt> ExamAnalysisIrtList = query.list();
			if (ExamAnalysisIrtList.isEmpty() != true) {
				return ExamAnalysisIrtList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisIrtDAO", "FindByExamAnalysisIDExamFormIDExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisIrt By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}