package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamAnalysisUnitStat;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamAnalysisUnitStatDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisHistogram
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisUnitStat Add(Session MyHSs,ExamAnalysisUnitStat ao_ExamAnalysisUnitStat, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisUnitStat.getOwnerSUID(), ao_ExamAnalysisUnitStat.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamAnalysisUnitStat.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisUnitStat.setModifyUser(as_UserName);
			ao_ExamAnalysisUnitStat.setCreateTime(Common.GetCurrTime());
			ao_ExamAnalysisUnitStat.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamAnalysisUnitStat);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Add", "[Ready][ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]");
			return ao_ExamAnalysisUnitStat;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "Add", "[ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisUnitStat
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisUnitStat Disable(Session MyHSs, ExamAnalysisUnitStat ao_ExamAnalysisUnitStat, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisUnitStat.getOwnerSUID(), ao_ExamAnalysisUnitStat.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamAnalysisUnitStat.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamAnalysisUnitStat.setDeletedUser(as_UserName);
			ao_ExamAnalysisUnitStat.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamAnalysisUnitStat);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Disable", "[Ready][ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]");
			return ao_ExamAnalysisUnitStat;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "Disable", "[ID:" +ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisUnitStat
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisUnitStat Delete(Session MyHSs, ExamAnalysisUnitStat ao_ExamAnalysisUnitStat, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisUnitStat.getOwnerSUID(), ao_ExamAnalysisUnitStat.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamAnalysisUnitStat);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Delete", "[ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]");
			return ao_ExamAnalysisUnitStat;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "Delete", "[ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamAnalysisUnitStat
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamAnalysisUnitStat Modify(Session MyHSs, ExamAnalysisUnitStat ao_ExamAnalysisUnitStat, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamAnalysisUnitStat.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamAnalysisUnitStat.setModifyTime(Common.GetCurrTime());
			ao_ExamAnalysisUnitStat.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamAnalysisUnitStat);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "Modify", "[ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]");
			return ao_ExamAnalysisUnitStat;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "Modify", "[ID:" + ao_ExamAnalysisUnitStat.getExamAnalysisUnitStatID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamAnalysisUnitStatID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamAnalysisUnitStat GetByID(Session MyHSs, Integer ai_ExamAnalysisUnitStatID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamAnalysisUnitStat theExamAnalysisUnitStat = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamAnalysisUnitStat> criteria = builder.createQuery(ExamAnalysisUnitStat.class);
		criteria.where(builder.equal(criteria.from(ExamAnalysisUnitStat.class).get("examAnalysisUnitStatID"), ai_ExamAnalysisUnitStatID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamAnalysisUnitStat = (ExamAnalysisUnitStat) query.getSingleResult();
			if (theExamAnalysisUnitStat != null) {
				return theExamAnalysisUnitStat;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisUnitStatID + "]");
				throw new DataNotFoundException("ExamAnalysisUnitStat [" + ai_ExamAnalysisUnitStatID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ExamAnalysisUnitStatID + "]");
			throw new DataNotFoundException("ExamAnalysisUnitStat [" + ai_ExamAnalysisUnitStatID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAUS.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisUnitStat EAUS ");
		sb_SQLCommand.append("WHERE EAUS.EAUS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamAnalysisUnitStat By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamAnalysisUnitStat> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamAnalysisUnitStat> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisUnitStat.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisUnitStat> ExamAnalysisUnitStatList = query.list();
			if (ExamAnalysisUnitStatList.isEmpty() != true) {
				return ExamAnalysisUnitStatList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisUnitStat By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamAnalysisIDUnitID(int ai_CommandType,Integer ai_ExamAnalysisID,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAUS.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisUnitStat EAUS ");
		sb_SQLCommand.append("JOIN Unit UN ON EAUS.EAUS_UnitID = UN.UnitID ");
		sb_SQLCommand.append("WHERE EAUS.EAUS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAUS.EAUS_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EAUS.EAUS_UnitID = "+ai_UnitID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisIDUnitID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisIDUnitID(10,ai_ExamAnalysisID, ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisID", "[" + RowCount.intValue() + "] Of ExamAnalysisUnitStat By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisUnitStat> FindByExamAnalysisIDUnitID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisIDUnitID(20,ai_ExamAnalysisID, ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisID", ls_SQLCommand);
			NativeQuery<ExamAnalysisUnitStat> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisUnitStat.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisUnitStat> ExamAnalysisUnitStatList = query.list();
			if (ExamAnalysisUnitStatList.isEmpty() != true) {
				return ExamAnalysisUnitStatList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisID[ExamAnalysisID:"+ai_ExamAnalysisID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisUnitStat By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAUS.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisUnitStat EAUS ");
		sb_SQLCommand.append("Join ExamAnalysis EA ON EA.ExamAnalysisID = EAUS.EAUS_ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAUS.EAUS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of ExamAnalysisUnitStat By ExamScheduleID [ExamScheduleID:"+ai_ExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisUnitStat> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamAnalysisUnitStat> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisUnitStat.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisUnitStat> ExamAnalysisUnitStatList = query.list();
			if (ExamAnalysisUnitStatList.isEmpty() != true) {
				return ExamAnalysisUnitStatList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamScheduleID[ExamScheduleID:"+ai_ExamScheduleID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisUnitStat By ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamAnalysisIDExamFormID(int ai_CommandType,Integer ai_ExamAnalysisID,Integer ai_ExamFormID , Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EAUS.* ");
		}
		sb_SQLCommand.append("FROM ExamAnalysisUnitStat EAUS ");
		sb_SQLCommand.append("JOIN ExamAnalysis EA ON EAUS.EAUS_ExamAnalysisID = EA.ExamAnalysisID ");
		sb_SQLCommand.append("WHERE EAUS.EAUS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamAnalysisID != null){
			sb_SQLCommand.append("AND EAUS.EAUS_ExamAnalysisID = "+ai_ExamAnalysisID+" ");
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EA.EA_ExamFormID = "+ai_ExamFormID+" ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamAnalysisIDExamFormID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisIDExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamAnalysisIDExamFormID(10,ai_ExamAnalysisID,ai_ExamFormID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisIDExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "GetSizeByExamAnalysisIDExamFormID", "[" + RowCount.intValue() + "] Of ExamAnalysisUnitStat By ExamAnalysisID [ExamAnalysisID:"+ai_ExamAnalysisID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamAnalysisUnitStat> FindByExamAnalysisIDExamFormID(Session MyHSs,Integer ai_ExamAnalysisID,Integer ai_ExamFormID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisIDExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamAnalysisIDExamFormID(20,ai_ExamAnalysisID,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisIDExamFormID", ls_SQLCommand);
			NativeQuery<ExamAnalysisUnitStat> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamAnalysisUnitStat.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamAnalysisUnitStat> ExamAnalysisUnitStatList = query.list();
			if (ExamAnalysisUnitStatList.isEmpty() != true) {
				return ExamAnalysisUnitStatList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamAnalysisUnitStatDAO", "FindByExamAnalysisIDExamFormIDExamItemID[ExamAnalysisID:"+ai_ExamAnalysisID+"][ExamFormID:"+ai_ExamFormID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamAnalysisUnitStat By ExamAnalysisID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
