package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamCreatorCondition;
import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamCreatorConditionDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamCreatorCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamCreatorCondition Add(Session MyHSs,ExamCreatorCondition ao_ExamCreatorCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamCreatorCondition.getOwnerSUID(), ao_ExamCreatorCondition.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamCreatorCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamCreatorCondition.setModifyUser(as_UserName);
			ao_ExamCreatorCondition.setCreateTime(Common.GetCurrTime());
			ao_ExamCreatorCondition.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamCreatorCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Add", "[Ready][ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]");
			return ao_ExamCreatorCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "Add", "[ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamCreatorCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamCreatorCondition Disable(Session MyHSs, ExamCreatorCondition ao_ExamCreatorCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamCreatorCondition.getOwnerSUID(), ao_ExamCreatorCondition.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamCreatorCondition.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamCreatorCondition.setDeletedUser(as_UserName);
			ao_ExamCreatorCondition.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamCreatorCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Disable", "[Ready][ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]");
			return ao_ExamCreatorCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "Disable", "[ID:" +ao_ExamCreatorCondition.getExamCreatorConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamCreatorCondition
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamCreatorCondition Delete(Session MyHSs, ExamCreatorCondition ao_ExamCreatorCondition, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamCreatorCondition.getOwnerSUID(), ao_ExamCreatorCondition.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamCreatorCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Delete", "[ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]");
			return ao_ExamCreatorCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "Delete", "[ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamCreatorCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamCreatorCondition Modify(Session MyHSs, ExamCreatorCondition ao_ExamCreatorCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamCreatorCondition.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamCreatorCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamCreatorCondition.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamCreatorCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "Modify", "[ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]");
			return ao_ExamCreatorCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "Modify", "[ID:" + ao_ExamCreatorCondition.getExamCreatorConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamCreatorConditionID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamCreatorCondition GetByID(Session MyHSs, Integer ai_ExamCreatorConditionID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamCreatorCondition theExamCreatorCondition = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamCreatorCondition> criteria = builder.createQuery(ExamCreatorCondition.class);
		criteria.where(builder.equal(criteria.from(ExamCreatorCondition.class).get("examCreatorConditionID"), ai_ExamCreatorConditionID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamCreatorCondition = (ExamCreatorCondition) query.getSingleResult();
			if (theExamCreatorCondition != null) {
				return theExamCreatorCondition;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamCreatorConditionID + "]");
				throw new DataNotFoundException("ExamCreatorCondition [" + ai_ExamCreatorConditionID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamCreatorConditionID + "]");
			throw new DataNotFoundException("ExamCreatorCondition [" + ai_ExamCreatorConditionID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ECCD.* ");
		}
		sb_SQLCommand.append("FROM ExamCreatorCondition ECCD ");
		sb_SQLCommand.append("WHERE ECCD.ECCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamCreatorCondition By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamCreatorCondition> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamCreatorCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamCreatorCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamCreatorCondition> ExamCreatorConditionList = query.list();
			if (ExamCreatorConditionList.isEmpty() != true) {
				return ExamCreatorConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamCreatorCondition By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_PersonID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ECCD.* ");
		}
		sb_SQLCommand.append("FROM ExamCreatorCondition ECCD ");
//		sb_SQLCommand.append("JOIN BehaviorLevel BL ON BL.BehaviorLevelID = ECCD.ECCD_BehaviorLevelID ");
//		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ECCD.ECCD_UnitID ");
//		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = ECCD.ECCD_SectionID ");
//		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = ECCD.ECCD_ObjectiveID ");
		sb_SQLCommand.append("WHERE ECCD.ECCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_PersonID = "+ai_PersonID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND ECCD.ECCD_SectionID IS NULL ");
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ECCD.ECCD_PersonID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_PersonID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType(10,ai_ExamFormConditionID,ai_PersonID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "GetSizeByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", "[" + RowCount.intValue() + "] Of ExamCreatorCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamCreatorCondition> FindByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_PersonID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "FindByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType(20,ai_ExamFormConditionID,ai_PersonID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamCreatorConditionDAO", "FindByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
			NativeQuery<ExamCreatorCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamCreatorCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamCreatorCondition> ExamCreatorConditionList = query.list();
			if (ExamCreatorConditionList.isEmpty() != true) {
				return ExamCreatorConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamCreatorConditionDAO", "FindByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveIDConditionType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamCreatorCondition By FindByExamFormConditionIDPersonIDUnitIDSectionIDObjectiveID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT SUM(ECCD.ECCD_NOFItem) ");
		sb_SQLCommand.append("FROM ExamCreatorCondition ECCD ");
		sb_SQLCommand.append("WHERE ECCD.ECCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND ECCD.ECCD_SectionID IS NULL ");
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND ECCD.ECCD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(ai_ExamFormConditionID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
}
