package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormAnalysisHistory;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormAnalysisHistoryDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormAnalysisHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormAnalysisHistory Add(Session MyHSs,ExamFormAnalysisHistory ao_ExamFormAnalysisHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormAnalysisHistory.getOwnerSUID(), ao_ExamFormAnalysisHistory.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormAnalysisHistory.setModifyTime(Common.GetCurrTime());
			ao_ExamFormAnalysisHistory.setModifyUser(as_UserName);
			ao_ExamFormAnalysisHistory.setCreateTime(Common.GetCurrTime());
			ao_ExamFormAnalysisHistory.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormAnalysisHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Add", "[Ready][ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]");
			return ao_ExamFormAnalysisHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "Add", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormAnalysisHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormAnalysisHistory Disable(Session MyHSs, ExamFormAnalysisHistory ao_ExamFormAnalysisHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormAnalysisHistory.getOwnerSUID(), ao_ExamFormAnalysisHistory.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormAnalysisHistory.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
//			ao_ExamFormAnalysisHistory.setDeletedUser(as_UserName);
//			ao_ExamFormAnalysisHistory.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormAnalysisHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Disable", "[Ready][ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]");
			return ao_ExamFormAnalysisHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "Disable", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormAnalysisHistory
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormAnalysisHistory Delete(Session MyHSs, ExamFormAnalysisHistory ao_ExamFormAnalysisHistory, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormAnalysisHistory.getOwnerSUID(), ao_ExamFormAnalysisHistory.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormAnalysisHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Delete", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]");
			return ao_ExamFormAnalysisHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "Delete", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormAnalysisHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormAnalysisHistory Modify(Session MyHSs, ExamFormAnalysisHistory ao_ExamFormAnalysisHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormAnalysisHistory.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormAnalysisHistory.setModifyTime(Common.GetCurrTime());
			ao_ExamFormAnalysisHistory.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormAnalysisHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "Modify", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]");
			return ao_ExamFormAnalysisHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "Modify", "[ExamFormAnalysisHistoryID:" + ao_ExamFormAnalysisHistory.getExamFormAnalysisHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormAnalysisHistoryID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormAnalysisHistory GetByID(Session MyHSs, Integer ai_ExamFormAnalysisHistoryID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormAnalysisHistory theExamFormAnalysisHistory = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormAnalysisHistory> criteria = builder.createQuery(ExamFormAnalysisHistory.class);
		criteria.where(builder.equal(criteria.from(ExamFormAnalysisHistory.class).get("examFormAnalysisHistoryID"), ai_ExamFormAnalysisHistoryID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormAnalysisHistory = (ExamFormAnalysisHistory) query.getSingleResult();
			if (theExamFormAnalysisHistory != null) {
				return theExamFormAnalysisHistory;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormAnalysisHistoryID + "]");
				throw new DataNotFoundException("ExamFormAnalysisHistory [" + ai_ExamFormAnalysisHistoryID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormAnalysisHistoryID + "]");
			throw new DataNotFoundException("ExamFormAnalysisHistory [" + ai_ExamFormAnalysisHistoryID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFAH.* ");
		}
		sb_SQLCommand.append("FROM ExamFormAnalysisHistory EFAH ");
		sb_SQLCommand.append("WHERE EFAH.EFAH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormAnalysisHistory By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormAnalysisHistory> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormAnalysisHistory> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormAnalysisHistory.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormAnalysisHistory> ExamFormAnalysisHistoryList = query.list();
			if (ExamFormAnalysisHistoryList.isEmpty() != true) {
				return ExamFormAnalysisHistoryList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormAnalysisHistoryDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormAnalysisHistory By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

}