package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormCommand;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormCommandDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormCommand
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCommand Add(Session MyHSs,ExamFormCommand ao_ExamFormCommand, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCommand.getOwnerSUID(), ao_ExamFormCommand.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormCommand.setModifyTime(Common.GetCurrTime());
			ao_ExamFormCommand.setModifyUser(as_UserName);
			ao_ExamFormCommand.setCreateTime(Common.GetCurrTime());
			ao_ExamFormCommand.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormCommand);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Add", "[Ready][ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]");
			return ao_ExamFormCommand;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "Add", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCommand
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCommand Disable(Session MyHSs, ExamFormCommand ao_ExamFormCommand, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCommand.getOwnerSUID(), ao_ExamFormCommand.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormCommand.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormCommand.setDeletedUser(as_UserName);
			ao_ExamFormCommand.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormCommand);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Disable", "[Ready][ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]");
			return ao_ExamFormCommand;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "Disable", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCommand
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCommand Delete(Session MyHSs, ExamFormCommand ao_ExamFormCommand, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCommand.getOwnerSUID(), ao_ExamFormCommand.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormCommand);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Delete", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]");
			return ao_ExamFormCommand;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "Delete", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCommand
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCommand Modify(Session MyHSs, ExamFormCommand ao_ExamFormCommand, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCommand.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormCommand.setModifyTime(Common.GetCurrTime());
			ao_ExamFormCommand.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormCommand);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "Modify", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]");
			return ao_ExamFormCommand;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "Modify", "[ExamFormCommandID:" + ao_ExamFormCommand.getExamFormCommandID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormCommandID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormCommand GetByID(Session MyHSs, Integer ai_ExamFormCommandID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormCommand theExamFormCommand = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormCommand> criteria = builder.createQuery(ExamFormCommand.class);
		criteria.where(builder.equal(criteria.from(ExamFormCommand.class).get("examFormCommandID"), ai_ExamFormCommandID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormCommand = (ExamFormCommand) query.getSingleResult();
			if (theExamFormCommand != null) {
				return theExamFormCommand;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormCommandID + "]");
				throw new DataNotFoundException("ExamFormCommand [" + ai_ExamFormCommandID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormCommandID + "]");
			throw new DataNotFoundException("ExamFormCommand [" + ai_ExamFormCommandID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCommand EFC ");
		sb_SQLCommand.append("WHERE EFC.EFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormCommand By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormCommand> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormCommand> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCommand.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormCommand> ExamFormCommandList = query.list();
			if (ExamFormCommandList.isEmpty() != true) {
				return ExamFormCommandList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCommand By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	public static String GenSQLByExamFormID(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCommand EFC ");
		sb_SQLCommand.append("WHERE EFC.EFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFC.EFC_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFC.EFC_AboveItemOrder ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormCommand By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCommand> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormCommand> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCommand.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormCommand> ExamFormCommandList = query.list();
			if (ExamFormCommandList.isEmpty() != true) {
				return ExamFormCommandList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCommand By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDAboveItemOrder(int ai_CommandType,Integer ai_ExamFormID,Integer ai_AboveItemOrder, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCommand EFC ");
		sb_SQLCommand.append("WHERE EFC.EFC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFC.EFC_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_AboveItemOrder != null){
			sb_SQLCommand.append("AND EFC.EFC_AboveItemOrder = "+ai_AboveItemOrder+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDAboveItemOrder(Session MyHSs,Integer ai_ExamFormID,Integer ai_AboveItemOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeByExamFormIDAboveItemOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDAboveItemOrder(10,ai_ExamFormID,ai_AboveItemOrder,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeByExamFormIDAboveItemOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "GetSizeByExamFormIDAboveItemOrder", "[" + RowCount.intValue() + "] Of ExamFormCommand By ExamFormID ["+ai_ExamFormID+"] AboveItemOrder["+ai_AboveItemOrder+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCommand> FindByExamFormIDAboveItemOrder(Session MyHSs,Integer ai_ExamFormID,Integer ai_AboveItemOrder,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByExamFormIDAboveItemOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDAboveItemOrder(20,ai_ExamFormID,ai_AboveItemOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandDAO", "FindByExamFormIDAboveItemOrder", ls_SQLCommand);
			NativeQuery<ExamFormCommand> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCommand.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormCommand> ExamFormCommandList = query.list();
			if (ExamFormCommandList.isEmpty() != true) {
				return ExamFormCommandList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormCommandDAO", "FindByExamFormIDAboveItemOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCommand By ExamFormIDAboveItemOrder is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}