package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormCondition;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

public class ExamFormConditionDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCondition Add(Session MyHSs,ExamFormCondition ao_ExamFormCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCondition.getOwnerSUID(), ao_ExamFormCondition.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamFormCondition.setModifyUser(as_UserName);
			ao_ExamFormCondition.setCreateTime(Common.GetCurrTime());
			ao_ExamFormCondition.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamFormCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Add", "[Ready][ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]");
			return ao_ExamFormCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "Add", "[ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCondition Disable(Session MyHSs, ExamFormCondition ao_ExamFormCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCondition.getOwnerSUID(), ao_ExamFormCondition.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormCondition.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormCondition.setDeletedUser(as_UserName);
			ao_ExamFormCondition.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Disable", "[Ready][ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]");
			return ao_ExamFormCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "Disable", "[ID:" +ao_ExamFormCondition.getExamFormConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCondition
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCondition Delete(Session MyHSs, ExamFormCondition ao_ExamFormCondition, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCondition.getOwnerSUID(), ao_ExamFormCondition.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Delete", "[ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]");
			return ao_ExamFormCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "Delete", "[ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormCondition Modify(Session MyHSs, ExamFormCondition ao_ExamFormCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormCondition.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamFormCondition.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "Modify", "[ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]");
			return ao_ExamFormCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "Modify", "[ID:" + ao_ExamFormCondition.getExamFormConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormConditionID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormCondition GetByID(Session MyHSs, Integer ai_ExamFormConditionID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormCondition theExamFormCondition = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormCondition> criteria = builder.createQuery(ExamFormCondition.class);
		criteria.where(builder.equal(criteria.from(ExamFormCondition.class).get("examFormConditionID"), ai_ExamFormConditionID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormCondition = (ExamFormCondition) query.getSingleResult();
			if (theExamFormCondition != null) {
				return theExamFormCondition;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormConditionID + "]");
				throw new DataNotFoundException("ExamFormCondition [" + ai_ExamFormConditionID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormConditionID + "]");
			throw new DataNotFoundException("ExamFormCondition [" + ai_ExamFormConditionID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFCD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCondition EFCD ");
		sb_SQLCommand.append("WHERE EFCD.EFCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormCondition By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormCondition> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormCondition> ExamFormConditionList = query.list();
			if (ExamFormConditionList.isEmpty() != true) {
				return ExamFormConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCondition By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleDetailIDExamLevel(int ai_CommandType,Integer ai_ExamScheduleDetailID,Integer ai_ExamLevel, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFCD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCondition EFCD ");
		sb_SQLCommand.append("WHERE EFCD.EFCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamLevel = "+ai_ExamLevel+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDExamLevel(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ExamLevel,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamScheduleDetailIDExamLevel", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDExamLevel(10,ai_ExamScheduleDetailID,ai_ExamLevel,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamScheduleDetailIDExamLevel", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamScheduleDetailIDExamLevel", "[" + RowCount.intValue() + "] Of ExamFormCondition By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCondition> FindByExamScheduleDetailIDExamLevel(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ExamLevel,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamScheduleDetailIDExamLevel", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDExamLevel(20,ai_ExamScheduleDetailID,ai_ExamLevel,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamScheduleDetailIDExamLevel", ls_SQLCommand);
			NativeQuery<ExamFormCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormCondition> ExamFormConditionList = query.list();
			if (ExamFormConditionList.isEmpty() != true) {
				return ExamFormConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "FindByExamScheduleDetailID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCondition By FindByExamScheduleDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFCD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCondition EFCD ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EFCD.EFCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamLevel = "+ai_ExamLevel+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ES.ES_ExamYearID , ES.ES_ExamTermID  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus(10,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamFormCondition By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCondition> FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus(20,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamFormCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormCondition> ExamFormConditionList = query.list();
			if (ExamFormConditionList.isEmpty() != true) {
				return ExamFormConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCondition By FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatus ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,Integer ai_PersonID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFCD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCondition EFCD ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EFCD.EFCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamLevel = "+ai_ExamLevel+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND EFCD.ExamFormConditionID IN (SELECT ECCD.ECCD_ExamFormConditionID FROM ExamCreatorCondition ECCD WHERE ECCD.ECCD_PersonID = "+ai_PersonID+") ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ES.ES_ExamYearID , ES.ES_ExamTermID  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,Integer ai_PersonID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus(10,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ai_PersonID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamFormCondition By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCondition> FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,Integer ai_PersonID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus(20,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ai_PersonID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamFormCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormCondition> ExamFormConditionList = query.list();
			if (ExamFormConditionList.isEmpty() != true) {
				return ExamFormConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCondition By FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID, Integer ai_NOFExamItem, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFCD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormCondition EFCD ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EFCD.EFCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamLevel = "+ai_ExamLevel+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND EFCD.EFCD_ExamScheduleDetailID IN ( ");
				sb_SQLCommand.append("SELECT ESDIS.ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
				sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESDIS.PersonID = "+ai_PersonID+" ");
			sb_SQLCommand.append(" ) ");
		}
		if(ai_NOFExamItem != null){
			sb_SQLCommand.append("AND (EFCD.EFCD_NOFObjectiveRequire + EFCD.EFCD_NOFSubjectiveRequire) = "+ai_NOFExamItem+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ES.ES_ExamYearID , ES.ES_ExamTermID  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID,Integer ai_NOFExamItem,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem(10,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ae_ExaminationType,ae_ExaminationStatusList,ai_PersonID,ai_NOFExamItem,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "GetSizeByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem", "[" + RowCount.intValue() + "] Of ExamFormCondition By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormCondition> FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_ExamLevel,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID,Integer ai_NOFExamItem,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem(20,ai_ExamYearID,ai_ExamTermID,ai_ExamLevel,ae_ExaminationType,ae_ExaminationStatusList,ai_PersonID,ai_NOFExamItem,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelectorNOFExamItem", ls_SQLCommand);
			NativeQuery<ExamFormCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormCondition> ExamFormConditionList = query.list();
			if (ExamFormConditionList.isEmpty() != true) {
				return ExamFormConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormConditionDAO", "FindByExamYearIDExamTermIDExamLevelExaminationTypeExaminationStatusPersonIDInESDItemSelector", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormCondition By FindByExamYearIDExamTermIDExamLevelPersonIDExaminationTypeExaminationStatus ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
