package esi.examwh.dao;

import java.text.DecimalFormat;
import java.util.Formatter;
import java.util.List;
import java.util.Locale;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamSchedule;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.common.TYPE_ADD_ITEM;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAMFORM_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAM_ITEM_LOCK_STATUS;
import esi.examwh.service.runnumber.CodeGenerator;

public class ExamFormDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamForm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamForm Add(Session MyHSs,ExamForm ao_ExamForm, Integer ai_Year , String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamForm.getOwnerSUID(), ao_ExamForm.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamForm.setModifyTime(Common.GetCurrTime());
			ao_ExamForm.setModifyUser(as_UserName);
			ao_ExamForm.setCreateTime(Common.GetCurrTime());
			ao_ExamForm.setCreateUser(as_UserName);
			ExamScheduleDetail lo_ExamScheduleDetail = ao_ExamForm.getOExamScheduleDetail();
			
			if(lo_ExamScheduleDetail != null){
				ExamSchedule lo_ExamSchedule = lo_ExamScheduleDetail.getOCopiedExamSchedule();
//				Integer li_ExamSemesterID = lo_ExamSchedule.getOExamSemester().getExamSemesterID();
//				Integer li_ExamRoundID = lo_ExamSchedule.getOExamRound().getExamRoundID();
				String ls_SubjectCode =  lo_ExamScheduleDetail.getOSubject().getCode();
//				ExamTimes lo_ExamTimes = ExamTimesDAO.GetByID(MyHSs, li_ExamSemesterID, li_ExamRoundID, SUID, SGID);
//				Integer li_ExamTimes  = lo_ExamTimes.getExamTimes();
				Integer li_ExamTimes  = lo_ExamSchedule.getOExamTerm().getNumber();
				DecimalFormat myFormatter = new DecimalFormat("00000");
				StringBuilder SB = new StringBuilder();
				Formatter FM = new Formatter(SB, new Locale("en"));
				Integer YearDigit = 2;
				FM.format("%0" + YearDigit + "d",
						((ai_Year ) % (1 * (int) (Math.pow(10, YearDigit)))));
				if(ao_ExamForm.getExaminationType() == TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN){
//					String ls_Pre = "W"+FM.toString()+String.valueOf(li_ExamTimes)+myFormatter.format(Integer.parseInt(ls_SubjectCode) );
					String ls_Pre = "W"+FM.toString()+String.valueOf(li_ExamTimes)+ls_SubjectCode;
					String ls_GenCode = CodeGenerator.ExamFormNextCode(ai_Year, ls_Pre );
				//	String ls_Code = "W"+ SB .toString()+ls_GenCode.substring(1,10)+ls_GenCode.substring(12);
//					String ls_Code = "W"+ SB .toString()+ ls_GenCode;
					String ls_Code = ls_GenCode;
				//	ls_Code = "W"+ls_Code.substring(1);
					
					ao_ExamForm.setCode(ls_Code);
					CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Add", "Code = " + ls_Code);
				}else{
					String ls_Pre = "P"+FM.toString()+String.valueOf(li_ExamTimes)+ls_SubjectCode;
					String ls_GenCode = CodeGenerator.ExamFormNextCode(ai_Year, ls_Pre );
					//String ls_Code = "P"+ SB .toString()+ls_GenCode.substring(1,10)+ls_GenCode.substring(12);
//					String ls_Code = "P"+ SB .toString()+ ls_GenCode;
					String ls_Code = ls_GenCode;
					//ls_Code = "P"+ls_Code.substring(1);
					
					ao_ExamForm.setCode(ls_Code);
					CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Add", "Code = " + ls_Code);
				}
				
				
			}
			
			
			ObjectDAO.Add(MyHSs, ao_ExamForm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Add", "[Ready][ExamFormID:" + ao_ExamForm.getExamFormID()+"]");
			return ao_ExamForm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "Add", "[ExamFormID:" + ao_ExamForm.getExamFormID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	public static ExamForm AddWithoutCode(Session MyHSs,ExamForm ao_ExamForm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamYear.getOwnerSUID(), ao_ExamYear.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamForm.setModifyTime(Common.GetCurrTime());
			ao_ExamForm.setModifyUser(as_UserName);
			ao_ExamForm.setCreateTime(Common.GetCurrTime());
			ao_ExamForm.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamForm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Add", "[Ready][ID:" + ao_ExamForm.getExamFormID() + "]");
			return ao_ExamForm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "Add", "[ID:" + ao_ExamForm.getExamFormID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ao_ExamForm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamForm Disable(Session MyHSs, ExamForm ao_ExamForm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamForm.getOwnerSUID(), ao_ExamForm.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamForm.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamForm.setDeletedUser(as_UserName);
			ao_ExamForm.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamForm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Disable", "[Ready][ExamFormID:" + ao_ExamForm.getExamFormID()+"]");
			return ao_ExamForm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "Disable", "[ExamFormID:" + ao_ExamForm.getExamFormID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamForm
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamForm Delete(Session MyHSs, ExamForm ao_ExamForm, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamForm.getOwnerSUID(), ao_ExamForm.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamForm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Delete", "[ExamFormID:" + ao_ExamForm.getExamFormID()+"]");
			return ao_ExamForm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "Delete", "[ExamFormID:" + ao_ExamForm.getExamFormID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamForm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamForm Modify(Session MyHSs, ExamForm ao_ExamForm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamForm.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamForm.setModifyTime(Common.GetCurrTime());
			ao_ExamForm.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamForm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "Modify", "[ExamFormID:" + ao_ExamForm.getExamFormID()+"]");
			return ao_ExamForm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "Modify", "[ExamFormID:" + ao_ExamForm.getExamFormID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamForm GetByID(Session MyHSs, Integer ai_ExamFormID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamForm theExamForm = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamForm> criteria = builder.createQuery(ExamForm.class);
		criteria.where(builder.equal(criteria.from(ExamForm.class).get("examFormID"), ai_ExamFormID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamForm = (ExamForm) query.getSingleResult();
			if (theExamForm != null) {
				return theExamForm;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormID + "]");
				throw new DataNotFoundException("ExamForm [" + ai_ExamFormID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormID + "]");
			throw new DataNotFoundException("ExamForm [" + ai_ExamFormID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamForm By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamForm> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	
	public static String GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus(int ai_CommandType,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItemRequire, Integer ai_NOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound,Integer ai_LastUsedTerm , TYPE_EXAMINATION ae_ScheduleExaminationType,TYPE_EXAM_ITEM_LOCK_STATUS ae_LockStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
//		if(ai_LastUsedYear != null || ai_LastUsedSemester != null || ai_LastUsedRound != null ){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
			
//		}
		
		
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		} 
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		} 
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		} 
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+ "%' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ai_NOFItemChoice+" ");
		}		
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_FormStatus.getValue()+" ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_LastUsedRound+" ");
		}
		if(ai_LastUsedTerm  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_LastUsedTerm+" ");
		}
		if(ae_LockStatus  != null){
			
			if(ae_LockStatus == TYPE_EXAM_ITEM_LOCK_STATUS.STATUS_UNLOCK){
				sb_SQLCommand.append("AND ( EF.EF_LockStatus = "+ae_LockStatus.getValue()+" ");
				sb_SQLCommand.append("OR EF.EF_LockStatus IS NULL ");
				sb_SQLCommand.append(") ");
			}else{
				sb_SQLCommand.append("AND EF.EF_LockStatus = "+ae_LockStatus.getValue()+" ");
			}
		}
		if(ae_ScheduleExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ScheduleExaminationType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EF_ExaminationType asc,EF_Code desc");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound ,Integer ai_LastUsedTerm, TYPE_EXAMINATION ae_ScheduleExaminationType,TYPE_EXAM_ITEM_LOCK_STATUS ae_LockStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus(10,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound ,ai_LastUsedTerm,ae_ScheduleExaminationType,ae_LockStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", "[" + RowCount.intValue() + "] Of ExamForm By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound ,Integer ai_LastUsedTerm, TYPE_EXAMINATION ae_ScheduleExaminationType,TYPE_EXAM_ITEM_LOCK_STATUS ae_LockStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus(20,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound ,ai_LastUsedTerm,ae_ScheduleExaminationType,ae_LockStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeLockStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleDetailID(int ai_CommandType,Integer ai_ExamScheduleDetailID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID  != null){
			sb_SQLCommand.append("AND EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailID(10,ai_ExamScheduleDetailID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailID", "[" + RowCount.intValue() + "] Of ExamForm By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByExamScheduleDetailID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailID(20,ai_ExamScheduleDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By ExamScheduleDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(int ai_CommandType, Integer ai_SubjectID , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID, Integer SGID,int... StatusList) {
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		if(ai_ExamYearID != null || ai_ExamSemesterID != null || ai_ExamRoundID != null || ae_ExaminationType != null) {
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		}
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		}
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+"%' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ ai_NOFItemChoice+" ");
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ ae_FormStatus.getValue()+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ai_FilterExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID != "+ai_FilterExamScheduleID+" ");
			
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
	 
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(Session MyHSs,Integer ai_SubjectID , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus, Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(10,ai_SubjectID , as_FormCode, as_FormName, ai_NOFFormItemRequire , ai_NOFItemChoice , ae_ExamType, ae_ItemAddType , ae_FormStatus, ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID , ae_ExaminationType , ai_FilterExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDScheduleExaminationTypeNotInExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[" + RowCount.intValue() + "] Of ExamForm By SubjectID ["+ai_SubjectID+"] FormCode ["+as_FormCode+"] FormName ["+as_FormName+"] NOFFormItemRequire ["+ai_NOFFormItemRequire+"] NOFItemChoice ["+ai_NOFItemChoice+"] ExamType ["+ae_ExamType+"] ItemAddType ["+ae_ItemAddType+"] FormStatus ["+ae_FormStatus+"] ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"] ExamRoundID ["+ai_ExamRoundID+"] ExaminationType ["+ae_ExaminationType+"] NotInExamScheduleID ["+ai_FilterExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(Session MyHSs,Integer ai_SubjectID , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(20,ai_SubjectID , as_FormCode, as_FormName, ai_NOFFormItemRequire , ai_NOFItemChoice , ae_ExamType, ae_ItemAddType , ae_FormStatus,ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID, ae_ExaminationType , ai_FilterExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType(int ai_CommandType, String as_SubjectCode , String as_SubjectName , String as_FormCode , String as_FormName, Integer ai_NOFFormItemRequire, Integer ai_NOFItemChoice , TYPE_ADD_ITEM ae_ItemAddType , TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) {
		
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		if(ai_ExamYearID != null || ai_ExamSemesterID != null || ai_ExamRoundID != null || ae_ExaminationType != null){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		}
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		}
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+"%' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ ai_NOFItemChoice+" ");
		}
		
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ ae_FormStatus.getValue()+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType(Session MyHSs,String as_SubjectCode , String as_SubjectName , String as_FormCode , String as_FormName, Integer ai_NOFFormItemRequire, Integer ai_NOFItemChoice , TYPE_ADD_ITEM ae_ItemAddType , TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType(10,as_SubjectCode , as_SubjectName , as_FormCode ,  as_FormName,  ai_NOFFormItemRequire, ai_NOFItemChoice , ae_ItemAddType , ae_FormStatus, ai_ExamYearID,  ai_ExamSemesterID , ai_ExamRoundID , ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+as_SubjectCode+"] , SubjectName ["+ as_SubjectName +"] , FormCode [ "+as_FormCode+"] , FormName [ "+ as_FormName+"], NOFFormItemRequire["+ai_NOFFormItemRequire+"] , NOFItemChoice ["+ai_NOFItemChoice+"] , ItemAddType ["+ ae_ItemAddType+"] , FormStatus["+ ae_FormStatus+"] ,ExamYearID [ "+ai_ExamYearID+"],ExamSemesterID["+  ai_ExamSemesterID +"] ,ExamRoundID ["+ ai_ExamRoundID+"] ,ExaminationType ["+ ae_ExaminationType+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType(Session MyHSs,String as_SubjectCode , String as_SubjectName , String as_FormCode , String as_FormName, Integer ai_NOFFormItemRequire, Integer ai_NOFItemChoice , TYPE_ADD_ITEM ae_ItemAddType , TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType(20,as_SubjectCode , as_SubjectName , as_FormCode ,  as_FormName,  ai_NOFFormItemRequire, ai_NOFItemChoice , ae_ItemAddType , ae_FormStatus, ai_ExamYearID,  ai_ExamSemesterID , ai_ExamRoundID , ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByFormCodeFormName(int ai_CommandType, String as_FormCode , String as_FormName,Integer SUID, Integer SGID,int... StatusList) {
		
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		}
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+"%' ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByFormCodeFormName(Session MyHSs, String as_FormCode , String as_FormName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByFormCodeFormName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByFormCodeFormName(10, as_FormCode ,  as_FormName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByFormCodeFormName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByFormCodeFormName", "[" + RowCount.intValue() + "] Of ExamForm By  FormCode [ "+as_FormCode+"] , FormName [ "+ as_FormName+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByFormCodeFormName(Session MyHSs, String as_FormCode , String as_FormName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByFormCodeFormName(20, as_FormCode ,  as_FormName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByFormCodeFormName", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByFormCodeFormName", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundLastUsedTermScheduleExaminationTypeFilterListFormStatus(int ai_CommandType,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItemRequire,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_NOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound ,Integer ai_LastUsedTerm, TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		if(ai_LastUsedYear != null || ai_LastUsedSemester != null || ai_LastUsedRound != null || ai_LastUsedTerm != null){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
			
		}
		
		
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		} 
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name = '%"+as_SubjectName+"%' ");
		} 
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+ "%' ");
		}
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+ "' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFObjectiveItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFObjectiveItemRequire = "+ai_NOFObjectiveItemRequire+" ");
		}
		if(ai_NOFSubjectiveItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFSubjectiveItemRequire = "+ai_NOFSubjectiveItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ai_NOFItemChoice+" ");
		}		
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_FormStatus.getValue()+" ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_LastUsedRound+" ");
		}
		if(ai_LastUsedTerm  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_LastUsedTerm+" ");
		}
		if(ae_ScheduleExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ScheduleExaminationType.getValue()+" ");
		}
		if(ae_ListFilterFormStatus != null){
			if(ae_ListFilterFormStatus.size() == 1){
				sb_SQLCommand.append("AND EF.EF_FormStatus != "+ae_ListFilterFormStatus.get(0).getValue()+" ");
			}else if(ae_ListFilterFormStatus.size() > 1){
				sb_SQLCommand.append("AND EF.EF_FormStatus NOT IN ( "+ae_ListFilterFormStatus.get(0).getValue()+" ");
				for(int i = 1;i < ae_ListFilterFormStatus.size();i++){
					sb_SQLCommand.append(" , ");
					sb_SQLCommand.append(ae_ListFilterFormStatus.get(i).getValue());
				
				}
				sb_SQLCommand.append(" ) ");
			}else{}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code , EF.EF_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundLastUsedTermScheduleExaminationTypeFilterListFormStatus(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound ,Integer ai_LastUsedTerm, TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeFilterListFormStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundLastUsedTermScheduleExaminationTypeFilterListFormStatus(10,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem,ai_NOFObjectiveItemRequire,ai_NOFSubjectiveItemRequire, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound ,ai_LastUsedTerm,ae_ScheduleExaminationType,ae_ListFilterFormStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeFilterListFormStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeFilterListFormStatus", "[" + RowCount.intValue() + "] Of ExamForm By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundLastUsedTermScheduleExaminationTypeFilterListFormStatus(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound ,Integer ai_LastUsedTerm, TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamFormBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundLastUsedTermScheduleExaminationTypeFilterListFormStatus(20,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem,ai_NOFObjectiveItemRequire,ai_NOFSubjectiveItemRequire, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound,ai_LastUsedTerm ,ae_ScheduleExaminationType,ae_ListFilterFormStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamFormBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationType", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeFilterListFormStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeFilterListFormStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus(int ai_CommandType,Integer ai_PersonID,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItemRequire,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_NOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound, Integer ai_LastUsedTerm , TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		if(ai_PersonID != null){
			sb_SQLCommand.append("JOIN ESDFormCollator ESDFC ON ESDFC.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		}
		if(ai_LastUsedYear != null || ai_LastUsedSemester != null || ai_LastUsedRound != null ){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
			
		}
		
		
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_PersonID+" ");
			sb_SQLCommand.append("AND ( ((ESDFC.ESDFC_Draft1CollatorFlag * 5) = EF.EF_FormStatus /2 AND EF.EF_FormStatus /2 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft2CollatorFlag * 5) = EF.EF_FormStatus /3 AND EF.EF_FormStatus /3 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft3CollatorFlag * 5) = EF.EF_FormStatus /4 AND EF.EF_FormStatus /4 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft4CollatorFlag * 5) = EF.EF_FormStatus /5 AND EF.EF_FormStatus /5 = 100) ");
			sb_SQLCommand.append(" ) ");
		} 
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		} 
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name = '%"+as_SubjectName+"%' ");
		} 
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+ "%' ");
		}
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+ "' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFObjectiveItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFObjectiveItemRequire = "+ai_NOFObjectiveItemRequire+" ");
		}
		if(ai_NOFSubjectiveItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFSubjectiveItemRequire = "+ai_NOFSubjectiveItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ai_NOFItemChoice+" ");
		}		
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_FormStatus.getValue()+" ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_LastUsedRound+" ");
		}
		if(ai_LastUsedTerm  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_LastUsedTerm+" ");
		}
		if(ae_ScheduleExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ScheduleExaminationType.getValue()+" ");
		}
		if(ae_ListFilterFormStatus != null){
			if(ae_ListFilterFormStatus.size() == 1){
				sb_SQLCommand.append("AND EF.EF_FormStatus != "+ae_ListFilterFormStatus.get(0).getValue()+" ");
			}else if(ae_ListFilterFormStatus.size() > 1){
				sb_SQLCommand.append("AND EF.EF_FormStatus NOT IN ( "+ae_ListFilterFormStatus.get(0).getValue()+" ");
				for(int i = 1;i < ae_ListFilterFormStatus.size();i++){
					sb_SQLCommand.append(" , ");
					sb_SQLCommand.append(ae_ListFilterFormStatus.get(i).getValue());
				
				}
				sb_SQLCommand.append(" ) ");
			}else{}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EF_ModifyTime desc, SJ.SJ_Code , EF.EF_Code , EF.EF_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus(Session MyHSs,Integer ai_PersonID,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound, Integer ai_LastUsedTerm , TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus(10,ai_PersonID,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem,ai_NOFObjectiveItemRequire,ai_NOFSubjectiveItemRequire, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound,ai_LastUsedTerm ,ae_ScheduleExaminationType,ae_ListFilterFormStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", "[" + RowCount.intValue() + "] Of ExamForm By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus(Session MyHSs,Integer ai_PersonID,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem,Integer ai_NOFObjectiveItemRequire,Integer ai_NOFSubjectiveItemRequire, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound, Integer ai_LastUsedTerm , TYPE_EXAMINATION ae_ScheduleExaminationType,List<TYPE_EXAMFORM_STATUS> ae_ListFilterFormStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus(20,ai_PersonID,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem,ai_NOFObjectiveItemRequire,ai_NOFSubjectiveItemRequire, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound,ai_LastUsedTerm ,ae_ScheduleExaminationType,ae_ListFilterFormStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By FindByPersonIDSubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearIDLastUsedSemeterIDLastUsedRoundIDUsedTermIDScheduleExaminationTypeFilterListFormStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(int ai_CommandType, String as_SubjectCode , String as_SubjectName ,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType, String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) {
		
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		if(ai_ExamYearID != null || ai_ExamSemesterID != null || ai_ExamRoundID != null || ae_ExaminationType != null){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		}
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		
		
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(as_ExamFormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_ExamFormName+"%' ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType, String as_ExamFormName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(10,as_SubjectCode ,  as_SubjectName , ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID , ae_ExaminationType, as_ExamFormName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+as_SubjectCode+"] , SubjectName ["+ as_SubjectName +"] ,ExamYearID [ "+ai_ExamYearID+"],ExamSemesterID["+  ai_ExamSemesterID +"] ,ExamRoundID ["+ ai_ExamRoundID+"] ,ExaminationType ["+ ae_ExaminationType+"] ExamFormName [ "+ as_ExamFormName+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType, String as_ExamFormName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(20,as_SubjectCode ,  as_SubjectName , ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID , ae_ExaminationType, as_ExamFormName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID(int ai_CommandType,Integer ai_PersonCollatorID,Integer ai_PersonEditorID,String as_SubjectCode,String as_SubjectName,String as_ExamFormCode,String as_ExamFormName,TYPE_EXAMFORM_STATUS ae_FormStatus,TYPE_EXAMINATION ae_ExaminationType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		if(ai_PersonCollatorID != null){
			sb_SQLCommand.append("JOIN ESDFormCollator ESDFC ON ESDFC.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		}
		if(ai_PersonEditorID != null){
			sb_SQLCommand.append("JOIN ESDFormEditor ESDFE ON ESDFE.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		}
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_PersonCollatorID != null){
			sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_PersonCollatorID+" ");
			sb_SQLCommand.append("AND ( ((ESDFC.ESDFC_Draft1CollatorFlag * 5) = EF.EF_FormStatus /2 AND EF.EF_FormStatus /2 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft2CollatorFlag * 5) = EF.EF_FormStatus /3 AND EF.EF_FormStatus /3 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft3CollatorFlag * 5) = EF.EF_FormStatus /4 AND EF.EF_FormStatus /4 = 100) ");
			sb_SQLCommand.append("OR ((ESDFC.ESDFC_Draft4CollatorFlag * 5) = EF.EF_FormStatus /5 AND EF.EF_FormStatus /5 = 100) ");
			sb_SQLCommand.append(" ) ");
		} 
		if(ai_PersonEditorID != null){
			sb_SQLCommand.append("AND ESDFE.PersonID = "+ai_PersonEditorID+" ");
			sb_SQLCommand.append("AND ( EF.EF_FormStatus =  100 ) ");
		} 
		if(as_SubjectCode  != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName  != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		
		if(as_ExamFormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_ExamFormCode+"' ");
		}
		if(as_ExamFormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_ExamFormName+"%' ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_FormStatus.getValue()+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND ES.ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID(Session MyHSs,Integer ai_PersonCollatorID,Integer ai_PersonEditorID,String as_SubjectCode,String as_SubjectName,String as_ExamFormCode,String as_ExamFormName,TYPE_EXAMFORM_STATUS ae_FormStatus,TYPE_EXAMINATION ae_ExaminationType,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID(10,ai_PersonCollatorID,ai_PersonEditorID,as_SubjectCode,as_SubjectName, as_ExamFormCode,as_ExamFormName, ae_FormStatus, ae_ExaminationType,ai_ExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode = "+as_SubjectCode+", SubjectName = "+as_SubjectName+",ExamFormCode = "+as_ExamFormCode+",ExamFormName = "+as_ExamFormName+",FormStatus = "+ae_FormStatus+",ExaminationType = "+ae_ExaminationType+",ExamScheduleID = "+ai_ExamScheduleID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID(Session MyHSs,Integer ai_PersonCollatorID,Integer ai_PersonEditorID,String as_SubjectCode,String as_SubjectName,String as_ExamFormCode,String as_ExamFormName,TYPE_EXAMFORM_STATUS ae_FormStatus,TYPE_EXAMINATION ae_ExaminationType,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID(20,ai_PersonCollatorID,ai_PersonEditorID,as_SubjectCode,as_SubjectName, as_ExamFormCode,as_ExamFormName, ae_FormStatus, ae_ExaminationType,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameESDFormCollatorNameESDFormCollatorLastNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByPersonCollatorIDPersonEditorIDSubjectCodeSubjectNameExamFormCodeExamFormNameFormStatusExaminationTypeExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCode SubjectName ESDFormCollatorName ESDFormCollatorLastName ExamFormCode ExamFormName FormStatus ExaminationType ExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
public static String GenSQLBySubjectCodeSubjectNameExamScheduleID(int ai_CommandType, String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) {
		
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND ES.ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamScheduleID(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamScheduleID(10,as_SubjectCode ,  as_SubjectName ,ai_ExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleID", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+as_SubjectCode+"] , SubjectName ["+ as_SubjectName +"] ,ExamSchedulID [ "+ai_ExamScheduleID+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameExamScheduleID(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamScheduleID(20,as_SubjectCode ,  as_SubjectName , ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameExamScheduleIDFormStatus(int ai_CommandType, String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus,Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND ES.ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ae_FormStatus != null && ae_FormStatus.size() > 0){
			sb_SQLCommand.append("AND EF_FormStatus IN ( ");
			sb_SQLCommand.append(ae_FormStatus.get(0).getValue());
			for (int i = 1; i < ae_FormStatus.size(); i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(ae_FormStatus.get(i).getValue());
			}
			sb_SQLCommand.append(") ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamScheduleIDFormStatus(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleIDFormStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamScheduleIDFormStatus(10,as_SubjectCode ,  as_SubjectName ,ai_ExamScheduleID,ae_FormStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleIDFormStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleIDFormStatus", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+as_SubjectCode+"] , SubjectName ["+ as_SubjectName +"] ,ExamSchedulID [ "+ai_ExamScheduleID+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameExamScheduleIDFormStatus(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDFormStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamScheduleIDFormStatus(20,as_SubjectCode ,  as_SubjectName , ai_ExamScheduleID,ae_FormStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDFormStatus", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDFormStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By FindBySubjectCodeSubjectNameExamScheduleIDFormStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameExamScheduleIDAnalysisType(int ai_CommandType, String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer ai_AnalysisType,List<TYPE_EXAMFORM_STATUS> ae_TYPE_EXAMFORM_STATUS,Integer SUID, Integer SGID,int... StatusList) {
		
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ae_TYPE_EXAMFORM_STATUS != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus IN ( ");
			sb_SQLCommand.append(ae_TYPE_EXAMFORM_STATUS.get(0).getValue());
			for(int i=1;i<ae_TYPE_EXAMFORM_STATUS.size();i++){
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(ae_TYPE_EXAMFORM_STATUS.get(i).getValue());
			}
			sb_SQLCommand.append(") ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		
		
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND ES.ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		if(ai_AnalysisType != null){
			if(ai_AnalysisType == 10){
				sb_SQLCommand.append("AND 0 < ");
			}else if(ai_AnalysisType == 20){
				sb_SQLCommand.append("AND 1 > ");
			}
			sb_SQLCommand.append("(SELECT COUNT(*) FROM ExamAnalysis EA WHERE EA.EA_ExamFormID = EF.ExamFormID and  EA.EA_ExamScheduleID = "+ai_ExamScheduleID+" and EA.EA_DataStatus NOT IN ( 411,511)) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameExamScheduleIDAnalysisType(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer ai_AnalysisType,List<TYPE_EXAMFORM_STATUS> ae_TYPE_EXAMFORM_STATUS,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleIDAnalysisType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameExamScheduleIDAnalysisType(10,as_SubjectCode ,  as_SubjectName ,ai_ExamScheduleID,ai_AnalysisType,ae_TYPE_EXAMFORM_STATUS,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameExamScheduleIDAnalysisType", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+as_SubjectCode+"] , SubjectName ["+ as_SubjectName +"] ,ExamSchedulID [ "+ai_ExamScheduleID+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameExamScheduleIDAnalysisType(Session MyHSs,String as_SubjectCode , String as_SubjectName ,Integer ai_ExamScheduleID,Integer ai_AnalysisType,List<TYPE_EXAMFORM_STATUS> ae_TYPE_EXAMFORM_STATUS,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDAnalysisType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameExamScheduleIDAnalysisType(20,as_SubjectCode ,  as_SubjectName , ai_ExamScheduleID,ai_AnalysisType,ae_TYPE_EXAMFORM_STATUS,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDAnalysisType", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameExamScheduleIDAnalysisType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameExamScheduleIDAnalysisType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID(int ai_CommandType,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ESDFormEditor ESDFE ON ESDFE.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_PersonID  != null){
			sb_SQLCommand.append("AND ESDFE.PersonID = "+ai_PersonID+" ");
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID(10,ai_PersonID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", "[" + RowCount.intValue() + "] Of ExamForm By [PersonID : "+ai_PersonID+",ExamYearID : "+ai_ExamYearID+",ExamSemesterID : "+ai_ExamSemesterID+",ExamRoundID : "+ai_ExamRoundID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID(20,ai_PersonID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByESDFormEditorIDExamYearIDExamSemesterIDExamRoundID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By ESDFormEditorIDExamYearIDExamSemesterIDExamRoundID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID(int ai_CommandType,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ESDFormCollator ESDFC ON ESDFC.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_PersonID  != null){
			sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_PersonID+" ");
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID(10,ai_PersonID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", "[" + RowCount.intValue() + "] Of ExamForm By [PersonID : "+ai_PersonID+",ExamYearID : "+ai_ExamYearID+",ExamSemesterID : "+ai_ExamSemesterID+",ExamRoundID : "+ai_ExamRoundID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_PersonID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID(20,ai_PersonID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By ESDFormCollatorIDExamYearIDExamSemesterIDExamRoundID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleDetailIDItemAddType(int ai_CommandType,Integer ai_ExamScheduleDetailID,Integer ai_ItemAddType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID  != null){
			sb_SQLCommand.append("AND EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ai_ItemAddType+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_ModifyTime DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDItemAddType(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ItemAddType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDItemAddType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDItemAddType(10,ai_ExamScheduleDetailID,ai_ItemAddType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDItemAddType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDItemAddType", "[" + RowCount.intValue() + "] Of ExamForm By [ExamScheduleDetailID : "+ai_ExamScheduleDetailID+",ItemAddType : "+ai_ItemAddType+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByExamScheduleDetailIDItemAddType(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ItemAddType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailIDItemAddType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDItemAddType(20,ai_ExamScheduleDetailID,ai_ItemAddType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailIDItemAddType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By ExamScheduleDetailIDItemAddType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor(int ai_CommandType,Integer ai_SubjectID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ESDFormEditor ESDFE ON ESDFE.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_SubjectID  != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor(10,ai_SubjectID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", "[" + RowCount.intValue() + "] Of ExamForm By [SubjectID : "+ai_SubjectID+",ExamYearID : "+ai_ExamYearID+",ExamSemesterID : "+ai_ExamSemesterID+",ExamRoundID : "+ai_ExamRoundID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor(20,ai_SubjectID,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectIDExamYearIDExamSemesterIDExamRoundIDHaveESDFormEditor is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly(int ai_CommandType,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItemRequire, Integer ai_NOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound , TYPE_EXAMINATION ae_ScheduleExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		if(ai_LastUsedYear != null || ai_LastUsedSemester != null || ai_LastUsedRound != null ){
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
			
		}
		
		
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		} 
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		} 
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		} 
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+ "%' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ai_NOFItemChoice+" ");
		}		
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_FormStatus.getValue()+" ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_LastUsedRound+" ");
		}
		
		if(ae_ScheduleExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ScheduleExaminationType.getValue()+" ");
		}
		/////////////////////////////////////
		sb_SQLCommand.append(" AND (SELECT COUNT(*) ");
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND EFI.EFI_ExamFormID = EF.ExamFormID " );
		sb_SQLCommand.append("AND EFI.EFI_ExamType = "+TYPE_EXAM.TYPE_OBJECTIVE.getValue()+" ");
		sb_SQLCommand.append(" ) > 0 ");
		//////////////////////////////////////
		sb_SQLCommand.append(" AND EF.EF_NOFObjectiveItemRequire > 0 ");
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , EF.EF_Code , EF.EF_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound , TYPE_EXAMINATION ae_ScheduleExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly(10,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound ,ae_ScheduleExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly", "[" + RowCount.intValue() + "] Of ExamForm By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly(Session MyHSs,String as_SubjectCode, String as_SubjectName, String as_FormCode ,String as_FormName, Integer ai_NOFFormItem, Integer ai_RequireNOFItemChoice,TYPE_EXAMINATION ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType,TYPE_EXAMFORM_STATUS ae_FormStatus ,Integer ai_LastUsedYear,Integer ai_LastUsedSemester , Integer ai_LastUsedRound , TYPE_EXAMINATION ae_ScheduleExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly(20,as_SubjectCode, as_SubjectName, as_FormCode , as_FormName, ai_NOFFormItem, ai_RequireNOFItemChoice,ae_ExamType,ae_ItemAddType,ae_FormStatus ,ai_LastUsedYear,ai_LastUsedSemester , ai_LastUsedRound ,ae_ScheduleExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationTypeNotSubjectiveOnly", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By SubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusLastUsedYearLastUsedSemeterLastUsedRoundScheduleExaminationType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleDetailIDFormStatus(int ai_CommandType,Integer ai_ExamScheduleDetailID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ae_FormStatus != null && ae_FormStatus.size() > 0){
			sb_SQLCommand.append("AND EF.EF_FormStatus IN ( ");
			sb_SQLCommand.append(ae_FormStatus.get(0).getValue());
			if (ae_FormStatus.size() > 1) {
				for (int i = 1; i < ae_FormStatus.size(); i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(ae_FormStatus.get(i).getValue());
				}
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleDetailID  != null){
			sb_SQLCommand.append("AND EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDFormStatus(Session MyHSs,Integer ai_ExamScheduleDetailID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDFormStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDFormStatus(10,ai_ExamScheduleDetailID,ae_FormStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDFormStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeByExamScheduleDetailIDFormStatus", "[" + RowCount.intValue() + "] Of ExamForm By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindByExamScheduleDetailIDFormStatus(Session MyHSs,Integer ai_ExamScheduleDetailID,List<TYPE_EXAMFORM_STATUS> ae_FormStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailIDFormStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDFormStatus(20,ai_ExamScheduleDetailID,ae_FormStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailIDFormStatus", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindByExamScheduleDetailIDFormStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By FindByExamScheduleDetailIDFormStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(int ai_CommandType, String ai_SubjectCode, String ai_SubjectName , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID, Integer SGID,int... StatusList) {
		
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EF.* ");
		}
		sb_SQLCommand.append("FROM ExamForm EF ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		if(ai_ExamYearID != null || ai_ExamSemesterID != null || ai_ExamRoundID != null || ae_ExaminationType != null) {
			sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		}
		sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
//		if(ai_SubjectID != null){
//			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
//		}
		if(ai_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+ai_SubjectCode+"' ");
		}
		if(ai_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+ai_SubjectName+"%' ");
		}
		if(as_FormCode != null){
			sb_SQLCommand.append("AND EF.EF_Code = '"+as_FormCode+"' ");
		}
		if(as_FormName != null){
			sb_SQLCommand.append("AND EF.EF_Name LIKE '%"+as_FormName+"%' ");
		}
		if(ai_NOFFormItemRequire != null){
			sb_SQLCommand.append("AND EF.EF_NOFFormItemRequire = "+ai_NOFFormItemRequire+" ");
		}
		if(ai_NOFItemChoice != null){
			sb_SQLCommand.append("AND EF.EF_NOFItemChoice = "+ ai_NOFItemChoice+" ");
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EF.EF_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ae_ItemAddType != null){
			sb_SQLCommand.append("AND EF.EF_ItemAddType = "+ ae_ItemAddType.getValue()+" ");
		}
		if(ae_FormStatus != null){
			sb_SQLCommand.append("AND EF.EF_FormStatus = "+ ae_FormStatus.getValue()+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND EF.EF_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ai_FilterExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID != "+ai_FilterExamScheduleID+" ");
			
		}
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
	 
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(Session MyHSs, String ai_SubjectCode, String ai_SubjectName , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus, Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(10,ai_SubjectCode, ai_SubjectName, as_FormCode, as_FormName, ai_NOFFormItemRequire , ai_NOFItemChoice , ae_ExamType, ae_ItemAddType , ae_FormStatus, ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID , ae_ExaminationType , ai_FilterExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "GetSizeBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[" + RowCount.intValue() + "] Of ExamForm By SubjectCode ["+ai_SubjectCode+"] FormCode ["+as_FormCode+"] FormName ["+as_FormName+"] NOFFormItemRequire ["+ai_NOFFormItemRequire+"] NOFItemChoice ["+ai_NOFItemChoice+"] ExamType ["+ae_ExamType+"] ItemAddType ["+ae_ItemAddType+"] FormStatus ["+ae_FormStatus+"] ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"] ExamRoundID ["+ai_ExamRoundID+"] ExaminationType ["+ae_ExaminationType+"] NotInExamScheduleID ["+ai_FilterExamScheduleID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamForm> FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(Session MyHSs, String ai_SubjectCode, String ai_SubjectName , String as_FormCode,String as_FormName, Integer ai_NOFFormItemRequire ,Integer ai_NOFItemChoice ,TYPE_EXAM ae_ExamType,TYPE_ADD_ITEM ae_ItemAddType ,TYPE_EXAMFORM_STATUS ae_FormStatus,Integer ai_ExamYearID, Integer ai_ExamSemesterID , Integer ai_ExamRoundID ,TYPE_EXAMINATION ae_ExaminationType ,Integer ai_FilterExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID(20,ai_SubjectCode, ai_SubjectName , as_FormCode, as_FormName, ai_NOFFormItemRequire , ai_NOFItemChoice , ae_ExamType, ae_ItemAddType , ae_FormStatus,ai_ExamYearID,  ai_ExamSemesterID ,  ai_ExamRoundID, ae_ExaminationType , ai_FilterExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", ls_SQLCommand);
			NativeQuery<ExamForm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamForm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamForm> ExamFormList = query.list();
			if (ExamFormList.isEmpty() != true) {
				return ExamFormList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDAO", "FindBySubjectCodeSubjectNameFormCodeFormNameNOFFormItemRequireNOFItemChoiceExamTypeItemAddTypeFormStatusExamYearIDExamSemesterIDExamRoundIDExaminationTypeNotInExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamForm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}