package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormDocument;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormDocumentDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormDocument Add(Session MyHSs,ExamFormDocument ao_ExamFormDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormDocument.getOwnerSUID(), ao_ExamFormDocument.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamFormDocument.setModifyUser(as_UserName);
			ao_ExamFormDocument.setCreateTime(Common.GetCurrTime());
			ao_ExamFormDocument.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Add", "[Ready][ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]");
			return ao_ExamFormDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "Add", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormDocument Disable(Session MyHSs, ExamFormDocument ao_ExamFormDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormDocument.getOwnerSUID(), ao_ExamFormDocument.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormDocument.setDeletedUser(as_UserName);
			ao_ExamFormDocument.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Disable", "[Ready][ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]");
			return ao_ExamFormDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "Disable", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormDocument
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormDocument Delete(Session MyHSs, ExamFormDocument ao_ExamFormDocument, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormDocument.getOwnerSUID(), ao_ExamFormDocument.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Delete", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]");
			return ao_ExamFormDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "Delete", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormDocument Modify(Session MyHSs, ExamFormDocument ao_ExamFormDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormDocument.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamFormDocument.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "Modify", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]");
			return ao_ExamFormDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "Modify", "[ExamFormDocumentID:" + ao_ExamFormDocument.getExamFormDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormDocumentID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormDocument GetByID(Session MyHSs, Integer ai_ExamFormDocumentID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormDocument theExamFormDocument = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormDocument> criteria = builder.createQuery(ExamFormDocument.class);
		criteria.where(builder.equal(criteria.from(ExamFormDocument.class).get("examFormDocumentID"), ai_ExamFormDocumentID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormDocument = (ExamFormDocument) query.getSingleResult();
			if (theExamFormDocument != null) {
				return theExamFormDocument;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormDocumentID + "]");
				throw new DataNotFoundException("ExamFormDocument [" + ai_ExamFormDocumentID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormDocumentID + "]");
			throw new DataNotFoundException("ExamFormDocument [" + ai_ExamFormDocumentID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormDocument By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormDocument> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	public static String GenSQLByExamFormID(int ai_CommandType, Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFD.EFD_Order , EFD.EFD_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamFormDocument By ExamFormID = "+ai_ExamFormID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDExamFormItemID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_ExamFormItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_ExamFormItemID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormItemID = "+ai_ExamFormItemID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFD.EFD_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamFormItemID(Session MyHSs,Integer ai_ExamFormID,Integer ai_ExamFormItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamFormItemID(10,ai_ExamFormID, ai_ExamFormItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemID", "[" + RowCount.intValue() + "] Of ExamFormDocument By ExamFormID = "+ai_ExamFormID+", ExamFormItemID = "+ai_ExamFormItemID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindByExamFormIDExamFormItemID(Session MyHSs,Integer ai_ExamFormID,Integer ai_ExamFormItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamFormItemID(20,ai_ExamFormID,ai_ExamFormItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemID", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By ExamFormID ExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDExamFormItemGroupID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_ExamFormItemGroupID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_ExamFormItemGroupID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormItemGroupID = "+ai_ExamFormItemGroupID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFD.EFD_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamFormItemGroupID(Session MyHSs,Integer ai_ExamFormID,Integer ai_ExamFormItemGroupID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamFormItemGroupID(10,ai_ExamFormID, ai_ExamFormItemGroupID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDExamFormItemGroupID", "[" + RowCount.intValue() + "] Of ExamFormDocument By ExamFormID = "+ai_ExamFormID+", ExamFormItemGroupID = "+ai_ExamFormItemGroupID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindByExamFormIDExamFormItemGroupID(Session MyHSs,Integer ai_ExamFormID,Integer ai_ExamFormItemGroupID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamFormItemGroupID(20,ai_ExamFormID,ai_ExamFormItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemGroupID", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDExamFormItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By ExamFormID ExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCopiedExamItemDocumentID(int ai_CommandType, Integer ai_CopiedExamItemDocumentID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamItemDocumentID != null){
			sb_SQLCommand.append("AND EFD.EFD_CopiedExamItemDocumentID = "+ai_CopiedExamItemDocumentID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFD.EFD_Order , EFD.EFD_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamItemDocumentID(Session MyHSs,Integer ai_CopiedExamItemDocumentID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByCopiedExamItemDocumentID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamItemDocumentID(10,ai_CopiedExamItemDocumentID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByCopiedExamItemDocumentID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByCopiedExamItemDocumentID", "[" + RowCount.intValue() + "] Of ExamFormDocument By CopiedExamItemDocumentID = "+ai_CopiedExamItemDocumentID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindByCopiedExamItemDocumentID(Session MyHSs,Integer ai_CopiedExamItemDocumentID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByCopiedExamItemDocumentID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamItemDocumentID(20,ai_CopiedExamItemDocumentID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByCopiedExamItemDocumentID", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByCopiedExamItemDocumentID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By CopiedExamItemDocumentID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDInCopiedExamItemDocument(int ai_CommandType, Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("JOIN ExamItemDocument EID ON EID.ExamItemDocumentID = EFD.EFD_CopiedExamItemDocumentID ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormID = "+ai_ExamFormID+" ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDInCopiedExamItemDocument(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDInCopiedExamItemDocument", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDInCopiedExamItemDocument(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDInCopiedExamItemDocument", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeByExamFormIDInCopiedExamItemDocument", "[" + RowCount.intValue() + "] Of ExamFormDocument By ExamFormIDInCopiedExamItemDocument [ExamFormID = "+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindByExamFormIDInCopiedExamItemDocument(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDInCopiedExamItemDocument", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDInCopiedExamItemDocument(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDInCopiedExamItemDocument", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindByExamFormIDInCopiedExamItemDocument", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By ExamFormIDInCopiedExamItemDocument is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static Integer GetMaxOrderByExamFormID(Session MyHSs,Integer ai_ExamFormID, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSumExamScoreByExamFormID", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT Max(ISNull(EFD.EFD_Order,0)) MaxOrder From ExamFormDocument EFD ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFD.EFD_ExamFormID = "+ai_ExamFormID+" ");
		}
		
		NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormDocument.class);
		Object amount =  query.uniqueResult(); 
	    return (Integer)amount;   	
	}
	
	public static String GenSQLBySubjectDocumentID(int ai_CommandType, Integer ai_SubjectDocumentID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFD.* ");
		}
		sb_SQLCommand.append("FROM ExamFormDocument EFD ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EFD.EFD_ExamFormID ");
		sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_SubjectDocumentID != null){
			sb_SQLCommand.append("AND ( " );
				sb_SQLCommand.append(" EFD.EFD_CopiedExamItemDocumentID  IN ( ");
						sb_SQLCommand.append("SELECT EID.ExamItemDocumentID ");
						sb_SQLCommand.append("FROM ExamItemDocument EID ");
						sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
						sb_SQLCommand.append(") ");
						sb_SQLCommand.append("AND EID.EID_SubjectDocumentID = "+ai_SubjectDocumentID+" ");
				sb_SQLCommand.append(" ) ");
				
				sb_SQLCommand.append(" OR ");
				sb_SQLCommand.append(" EFD.EFD_CopiedExamItemGroupDocumentID  IN ( ");
				sb_SQLCommand.append("SELECT EIGD.ExamItemGroupDocumentID ");
				sb_SQLCommand.append("FROM ExamItemGroupDocument EIGD ");
				sb_SQLCommand.append("WHERE EIGD.EIGD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND EIGD.EIGD_SubjectDocumentID = "+ai_SubjectDocumentID+" ");
		sb_SQLCommand.append(" ) ");
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EF.EF_Code , EF.EF_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeBySubjectDocumentID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectDocumentID(10,ai_SubjectDocumentID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeBySubjectDocumentID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "GetSizeBySubjectDocumentID", "[" + RowCount.intValue() + "] Of ExamFormDocument By SubjectDocumentID = "+ai_SubjectDocumentID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormDocument> FindBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindBySubjectDocumentID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectDocumentID(20,ai_SubjectDocumentID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentDAO", "FindBySubjectDocumentID", ls_SQLCommand);
			NativeQuery<ExamFormDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormDocument> ExamFormDocumentList = query.list();
			if (ExamFormDocumentList.isEmpty() != true) {
				return ExamFormDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormDocumentDAO", "FindBySubjectDocumentID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormDocument By SubjectDocumentID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}