package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormItemChoice;
import esi.examwh.model.common.TYPE_ANSWER_STATUS;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormItemChoiceDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemChoice Add(Session MyHSs,ExamFormItemChoice ao_ExamFormItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemChoice.getOwnerSUID(), ao_ExamFormItemChoice.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormItemChoice.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItemChoice.setModifyUser(as_UserName);
			ao_ExamFormItemChoice.setCreateTime(Common.GetCurrTime());
			ao_ExamFormItemChoice.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Add", "[Ready][ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]");
			return ao_ExamFormItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "Add", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemChoice Disable(Session MyHSs, ExamFormItemChoice ao_ExamFormItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemChoice.getOwnerSUID(), ao_ExamFormItemChoice.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormItemChoice.setDeletedUser(as_UserName);
			ao_ExamFormItemChoice.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Disable", "[Ready][ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]");
			return ao_ExamFormItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "Disable", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemChoice
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemChoice Delete(Session MyHSs, ExamFormItemChoice ao_ExamFormItemChoice, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemChoice.getOwnerSUID(), ao_ExamFormItemChoice.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Delete", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]");
			return ao_ExamFormItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "Delete", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemChoice Modify(Session MyHSs, ExamFormItemChoice ao_ExamFormItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemChoice.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormItemChoice.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItemChoice.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "Modify", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]");
			return ao_ExamFormItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "Modify", "[ExamFormItemChoiceID:" + ao_ExamFormItemChoice.getExamFormItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormItemChoiceID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormItemChoice GetByID(Session MyHSs, Integer ai_ExamFormItemChoiceID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormItemChoice theExamFormItemChoice = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormItemChoice> criteria = builder.createQuery(ExamFormItemChoice.class);
		criteria.where(builder.equal(criteria.from(ExamFormItemChoice.class).get("examFormItemChoiceID"), ai_ExamFormItemChoiceID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormItemChoice = (ExamFormItemChoice) query.getSingleResult();
			if (theExamFormItemChoice != null) {
				return theExamFormItemChoice;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemChoiceID + "]");
				throw new DataNotFoundException("ExamFormItemChoice [" + ai_ExamFormItemChoiceID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemChoiceID + "]");
			throw new DataNotFoundException("ExamFormItemChoice [" + ai_ExamFormItemChoiceID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormItemChoice By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormItemChoice> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemChoice> ExamFormItemChoiceList = query.list();
			if (ExamFormItemChoiceList.isEmpty() != true) {
				return ExamFormItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemChoice By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormItemID(int ai_CommandType,Integer ai_ExamFormItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormItemID != null){
			sb_SQLCommand.append("AND EFIC.EFIC_ExamFormItemID = "+ai_ExamFormItemID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFIC.EFIC_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormItemID(Session MyHSs,Integer ai_ExamFormItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormItemID(10,ai_ExamFormItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemID", "[" + RowCount.intValue() + "] Of ExamFormItemChoice By ExamFormItemID["+ai_ExamFormItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItemChoice> FindByExamFormItemID(Session MyHSs,Integer ai_ExamFormItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormItemID(20,ai_ExamFormItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemID", ls_SQLCommand);
			NativeQuery<ExamFormItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemChoice> ExamFormItemChoiceList = query.list();
			if (ExamFormItemChoiceList.isEmpty() != true) {
				return ExamFormItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemChoice By ExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormID(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("JOIN ExamFormItem EFI ON EFI.ExamFormItemID = EFIC.EFIC_ExamFormItemID ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFIC.EFIC_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamFormItemChoice By ExamFormID["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItemChoice> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemChoice> ExamFormItemChoiceList = query.list();
			if (ExamFormItemChoiceList.isEmpty() != true) {
				return ExamFormItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemChoice By ExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormItemIDOrderByDisplayOrder(int ai_CommandType,Integer ai_ExamFormItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormItemID != null){
			sb_SQLCommand.append("AND EFIC.EFIC_ExamFormItemID = "+ai_ExamFormItemID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFIC.EFIC_DisplayOrder ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormItemIDOrderByDisplayOrder(Session MyHSs,Integer ai_ExamFormItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDOrderByDisplayOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormItemIDOrderByDisplayOrder(10,ai_ExamFormItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDOrderByDisplayOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDOrderByDisplayOrder", "[" + RowCount.intValue() + "] Of ExamFormItemChoice By ExamFormItemID["+ai_ExamFormItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItemChoice> FindByExamFormItemIDOrderByDisplayOrder(Session MyHSs,Integer ai_ExamFormItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDOrderByDisplayOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormItemIDOrderByDisplayOrder(20,ai_ExamFormItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDOrderByDisplayOrder", ls_SQLCommand);
			NativeQuery<ExamFormItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemChoice> ExamFormItemChoiceList = query.list();
			if (ExamFormItemChoiceList.isEmpty() != true) {
				return ExamFormItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDOrderByDisplayOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemChoice By ExamFormItemID OrderByDisplayOrder is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormItemIDAnswerStatusOrderByDisplayOrder(int ai_CommandType,Integer ai_ExamFormItemID,TYPE_ANSWER_STATUS ae_AnswerStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIC.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemChoice EFIC ");
		sb_SQLCommand.append("WHERE EFIC.EFIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormItemID != null){
			sb_SQLCommand.append("AND EFIC.EFIC_ExamFormItemID = "+ai_ExamFormItemID+" ");
		}
		if(ae_AnswerStatus != null){
			sb_SQLCommand.append("AND EFIC.EFIC_AnswerStatus = "+ae_AnswerStatus.getValue()+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EFIC.EFIC_DisplayOrder ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormItemIDAnswerStatusOrderByDisplayOrder(Session MyHSs,Integer ai_ExamFormItemID,TYPE_ANSWER_STATUS ae_AnswerStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDAnswerStatusOrderByDisplayOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormItemIDAnswerStatusOrderByDisplayOrder(10,ai_ExamFormItemID,ae_AnswerStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDAnswerStatusOrderByDisplayOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "GetSizeByExamFormItemIDAnswerStatusOrderByDisplayOrder", "[" + RowCount.intValue() + "] Of ExamFormItemChoice By ExamFormItemID["+ai_ExamFormItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItemChoice> FindByExamFormItemIDAnswerStatusOrderByDisplayOrder(Session MyHSs,Integer ai_ExamFormItemID,TYPE_ANSWER_STATUS ae_AnswerStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDAnswerStatusOrderByDisplayOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormItemIDAnswerStatusOrderByDisplayOrder(20,ai_ExamFormItemID,ae_AnswerStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDOrderByDisplayOrder", ls_SQLCommand);
			NativeQuery<ExamFormItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemChoice> ExamFormItemChoiceList = query.list();
			if (ExamFormItemChoiceList.isEmpty() != true) {
				return ExamFormItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceDAO", "FindByExamFormItemIDAnswerStatusOrderByDisplayOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemChoice By ExamFormItemID OrderByDisplayOrder is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}