package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.ExamFormItem;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAMFORM_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

public class ExamFormItemDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItem Add(Session MyHSs,ExamFormItem ao_ExamFormItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItem.getOwnerSUID(), ao_ExamFormItem.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormItem.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItem.setModifyUser(as_UserName);
			ao_ExamFormItem.setCreateTime(Common.GetCurrTime());
			ao_ExamFormItem.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_ExamFormItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Add", "[Ready][ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]");
			return ao_ExamFormItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "Add", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItem Disable(Session MyHSs, ExamFormItem ao_ExamFormItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItem.getOwnerSUID(), ao_ExamFormItem.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormItem.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormItem.setDeletedUser(as_UserName);
			ao_ExamFormItem.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Disable", "[Ready][ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]");
			return ao_ExamFormItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "Disable", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItem
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItem Delete(Session MyHSs, ExamFormItem ao_ExamFormItem, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItem.getOwnerSUID(), ao_ExamFormItem.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Delete", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]");
			return ao_ExamFormItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "Delete", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItem Modify(Session MyHSs, ExamFormItem ao_ExamFormItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItem.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormItem.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItem.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "Modify", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]");
			return ao_ExamFormItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "Modify", "[ExamFormItemID:" + ao_ExamFormItem.getExamFormItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormItemID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormItem GetByID(Session MyHSs, Integer ai_ExamFormItemID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormItem theExamFormItem = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormItem> criteria = builder.createQuery(ExamFormItem.class);
		criteria.where(builder.equal(criteria.from(ExamFormItem.class).get("examFormItemID"), ai_ExamFormItemID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormItem = (ExamFormItem) query.getSingleResult();
			if (theExamFormItem != null) {
				return theExamFormItem;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemID + "]");
				throw new DataNotFoundException("ExamFormItem [" + ai_ExamFormItemID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemID + "]");
			throw new DataNotFoundException("ExamFormItem [" + ai_ExamFormItemID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	public static ExamFormItem GetByExamFormIDExamCode(Session MyHSs,Integer ai_ExamFormID, String as_ExamFormItemCode,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByExamFormIDExamCode", "[START] @@@");

		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EFI.* ");
			sb_SQLCommand.append("FROM ExamFormItem EFI ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("EFI.EFI_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EFI.EFI_CreateTime IS NOT NULL ");
			if(ai_ExamFormID != null){
				sb_SQLCommand.append("AND EFI.EFI_ExamFormID = " + ai_ExamFormID+" ");
			}
			if(as_ExamFormItemCode != null){
				sb_SQLCommand.append("AND EFI.EFI_Code = '" + as_ExamFormItemCode+"' ");
			}
			
			sb_SQLCommand.append("AND EFI.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("EFI.EFI_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByCode", sb_SQLCommand.toString());
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByCode", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamFormItem By Code ["+as_ExamFormItemCode+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static ExamFormItem GetByExamFormIDExamOrderExamType(Session MyHSs,Integer ai_ExamFormID, Integer ai_ExamFormItemOrder,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByOrder", "[START] @@@");

		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EFI.* ");
			sb_SQLCommand.append("FROM ExamFormItem EFI ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("EFI.EFI_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EFI.EFI_CreateTime IS NOT NULL ");
			if(ai_ExamFormID != null){
				sb_SQLCommand.append("AND EFI.EFI_ExamFormID = " + ai_ExamFormID+" ");
			}
			if(ai_ExamFormItemOrder != null){
				sb_SQLCommand.append("AND EFI.EFI_Order = " + ai_ExamFormItemOrder+" ");
			}
			if(ae_ExamType != null){
				sb_SQLCommand.append("AND EFI.EFI_ExamType = " + ae_ExamType.getValue()+" ");
			}
			sb_SQLCommand.append("AND EFI.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("EFI.EFI_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByOrder", sb_SQLCommand.toString());
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamFormItem By Order ["+ai_ExamFormItemOrder+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static ExamFormItem GetByExamFormItemName(Session MyHSs, String as_ExamFormItemName,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByExamFormItemName", "[START] @@@");

		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EFI.* ");
			sb_SQLCommand.append("FROM ExamFormItem EFI ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("EFI.EFI_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EFI.EFI_CreateTime IS NOT NULL ");
			
			if(as_ExamFormItemName != null){
				sb_SQLCommand.append("AND EFI.EFI_QuestionText = '" + as_ExamFormItemName+"' ");
			}
			
			sb_SQLCommand.append("AND EFI.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("EFI.EFI_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByCode", sb_SQLCommand.toString());
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetByExamFormItemName", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamFormItem By Name ["+as_ExamFormItemName+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormItem By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormItem> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	public static String GenSQLByExamFormID(int ai_CommandType, Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs, Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormID(Session MyHSs, Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDExamGroupNull(int ai_CommandType, Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		sb_SQLCommand.append("AND EFI.EFI_ExamFormItemGroupID IS NULL " );
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamGroupNull(Session MyHSs, Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamGroupNull", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamGroupNull(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamGroupNull", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamGroupNull", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamGroupNull(Session MyHSs, Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamGroupNull", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamGroupNull(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamGroupNull", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamGroupNull", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDUnitID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EFI.EFI_UnitID = "+ai_UnitID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDUnitID(Session MyHSs, Integer ai_ExamFormID, Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDUnitID(10,ai_ExamFormID,ai_UnitID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"],UnitID ["+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDUnitID(Session MyHSs, Integer ai_ExamFormID,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDUnitID(20,ai_ExamFormID, ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID And UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDUnitIDSectionID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_UnitID,Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EFI.EFI_UnitID = "+ai_UnitID+" ");
		}
		if(ai_SectionID != null && ai_SectionID > 0){
			sb_SQLCommand.append("AND EFI.EFI_SectionID = "+ai_SectionID+" ");
		}else{
//			sb_SQLCommand.append("AND (EFI.EFI_SectionID = 0 OR EFI.EFI_SectionID IS NULL) ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDUnitIDSectionID(Session MyHSs, Integer ai_ExamFormID, Integer ai_UnitID,Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitIDSectionID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDUnitIDSectionID(10,ai_ExamFormID,ai_UnitID,ai_SectionID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitIDSectionID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDUnitIDSectionID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"],UnitID ["+ai_UnitID+"] ,SectionID["+ai_SectionID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDUnitIDSectionID(Session MyHSs, Integer ai_ExamFormID,Integer ai_UnitID,Integer ai_SectionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitIDSectionID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDUnitIDSectionID(20,ai_ExamFormID, ai_UnitID,ai_SectionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitIDSectionID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDUnitIDSectionID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID And UnitID  And SectionID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormItemGroupID(int ai_CommandType, Integer ai_ExamFormItemGroupID, Integer SUID,Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormItemGroupID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormItemGroupID = "+ai_ExamFormItemGroupID+" " );
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormItemGroupID(Session MyHSs, Integer ai_ExamFormItemGroupID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormItemGroupID(10,ai_ExamFormItemGroupID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormItemGroupID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormItemGroupID["+ai_ExamFormItemGroupID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormItemGroupID(Session MyHSs,Integer ai_ExamFormItemGroupID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormItemGroupID(20,ai_ExamFormItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormItemGroupID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormItemGroupID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By EExamFormItemGroupID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDExamTypeOrderByUnitSectionGroupOrder(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" " );
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append(" ORDER BY UN.UN_Order,ST.ST_Order,EFI.EFI_GroupOrder ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamTypeOrderByUnitSectionGroupOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamTypeOrderByUnitSectionGroupOrder(10,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamTypeOrderByUnitSectionGroupOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamTypeOrderByUnitSectionGroupOrder(20,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDOrderByUnitSectionGroupOrderExamType(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		if (ae_ExamType == TYPE_EXAM.TYPE_OBJECTIVE) {
			sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
			sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
		}
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ai_CommandType != 10){
			if (ae_ExamType == TYPE_EXAM.TYPE_OBJECTIVE) {
				sb_SQLCommand.append(" ORDER BY UN.UN_Order,ST.ST_Order,EFI.EFI_GroupOrder ");
			}
			if (ae_ExamType == TYPE_EXAM.TYPE_SUBJECTIVE) {
				sb_SQLCommand.append(" ORDER BY EFI.EFI_GroupOrder ");
			}
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDOrderByUnitSectionGroupOrderExamType(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDOrderByUnitSectionGroupOrderExamType(10,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDOrderByUnitSectionGroupOrder", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDOrderByUnitSectionGroupOrderExamType(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDOrderByUnitSectionGroupOrderExamType(20,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDOrderByUnitSectionGroupOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static Double GetSumExamScoreByExamFormID(Session MyHSs,Integer ai_ExamFormID, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSumExamScoreByExamFormID", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT isNull(sum(EFI.EFI_ExamScore),0) SumExamScore From ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus IN ("+TYPE_DATA_STATUS.STATUS_NEW.getValue()+","+TYPE_DATA_STATUS.STATUS_USE.getValue()+") ");
		
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		
		NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
		Object amount =  query.uniqueResult(); 
	    return (Double)amount;   	
	}
	
	/*public static Integer GetNumberOfExamFormItemByExamFormIDExamType(Session MyHSs,Integer ai_ExamFormID,TYPE_EXAM ae_ExamType, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetNumberOfExamFormItemObjectiveByExamFormIDExamType", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT isNull(COUNT(EFI.ExamFormItemID),0) NofExamFormItemID From ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus IN ("+TYPE_DATA_STATUS.STATUS_NEW.getValue()+","+TYPE_DATA_STATUS.STATUS_USE.getValue()+") ");
		
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
		Object amount =  query.uniqueResult(); 
	    return (Integer)amount;   	
	}*/
	
	public static Double GetSumExamScoreByExamFormIDExamType(Session MyHSs,Integer ai_ExamFormID,TYPE_EXAM ae_ExamType, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSumExamScoreByExamFormIDExamType", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT isNull(sum(EFI.EFI_ExamScore),0) SumExamScore From ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus IN ("+TYPE_DATA_STATUS.STATUS_NEW.getValue()+","+TYPE_DATA_STATUS.STATUS_USE.getValue()+") ");
		
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItem.class);
		Object amount =  query.uniqueResult(); 
	    return (Double)amount;   
	}
	
	public static String GenSQLByExamFormIDExamType(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		if(ae_ExamType != null){
			if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
				sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
				sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
				sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
			}
		}
		
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			if(ae_ExamType != null){
				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order , EFI.EFI_GroupOrder ");
				}else{
					sb_SQLCommand.append("ORDER BY EFI.EFI_GroupOrder ");
				}
			}else{
				sb_SQLCommand.append("ORDER BY EFI.EFI_GroupOrder ");
			}
			
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamType(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamType(10,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID  ["+ai_ExamFormID+"] ,ExamType ["+ae_ExamType+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamType(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamType(20,ai_ExamFormID , ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID ExamType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDExamTypeSortOrder(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		if(ae_ExamType != null){
			if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
				sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
				sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
				sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
			}
		}
		
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			if(ae_ExamType != null){
				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}else{
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}
			}else{
				sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			}
			
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamTypeSortOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamTypeSortOrder(10,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamType", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID  ["+ai_ExamFormID+"] ,ExamType ["+ae_ExamType+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamTypeSortOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamTypeSortOrder(20,ai_ExamFormID , ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID ExamType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDExamFormItemGroupID(int ai_CommandType,Integer ai_ExamFormID, Integer ai_ExamFormItemGroupID, Integer SUID,Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_ExamFormItemGroupID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormItemGroupID = "+ai_ExamFormItemGroupID+" " );
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamFormItemGroupID(Session MyHSs,Integer ai_ExamFormID, Integer ai_ExamFormItemGroupID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamFormItemGroupID(10,ai_ExamFormID,ai_ExamFormItemGroupID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemGroupID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] , ExamFormItemGroupID["+ai_ExamFormItemGroupID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamFormItemGroupID(Session MyHSs,Integer ai_ExamFormID,Integer ai_ExamFormItemGroupID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamFormItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamFormItemGroupID(20,ai_ExamFormID,ai_ExamFormItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamFormItemGroupID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamFormItemGroupID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID And ExamFormItemGroupID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDExamTypeOrderByOrder(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamTypeOrderByOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamTypeOrderByOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamTypeOrderByOrder(10,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamTypeOrderByOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamTypeOrderByOrder", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID  ["+ai_ExamFormID+"] ,ExamType ["+ae_ExamType+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamTypeOrderByOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamTypeOrderByOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamTypeOrderByOrder(20,ai_ExamFormID , ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamTypeOrderByOrder", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamTypeOrderByOrder", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID ExamType OrderByOrder is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDCopiedExamItemID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_CopiedExamItemID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_CopiedExamItemID != null){
			sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID = "+ai_CopiedExamItemID+" " );
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDCopiedExamItemID(Session MyHSs, Integer ai_ExamFormID,Integer ai_CopiedExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDCopiedExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDCopiedExamItemID(10,ai_ExamFormID,ai_CopiedExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDCopiedExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDCopiedExamItemID", "[" + RowCount.intValue() + "] Of ExamFormItem CopiedExamItemID By ExamFormID ["+ai_ExamFormID+"] ,CopiedExamItemID ["+ai_CopiedExamItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDCopiedExamItemID(Session MyHSs, Integer ai_ExamFormID,Integer ai_CopiedExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDCopiedExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDCopiedExamItemID(20,ai_ExamFormID,ai_CopiedExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDCopiedExamItemID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormIDCopiedExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID CopiedExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus(int ai_CommandType,Integer ai_ExamScheduleDetailID, Integer ai_ExamItemID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID = "+ai_ExamItemID+" ");
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID IN (  " );
			sb_SQLCommand.append("SELECT EF.ExamFormID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESD.ESD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				if(ae_ListExaminationStatus.length ==1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus = "+ae_ListExaminationStatus[0].getValue()+" ");
				}else if(ae_ListExaminationStatus.length >1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  "+ae_ListExaminationStatus[0].getValue()+" ");
					for(int i = 1;i < ae_ListExaminationStatus.length;i++){
						sb_SQLCommand.append(" , ");
						sb_SQLCommand.append(ae_ListExaminationStatus[i].getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
				if(ai_ExamScheduleDetailID != null){
					sb_SQLCommand.append("AND  EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" " );
				}
				
			sb_SQLCommand.append(" ) ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus(Session MyHSs,Integer ai_ExamScheduleDetailID, Integer ai_ExamItemID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus(10,ai_ExamScheduleDetailID,ai_ExamItemID,ae_ListExaminationStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] ExamFormItemID ["+ai_ExamItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus(Session MyHSs,Integer ai_ExamScheduleDetailID, Integer ai_ExamItemID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus(20,ai_ExamScheduleDetailID,ai_ExamItemID,ae_ListExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamItemIDInExamScheduleExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamItemIDInExamScheduleExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDExamFormItemOrder(int ai_CommandType, Integer ai_ExamFormID, Integer ai_ExamFormItemOrder,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_ExamFormItemOrder != null){
			sb_SQLCommand.append("AND EFI.EFI_Order = "+ai_ExamFormItemOrder+" " );
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDExamFormItemOrder(Session MyHSs, Integer ai_ExamFormID, Integer ai_ExamFormItemOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamFormItemOrder(10,ai_ExamFormID,ai_ExamFormItemOrder,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamFormIDExamFormItemOrder", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamFormID ["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamFormIDExamFormItemOrder(Session MyHSs, Integer ai_ExamFormID, Integer ai_ExamFormItemOrder,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamFormItemOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamFormItemOrder(20,ai_ExamFormID,ai_ExamFormItemOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamFormIDExamFormItemOrder", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamItemID(int ai_CommandType, Integer ai_ExamItemID, Integer SUID,Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EFI.EFI_ExamFormID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON EF.EF_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID = "+ai_ExamItemID+" " );
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year,EST.ES_Number , ER.ER_Number ,EF.EF_Code desc ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs, Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamItemID["+ai_ExamItemID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By FindByExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus(int ai_CommandType,Integer ai_ExamScheduleDetailID,TYPE_EXAM ae_ExamType, Integer ai_ExamItemID,Integer ai_PersonID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,TYPE_EXAMFORM_STATUS[] ae_ListExamFormStatus,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EFI.EFI_CopiedExamItemID = "+ai_ExamItemID+" ");
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamCreator = "+ai_PersonID+" ");
		}
//		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID IN (  " );
			sb_SQLCommand.append("SELECT EF.ExamFormID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESD.ESD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				if(ae_ListExaminationStatus.length ==1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus = "+ae_ListExaminationStatus[0].getValue()+" ");
				}else if(ae_ListExaminationStatus.length >1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  "+ae_ListExaminationStatus[0].getValue()+" ");
					for(int i = 1;i < ae_ListExaminationStatus.length;i++){
						sb_SQLCommand.append(" , ");
						sb_SQLCommand.append(ae_ListExaminationStatus[i].getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
				if(ae_ListExamFormStatus.length ==1){
					sb_SQLCommand.append("AND EF.EF_FormStatus = "+ae_ListExamFormStatus[0].getValue()+" ");
				}else if(ae_ListExamFormStatus.length >1){
					sb_SQLCommand.append("AND EF.EF_FormStatus IN (  "+ae_ListExamFormStatus[0].getValue()+" ");
					for(int i = 1;i < ae_ListExamFormStatus.length;i++){
						sb_SQLCommand.append(" , ");
						sb_SQLCommand.append(ae_ListExamFormStatus[i].getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
				if(ai_ExamScheduleDetailID != null){
					sb_SQLCommand.append("AND  EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" " );
				}
				
			sb_SQLCommand.append(" ) ");
//		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus(Session MyHSs,Integer ai_ExamScheduleDetailID,TYPE_EXAM ae_ExamType, Integer ai_ExamItemID,Integer ai_PersonID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,TYPE_EXAMFORM_STATUS[] ae_ListExamFormStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus(10,ai_ExamScheduleDetailID,ae_ExamType,ai_ExamItemID,ai_PersonID,ae_ListExaminationStatus,ae_ListExamFormStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSizeByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", "[" + RowCount.intValue() + "] Of ExamFormItem By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] ExamFormItemID ["+ai_ExamItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItem> FindByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus(Session MyHSs,Integer ai_ExamScheduleDetailID,TYPE_EXAM ae_ExamType, Integer ai_ExamItemID,Integer ai_PersonID,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,TYPE_EXAMFORM_STATUS[] ae_ListExamFormStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus(20,ai_ExamScheduleDetailID,ae_ExamType,ai_ExamItemID,ai_PersonID,ae_ListExaminationStatus,ae_ListExamFormStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", ls_SQLCommand);
			NativeQuery<ExamFormItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItem> ExamFormItemList = query.list();
			if (ExamFormItemList.isEmpty() != true) {
				return ExamFormItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemDAO", "FindByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By FindByExamScheduleDetailIDExamTypeExamItemIDPersonIDInExamScheduleExaminationStatusExamFormStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}