package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.ExamFormItemGroup;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormItemGroupDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemGroup Add(Session MyHSs,ExamFormItemGroup ao_ExamFormItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemGroup.getOwnerSUID(), ao_ExamFormItemGroup.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormItemGroup.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItemGroup.setModifyUser(as_UserName);
			ao_ExamFormItemGroup.setCreateTime(Common.GetCurrTime());
			ao_ExamFormItemGroup.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Add", "[Ready][ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]");
			return ao_ExamFormItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "Add", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemGroup Disable(Session MyHSs, ExamFormItemGroup ao_ExamFormItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemGroup.getOwnerSUID(), ao_ExamFormItemGroup.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormItemGroup.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormItemGroup.setDeletedUser(as_UserName);
			ao_ExamFormItemGroup.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Disable", "[Ready][ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]");
			return ao_ExamFormItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "Disable", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemGroup
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemGroup Delete(Session MyHSs, ExamFormItemGroup ao_ExamFormItemGroup, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemGroup.getOwnerSUID(), ao_ExamFormItemGroup.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Delete", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]");
			return ao_ExamFormItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "Delete", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormItemGroup Modify(Session MyHSs, ExamFormItemGroup ao_ExamFormItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormItemGroup.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormItemGroup.setModifyTime(Common.GetCurrTime());
			ao_ExamFormItemGroup.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "Modify", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]");
			return ao_ExamFormItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "Modify", "[ExamFormItemGroupID:" + ao_ExamFormItemGroup.getExamFormItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormItemGroupID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormItemGroup GetByID(Session MyHSs, Integer ai_ExamFormItemGroupID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormItemGroup theExamFormItemGroup = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormItemGroup> criteria = builder.createQuery(ExamFormItemGroup.class);
		criteria.where(builder.equal(criteria.from(ExamFormItemGroup.class).get("examFormItemGroupID"), ai_ExamFormItemGroupID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormItemGroup = (ExamFormItemGroup) query.getSingleResult();
			if (theExamFormItemGroup != null) {
				return theExamFormItemGroup;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemGroupID + "]");
				throw new DataNotFoundException("ExamFormItemGroup [" + ai_ExamFormItemGroupID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormItemGroupID + "]");
			throw new DataNotFoundException("ExamFormItemGroup [" + ai_ExamFormItemGroupID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	public static ExamFormItemGroup GetByCode(Session MyHSs,Integer ai_ExamFormID, String as_ExamFormItemGroupCode,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetByCode", "[START] @@@");

		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EFIG.* ");
			sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("EFIG.EFIG_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EFIG.EFIG_CreateTime IS NOT NULL ");
			if(ai_ExamFormID != null){
				sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = " + ai_ExamFormID+" ");
			}
			if(as_ExamFormItemGroupCode != null){
				sb_SQLCommand.append("AND EFIG.EFIG_Code = '" + as_ExamFormItemGroupCode+"' ");
			}
			
			sb_SQLCommand.append("AND EFIG.EFIG_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("EFIG.EFIG_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetByCode", sb_SQLCommand.toString());
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetByCode", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamFormItemGroup By Code ["+as_ExamFormItemGroupCode+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormItemGroup> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemGroup By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDCopiedExamItemGroupID(int ai_CommandType,Integer ai_ExamFormID , Integer ai_CopiedExamItemGroupID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ ai_ExamFormID+" ");
		}
		if(ai_CopiedExamItemGroupID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_CopiedExamItemGroupID = "+ai_CopiedExamItemGroupID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDCopiedExamItemGroupID(Session MyHSs,Integer ai_ExamFormID , Integer ai_CopiedExamItemGroupID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeExamFormIDCopiedExamItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDCopiedExamItemGroupID(10,ai_ExamFormID, ai_CopiedExamItemGroupID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDCopiedExamItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDCopiedExamItemGroupID", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By ExamFormID = "+ai_ExamFormID +",CopiedExamItemGroupID = "+ai_CopiedExamItemGroupID+" [END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamFormItemGroup> FindByExamFormIDCopiedExamItemGroupID(Session MyHSs,Integer ai_ExamFormID , Integer ai_CopiedExamItemGroupID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDCopiedExamItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDCopiedExamItemGroupID(20,ai_ExamFormID, ai_CopiedExamItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDCopiedExamItemGroupID", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDCopiedExamItemGroupID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemGroup By ExamFormID CopiedExamItemGroupID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	public static String GenSQLByExamFormID(int ai_CommandType,Integer ai_ExamFormID  ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ ai_ExamFormID+" ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By ExamFormID = "+ai_ExamFormID +"[END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamFormItemGroup> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID, SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemGroup By ExamFormID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDUnitID(int ai_CommandType,Integer ai_ExamFormID,Integer ai_UnitID  ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		if(ai_UnitID != null){
			sb_SQLCommand.append("JOIN ExamItemGroup EIG ON EIG.ExamItemGroupID = EFIG.EFIG_CopiedExamItemGroupID ");
		}
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ ai_ExamFormID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EIG.EIG_UnitID = "+ ai_UnitID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDUnitID(Session MyHSs,Integer ai_ExamFormID ,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDUnitID(10,ai_ExamFormID,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDUnitID", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By ExamFormID = "+ai_ExamFormID +"[END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamFormItemGroup> FindByExamFormIDUnitID(Session MyHSs,Integer ai_ExamFormID,Integer ai_UnitID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDUnitID(20,ai_ExamFormID,ai_UnitID, SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDUnitID", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDUnitID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemGroup By ExamFormID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormIDHaveExamFormItem(int ai_CommandType,Integer ai_ExamFormID  ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_ExamFormID = "+ ai_ExamFormID+" ");
		}
		sb_SQLCommand.append("AND 0 < (SELECT COUNT(*) FROM ExamFormItem EFI WHERE EFI.EFI_ExamFormItemGroupID = EFIG.ExamFormItemGroupID ) ");
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDHaveExamFormItem(Session MyHSs,Integer ai_ExamFormID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDHaveExamFormItem", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDHaveExamFormItem(10,ai_ExamFormID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDHaveExamFormItem", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "GetSizeByExamFormIDHaveExamFormItem", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By ExamFormID = "+ai_ExamFormID +"[END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamFormItemGroup> FindByExamFormIDHaveExamFormItem(Session MyHSs,Integer ai_ExamFormID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDHaveExamFormItem", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDHaveExamFormItem(20,ai_ExamFormID, SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDHaveExamFormItem", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroupDAO", "FindByExamFormIDHaveExamFormItem", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItemGroup By ExamFormID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamItemGroupID(int ai_CommandType, Integer ai_ExamItemGroupID, Integer SUID,Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFIG.* ");
		}
		sb_SQLCommand.append("FROM ExamFormItemGroup EFIG ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.ExamFormID = EFIG.EFIG_ExamFormID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON EF.EF_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("WHERE EFIG.EFIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemGroupID != null){
			sb_SQLCommand.append("AND EFIG.EFIG_CopiedExamItemGroupID = "+ai_ExamItemGroupID+" " );
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year,EST.ES_Number , ER.ER_Number ,EF.EF_Code desc ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemGroupID(Session MyHSs, Integer ai_ExamItemGroupID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroup", "GetSizeByExamItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemGroupID(10,ai_ExamItemGroupID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroup", "GetSizeByExamItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroup", "GetSizeByExamItemGroupID", "[" + RowCount.intValue() + "] Of ExamFormItemGroup By ExamItemGroupID["+ai_ExamItemGroupID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormItemGroup> FindByExamItemGroupID(Session MyHSs,Integer ai_ExamItemGroupID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroup", "FindByExamItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemGroupID(20,ai_ExamItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGroup", "FindByExamItemGroupID", ls_SQLCommand);
			NativeQuery<ExamFormItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemGroup> ExamFormItemGroupList = query.list();
			if (ExamFormItemGroupList.isEmpty() != true) {
				return ExamFormItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGroup", "FindByExamItemGroupID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormItem By FindByExamItemGroupID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}