package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormOperationLog;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormOperationLogDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormOperationLog
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormOperationLog Add(Session MyHSs,ExamFormOperationLog ao_ExamFormOperationLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormOperationLog.getOwnerSUID(), ao_ExamFormOperationLog.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormOperationLog.setModifyTime(Common.GetCurrTime());
			ao_ExamFormOperationLog.setModifyUser(as_UserName);
			ao_ExamFormOperationLog.setCreateTime(Common.GetCurrTime());
			ao_ExamFormOperationLog.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamFormOperationLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Add", "[Ready][ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]");
			return ao_ExamFormOperationLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "Add", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormOperationLog
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormOperationLog Disable(Session MyHSs, ExamFormOperationLog ao_ExamFormOperationLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormOperationLog.getOwnerSUID(), ao_ExamFormOperationLog.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormOperationLog.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormOperationLog.setDeletedUser(as_UserName);
			ao_ExamFormOperationLog.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormOperationLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Disable", "[Ready][ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]");
			return ao_ExamFormOperationLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "Disable", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormOperationLog
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormOperationLog Delete(Session MyHSs, ExamFormOperationLog ao_ExamFormOperationLog, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormOperationLog.getOwnerSUID(), ao_ExamFormOperationLog.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormOperationLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Delete", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]");
			return ao_ExamFormOperationLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "Delete", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormOperationLog
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormOperationLog Modify(Session MyHSs, ExamFormOperationLog ao_ExamFormOperationLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormOperationLog.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormOperationLog.setModifyTime(Common.GetCurrTime());
			ao_ExamFormOperationLog.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormOperationLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "Modify", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]");
			return ao_ExamFormOperationLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "Modify", "[ExamFormOperationLogID:" + ao_ExamFormOperationLog.getExamFormOperationLogID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormOperationLogID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormOperationLog GetByID(Session MyHSs, Integer ai_ExamFormOperationLogID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormOperationLog theExamFormOperationLog = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormOperationLog> criteria = builder.createQuery(ExamFormOperationLog.class);
		criteria.where(builder.equal(criteria.from(ExamFormOperationLog.class).get("examFormOperationLogID"), ai_ExamFormOperationLogID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormOperationLog = (ExamFormOperationLog) query.getSingleResult();
			if (theExamFormOperationLog != null) {
				return theExamFormOperationLog;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormOperationLogID + "]");
				throw new DataNotFoundException("ExamFormOperationLog [" + ai_ExamFormOperationLogID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormOperationLogID + "]");
			throw new DataNotFoundException("ExamFormOperationLog [" + ai_ExamFormOperationLogID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFOL.* ");
		}
		sb_SQLCommand.append("FROM ExamFormOperationLog EFOL ");
		sb_SQLCommand.append("WHERE EFOL.EFOL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormOperationLog By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormOperationLog> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormOperationLog> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormOperationLog.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormOperationLog> ExamFormOperationLogList = query.list();
			if (ExamFormOperationLogList.isEmpty() != true) {
				return ExamFormOperationLogList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormOperationLog By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	public static String GenSQLByExamFormID(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFOL.* ");
		}
		sb_SQLCommand.append("FROM ExamFormOperationLog EFOL ");
		sb_SQLCommand.append("WHERE EFOL.EFOL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFOL.EFOL_ExamFormID = "+ai_ExamFormID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EFOL.EFOL_ModifyTime DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of ExamFormOperationLog By ExamFormID["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamFormOperationLog> FindByExamFormID(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "FindByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormID(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogDAO", "FindByExamFormID", ls_SQLCommand);
			NativeQuery<ExamFormOperationLog> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormOperationLog.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormOperationLog> ExamFormOperationLogList = query.list();
			if (ExamFormOperationLogList.isEmpty() != true) {
				return ExamFormOperationLogList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormOperationLogDAO", "FindByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormOperationLog By ExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}