package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormSelected;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamFormSelectedDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamFormSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormSelected Add(Session MyHSs,ExamFormSelected ao_ExamFormSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormSelected.getOwnerSUID(), ao_ExamFormSelected.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamFormSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamFormSelected.setModifyUser(as_UserName);
			ao_ExamFormSelected.setCreateTime(Common.GetCurrTime());
			ao_ExamFormSelected.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamFormSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Add", "[Ready][ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]");
			return ao_ExamFormSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "Add", "[ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormSelected Disable(Session MyHSs, ExamFormSelected ao_ExamFormSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormSelected.getOwnerSUID(), ao_ExamFormSelected.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamFormSelected.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamFormSelected.setDeletedUser(as_UserName);
			ao_ExamFormSelected.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamFormSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Disable", "[Ready][ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]");
			return ao_ExamFormSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "Disable", "[ID:" +ao_ExamFormSelected.getExamFormSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormSelected
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormSelected Delete(Session MyHSs, ExamFormSelected ao_ExamFormSelected, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormSelected.getOwnerSUID(), ao_ExamFormSelected.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamFormSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Delete", "[ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]");
			return ao_ExamFormSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "Delete", "[ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamFormSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamFormSelected Modify(Session MyHSs, ExamFormSelected ao_ExamFormSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamFormSelected.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamFormSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamFormSelected.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamFormSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "Modify", "[ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]");
			return ao_ExamFormSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "Modify", "[ID:" + ao_ExamFormSelected.getExamFormSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamFormSelectedID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamFormSelected GetByID(Session MyHSs, Integer ai_ExamFormSelectedID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamFormSelected theExamFormSelected = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamFormSelected> criteria = builder.createQuery(ExamFormSelected.class);
		criteria.where(builder.equal(criteria.from(ExamFormSelected.class).get("examFormSelectedID"), ai_ExamFormSelectedID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamFormSelected = (ExamFormSelected) query.getSingleResult();
			if (theExamFormSelected != null) {
				return theExamFormSelected;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormSelectedID + "]");
				throw new DataNotFoundException("ExamFormSelected [" + ai_ExamFormSelectedID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "GetByID", "[Not Found][ID:" + ai_ExamFormSelectedID + "]");
			throw new DataNotFoundException("ExamFormSelected [" + ai_ExamFormSelectedID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFS.* ");
		}
		sb_SQLCommand.append("FROM ExamFormSelected EFS ");
		sb_SQLCommand.append("WHERE EFS.EFS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamFormSelected By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamFormSelected> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamFormSelected> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormSelected.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormSelected> ExamFormSelectedList = query.list();
			if (ExamFormSelectedList.isEmpty() != true) {
				return ExamFormSelectedList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamFormSelected By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem(int ai_CommandType,Integer ai_ExamFormConditionID,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFS.* ");
		}
		sb_SQLCommand.append("FROM ExamFormSelected EFS ");
		sb_SQLCommand.append("WHERE EFS.EFS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EFS.EFS_ExamFormConditionID = " + ai_ExamFormConditionID+" ");
		}
		if(ai_ExamItemIDList != null && ai_ExamItemIDList.size() > 0){
			sb_SQLCommand.append("AND EFS.EFS_ExamScheduleDetailSelectedID IN ( ");
			sb_SQLCommand.append("SELECT ESDS.ExamScheduleDetailSelectedID ");
			sb_SQLCommand.append("FROM ExamScheduleDetailSelected ESDS ");
			sb_SQLCommand.append("WHERE ESDS.ESDS_DataStatus NOT IN ( 411,511 ) ");
			if(ai_ExamScheduleDetailID != null){
				sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
			}
			sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID IN ( ");
			sb_SQLCommand.append(ai_ExamItemIDList.get(0));
			for (int i = 1; i < ai_ExamItemIDList.size(); i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(ai_ExamItemIDList.get(i));
			}
			sb_SQLCommand.append(") ");
			
			sb_SQLCommand.append(") ");
		}
//		if(ae_ExamItemSelectedStatus != null){
//			sb_SQLCommand.append("AND EFS.EFS_ExamFormSelectedStatus = " + ae_ExamItemSelectedStatus.getValue()+" ");
//		}
		return sb_SQLCommand.toString();
	}

	public static int GetSizeByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem(Session MyHSs,Integer ai_ExamFormConditionID,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem(10,ai_ExamFormConditionID,ai_ExamScheduleDetailID,ai_ExamItemIDList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", "[" + RowCount.intValue() + "] Of ExamFormSelected By All [END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamFormSelected> FindByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem(Session MyHSs,Integer ai_ExamFormConditionID,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "FindByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem(20,ai_ExamFormConditionID,ai_ExamScheduleDetailID,ai_ExamItemIDList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormSelectedDAO", "FindByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", ls_SQLCommand);
			NativeQuery<ExamFormSelected> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamFormSelected.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamFormSelected> ExamFormSelectedList = query.list();
			if (ExamFormSelectedList.isEmpty() != true) {
				return ExamFormSelectedList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormSelectedDAO", "FindByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem", "[Not Found] @@@");
				throw new DataNotFoundException("Find FindByExamFormConditionIDExamScheduleDetailIDExamItemIDListExamItem By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
