package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemAttribute;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemAttributeDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemAttribute Add(Session MyHSs,ExamItemAttribute ao_ExamItemAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemAttribute.getOwnerSUID(), ao_ExamItemAttribute.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemAttribute.setModifyTime(Common.GetCurrTime());
			ao_ExamItemAttribute.setModifyUser(as_UserName);
			ao_ExamItemAttribute.setCreateTime(Common.GetCurrTime());
			ao_ExamItemAttribute.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamItemAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Add", "[Ready][ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]");
			return ao_ExamItemAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "Add", "[ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemAttribute
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemAttribute Disable(Session MyHSs, ExamItemAttribute ao_ExamItemAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemAttribute.getOwnerSUID(), ao_ExamItemAttribute.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemAttribute.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemAttribute.setDeletedUser(as_UserName);
			ao_ExamItemAttribute.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Disable", "[Ready][ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]");
			return ao_ExamItemAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "Disable", "[ID:" +ao_ExamItemAttribute.getExamItemAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemAttribute
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemAttribute Delete(Session MyHSs, ExamItemAttribute ao_ExamItemAttribute, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemAttribute.getOwnerSUID(), ao_ExamItemAttribute.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Delete", "[ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]");
			return ao_ExamItemAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "Delete", "[ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemAttribute
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemAttribute Modify(Session MyHSs, ExamItemAttribute ao_ExamItemAttribute, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemAttribute.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemAttribute.setModifyTime(Common.GetCurrTime());
			ao_ExamItemAttribute.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemAttribute);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "Modify", "[ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]");
			return ao_ExamItemAttribute;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "Modify", "[ID:" + ao_ExamItemAttribute.getExamItemAttributeID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemAttributeID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemAttribute GetByID(Session MyHSs, Integer ai_ExamItemAttributeID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemAttribute theExamItemAttribute = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemAttribute> criteria = builder.createQuery(ExamItemAttribute.class);
		criteria.where(builder.equal(criteria.from(ExamItemAttribute.class).get("examItemAttributeID"), ai_ExamItemAttributeID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemAttribute = (ExamItemAttribute) query.getSingleResult();
			if (theExamItemAttribute != null) {
				return theExamItemAttribute;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemAttributeID + "]");
				throw new DataNotFoundException("ExamItemAttribute [" + ai_ExamItemAttributeID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemAttributeID + "]");
			throw new DataNotFoundException("ExamItemAttribute [" + ai_ExamItemAttributeID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIA.* ");
		}
		sb_SQLCommand.append("FROM ExamItemAttribute EIA ");
		sb_SQLCommand.append("WHERE EIA.EIA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemAttribute By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemAttribute> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemAttribute> ExamItemAttributeList = query.list();
			if (ExamItemAttributeList.isEmpty() != true) {
				return ExamItemAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemAttribute By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemIDAttributeID(int ai_CommandType, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIA.* ");
		}
		sb_SQLCommand.append("FROM ExamItemAttribute EIA ");
		sb_SQLCommand.append("WHERE EIA.EIA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIA.EIA_ExamItemID = "+ai_ExamItemID+" ");
		}
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND EIA.EIA_AttributeID = "+ai_AttributeID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIA.EIA_AttributeID ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemIDAttributeID(Session MyHSs, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemIDAttributeID(10,ai_ExamItemID,ai_AttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeID", "[" + RowCount.intValue() + "] Of ExamItemAttribute By ExamItemAttributeGroupID[ai_ExamItemID :"+ai_ExamItemID +"] [ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemAttribute> FindByExamItemIDAttributeID(Session MyHSs, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemIDAttributeID(20,ai_ExamItemID,ai_AttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeID", ls_SQLCommand);
			NativeQuery<ExamItemAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemAttribute> ExamItemAttributeList = query.list();
			if (ExamItemAttributeList.isEmpty() != true) {
				return ExamItemAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemAttribute By FindByExamItemIDAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCurriculumIDExamItemIDAttributeID(int ai_CommandType,Integer ai_CurriculumID, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIA.* ");
		}
		sb_SQLCommand.append("FROM ExamItemAttribute EIA ");
		sb_SQLCommand.append("JOIN CurriculumAttribute CA ON CA.CA_AttributeID = EIA.EIA_AttributeID ");
		sb_SQLCommand.append("WHERE EIA.EIA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIA.EIA_ExamItemID = "+ai_ExamItemID+" ");
		}
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND EIA.EIA_AttributeID = "+ai_AttributeID+" ");
		}
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumIDExamItemIDAttributeID(Session MyHSs,Integer ai_CurriculumID, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByCurriculumIDExamItemIDAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumIDExamItemIDAttributeID(10,ai_CurriculumID,ai_ExamItemID,ai_AttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByCurriculumIDExamItemIDAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByCurriculumIDExamItemIDAttributeID", "[" + RowCount.intValue() + "] Of ExamItemAttribute By GetSizeByCurriculumIDExamItemIDAttributeID[ai_ExamItemID :"+ai_ExamItemID +"] [ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemAttribute> FindByCurriculumIDExamItemIDAttributeID(Session MyHSs,Integer ai_CurriculumID, Integer ai_ExamItemID, Integer ai_AttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByCurriculumIDExamItemIDAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumIDExamItemIDAttributeID(20,ai_CurriculumID,ai_ExamItemID,ai_AttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByCurriculumIDExamItemIDAttributeID", ls_SQLCommand);
			NativeQuery<ExamItemAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemAttribute> ExamItemAttributeList = query.list();
			if (ExamItemAttributeList.isEmpty() != true) {
				return ExamItemAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "FindByCurriculumIDExamItemIDAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemAttribute By FindByCurriculumIDExamItemIDAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemIDAttributeIDNotINCurriculumID(int ai_CommandType, Integer ai_ExamItemID, Integer ai_AttributeID,Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIA.* ");
		}
		sb_SQLCommand.append("FROM ExamItemAttribute EIA ");
		sb_SQLCommand.append("JOIN CurriculumAttribute CA ON CA.CA_AttributeID = EIA.EIA_AttributeID ");
		sb_SQLCommand.append("WHERE EIA.EIA_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIA.EIA_ExamItemID = "+ai_ExamItemID+" ");
		}
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND EIA.EIA_AttributeID = "+ai_AttributeID+" ");
		}
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID NOT IN ( "+ai_CurriculumID+" ) ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemIDAttributeIDNotINCurriculumID(Session MyHSs, Integer ai_ExamItemID, Integer ai_AttributeID,Integer ai_CurriculumID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeIDNotINCurriculumID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemIDAttributeIDNotINCurriculumID(10,ai_ExamItemID,ai_AttributeID,ai_CurriculumID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeIDNotINCurriculumID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "GetSizeByExamItemIDAttributeIDNotINCurriculumID", "[" + RowCount.intValue() + "] Of ExamItemAttribute By GetSizeByCurriculumIDExamItemIDAttributeID[ai_ExamItemID :"+ai_ExamItemID +"] [ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemAttribute> FindByExamItemIDAttributeIDNotINCurriculumID(Session MyHSs, Integer ai_ExamItemID, Integer ai_AttributeID,Integer ai_CurriculumID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeIDNotINCurriculumID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemIDAttributeIDNotINCurriculumID(20,ai_ExamItemID,ai_AttributeID,ai_CurriculumID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeIDNotINCurriculumID", ls_SQLCommand);
			NativeQuery<ExamItemAttribute> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemAttribute.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemAttribute> ExamItemAttributeList = query.list();
			if (ExamItemAttributeList.isEmpty() != true) {
				return ExamItemAttributeList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemAttributeDAO", "FindByExamItemIDAttributeIDNotINCurriculumID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemAttribute By FindByExamItemIDAttributeIDNotINCurriculumID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}