package esi.examwh.dao;

import java.util.List;
import java.util.Random;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemChoice;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.service.runnumber.CodeGenerator;
import esi.examwh.service.runnumber.DataNotGenerateException;

public class ExamItemChoiceDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemChoice Add(Session MyHSs,ExamItemChoice ao_ExamItemChoice,Integer ai_Year, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Add", "[START] @@@");
		String ls_Code = null;
		Random Rd = new Random();
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_ExamItemChoice.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemChoice.setModifyTime(Common.GetCurrTime());
			ao_ExamItemChoice.setModifyUser(as_UserName);
			ao_ExamItemChoice.setCreateTime(Common.GetCurrTime());
			ao_ExamItemChoice.setCreateUser(as_UserName);
//			String ls_Code = lo_ExamItem.getCode()+CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
			try {
				ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
			} catch (DataNotGenerateException e) {
					// TODO Auto-generated catch block
					try {
						Thread.currentThread().sleep(Rd.nextInt(1000));
						ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
					} catch (DataNotGenerateException e2) {
						// TODO Auto-generated catch block
						Thread.currentThread().sleep(Rd.nextInt(1000));
						ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
					}
				}
				ao_ExamItemChoice.setCode(ls_Code);
				ObjectDAO.Add(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Add", "[Ready][ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "Add", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	public static ExamItemChoice AddNotStamp(Session MyHSs,ExamItemChoice ao_ExamItemChoice,Integer ai_Year, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "AddNotStamp", "[START] @@@");
		String ls_Code = null;
		Random Rd = new Random();
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_ExamItemChoice.getOwnerSGID(), SUID, SGID);
		try {
		
//			ao_ExamItemChoice.setModifyTime(Common.GetCurrTime());
//			ao_ExamItemChoice.setModifyUser(as_UserName);
//			ao_ExamItemChoice.setCreateTime(Common.GetCurrTime());
//			ao_ExamItemChoice.setCreateUser(as_UserName);
//			String ls_Code = lo_ExamItem.getCode()+CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
			try {
				ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
			} catch (DataNotGenerateException e) {
					// TODO Auto-generated catch block
					try {
						Thread.currentThread().sleep(Rd.nextInt(1000));
						ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
					} catch (DataNotGenerateException e2) {
						// TODO Auto-generated catch block
						Thread.currentThread().sleep(Rd.nextInt(1000));
						ls_Code = CodeGenerator.ExamItemChoiceNextCode(ai_Year).substring(5);
					}
				}
				ao_ExamItemChoice.setCode(ls_Code);
				ObjectDAO.Add(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "AddNotStamp", "[Ready][ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "AddNotStamp", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ao_ExamItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemChoice Disable(Session MyHSs, ExamItemChoice ao_ExamItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_ExamItemChoice.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemChoice.setDeletedUser(as_UserName);
			ao_ExamItemChoice.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Disable", "[Ready][ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "Disable", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemChoice
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemChoice Delete(Session MyHSs, ExamItemChoice ao_ExamItemChoice, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_ExamItemChoice.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Delete", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "Delete", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemChoice
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemChoice Modify(Session MyHSs, ExamItemChoice ao_ExamItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemChoice.setModifyTime(Common.GetCurrTime());
			ao_ExamItemChoice.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Modify", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "Modify", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	public static ExamItemChoice ModifyNotStamp(Session MyHSs, ExamItemChoice ao_ExamItemChoice, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemChoice.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
//			ao_ExamItemChoice.setModifyTime(Common.GetCurrTime());
//			ao_ExamItemChoice.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemChoice);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "Modify", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]");
			return ao_ExamItemChoice;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "Modify", "[ExamItemChoiceID:" + ao_ExamItemChoice.getExamItemChoiceID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemChoiceID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemChoice GetByID(Session MyHSs, Integer ai_ExamItemChoiceID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemChoice theExamItemChoice = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemChoice> criteria = builder.createQuery(ExamItemChoice.class);
		criteria.where(builder.equal(criteria.from(ExamItemChoice.class).get("examItemChoiceID"), ai_ExamItemChoiceID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemChoice = (ExamItemChoice) query.getSingleResult();
			if (theExamItemChoice != null) {
				return theExamItemChoice;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemChoiceID + "]");
				throw new DataNotFoundException("ExamItemChoice [" + ai_ExamItemChoiceID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemChoiceID + "]");
			throw new DataNotFoundException("ExamItemChoice [" + ai_ExamItemChoiceID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIC.* ");
		}
		sb_SQLCommand.append("FROM ExamItemChoice EIC ");
		sb_SQLCommand.append("WHERE EIC.EIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemChoice By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemChoice> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "FindByAll", ls_SQLCommand);

			NativeQuery<ExamItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemChoice> ExamItemChoiceList = query.list();
			if (ExamItemChoiceList.isEmpty() != true) {
				return ExamItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemChoice By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType,Integer ai_ExamItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIC.* ");
		}
		sb_SQLCommand.append("FROM ExamItemChoice EIC ");
		sb_SQLCommand.append("WHERE EIC.EIC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIC.EIC_ExamItemID = "+ai_ExamItemID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIC.EIC_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamItemChoice By ExamItemID["+ai_ExamItemID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemChoice> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamItemChoice> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemChoice.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemChoice> ExamItemChoiceList = query.list();
			if (ExamItemChoiceList.isEmpty() != true) {
				return ExamItemChoiceList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemChoiceDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemChoice By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}