package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemCondition;
import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemConditionDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemCondition Add(Session MyHSs,ExamItemCondition ao_ExamItemCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemCondition.getOwnerSUID(), ao_ExamItemCondition.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamItemCondition.setModifyUser(as_UserName);
			ao_ExamItemCondition.setCreateTime(Common.GetCurrTime());
			ao_ExamItemCondition.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamItemCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Add", "[Ready][ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]");
			return ao_ExamItemCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "Add", "[ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemCondition Disable(Session MyHSs, ExamItemCondition ao_ExamItemCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemCondition.getOwnerSUID(), ao_ExamItemCondition.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemCondition.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemCondition.setDeletedUser(as_UserName);
			ao_ExamItemCondition.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Disable", "[Ready][ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]");
			return ao_ExamItemCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "Disable", "[ID:" +ao_ExamItemCondition.getExamItemConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemCondition
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemCondition Delete(Session MyHSs, ExamItemCondition ao_ExamItemCondition, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemCondition.getOwnerSUID(), ao_ExamItemCondition.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Delete", "[ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]");
			return ao_ExamItemCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "Delete", "[ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemCondition Modify(Session MyHSs, ExamItemCondition ao_ExamItemCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemCondition.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamItemCondition.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "Modify", "[ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]");
			return ao_ExamItemCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "Modify", "[ID:" + ao_ExamItemCondition.getExamItemConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemConditionID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemCondition GetByID(Session MyHSs, Integer ai_ExamItemConditionID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemCondition theExamItemCondition = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemCondition> criteria = builder.createQuery(ExamItemCondition.class);
		criteria.where(builder.equal(criteria.from(ExamItemCondition.class).get("examItemConditionID"), ai_ExamItemConditionID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemCondition = (ExamItemCondition) query.getSingleResult();
			if (theExamItemCondition != null) {
				return theExamItemCondition;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemConditionID + "]");
				throw new DataNotFoundException("ExamItemCondition [" + ai_ExamItemConditionID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemConditionID + "]");
			throw new DataNotFoundException("ExamItemCondition [" + ai_ExamItemConditionID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EICD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemCondition EICD ");
		sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemCondition By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemCondition> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemCondition> ExamItemConditionList = query.list();
			if (ExamItemConditionList.isEmpty() != true) {
				return ExamItemConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemCondition By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EICD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemCondition EICD ");
//		sb_SQLCommand.append("JOIN BehaviorLevel BL ON BL.BehaviorLevelID = EICD.EICD_BehaviorLevelID ");
//		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EICD.EICD_UnitID ");
//		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EICD.EICD_SectionID ");
//		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EICD.EICD_ObjectiveID ");
		sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		if(ai_BehaviorLevelID != null){
			sb_SQLCommand.append("AND EICD.EICD_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EICD.EICD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EICD.EICD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EICD.EICD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EICD.EICD_BehaviorLevelID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(10,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",BehaviorLevelID:"+ai_BehaviorLevelID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemCondition> FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(20,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
			NativeQuery<ExamItemCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemCondition> ExamItemConditionList = query.list();
			if (ExamItemConditionList.isEmpty() != true) {
				return ExamItemConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemCondition By FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT SUM(EICD.EICD_NOFItem) ");
		sb_SQLCommand.append("FROM ExamItemCondition EICD ");
		sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EICD.EICD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EICD.EICD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EICD.EICD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(ai_ExamFormConditionID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
}
