package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ActionType;
import esi.examwh.model.ExamItemDocument;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemDocumentDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemDocument Add(Session MyHSs,ExamItemDocument ao_ExamItemDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemDocument.getOwnerSUID(), ao_ExamItemDocument.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamItemDocument.setModifyUser(as_UserName);
			ao_ExamItemDocument.setCreateTime(Common.GetCurrTime());
			ao_ExamItemDocument.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamItemDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Add", "[Ready][ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]");
			return ao_ExamItemDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "Add", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemDocument Disable(Session MyHSs, ExamItemDocument ao_ExamItemDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemDocument.getOwnerSUID(), ao_ExamItemDocument.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemDocument.setDeletedUser(as_UserName);
			ao_ExamItemDocument.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Disable", "[Ready][ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]");
			return ao_ExamItemDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "Disable", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemDocument
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemDocument Delete(Session MyHSs, ExamItemDocument ao_ExamItemDocument, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemDocument.getOwnerSUID(), ao_ExamItemDocument.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Delete", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]");
			return ao_ExamItemDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "Delete", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemDocument Modify(Session MyHSs, ExamItemDocument ao_ExamItemDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemDocument.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamItemDocument.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "Modify", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]");
			return ao_ExamItemDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "Modify", "[ExamItemDocumentID:" + ao_ExamItemDocument.getExamItemDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemDocumentID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemDocument GetByID(Session MyHSs, Integer ai_ExamItemDocumentID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemDocument theExamItemDocument = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemDocument> criteria = builder.createQuery(ExamItemDocument.class);
		criteria.where(builder.equal(criteria.from(ExamItemDocument.class).get("examItemDocumentID"), ai_ExamItemDocumentID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemDocument = (ExamItemDocument) query.getSingleResult();
			if (theExamItemDocument != null) {
				return theExamItemDocument;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemDocumentID + "]");
				throw new DataNotFoundException("ExamItemDocument [" + ai_ExamItemDocumentID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemDocumentID + "]");
			throw new DataNotFoundException("ExamItemDocument [" + ai_ExamItemDocumentID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EID.* ");
		}
		sb_SQLCommand.append("FROM ExamItemDocument EID ");
		sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemDocument By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemDocument> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemDocument> ExamItemDocumentList = query.list();
			if (ExamItemDocumentList.isEmpty() != true) {
				return ExamItemDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemDocument By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	public static String GenSQLByExamItemIDSubjectID(int ai_CommandType,Integer ai_ExamItemID,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EID.* ");
		}
		sb_SQLCommand.append("FROM ExamItemDocument EID ");
		if(ai_SubjectID != null){
			sb_SQLCommand.append("JOIN SubjectDocument SJD ON SJD.SubjectDocumentID = EID.EID_SubjectDocumentID ");
		}
		sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EID.EID_ExamItemID = "+ai_ExamItemID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJD.SJD_SubjectID = "+ai_SubjectID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EID.EID_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemIDSubjectID(Session MyHSs,Integer ai_ExamItemID,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemIDSubjectID(10,ai_ExamItemID,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemIDSubjectID", "[" + RowCount.intValue() + "] Of ExamItemDocument By ExamItemID["+ai_ExamItemID+"] SubjectID["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemDocument> FindByExamItemIDSubjectID(Session MyHSs,Integer ai_ExamItemID,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamItemIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemIDSubjectID(20,ai_ExamItemID,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamItemIDSubjectID", ls_SQLCommand);
			NativeQuery<ExamItemDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemDocument> ExamItemDocumentList = query.list();
			if (ExamItemDocumentList.isEmpty() != true) {
				return ExamItemDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "FindByExamItemIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemDocument By ExamItemID SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType,Integer ai_ExamItemID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EID.* ");
		}
		sb_SQLCommand.append("FROM ExamItemDocument EID ");
		
		sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EID.EID_ExamItemID = "+ai_ExamItemID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EID.EID_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamItemDocument By ExamItemID["+ai_ExamItemID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemDocument> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamItemDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemDocument> ExamItemDocumentList = query.list();
			if (ExamItemDocumentList.isEmpty() != true) {
				return ExamItemDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemDocument By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDNotInExamFormDocument(int ai_CommandType,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EID.* ");
		}
		sb_SQLCommand.append("FROM ExamItemDocument EID ");
		sb_SQLCommand.append("JOIN ExamFormItem EFI ON EFI.EFI_CopiedExamItemID = EID.EID_ExamItemID ");
		sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" ");
		}
		sb_SQLCommand.append("AND EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND EID.ExamItemDocumentID NOT IN ( ");
			sb_SQLCommand.append("SELECT EFD.EFD_CopiedExamItemDocumentID ");
			sb_SQLCommand.append("FROM ExamFormDocument EFD ");
			sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
		sb_SQLCommand.append(" ) ");
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDNotInExamFormDocument(Session MyHSs,Integer ai_ExamFormID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamFormIDNotInExamFormDocument", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDNotInExamFormDocument(10,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamFormIDNotInExamFormDocument", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeByExamFormIDNotInExamFormDocument", "[" + RowCount.intValue() + "] Of ExamItemDocument By ExamFormIDNotInExamFormDocument["+ai_ExamFormID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemDocument> FindByExamFormIDNotInExamFormDocument(Session MyHSs,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamFormIDNotInExamFormDocument", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDNotInExamFormDocument(20,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindByExamFormIDNotInExamFormDocument", ls_SQLCommand);
			NativeQuery<ExamItemDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemDocument> ExamItemDocumentList = query.list();
			if (ExamItemDocumentList.isEmpty() != true) {
				return ExamItemDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "FindByExamFormIDNotInExamFormDocument", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemDocument By ExamFormIDNotInExamFormDocument is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectDocumentID(int ai_CommandType,Integer ai_SubjectDocumentID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EID.* ");
		}
		sb_SQLCommand.append("FROM ExamItemDocument EID ");
		sb_SQLCommand.append("JOIN ExamItem EI ON EI.ExamItemID = EID.EID_ExamItemID ");
		sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_SubjectDocumentID != null){
			sb_SQLCommand.append("AND EID.EID_SubjectDocumentID = "+ai_SubjectDocumentID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EI.EI_Code , EI.EI_QuestionText  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeBySubjectDocumentID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectDocumentID(10,ai_SubjectDocumentID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeBySubjectDocumentID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "GetSizeBySubjectDocumentID", "[" + RowCount.intValue() + "] Of ExamItemDocument By SubjectDocumentID["+ai_SubjectDocumentID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemDocument> FindBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindBySubjectDocumentID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectDocumentID(20,ai_SubjectDocumentID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentDAO", "FindBySubjectDocumentID", ls_SQLCommand);
			NativeQuery<ExamItemDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemDocument> ExamItemDocumentList = query.list();
			if (ExamItemDocumentList.isEmpty() != true) {
				return ExamItemDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemDocumentDAO", "FindBySubjectDocumentID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemDocument By SubjectDocumentID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}