package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.ExamItemGroup;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_DISABLE_STATUS;
import esi.examwh.model.common.TYPE_VERIFY_STATUS;
import esi.examwh.service.runnumber.CodeGenerator;

public class ExamItemGroupDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroup Add(Session MyHSs,ExamItemGroup ao_ExamItemGroup,Integer ai_Year, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_ExamItemGroup.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemGroup.setModifyTime(Common.GetCurrTime());
			ao_ExamItemGroup.setModifyUser(as_UserName);
			ao_ExamItemGroup.setCreateTime(Common.GetCurrTime());
			ao_ExamItemGroup.setCreateUser(as_UserName);
			ao_ExamItemGroup.setCode(CodeGenerator.ExamItemGroupNextCode(ai_Year));
			ObjectDAO.Add(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Add", "[Ready][ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "Add", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static ExamItemGroup AddNotStamp(Session MyHSs,ExamItemGroup ao_ExamItemGroup,Integer ai_Year, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "AddNotStamp", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_ExamItemGroup.getOwnerSGID(), SUID, SGID);
		try {
		
//			ao_ExamItemGroup.setModifyTime(Common.GetCurrTime());
//			ao_ExamItemGroup.setModifyUser(as_UserName);
//			ao_ExamItemGroup.setCreateTime(Common.GetCurrTime());
//			ao_ExamItemGroup.setCreateUser(as_UserName);
			ao_ExamItemGroup.setCode(CodeGenerator.ExamItemGroupNextCode(ai_Year));
			ObjectDAO.Add(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "AddNotStamp", "[Ready][ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "AddNotStamp", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroup Disable(Session MyHSs, ExamItemGroup ao_ExamItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_ExamItemGroup.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemGroup.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemGroup.setDeletedUser(as_UserName);
			ao_ExamItemGroup.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Disable", "[Ready][ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "Disable", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroup
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroup Delete(Session MyHSs, ExamItemGroup ao_ExamItemGroup, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_ExamItemGroup.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Delete", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "Delete", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroup
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroup Modify(Session MyHSs, ExamItemGroup ao_ExamItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemGroup.setModifyTime(Common.GetCurrTime());
			ao_ExamItemGroup.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "Modify", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "Modify", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	public static ExamItemGroup ModifyNotStamp(Session MyHSs, ExamItemGroup ao_ExamItemGroup, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "ModifyNotStamp", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroup.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
//			ao_ExamItemGroup.setModifyTime(Common.GetCurrTime());
//			ao_ExamItemGroup.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemGroup);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "ModifyNotStamp", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]");
			return ao_ExamItemGroup;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "ModifyNotStamp", "[ExamItemGroupID:" + ao_ExamItemGroup.getExamItemGroupID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemGroupID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemGroup GetByID(Session MyHSs, Integer ai_ExamItemGroupID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemGroup theExamItemGroup = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemGroup> criteria = builder.createQuery(ExamItemGroup.class);
		criteria.where(builder.equal(criteria.from(ExamItemGroup.class).get("examItemGroupID"), ai_ExamItemGroupID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemGroup = (ExamItemGroup) query.getSingleResult();
			if (theExamItemGroup != null) {
				return theExamItemGroup;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemGroupID + "]");
				throw new DataNotFoundException("ExamItemGroup [" + ai_ExamItemGroupID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemGroupID + "]");
			throw new DataNotFoundException("ExamItemGroup [" + ai_ExamItemGroupID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	public static ExamItemGroup GetByCode(Session MyHSs, String as_Code, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemGroup theExamItemGroup = null;
		List<ExamItemGroup> ExamItemGroupList;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetByCode", "[START] @@@");
		Criteria MyHC;
		MyHC = MyHSs.createCriteria(ExamItemGroup.class).add(Restrictions.eq("code", as_Code));
		MyHC.setFirstResult(0);
		MyHC.setMaxResults(1);
		ExamItemGroupList = MyHC.list();
		if (ExamItemGroupList.isEmpty() != true) {
			theExamItemGroup = ExamItemGroupList.get(0);
			return theExamItemGroup;
		} else {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "GetByCode", "[Not Found] @@@");
			throw new DataNotFoundException("ExamItemGroup [" +as_Code+  "] is not found.");
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemGroup By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemGroup> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	public static String GenSQLBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(int ai_CommandType,String as_SubjectCode ,String as_SubjectName ,Integer ai_UnitID, Integer ai_SectionID ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EIG.EIG_UnitID = "+ai_UnitID+" ");
		}
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND EIG.EIG_SectionID = "+ai_SectionID+" ");
		}
		if(as_ExamItemGroupCode != null){
			sb_SQLCommand.append("AND EIG.EIG_Code = '"+as_ExamItemGroupCode+"' ");
		}
		if(as_QuestionText != null){
			sb_SQLCommand.append("AND EIG.EIG_QuestionText LIKE '%"+as_QuestionText+"%' ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedYear = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedSemester = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedRound = "+ai_LastUsedRound+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EIG.EIG_Code , SJ.SJ_Code, UN.UN_Order, ST.ST_Order, EIG.EIG_QuestionText  ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer ai_UnitID, Integer ai_SectionID ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(10,as_SubjectCode ,as_SubjectName ,ai_UnitID, ai_SectionID , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroup By SubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound [SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer ai_UnitID, Integer ai_SectionID ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(20,as_SubjectCode ,as_SubjectName ,ai_UnitID, ai_SectionID , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationType[SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By SubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(int ai_CommandType,String as_SubjectCode ,String as_SubjectName ,String as_UnitName, String as_SectionName ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_UnitName != null){
			sb_SQLCommand.append("AND UN.UN_Name LIKE '%"+as_UnitName+"%' ");
		}
		if(as_SectionName != null){
			sb_SQLCommand.append("AND ST.ST_Name LIKE '%"+as_SectionName+"%' ");
		}
		if(as_ExamItemGroupCode != null){
			sb_SQLCommand.append("AND EIG.EIG_Code = '"+as_ExamItemGroupCode+"' ");
		}
		if(as_QuestionText != null){
			sb_SQLCommand.append("AND EIG.EIG_QuestionText LIKE '%"+as_QuestionText+"%' ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedYear = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedSemester = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedRound = "+ai_LastUsedRound+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY EIG.EIG_Code , SJ.SJ_Code, UN.UN_Order, ST.ST_Order, EIG.EIG_QuestionText  ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,String as_UnitName, String as_SectionName ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(10,as_SubjectCode ,as_SubjectName ,as_UnitName, as_SectionName , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroup By SubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound [SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitName:"+as_UnitName+",SectionName:"+as_SectionName+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,String as_UnitName, String as_SectionName,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound(20,as_SubjectCode ,as_SubjectName ,as_UnitName, as_SectionName , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRound", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationType[SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitName:"+as_UnitName+",SectionName:"+as_SectionName+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By SubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus(int ai_CommandType,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,TYPE_DISABLE_STATUS ae_DisableStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_UnitOrder != null){
			sb_SQLCommand.append("AND UN.UN_Order = "+as_UnitOrder+" ");
		}
		if(as_SectionOrder != null){
			sb_SQLCommand.append("AND ST.ST_Order = "+as_SectionOrder+" ");
		}
		if(as_ExamItemGroupCode != null){
			sb_SQLCommand.append("AND EIG.EIG_Code = '"+as_ExamItemGroupCode+"' ");
		}
		if(as_QuestionText != null){
			sb_SQLCommand.append("AND EIG.EIG_QuestionText LIKE '%"+as_QuestionText+"%' ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedYear = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedSemester = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedRound = "+ai_LastUsedRound+" ");
		}
		if(ae_DisableStatus != null){
			sb_SQLCommand.append("AND EIG.EIG_DisableStatus = "+ae_DisableStatus.getValue()+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY  SJ.SJ_Code, UN.UN_Order, ST.ST_Order,EIG.EIG_Code , EIG.EIG_QuestionText  ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus(10,as_SubjectCode ,as_SubjectName ,as_UnitOrder, as_SectionOrder , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound, ae_DisableStatus, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroup By SubjectCodeSubjectNameUnitIDSectionIDExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus [SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitOrder:"+as_UnitOrder+",SectionOrder:"+as_SectionOrder+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus(20,as_SubjectCode ,as_SubjectName ,as_UnitOrder, as_SectionOrder , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound, ae_DisableStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundDisableStatus", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationTypeDisableStatus[SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitOrder:"+as_UnitOrder+",SectionOrder:"+as_SectionOrder+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By SubjectCodeSubjectNameUnitNameSectionNameExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemeterLastUsedRoundExaminationTypeDisableStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus(int ai_CommandType,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,Integer ai_SystemUserID,Integer ai_ExamYearID,Integer ai_ExamTermID, TYPE_DISABLE_STATUS ae_DisableStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		if(ai_SystemUserID != null ){
			sb_SQLCommand.append("LEFT JOIN Person PS ON PS.PersonID = EIG.EIG_ExamCreator ");
		}
		sb_SQLCommand.append("LEFT JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EIG.EIG_ExamScheduleDetailID ");
		sb_SQLCommand.append("LEFT JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_UnitOrder != null){
			sb_SQLCommand.append("AND UN.UN_Order = "+as_UnitOrder+" ");
		}
		if(as_SectionOrder != null){
			sb_SQLCommand.append("AND ST.ST_Order = "+as_SectionOrder+" ");
		}
		if(as_ExamItemGroupCode != null){
			sb_SQLCommand.append("AND EIG.EIG_Code = '"+as_ExamItemGroupCode+"' ");
		}
		if(as_QuestionText != null){
			sb_SQLCommand.append("AND EIG.EIG_QuestionText LIKE '%"+as_QuestionText+"%' ");
		}
		if(ai_LastUsedYear != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedYear = "+ai_LastUsedYear+" ");
		}
		if(ai_LastUsedSemester != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedSemester = "+ai_LastUsedSemester+" ");
		}
		if(ai_LastUsedRound != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedRound = "+ai_LastUsedRound+" ");
		}
		if(ai_LastUsedTerm != null){
			sb_SQLCommand.append("AND EIG.EIG_LastUsedTerm = "+ai_LastUsedTerm+" ");
		}
		if(ai_SystemUserID != null ){
			sb_SQLCommand.append("AND PS.PS_SystemUserID = "+ai_SystemUserID+" ");
		}
		if(ai_ExamYearID != null ){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID != null ){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		if(ae_DisableStatus != null ){
			sb_SQLCommand.append("AND EIG.EIG_DisableStatus = "+ae_DisableStatus.getValue()+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY  SJ.SJ_Code, UN.UN_Order, ST.ST_Order,EIG.EIG_Code , EIG.EIG_QuestionText  ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder ,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,Integer ai_SystemUserID,Integer ai_ExamYearID,Integer ai_ExamTermID, TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus(10,as_SubjectCode ,as_SubjectName ,as_UnitOrder, as_SectionOrder , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,ai_LastUsedTerm,ai_SystemUserID,ai_ExamYearID,ai_ExamTermID, ae_DisableStatus, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroup By GetSizeBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus [SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitOrder:"+as_UnitOrder+",SectionOrder:"+as_SectionOrder+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus(Session MyHSs,String as_SubjectCode ,String as_SubjectName ,Integer as_UnitOrder, Integer as_SectionOrder,String as_ExamItemGroupCode, String as_QuestionText,Integer  ai_LastUsedYear,Integer ai_LastUsedSemester,Integer ai_LastUsedRound,Integer ai_LastUsedTerm,Integer ai_SystemUserID,Integer ai_ExamYearID,Integer ai_ExamTermID, TYPE_DISABLE_STATUS ae_DisableStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDExamLevelDisableStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDDisableStatus(20,as_SubjectCode ,as_SubjectName ,as_UnitOrder, as_SectionOrder , as_ExamItemGroupCode, as_QuestionText,  ai_LastUsedYear, ai_LastUsedSemester,ai_LastUsedRound,ai_LastUsedTerm,ai_SystemUserID,ai_ExamYearID,ai_ExamTermID, ae_DisableStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDExamLevelDisableStatus", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDExamLevel[SubjectCode:"+as_SubjectCode +",SubjectName:"+as_SubjectName +",UnitOrder:"+as_UnitOrder+",SectionOrder:"+as_SectionOrder+",ExamItemGroupCode:" + as_ExamItemGroupCode+",QuestionText:"+as_QuestionText+",LastUsedYear:"+  ai_LastUsedYear+",LastUserSemester:"+ai_LastUsedSemester+",LastUsedRound:"+ai_LastUsedRound+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By FindBySubjectCodeSubjectNameUnitOrderSectionOrderExamItemGroupCodeQuestionTextLastUsedYearLastUsedSemesterLastUsedRoundSystemUserIDExamYearIDExamTermIDExamLevel is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID(int ai_CommandType,Integer ai_ExamItemGroupCopyParentID ,Integer ai_SubjectID ,Integer ai_UnitID, Integer ai_SectionID , Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EIG.EIG_SectionID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamItemGroupCopyParentID != null){
			sb_SQLCommand.append("AND EIG.EIG_ExamItemGroupCopyParentID = "+ai_ExamItemGroupCopyParentID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND EIG.EIG_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EIG.EIG_UnitID = "+ai_UnitID+" ");
		}
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND EIG.EIG_SectionID = "+ai_SectionID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemGroupCopyParentIDSubjectIDUnitIDSectionI(Session MyHSs,Integer ai_ExamItemGroupCopyParentID ,Integer ai_SubjectID ,Integer ai_UnitID, Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeByExamItemGroupCopyParentIDSubjectIDUnitIDSectionI", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID(10,ai_ExamItemGroupCopyParentID ,ai_SubjectID ,ai_UnitID, ai_SectionID , SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeByExamItemGroupCopyParentIDSubjectIDUnitIDSectionI", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroup By GetSizeByExamItemGroupCopyParentIDSubjectIDUnitIDSectionI [SubjectID:"+ai_SubjectID +",UnitID:"+ai_UnitID +",SectionID:"+ai_SectionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID(Session MyHSs,Integer ai_ExamItemGroupCopyParentID ,Integer ai_SubjectID ,Integer ai_UnitID, Integer ai_SectionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID(20,ai_ExamItemGroupCopyParentID ,ai_SubjectID ,ai_UnitID ,ai_SectionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID[ExamItemGroupCopyParentID:"+ai_ExamItemGroupCopyParentID +",SubjectID:"+ai_SubjectID +",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By FindByExamItemGroupCopyParentIDSubjectIDUnitIDSectionID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectIDUnitID(int ai_CommandType, Integer ai_SubjectID, Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EIG.EIG_UnitID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = EIG.EIG_SubjectID ");
		sb_SQLCommand.append("WHERE EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
				
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND EIG.EIG_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EIG.EIG_UnitID = "+ai_UnitID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIG.EIG_Code ,SJ.SJ_Code, UN.UN_Order ,  EIG.EIG_QuestionText ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDUnitID(Session MyHSs,Integer ai_SubjectID, Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDUnitID(10,ai_SubjectID,ai_UnitID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDUnitID", "[" + RowCount.intValue() + "] Of ExamItemGroup By [SubjectID :"+ai_SubjectID+",UnitID : "+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroup> FindBySubjectIDUnitID(Session MyHSs,Integer ai_SubjectID, Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDUnitID(20,ai_SubjectID,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDUnitID", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDUnitID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By SubjectIDUnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static ExamItemGroup GetBySubjectIDExamItemGroupName(Session MyHSs,Integer ai_SubjectID, String as_ExamItemGroupName,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDAO", "GetBySubjectIDExamItemGroupName", "[START] @@@");

		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EIG.* ");
			sb_SQLCommand.append("FROM ExamItemGroup EIG ");
			
			sb_SQLCommand.append(PermissionService.GetJoinString("EIG.EIG_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EIG.EIG_CreateTime IS NOT NULL ");
			
			if(as_ExamItemGroupName != null){
				sb_SQLCommand.append("AND EIG.EIG_QuestionText = '" + as_ExamItemGroupName+"' ");
			}
			if(ai_SubjectID != null){
				sb_SQLCommand.append("AND EIG.EIG_SubjectID = " + ai_SubjectID+" ");
			}
			sb_SQLCommand.append("AND EIG.EIG_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(PermissionService.GetWhereString("EIG.EIG_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetByExamItemGroupName", sb_SQLCommand.toString());
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamItemGroup.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetByExamItemGroupName", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamItemGroupDAO By Name ["+as_ExamItemGroupName+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GetSQLBySubjectIDWalkInFlagVerifyType(int ai_CommandType,Integer ai_SubjectID,TYPE_VERIFY_STATUS ae_VerifyStatus,Integer SUID,Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIG.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroup EIG ");
		
		sb_SQLCommand.append(PermissionService.GetJoinString("EIG.EIG_OwnerGroupID", SUID, SGID));
		sb_SQLCommand.append("WHERE EIG.EIG_CreateTime IS NOT NULL ");
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND EIG.EIG_SubjectID = " + ai_SubjectID+" ");
		}
		
		if(ae_VerifyStatus != null){
			sb_SQLCommand.append("AND (EIG.EIG_VerifyExamItemStatus = " + ae_VerifyStatus.getValue()+" ");
			sb_SQLCommand.append("OR EIG.EIG_VerifyExamItemStatus IS NULL ) ");
		}
		sb_SQLCommand.append("AND EIG.EIG_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append(PermissionService.GetWhereString("EIG.EIG_OwnerUserID", SUID, SGID));
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDWalkInFlagVerifyType(Session MyHSs,Integer ai_SubjectID,TYPE_VERIFY_STATUS ae_VerifyStatus,Integer SUID,Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDWalkInFlagVerifyType", "[BEGIN] @@@");
		String ls_SQLCommand = GetSQLBySubjectIDWalkInFlagVerifyType(10,ai_SubjectID,ae_VerifyStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDWalkInFlagVerifyType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "GetSizeBySubjectIDWalkInFlagVerifyType", "[" + RowCount.intValue() + "] Of ExamItemGroup By ExamItemGroupGroupID[SubjectID :"+ai_SubjectID+",VerifyStatus : "+ae_VerifyStatus+" [END] @@@");
		return RowCount.intValue();
	}
	public static List<ExamItemGroup> FindBySubjectIDWalkInFlagVerifyType(Session MyHSs,Integer ai_SubjectID,TYPE_VERIFY_STATUS ae_VerifyStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDWalkInFlagVerifyType", "[START] @@@");
		try {
			String ls_SQLCommand =  GetSQLBySubjectIDWalkInFlagVerifyType(20,ai_SubjectID,ae_VerifyStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDWalkInFlagVerifyType", ls_SQLCommand);
			NativeQuery<ExamItemGroup> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroup.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroup> ExamItemGroupList = query.list();
			if (ExamItemGroupList.isEmpty() != true) {
				return ExamItemGroupList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDAO", "FindBySubjectIDWalkInFlagVerifyType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroup By FindBySubjectIDWalkInFlagVerifyType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
