package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemGroupDocument;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemGroupDocumentDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroupDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroupDocument Add(Session MyHSs,ExamItemGroupDocument ao_ExamItemGroupDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroupDocument.getOwnerSUID(), ao_ExamItemGroupDocument.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemGroupDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamItemGroupDocument.setModifyUser(as_UserName);
			ao_ExamItemGroupDocument.setCreateTime(Common.GetCurrTime());
			ao_ExamItemGroupDocument.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamItemGroupDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Add", "[Ready][ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]");
			return ao_ExamItemGroupDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "Add", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroupDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroupDocument Disable(Session MyHSs, ExamItemGroupDocument ao_ExamItemGroupDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroupDocument.getOwnerSUID(), ao_ExamItemGroupDocument.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemGroupDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemGroupDocument.setDeletedUser(as_UserName);
			ao_ExamItemGroupDocument.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemGroupDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Disable", "[Ready][ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]");
			return ao_ExamItemGroupDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "Disable", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroupDocument
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroupDocument Delete(Session MyHSs, ExamItemGroupDocument ao_ExamItemGroupDocument, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroupDocument.getOwnerSUID(), ao_ExamItemGroupDocument.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemGroupDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Delete", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]");
			return ao_ExamItemGroupDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "Delete", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemGroupDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemGroupDocument Modify(Session MyHSs, ExamItemGroupDocument ao_ExamItemGroupDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemGroupDocument.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemGroupDocument.setModifyTime(Common.GetCurrTime());
			ao_ExamItemGroupDocument.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemGroupDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "Modify", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]");
			return ao_ExamItemGroupDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "Modify", "[ExamItemGroupDocumentID:" + ao_ExamItemGroupDocument.getExamItemGroupDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemGroupDocumentID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemGroupDocument GetByID(Session MyHSs, Integer ai_ExamItemGroupDocumentID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemGroupDocument theExamItemGroupDocument = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemGroupDocument> criteria = builder.createQuery(ExamItemGroupDocument.class);
		criteria.where(builder.equal(criteria.from(ExamItemGroupDocument.class).get("examItemGroupDocumentID"), ai_ExamItemGroupDocumentID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemGroupDocument = (ExamItemGroupDocument) query.getSingleResult();
			if (theExamItemGroupDocument != null) {
				return theExamItemGroupDocument;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemGroupDocumentID + "]");
				throw new DataNotFoundException("ActionType [" + ai_ExamItemGroupDocumentID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemGroupDocumentID + "]");
			throw new DataNotFoundException("ActionType [" + ai_ExamItemGroupDocumentID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIGD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroupDocument EIGD ");
		sb_SQLCommand.append("WHERE EIGD.EIGD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemGroupDocument By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemGroupDocument> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemGroupDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroupDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroupDocument> ExamItemGroupDocumentList = query.list();
			if (ExamItemGroupDocumentList.isEmpty() != true) {
				return ExamItemGroupDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroupDocument By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}

	
	public static String GenSQLByExamItemGroupID(int ai_CommandType,Integer ai_ExamItemGroupID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIGD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroupDocument EIGD ");
		sb_SQLCommand.append("WHERE EIGD.EIGD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemGroupID != null){
			sb_SQLCommand.append("AND EIGD.EIGD_ExamItemGroupID = "+ai_ExamItemGroupID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIGD.EIGD_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemGroupID(Session MyHSs,Integer ai_ExamItemGroupID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemGroupID(10,ai_ExamItemGroupID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupID", "[" + RowCount.intValue() + "] Of ExamItemGroupDocument By ExamItemGroupID ["+ai_ExamItemGroupID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroupDocument> FindByExamItemGroupID(Session MyHSs,Integer ai_ExamItemGroupID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemGroupID(20,ai_ExamItemGroupID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupID", ls_SQLCommand);
			NativeQuery<ExamItemGroupDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroupDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroupDocument> ExamItemGroupDocumentList = query.list();
			if (ExamItemGroupDocumentList.isEmpty() != true) {
				return ExamItemGroupDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroupDocument By ExamItemGroupID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemGroupIDSubjectID(int ai_CommandType,Integer ai_ExamItemGroupID,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIGD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroupDocument EIGD ");
		sb_SQLCommand.append("JOIN SubjectDocument SJD ON SJD.SubjectDocumentID = EIGD.EIGD_SubjectDocumentID ");
		sb_SQLCommand.append("WHERE EIGD.EIGD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemGroupID != null){
			sb_SQLCommand.append("AND EIGD.EIGD_ExamItemGroupID = "+ai_ExamItemGroupID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJD.SJD_SubjectID = "+ai_SubjectID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIGD.EIGD_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemGroupIDSubjectID(Session MyHSs,Integer ai_ExamItemGroupID,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemGroupIDSubjectID(10,ai_ExamItemGroupID,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeByExamItemGroupIDSubjectID", "[" + RowCount.intValue() + "] Of ExamItemGroupDocument By ExamItemGroupID ["+ai_ExamItemGroupID+"] SubjectID ["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroupDocument> FindByExamItemGroupIDSubjectID(Session MyHSs,Integer ai_ExamItemGroupID,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemGroupIDSubjectID(20,ai_ExamItemGroupID,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupIDSubjectID", ls_SQLCommand);
			NativeQuery<ExamItemGroupDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroupDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroupDocument> ExamItemGroupDocumentList = query.list();
			if (ExamItemGroupDocumentList.isEmpty() != true) {
				return ExamItemGroupDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "FindByExamItemGroupIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroupDocument By ExamItemGroupID SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectDocumentID(int ai_CommandType,Integer ai_SubjectDocumentID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIGD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemGroupDocument EIGD ");
		sb_SQLCommand.append("WHERE EIGD.EIGD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_SubjectDocumentID != null){
			sb_SQLCommand.append("AND EIGD.EIGD_SubjectDocumentID = "+ai_SubjectDocumentID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EIGD.EIGD_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeBySubjectDocumentID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectDocumentID(10,ai_SubjectDocumentID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeBySubjectDocumentID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "GetSizeBySubjectDocumentID", "[" + RowCount.intValue() + "] Of ExamItemGroupDocument By SubjectDocumentID ["+ai_SubjectDocumentID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemGroupDocument> FindBySubjectDocumentID(Session MyHSs,Integer ai_SubjectDocumentID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindBySubjectDocumentID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectDocumentID(20,ai_SubjectDocumentID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentDAO", "FindBySubjectDocumentID", ls_SQLCommand);
			NativeQuery<ExamItemGroupDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemGroupDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemGroupDocument> ExamItemGroupDocumentList = query.list();
			if (ExamItemGroupDocumentList.isEmpty() != true) {
				return ExamItemGroupDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemGroupDocumentDAO", "FindBySubjectDocumentID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemGroupDocument By SubjectDocumentID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
