package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemHistory;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemHistoryDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemHistory Add(Session MyHSs,ExamItemHistory ao_ExamItemHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemHistory.getOwnerSUID(), ao_ExamItemHistory.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemHistory.setModifyTime(Common.GetCurrTime());
			ao_ExamItemHistory.setModifyUser(as_UserName);
			ao_ExamItemHistory.setCreateTime(Common.GetCurrTime());
			ao_ExamItemHistory.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamItemHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Add", "[Ready][ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]");
			return ao_ExamItemHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "Add", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemHistory Disable(Session MyHSs, ExamItemHistory ao_ExamItemHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemHistory.getOwnerSUID(), ao_ExamItemHistory.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemHistory.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemHistory.setDeletedUser(as_UserName);
			ao_ExamItemHistory.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Disable", "[Ready][ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]");
			return ao_ExamItemHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "Disable", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemHistory
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemHistory Delete(Session MyHSs, ExamItemHistory ao_ExamItemHistory, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemHistory.getOwnerSUID(), ao_ExamItemHistory.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Delete", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]");
			return ao_ExamItemHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "Delete", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemHistory
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemHistory Modify(Session MyHSs, ExamItemHistory ao_ExamItemHistory, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemHistory.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemHistory.setModifyTime(Common.GetCurrTime());
			ao_ExamItemHistory.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemHistory);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "Modify", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]");
			return ao_ExamItemHistory;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "Modify", "[ExamItemHistoryID:" + ao_ExamItemHistory.getExamItemHistoryID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemHistoryID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemHistory GetByID(Session MyHSs, Integer ai_ExamItemHistoryID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemHistory theExamItemHistory = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemHistory> criteria = builder.createQuery(ExamItemHistory.class);
		criteria.where(builder.equal(criteria.from(ExamItemHistory.class).get("examItemHistoryID"), ai_ExamItemHistoryID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemHistory = (ExamItemHistory) query.getSingleResult();
			if (theExamItemHistory != null) {
				return theExamItemHistory;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemHistoryID + "]");
				throw new DataNotFoundException("ExamItemHistory [" + ai_ExamItemHistoryID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemHistoryID + "]");
			throw new DataNotFoundException("ExamItemHistory [" + ai_ExamItemHistoryID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIH.* ");
		}
		sb_SQLCommand.append("FROM ExamItemHistory EIH ");
		sb_SQLCommand.append("WHERE EIH.EIH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemHistory By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemHistory> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemHistory> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemHistory.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemHistory> ExamItemHistoryList = query.list();
			if (ExamItemHistoryList.isEmpty() != true) {
				return ExamItemHistoryList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemHistory By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamItemID(int ai_CommandType, Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIH.* ");
		}
		sb_SQLCommand.append("FROM ExamItemHistory EIH ");
		sb_SQLCommand.append("WHERE EIH.EIH_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamItemID != null){
			sb_SQLCommand.append("AND EIH.EIH_ExamItemID = "+ai_ExamItemID +" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeByExamItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamItemID(10,ai_ExamItemID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeByExamItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "GetSizeByExamItemID", "[" + RowCount.intValue() + "] Of ExamItemHistory By ExamItemID [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemHistory> FindByExamItemID(Session MyHSs,Integer ai_ExamItemID ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "FindByExamItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamItemID(20,ai_ExamItemID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemHistoryDAO", "FindByExamItemID", ls_SQLCommand);
			NativeQuery<ExamItemHistory> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemHistory.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemHistory> ExamItemHistoryList = query.list();
			if (ExamItemHistoryList.isEmpty() != true) {
				return ExamItemHistoryList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemHistoryDAO", "FindByExamItemID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemHistory By ExamItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}