package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamItemSelectCondition;
import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemSelectConditionDAO {
	public static ExamItemSelectCondition Add(Session MyHSs,ExamItemSelectCondition ao_ExamItemSelectCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelectCondition.getOwnerSUID(), ao_ExamItemSelectCondition.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemSelectCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamItemSelectCondition.setModifyUser(as_UserName);
			ao_ExamItemSelectCondition.setCreateTime(Common.GetCurrTime());
			ao_ExamItemSelectCondition.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamItemSelectCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Add", "[Ready][ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]");
			return ao_ExamItemSelectCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "Add", "[ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelectCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelectCondition Disable(Session MyHSs, ExamItemSelectCondition ao_ExamItemSelectCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelectCondition.getOwnerSUID(), ao_ExamItemSelectCondition.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemSelectCondition.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemSelectCondition.setDeletedUser(as_UserName);
			ao_ExamItemSelectCondition.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemSelectCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Disable", "[Ready][ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]");
			return ao_ExamItemSelectCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "Disable", "[ID:" +ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelectCondition
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelectCondition Delete(Session MyHSs, ExamItemSelectCondition ao_ExamItemSelectCondition, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelectCondition.getOwnerSUID(), ao_ExamItemSelectCondition.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemSelectCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Delete", "[ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]");
			return ao_ExamItemSelectCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "Delete", "[ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelectCondition
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelectCondition Modify(Session MyHSs, ExamItemSelectCondition ao_ExamItemSelectCondition, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelectCondition.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemSelectCondition.setModifyTime(Common.GetCurrTime());
			ao_ExamItemSelectCondition.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemSelectCondition);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "Modify", "[ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]");
			return ao_ExamItemSelectCondition;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "Modify", "[ID:" + ao_ExamItemSelectCondition.getExamItemSelectConditionID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemSelectConditionID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemSelectCondition GetByID(Session MyHSs, Integer ai_ExamItemSelectConditionID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemSelectCondition theExamItemSelectCondition = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemSelectCondition> criteria = builder.createQuery(ExamItemSelectCondition.class);
		criteria.where(builder.equal(criteria.from(ExamItemSelectCondition.class).get("examItemSelectConditionID"), ai_ExamItemSelectConditionID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemSelectCondition = (ExamItemSelectCondition) query.getSingleResult();
			if (theExamItemSelectCondition != null) {
				return theExamItemSelectCondition;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemSelectConditionID + "]");
				throw new DataNotFoundException("ExamItemSelectCondition [" + ai_ExamItemSelectConditionID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemSelectConditionID + "]");
			throw new DataNotFoundException("ExamItemSelectCondition [" + ai_ExamItemSelectConditionID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EISCD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemSelectCondition EISCD ");
		sb_SQLCommand.append("WHERE EISCD.EISCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamItemSelectCondition By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamItemSelectCondition> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamItemSelectCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemSelectCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemSelectCondition> ExamItemSelectConditionList = query.list();
			if (ExamItemSelectConditionList.isEmpty() != true) {
				return ExamItemSelectConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemSelectCondition By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EISCD.* ");
		}
		sb_SQLCommand.append("FROM ExamItemSelectCondition EISCD ");
//		sb_SQLCommand.append("JOIN BehaviorLevel BL ON BL.BehaviorLevelID = EISCD.EISCD_BehaviorLevelID ");
//		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EISCD.EISCD_UnitID ");
//		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EISCD.EISCD_SectionID ");
//		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EISCD.EISCD_ObjectiveID ");
		sb_SQLCommand.append("WHERE EISCD.EISCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		if(ai_BehaviorLevelID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EISCD.EISCD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EISCD.EICD_BehaviorLevelID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(10,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDExamType", "[" + RowCount.intValue() + "] Of ExamItemSelectCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",BehaviorLevelID:"+ai_BehaviorLevelID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemSelectCondition> FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(20,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
			NativeQuery<ExamItemSelectCondition> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemSelectCondition.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemSelectCondition> ExamItemSelectConditionList = query.list();
			if (ExamItemSelectConditionList.isEmpty() != true) {
				return ExamItemSelectConditionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemSelectCondition By FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT SUM(EISCD.EISCD_NOFItem) ");
		sb_SQLCommand.append("FROM ExamItemSelectCondition EISCD ");
		sb_SQLCommand.append("WHERE EISCD.EISCD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_UnitEISCD "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EISCD.EISCD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EISCD.EISCD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType(ai_ExamFormConditionID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectConditionDAO", "SumItemByExamFormConditionIDUnitIDSectionIDObjectiveIDConditionType", "[" + RowCount.intValue() + "] Of ExamItemSelectCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
}
