package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.ExamItemSelected;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamItemSelectedDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelected Add(Session MyHSs,ExamItemSelected ao_ExamItemSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelected.getOwnerSUID(), ao_ExamItemSelected.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamItemSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamItemSelected.setModifyUser(as_UserName);
			ao_ExamItemSelected.setCreateTime(Common.GetCurrTime());
			ao_ExamItemSelected.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamItemSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Add", "[Ready][ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]");
			return ao_ExamItemSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectedDAO", "Add", "[ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelected Disable(Session MyHSs, ExamItemSelected ao_ExamItemSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelected.getOwnerSUID(), ao_ExamItemSelected.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamItemSelected.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamItemSelected.setDeletedUser(as_UserName);
			ao_ExamItemSelected.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamItemSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Disable", "[Ready][ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]");
			return ao_ExamItemSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectedDAO", "Disable", "[ID:" +ao_ExamItemSelected.getExamItemSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelected
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelected Delete(Session MyHSs, ExamItemSelected ao_ExamItemSelected, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelected.getOwnerSUID(), ao_ExamItemSelected.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamItemSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Delete", "[ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]");
			return ao_ExamItemSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectedDAO", "Delete", "[ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamItemSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamItemSelected Modify(Session MyHSs, ExamItemSelected ao_ExamItemSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamItemSelected.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamItemSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamItemSelected.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamItemSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "Modify", "[ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]");
			return ao_ExamItemSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectedDAO", "Modify", "[ID:" + ao_ExamItemSelected.getExamItemSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamItemSelectedID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamItemSelected GetByID(Session MyHSs, Integer ai_ExamItemSelectedID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamItemSelected theExamItemSelected = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamItemSelected> criteria = builder.createQuery(ExamItemSelected.class);
		criteria.where(builder.equal(criteria.from(ExamItemSelected.class).get("examItemSelectedID"), ai_ExamItemSelectedID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamItemSelected = (ExamItemSelected) query.getSingleResult();
			if (theExamItemSelected != null) {
				return theExamItemSelected;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemSelectedID + "]");
				throw new DataNotFoundException("ExamItemSelected [" + ai_ExamItemSelectedID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_ExamItemSelectedID + "]");
			throw new DataNotFoundException("ExamItemSelected [" + ai_ExamItemSelectedID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	public static ExamItemSelected GetByExamItemIDExamScheduleDetailIDPersonIDRatingRoundExamFormConditionID(Session MyHSs, Integer ai_ExamItemID, Integer ai_ExamScheduleDetailID, Integer ai_PersonID, Integer ai_RatingRoundID,Integer ai_ExamFormConditionID,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		ExamItemSelected Obj = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetByExamItemIDExamScheduleDetailIDPersonID", "[START] @@@");
		
		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT EIS.* ");
			sb_SQLCommand.append("FROM ExamItemSelected EIS ");
			sb_SQLCommand.append("JOIN ExamScheduleDetailSelected ESDS ON ESDS.ExamScheduleDetailSelectedID = EIS.EIS_ExamScheduleDetailSelectedID ");
			sb_SQLCommand.append(PermissionService.GetJoinString("EIS.EIS_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EIS.EIS_CreateTime IS NOT NULL ");
			if(ai_ExamItemID != null){
				sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID = " + ai_ExamItemID+" ");
			}
			if(ai_ExamScheduleDetailID != null){
				sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
			}
			if(ai_RatingRoundID != null){
				sb_SQLCommand.append("AND EIS.EIS_RatingRound = " + ai_RatingRoundID+" ");
			}
			if(ai_PersonID != null){
				sb_SQLCommand.append("AND EIS.EIS_PersonID = " + ai_PersonID+" ");
			}
			if(ai_ExamFormConditionID != null){
				sb_SQLCommand.append("AND EIS.EIS_ExamFormConditionID = " + ai_ExamFormConditionID+" ");
			}
			if (StatusList.length > 0) {
				sb_SQLCommand.append("AND EIS.EIS_DataStatus NOT IN ( ");
				for (int i = 0; i < StatusList.length; i++) {
					if(i!=0){
						sb_SQLCommand.append(", ");
					}
					sb_SQLCommand.append(StatusList[i]);
				}
				sb_SQLCommand.append(") ");
			}
			
			sb_SQLCommand.append(PermissionService.GetWhereString("EIS.EIS_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetByExamItemIDExamScheduleDetailIDPersonID", sb_SQLCommand.toString());
			NativeQuery<ExamItemSelected> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamItemSelected.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamItemSelected> ExamItemSelectedList = query.list();
			if (ExamItemSelectedList.isEmpty() != true) {
				return ExamItemSelectedList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetByCode", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamItemSelected By GetByExamItemIDExamScheduleDetailIDPersonID ["+ai_ExamItemID+ " ] ["+ai_ExamScheduleDetailID+ " ] ["+ai_PersonID+ " ] is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByPersonIDExamFormConditionID(int ai_CommandType, Integer ai_PersonID,Integer ai_ExamFormConditionID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EIS.* ");
		}
		sb_SQLCommand.append("FROM ExamItemSelected EIS ");
		sb_SQLCommand.append("JOIN ExamItem EI ON EI.ExamItemID = EIS.EIS_ExamItemID ");
		sb_SQLCommand.append(PermissionService.GetJoinString("EIS.EIS_OwnerGroupID", SUID, SGID));
		sb_SQLCommand.append("WHERE EIS.EIS_CreateTime IS NOT NULL ");
//		if(ai_BehaviorLevelID != null){
//			sb_SQLCommand.append("AND EI.EI_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
//		}
//		if(ai_UnitID != null){
//			sb_SQLCommand.append("AND EI.EI_UnitID = "+ai_UnitID+" ");
//			sb_SQLCommand.append("AND EI.EI_SectionID IS NULL ");
//			sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
//		}else if(ai_SectionID != null){
//			sb_SQLCommand.append("AND EI.EI_SectionID = "+ai_SectionID+" ");
//			sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
//		}else if(ai_ObjectiveID != null){
//			sb_SQLCommand.append("AND EI.EI_ObjectiveID = "+ai_ObjectiveID+" ");
//		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND EIS.EIS_PersonID = " + ai_PersonID+" ");
		}
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EIS.EIS_ExamFormConditionID = " + ai_ExamFormConditionID+" ");
		}
		sb_SQLCommand.append("AND EIS.EIS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
//		if (ai_CommandType != 10) {
//			sb_SQLCommand.append("ORDER BY EIS.EIS_Code , EIS.EIS_QuestionText ");
//		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonIDExamFormConditionID(Session MyHSs, Integer ai_PersonID,Integer ai_ExamFormConditionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetSizeByBehaviorLevelID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByPersonIDExamFormConditionID(10,ai_PersonID,ai_ExamFormConditionID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetSizeByBehaviorLevelID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "GetSizeByBehaviorLevelID", "[" + RowCount.intValue() + "] Of ExamItemSelected By ExamItemSelectedGroupID[ai_PersonID :"+ai_PersonID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemSelected> FindByPersonIDExamFormConditionID(Session MyHSs, Integer ai_PersonID,Integer ai_ExamFormConditionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "FindByBehaviorLevelID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonIDExamFormConditionID(20,ai_PersonID,ai_ExamFormConditionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemSelectedDAO", "FindByBehaviorLevelID", ls_SQLCommand);
			NativeQuery<ExamItemSelected> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamItemSelected.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamItemSelected> ExamItemSelectedList = query.list();
			if (ExamItemSelectedList.isEmpty() != true) {
				return ExamItemSelectedList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemSelectedDAO", "FindByBehaviorLevelID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItemSelected By FindByBehaviorLevelID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
