package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamRound;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamRoundDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamRound
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamRound Add(Session MyHSs,ExamRound ao_ExamRound, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamRound.getOwnerSUID(), ao_ExamRound.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamRound.setModifyTime(Common.GetCurrTime());
			ao_ExamRound.setModifyUser(as_UserName);
			ao_ExamRound.setCreateTime(Common.GetCurrTime());
			ao_ExamRound.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamRound);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Add", "[Ready][ID:" + ao_ExamRound.getExamRoundID() + "]");
			return ao_ExamRound;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "Add", "[ID:" + ao_ExamRound.getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamRound
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamRound Disable(Session MyHSs, ExamRound ao_ExamRound, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamRound.getOwnerSUID(), ao_ExamRound.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamRound.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamRound.setDeletedUser(as_UserName);
			ao_ExamRound.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamRound);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Disable", "[Ready][ID:" + ao_ExamRound.getExamRoundID() + "]");
			return ao_ExamRound;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "Disable", "[ID:" +ao_ExamRound.getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamRound
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamRound Delete(Session MyHSs, ExamRound ao_ExamRound, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamRound.getOwnerSUID(), ao_ExamRound.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamRound);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Delete", "[ID:" + ao_ExamRound.getExamRoundID() + "]");
			return ao_ExamRound;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "Delete", "[ID:" + ao_ExamRound.getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamRound
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamRound Modify(Session MyHSs, ExamRound ao_ExamRound, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamRound.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamRound.setModifyTime(Common.GetCurrTime());
			ao_ExamRound.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamRound);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "Modify", "[ID:" + ao_ExamRound.getExamRoundID() + "]");
			return ao_ExamRound;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "Modify", "[ID:" + ao_ExamRound.getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamRoundID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamRound GetByID(Session MyHSs, Integer ai_ExamRoundID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamRound theExamRound = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamRound> criteria = builder.createQuery(ExamRound.class);
		criteria.where(builder.equal(criteria.from(ExamRound.class).get("examRoundID"), ai_ExamRoundID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamRound = (ExamRound) query.getSingleResult();
			if (theExamRound != null) {
				return theExamRound;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "GetByID", "[Not Found][ID:" + ai_ExamRoundID + "]");
				throw new DataNotFoundException("ExamRound [" + ai_ExamRoundID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "GetByID", "[Not Found][ID:" + ai_ExamRoundID + "]");
			throw new DataNotFoundException("ExamRound [" + ai_ExamRoundID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBNumber(int ai_CommandType,Integer ai_ExamRoundNumber, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT ER.* ");
		}
		sb_SQLCommand.append("FROM ExamRound ER ");
		sb_SQLCommand.append("WHERE ER.ER_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamRoundNumber != null){
			sb_SQLCommand.append("AND ER.ER_Number = "+ai_ExamRoundNumber+" ");
		}
		
		return sb_SQLCommand.toString();
	}

	public static ExamRound GetByNumber(Session MyHSs,Integer ai_ExamRoundNumber,Integer SUID,Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetByNumber", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBNumber(20,ai_ExamRoundNumber,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetByNumber", ls_SQLCommand);
			NativeQuery<ExamRound> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamRound.class);
			
			List<ExamRound> ExamRoundList = query.list();
			if (ExamRoundList.isEmpty() != true) {
				return ExamRoundList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "GetByNumber", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamRound By GetByNumber is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ER.* ");
		}
		sb_SQLCommand.append("FROM ExamRound ER ");
		sb_SQLCommand.append("WHERE ER.ER_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamRound By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamRound> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamRound> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamRound.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamRound> ExamRoundList = query.list();
			if (ExamRoundList.isEmpty() != true) {
				return ExamRoundList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamRound By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamYearIDExamSemesterID(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT ER.* ");
		}
		sb_SQLCommand.append("FROM ExamRound ER ");
		sb_SQLCommand.append("WHERE ER.ER_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null || ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ER.ExamRoundID IN ( ");
				sb_SQLCommand.append("SELECT ES.ES_ExamRoundID ");
				sb_SQLCommand.append("FROM ExamSchedule ES ");
				sb_SQLCommand.append("WHERE ES.ES_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				if(ai_ExamYearID != null){
					sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
				}
				if(ai_ExamSemesterID != null){
					sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
				}
			sb_SQLCommand.append(" ) ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterID(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeByExamYearIDExamSemesterID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterID(10,ai_ExamYearID , ai_ExamSemesterID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeByExamYearIDExamSemesterID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "GetSizeByExamYearIDExamSemesterID", "[" + RowCount.intValue() + "] Of ExamRound By ExamYearID ["+ai_ExamYearID+"] ExamSemesterID ["+ai_ExamSemesterID+"][END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamRound> FindByExamYearIDExamSemesterID(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "FindByExamYearIDExamSemesterID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterID(20,ai_ExamYearID , ai_ExamSemesterID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamRoundDAO", "FindByExamYearIDExamSemesterID", ls_SQLCommand);
			NativeQuery<ExamRound> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamRound.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamRound> ExamRoundList = query.list();
			if (ExamRoundList.isEmpty() != true) {
				return ExamRoundList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamRoundDAO", "FindByExamYearIDExamSemesterID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamRound By ExamYearID ExamSemesterID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}