package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamSchedule;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

public class ExamScheduleDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamSchedule
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSchedule Add(Session MyHSs,ExamSchedule ao_ExamSchedule, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSchedule.getOwnerSUID(), ao_ExamSchedule.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamSchedule.setModifyTime(Common.GetCurrTime());
			ao_ExamSchedule.setModifyUser(as_UserName);
			ao_ExamSchedule.setCreateTime(Common.GetCurrTime());
			ao_ExamSchedule.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_ExamSchedule);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Add", "[Ready][ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]");
			return ao_ExamSchedule;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "Add", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSchedule
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSchedule Disable(Session MyHSs, ExamSchedule ao_ExamSchedule, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSchedule.getOwnerSUID(), ao_ExamSchedule.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamSchedule.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamSchedule.setDeletedUser(as_UserName);
			ao_ExamSchedule.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamSchedule);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Disable", "[Ready][ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]");
			return ao_ExamSchedule;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "Disable", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSchedule
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSchedule Delete(Session MyHSs, ExamSchedule ao_ExamSchedule, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSchedule.getOwnerSUID(), ao_ExamSchedule.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamSchedule);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Delete", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]");
			return ao_ExamSchedule;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "Delete", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSchedule
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSchedule Modify(Session MyHSs, ExamSchedule ao_ExamSchedule, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSchedule.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamSchedule.setModifyTime(Common.GetCurrTime());
			ao_ExamSchedule.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamSchedule);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "Modify", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]");
			return ao_ExamSchedule;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "Modify", "[ExamScheduleID:" + ao_ExamSchedule.getExamScheduleID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamScheduleID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamSchedule GetByID(Session MyHSs, Integer ai_ExamScheduleID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamSchedule theExamSchedule = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamSchedule> criteria = builder.createQuery(ExamSchedule.class);
		criteria.where(builder.equal(criteria.from(ExamSchedule.class).get("examScheduleID"), ai_ExamScheduleID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamSchedule = (ExamSchedule) query.getSingleResult();
			if (theExamSchedule != null) {
				return theExamSchedule;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleID + "]");
				throw new DataNotFoundException("ExamSchedule [" + ai_ExamScheduleID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleID + "]");
			throw new DataNotFoundException("ExamSchedule [" + ai_ExamScheduleID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ES.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ES ");
		sb_SQLCommand.append("WHERE ES.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamSchedule By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamSchedule> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRound != null){
			sb_SQLCommand.append("AND ESH.ES_ExamRoundID = "+ai_ExamRound+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatus != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationStatus = "+ae_ExaminationStatus.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(10, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ExaminationStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamSemesterID+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"] ExaminationStatus["+ae_ExaminationStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(20, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearNameExamSemesterNumberExamRoundNumberExaminationType(int ai_CommandType,String as_ExamYearName , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_ExamYearName != null){
			sb_SQLCommand.append("AND EY.EY_Name = "+as_ExamYearName+" ");
		}
		if(ai_ExamSemesterNumber != null){
			sb_SQLCommand.append("AND ES.ES_Number = "+ai_ExamSemesterNumber+" ");
		}
		if(ai_ExamRoundNumber != null){
			sb_SQLCommand.append("AND ER.ER_Number = "+ai_ExamRoundNumber+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearNameExamSemesterNumberExamRoundNumberExaminationType(Session MyHSs,String as_ExamYearName , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearNameExamSemesterNumberExamRoundNumberExaminationType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearNameExamSemesterNumberExamRoundNumberExaminationType(10, as_ExamYearName ,  ai_ExamSemesterNumber , ai_ExamRoundNumber, ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearNameExamSemesterNumberExamRoundNumberExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamSemesterID+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"] ExaminationStatus["+ae_ExaminationStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearNameExamSemesterNumberExamRoundNumberExaminationType(Session MyHSs,String as_ExamYearName , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearNameExamSemesterNumberExamRoundNumberExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearNameExamSemesterNumberExamRoundNumberExaminationType(20, as_ExamYearName ,  ai_ExamSemesterNumber , ai_ExamRoundNumber, ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearNameExamSemesterNumberExamRoundNumberExaminationType", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearNameExamSemesterNumberExamRoundNumberExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamSemesterNumberExamRoundNumberExaminationType(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND EY.ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterNumber != null){
			sb_SQLCommand.append("AND ES.ES_Number = "+ai_ExamSemesterNumber+" ");
		}
		if(ai_ExamRoundNumber != null){
			sb_SQLCommand.append("AND ER.ER_Number = "+ai_ExamRoundNumber+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterNumberExamRoundNumberExaminationType(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterNumberExamRoundNumberExaminationType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterNumberExamRoundNumberExaminationType(10, ai_ExamYearID ,  ai_ExamSemesterNumber , ai_ExamRoundNumber, ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterNumberExamRoundNumberExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamSemesterID+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"] ExaminationStatus["+ae_ExaminationStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearIDExamSemesterNumberExamRoundNumberExaminationType(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterNumber , Integer ai_ExamRoundNumber, TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterNumberExamRoundNumberExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterNumberExamRoundNumberExaminationType(20, ai_ExamYearID ,  ai_ExamSemesterNumber , ai_ExamRoundNumber, ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterNumberExamRoundNumberExaminationType", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterNumberExamRoundNumberExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYear ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ListFilterExaminationStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRound != null){
			sb_SQLCommand.append("AND ESH.ES_ExamRoundID = "+ai_ExamRound+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ListFilterExaminationStatus != null){
			if(ae_ListFilterExaminationStatus.size() > 0){
				if(ae_ListFilterExaminationStatus.size() == 1){
					sb_SQLCommand.append("AND ESH.ES_ExaminationStatus != "+ae_ListFilterExaminationStatus .get(0).getValue()+" ");
				}else{
					sb_SQLCommand.append("AND ESH.ES_ExaminationStatus NOT IN ( "+ae_ListFilterExaminationStatus .get(0).getValue()+" ");
					for(int i = 1;i < ae_ListFilterExaminationStatus.size();i++){
						sb_SQLCommand.append(",");	
						sb_SQLCommand.append(ae_ListFilterExaminationStatus .get(i).getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
			}
			
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , ES.ES_Number ,ER.ER_Number ,ET.ET_Number  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ListFilterExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(10, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ListFilterExaminationStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamSemesterID+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"] ExaminationStatus["+ae_ListFilterExaminationStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ListFilterExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(20, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ListFilterExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType FilterExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearExamSemesterExamRoundExamExaminationType(int ai_CommandType,Integer ai_ExamYear , Integer ai_ExamSemester , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYear != null){
			sb_SQLCommand.append("AND EY.EY_Year = "+ai_ExamYear+" ");
		}
		if(ai_ExamSemester != null){
			sb_SQLCommand.append("AND ES.ES_Number = "+ai_ExamSemester+" ");
		}
		if(ai_ExamRound != null){
			sb_SQLCommand.append("AND ER.ER_Number = "+ai_ExamRound+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearExamSemesterExamRoundExaminationType(Session MyHSs,Integer ai_ExamYear , Integer ai_ExamSemester , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearExamSemesterExamRoundExaminationType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearExamSemesterExamRoundExamExaminationType(10, ai_ExamYear ,  ai_ExamSemester , ai_ExamRound, ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearExamSemesterExamRoundExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearExamSemesterExamRoundExaminationType", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYear["+ai_ExamYear+"] ExamSemester["+ai_ExamSemester+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearExamSemesterExamRoundExaminationType(Session MyHSs,Integer ai_ExamYear , Integer ai_ExamSemester , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearExamSemesterExamRoundExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearExamSemesterExamRoundExamExaminationType(20, ai_ExamYear ,  ai_ExamSemester , ai_ExamRound, ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearExamSemesterExamRoundExaminationType", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearExamSemesterExamRoundExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamTermIDExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamTermID , TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatus != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationStatus = "+ae_ExaminationStatus.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamTermID, TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamTermIDExaminationTypeExaminationStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDExaminationTypeExaminationStatus(10, ai_ExamYearID ,  ai_ExamTermID, ae_ExaminationType, ae_ExaminationStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamTermIDExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamTermIDExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamTermID+"] ExaminationType ["+ae_ExaminationType+"] ExaminationStatus["+ae_ExaminationStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearIDExamTermIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamTermID, TYPE_EXAMINATION ae_ExaminationType, TYPE_EXAMINATION_STATUS ae_ExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamTermIDExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDExaminationTypeExaminationStatus(20, ai_ExamYearID ,  ai_ExamTermID, ae_ExaminationType, ae_ExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamTermIDExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamTermIDExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, Integer ai_SubjectID, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESH.* ");
		}
		sb_SQLCommand.append("FROM ExamSchedule ESH ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ESH.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = ESH.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ESH.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN ExamTerm ET ON ET.ExamTermID = ESH.ES_ExamTermID ");
		sb_SQLCommand.append("WHERE ESH.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRound != null){
			sb_SQLCommand.append("AND ESH.ES_ExamRoundID = "+ai_ExamRound+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ESH.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND 0 < ( SELECT COUNT(*) FROM ExamScheduleDetail ESD WHERE ESH.ExamScheduleID = ESD.ESD_CopiedExamScheduleID AND ESD_SubjectID = "+ai_SubjectID+" ) ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year DESC , ES.ES_Number DESC  ,ER.ER_Number DESC ,ET.ET_Number  DESC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, Integer ai_SubjectID, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList(10, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound,ai_SubjectID, ae_ExaminationType, ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList", "[" + RowCount.intValue() + "] Of ExamSchedule By ExamYearID["+ai_ExamYearID+"] ExamSemesterID["+ai_ExamSemesterID+"] ExamRound ["+ai_ExamRound+"] ExaminationType ["+ae_ExaminationType+"]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSchedule> FindByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, Integer ai_SubjectID, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList(20, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound,ai_SubjectID, ae_ExaminationType, ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatusList", ls_SQLCommand);
			NativeQuery<ExamSchedule> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSchedule.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSchedule> ExamScheduleList = query.list();
			if (ExamScheduleList.isEmpty() != true) {
				return ExamScheduleList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDAO", "FindByExamYearIDExamSemesterIDExamRoundSubjectIDExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSchedule By ExamYearID ExamSemesterID ExamRound ExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}