package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

public class ExamScheduleDetailDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetail Add(Session MyHSs,ExamScheduleDetail ao_ExamScheduleDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetail.getOwnerSUID(), ao_ExamScheduleDetail.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamScheduleDetail.setModifyTime(Common.GetCurrTime());
			ao_ExamScheduleDetail.setModifyUser(as_UserName);
			ao_ExamScheduleDetail.setCreateTime(Common.GetCurrTime());
			ao_ExamScheduleDetail.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_ExamScheduleDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Add", "[Ready][ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]");
			return ao_ExamScheduleDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "Add", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetail Disable(Session MyHSs, ExamScheduleDetail ao_ExamScheduleDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetail.getOwnerSUID(), ao_ExamScheduleDetail.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamScheduleDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamScheduleDetail.setDeletedUser(as_UserName);
			ao_ExamScheduleDetail.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamScheduleDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Disable", "[Ready][ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]");
			return ao_ExamScheduleDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "Disable", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetail
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetail Delete(Session MyHSs, ExamScheduleDetail ao_ExamScheduleDetail, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetail.getOwnerSUID(), ao_ExamScheduleDetail.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamScheduleDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Delete", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]");
			return ao_ExamScheduleDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "Delete", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetail Modify(Session MyHSs, ExamScheduleDetail ao_ExamScheduleDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetail.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamScheduleDetail.setModifyTime(Common.GetCurrTime());
			ao_ExamScheduleDetail.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamScheduleDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "Modify", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]");
			return ao_ExamScheduleDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "Modify", "[ExamScheduleDetailID:" + ao_ExamScheduleDetail.getExamScheduleDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamScheduleDetailID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamScheduleDetail GetByID(Session MyHSs, Integer ai_ExamScheduleDetailID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamScheduleDetail theExamScheduleDetail = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamScheduleDetail> criteria = builder.createQuery(ExamScheduleDetail.class);
		criteria.where(builder.equal(criteria.from(ExamScheduleDetail.class).get("examScheduleDetailID"), ai_ExamScheduleDetailID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamScheduleDetail = (ExamScheduleDetail) query.getSingleResult();
			if (theExamScheduleDetail != null) {
				return theExamScheduleDetail;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleDetailID + "]");
				throw new DataNotFoundException("ExamScheduleDetail [" + ai_ExamScheduleDetailID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleDetailID + "]");
			throw new DataNotFoundException("ExamScheduleDetail [" + ai_ExamScheduleDetailID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamScheduleDetail> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , EST.ES_Number , ER.ER_Number , SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(10,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(20,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By ExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(int ai_CommandType,Integer ai_CopiedExamScheduleID,String as_SubjectCode,String as_SubjectName,Integer ai_FormCreateStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID = "+ai_CopiedExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_FormCreateStatus == 10){
			//CREATE EXAMFORM
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID IN ( ");
				sb_SQLCommand.append("SELECT EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
			sb_SQLCommand.append(" ) ");
		}else if(ai_FormCreateStatus == 20){
			// NOT CREATE EXAMFORM
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID NOT IN ( ");
				sb_SQLCommand.append("SELECT EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
			sb_SQLCommand.append(" ) ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode,String as_SubjectName,Integer ai_FormCreateStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(10,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FormCreateStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By ExamScheduleID ["+ai_CopiedExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] FormCreateStatus ["+ai_FormCreateStatus+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode,String as_SubjectName,Integer ai_FormCreateStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(20,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FormCreateStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCopiedExamScheduleIDSubjectID(int ai_CommandType,Integer ai_CopiedExamScheduleID,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID = "+ai_CopiedExamScheduleID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamScheduleIDSubjectID(Session MyHSs,Integer ai_CopiedExamScheduleID,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamScheduleIDSubjectID(10,ai_CopiedExamScheduleID,ai_SubjectID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectID", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By CopiedExamScheduleID ["+ai_CopiedExamScheduleID+"] SubjectID ["+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByCopiedExamScheduleIDSubjectID(Session MyHSs,Integer ai_CopiedExamScheduleID,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamScheduleIDSubjectID(20,ai_CopiedExamScheduleID,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectID", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleID SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(int ai_CommandType,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID = "+ai_CopiedExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_FilterPersonID != null){
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID NOT IN ( ");
				sb_SQLCommand.append("SELECT ESDFC.ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ESDFormCollator ESDFC ");
				sb_SQLCommand.append("WHERE ESDFC.ESDFC_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESDFC.PersonID = "+ai_FilterPersonID+" ");
			sb_SQLCommand.append(" ) ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(10,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By CopiedExamScheduleID ["+ai_CopiedExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] FilterPersonID"+ai_FilterPersonID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(20,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleID SubjectCode SubjectName FilterPersonIDInESDFormCollator is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(int ai_CommandType,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID = "+ai_CopiedExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_FilterPersonID != null){
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID NOT IN ( ");
				sb_SQLCommand.append("SELECT ESDFE.ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ESDFormEditor ESDFE ");
				sb_SQLCommand.append("WHERE ESDFE.ESDFE_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESDFE.PersonID = "+ai_FilterPersonID+" ");
			sb_SQLCommand.append(" ) ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(10,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By CopiedExamScheduleID ["+ai_CopiedExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] FilterPersonID"+ai_FilterPersonID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(20,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleID SubjectCode SubjectName FilterPersonIDInESDFormEditor is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , EST.ES_Number , ER.ER_Number , SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(10,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(20,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By ExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , EST.ES_Number , ER.ER_Number , SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus(10,ai_ExamYearID,ai_ExamTermID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus(20,ai_ExamYearID,ai_ExamTermID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatus ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
public static String GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,String ai_SubjectCode,String ai_SubjectName,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRoundID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamRoundID = "+ai_ExamRoundID+" ");
		}
		if(ai_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+ai_SubjectCode+"' ");
		}
		if(ai_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name Like '"+ai_SubjectName+"' ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , EST.ES_Number , ER.ER_Number , SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,String ai_SubjectCode,String ai_SubjectName,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus(10,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectCode,ai_SubjectName,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,String ai_SubjectCode,String ai_SubjectName,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus(20,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectCode,ai_SubjectName,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamSemesterIDExamRoundIDSubjectCodeSubjectNameExaminationTypeExaminationStatus", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By ExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList(int ai_CommandType,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("JOIN ExamYear EY ON EY.ExamYearID = ES.ES_ExamYearID ");
		sb_SQLCommand.append("JOIN ExamSemester EST ON EST.ExamSemesterID = ES.ES_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = ES.ES_ExamRoundID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}

		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJ.SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year , EST.ES_Number , ER.ER_Number , SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", "[BEGIN] @@@");
		
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList(10,ai_ExamYearID,ai_ExamTermID, ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList(20,ai_ExamYearID,ai_ExamTermID, ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusList", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By ExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType ExaminationStatus is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector(int ai_CommandType,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CopiedExamScheduleID != null){
			sb_SQLCommand.append("AND ESD.ESD_CopiedExamScheduleID = "+ai_CopiedExamScheduleID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(ai_FilterPersonID != null){
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID NOT IN ( ");
				sb_SQLCommand.append("SELECT ESDIS.ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
				sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESDIS.PersonID = "+ai_FilterPersonID+" ");
			sb_SQLCommand.append(" ) ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector(10,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By CopiedExamScheduleID ["+ai_CopiedExamScheduleID+"] SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] FilterPersonID"+ai_FilterPersonID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector(Session MyHSs,Integer ai_CopiedExamScheduleID,String as_SubjectCode, String as_SubjectName, Integer ai_FilterPersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector(20,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDItemSelector", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleID SubjectCode SubjectName FilterPersonIDInESDFormEditor is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusPersonIDInESDItemSelector(int ai_CommandType ,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESD.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetail ESD ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE ESD.ESD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamTermID  != null){
			sb_SQLCommand.append("AND ES.ES_ExamTermID = "+ai_ExamTermID+" ");
		}

		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID IN ( ");
				sb_SQLCommand.append("SELECT ESDIS.ExamScheduleDetailID ");
				sb_SQLCommand.append("FROM ESDItemSelector ESDIS ");
				sb_SQLCommand.append("WHERE ESDIS.ESDIS_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESDIS.PersonID = "+ai_PersonID+" ");
			sb_SQLCommand.append(" ) ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ES.ES_ExamYearID , ES.ES_ExamTermID , ESD.ESD_SubjectID ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusPersonIDInESDItemSelector(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusPersonIDInESDItemSelector(10,ai_ExamYearID,ai_ExamTermID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,ai_PersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", "[" + RowCount.intValue() + "] Of ExamScheduleDetail By ExamYearID ["+ai_ExamYearID+"] ExamTermID ["+ai_ExamTermID+"] SubjectID ["+ai_SubjectID+"] ExaminationType"+ae_ExaminationType+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamScheduleDetail> FindByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusPersonIDInESDItemSelector(Session MyHSs,Integer ai_ExamYearID,Integer ai_ExamTermID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamTermIDSubjectIDExaminationTypeExaminationStatusPersonIDInESDItemSelector(20,ai_ExamYearID,ai_ExamTermID,ai_SubjectID,ae_ExaminationType,ae_ExaminationStatusList,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", ls_SQLCommand);
			NativeQuery<ExamScheduleDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetail> ExamScheduleDetailList = query.list();
			if (ExamScheduleDetailList.isEmpty() != true) {
				return ExamScheduleDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailDAO", "FindByCopiedExamScheduleIDSubjectCodeSubjectNamePersonIDInESDItemSelector", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetail By CopiedExamScheduleID SubjectCode SubjectName FilterPersonIDInESDFormEditor is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}