package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.model.ExamScheduleDetailSelected;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamScheduleDetailSelectedDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetailSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetailSelected Add(Session MyHSs,ExamScheduleDetailSelected ao_ExamScheduleDetailSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetailSelected.getOwnerSUID(), ao_ExamScheduleDetailSelected.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamScheduleDetailSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamScheduleDetailSelected.setModifyUser(as_UserName);
			ao_ExamScheduleDetailSelected.setCreateTime(Common.GetCurrTime());
			ao_ExamScheduleDetailSelected.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamScheduleDetailSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Add", "[Ready][ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]");
			return ao_ExamScheduleDetailSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "Add", "[ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetailSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetailSelected Disable(Session MyHSs, ExamScheduleDetailSelected ao_ExamScheduleDetailSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetailSelected.getOwnerSUID(), ao_ExamScheduleDetailSelected.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamScheduleDetailSelected.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamScheduleDetailSelected.setDeletedUser(as_UserName);
			ao_ExamScheduleDetailSelected.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamScheduleDetailSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Disable", "[Ready][ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]");
			return ao_ExamScheduleDetailSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "Disable", "[ID:" +ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetailSelected
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetailSelected Delete(Session MyHSs, ExamScheduleDetailSelected ao_ExamScheduleDetailSelected, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetailSelected.getOwnerSUID(), ao_ExamScheduleDetailSelected.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamScheduleDetailSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Delete", "[ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]");
			return ao_ExamScheduleDetailSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "Delete", "[ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamScheduleDetailSelected
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamScheduleDetailSelected Modify(Session MyHSs, ExamScheduleDetailSelected ao_ExamScheduleDetailSelected, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamScheduleDetailSelected.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamScheduleDetailSelected.setModifyTime(Common.GetCurrTime());
			ao_ExamScheduleDetailSelected.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamScheduleDetailSelected);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "Modify", "[ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]");
			return ao_ExamScheduleDetailSelected;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "Modify", "[ID:" + ao_ExamScheduleDetailSelected.getExamScheduleDetailSelectedID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamScheduleDetailSelectedID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamScheduleDetailSelected GetByID(Session MyHSs, Integer ai_ExamScheduleDetailSelectedID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamScheduleDetailSelected theExamScheduleDetailSelected = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamScheduleDetailSelected> criteria = builder.createQuery(ExamScheduleDetailSelected.class);
		criteria.where(builder.equal(criteria.from(ExamScheduleDetailSelected.class).get("examScheduleDetailSelectedID"), ai_ExamScheduleDetailSelectedID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamScheduleDetailSelected = (ExamScheduleDetailSelected) query.getSingleResult();
			if (theExamScheduleDetailSelected != null) {
				return theExamScheduleDetailSelected;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleDetailSelectedID + "]");
				throw new DataNotFoundException("ExamScheduleDetailSelected [" + ai_ExamScheduleDetailSelectedID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByID", "[Not Found][ID:" + ai_ExamScheduleDetailSelectedID + "]");
			throw new DataNotFoundException("ExamScheduleDetailSelected [" + ai_ExamScheduleDetailSelectedID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDS.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetailSelected ESDS ");
		sb_SQLCommand.append("WHERE ESDS.ESDS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamScheduleDetailSelected By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamScheduleDetailSelected> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamScheduleDetailSelected> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetailSelected.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetailSelected> ExamScheduleDetailSelectedList = query.list();
			if (ExamScheduleDetailSelectedList.isEmpty() != true) {
				return ExamScheduleDetailSelectedList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamScheduleDetailSelected By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static ExamScheduleDetailSelected GetByExamItemIDExamScheduleDetailID(Session MyHSs, Integer ai_ExamItemID, Integer ai_ExamScheduleDetailID,Integer SUID,Integer SGID,int... StatusList) throws Exception {
		ExamScheduleDetailSelected Obj = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByExamItemIDExamScheduleDetailID", "[START] @@@");
		
		try {
			StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT ESDS.* ");
			sb_SQLCommand.append("FROM ExamScheduleDetailSelected ESDS ");
			sb_SQLCommand.append(PermissionService.GetJoinString("ESDS.ESDS_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE ESDS.ESDS_CreateTime IS NOT NULL ");
			if(ai_ExamItemID != null){
				sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID = " + ai_ExamItemID+" ");
			}
			if(ai_ExamScheduleDetailID != null){
				sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
			}
			
			if (StatusList.length > 0) {
				sb_SQLCommand.append("AND ESDS.ESDS_DataStatus NOT IN ( ");
				for (int i = 0; i < StatusList.length; i++) {
					if(i!=0){
						sb_SQLCommand.append(", ");
					}
					sb_SQLCommand.append(StatusList[i]);
				}
				sb_SQLCommand.append(") ");
			}
			
			sb_SQLCommand.append(PermissionService.GetWhereString("ESDS.ESDS_OwnerUserID", SUID, SGID));
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByExamItemIDExamScheduleDetailID", sb_SQLCommand.toString());
			NativeQuery<ExamScheduleDetailSelected> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(ExamScheduleDetailSelected.class);
			query.setFirstResult(0);
			query.setMaxResults(1);
			List<ExamScheduleDetailSelected> ExamScheduleDetailSelectedList = query.list();
			if (ExamScheduleDetailSelectedList.isEmpty() != true) {
				return ExamScheduleDetailSelectedList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetByCode", "[Not Found] @@@");
				throw new DataNotFoundException("Get ExamScheduleDetailSelected By GetByExamItemIDExamScheduleDetailID ["+ai_ExamItemID+ " ] ["+ai_ExamScheduleDetailID+ " ]  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamScheduleDetailIDExamItemIDListExamItem(int ai_CommandType,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ESDS.* ");
		}
		sb_SQLCommand.append("FROM ExamScheduleDetailSelected ESDS ");
		sb_SQLCommand.append("WHERE ESDS.ESDS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID != null){
			sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
		}
		if(ai_ExamItemIDList != null && ai_ExamItemIDList.size() > 0){
			sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID IN ( ");
			sb_SQLCommand.append(ai_ExamItemIDList.get(0));
			for (int i = 1; i < ai_ExamItemIDList.size(); i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(ai_ExamItemIDList.get(i));
			}
			sb_SQLCommand.append(") ");
		}
//		if(ae_ExamItemSelectedStatus != null){
//			sb_SQLCommand.append("AND ESDS.ESDS_ExamFormSelectedStatus = " + ae_ExamItemSelectedStatus.getValue()+" ");
//		}
		return sb_SQLCommand.toString();
	}

	public static int GetSizeByExamScheduleDetailIDExamItemIDListExamItem(Session MyHSs,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeByExamScheduleDetailIDExamItemIDListExamItem", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDExamItemIDListExamItem(10,ai_ExamScheduleDetailID,ai_ExamItemIDList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeByExamScheduleDetailIDExamItemIDListExamItem", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "GetSizeByExamScheduleDetailIDExamItemIDListExamItem", "[" + RowCount.intValue() + "] Of ExamScheduleDetailSelected By All [END] @@@");
		return RowCount.intValue();
	}

	public static List<ExamScheduleDetailSelected> FindByExamScheduleDetailIDExamItemIDListExamItem(Session MyHSs,Integer ai_ExamScheduleDetailID,List<Integer> ai_ExamItemIDList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByExamScheduleDetailIDExamItemIDListExamItem", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDExamItemIDListExamItem(20,ai_ExamScheduleDetailID,ai_ExamItemIDList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByExamScheduleDetailIDExamItemIDListExamItem", ls_SQLCommand);
			NativeQuery<ExamScheduleDetailSelected> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamScheduleDetailSelected.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamScheduleDetailSelected> ExamScheduleDetailSelectedList = query.list();
			if (ExamScheduleDetailSelectedList.isEmpty() != true) {
				return ExamScheduleDetailSelectedList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamScheduleDetailSelectedDAO", "FindByExamScheduleDetailIDExamItemIDListExamItem", "[Not Found] @@@");
				throw new DataNotFoundException("Find FindByExamScheduleDetailIDExamItemIDListExamItem By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
