package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamSemester;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamSemesterDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamSemester
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSemester Add(Session MyHSs,ExamSemester ao_ExamSemester, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSemester.getOwnerSUID(), ao_ExamSemester.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamSemester.setModifyTime(Common.GetCurrTime());
			ao_ExamSemester.setModifyUser(as_UserName);
			ao_ExamSemester.setCreateTime(Common.GetCurrTime());
			ao_ExamSemester.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamSemester);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Add", "[Ready][ID:" + ao_ExamSemester.getExamSemesterID() + "]");
			return ao_ExamSemester;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "Add", "[ID:" + ao_ExamSemester.getExamSemesterID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSemester
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSemester Disable(Session MyHSs, ExamSemester ao_ExamSemester, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSemester.getOwnerSUID(), ao_ExamSemester.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamSemester.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamSemester.setDeletedUser(as_UserName);
			ao_ExamSemester.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamSemester);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Disable", "[Ready][ID:" + ao_ExamSemester.getExamSemesterID() + "]");
			return ao_ExamSemester;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "Disable", "[ID:" +ao_ExamSemester.getExamSemesterID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSemester
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSemester Delete(Session MyHSs, ExamSemester ao_ExamSemester, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSemester.getOwnerSUID(), ao_ExamSemester.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamSemester);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Delete", "[ID:" + ao_ExamSemester.getExamSemesterID() + "]");
			return ao_ExamSemester;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "Delete", "[ID:" + ao_ExamSemester.getExamSemesterID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamSemester
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamSemester Modify(Session MyHSs, ExamSemester ao_ExamSemester, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamSemester.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamSemester.setModifyTime(Common.GetCurrTime());
			ao_ExamSemester.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamSemester);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "Modify", "[ID:" + ao_ExamSemester.getExamSemesterID() + "]");
			return ao_ExamSemester;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "Modify", "[ID:" + ao_ExamSemester.getExamSemesterID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamSemesterID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamSemester GetByID(Session MyHSs, Integer ai_ExamSemesterID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamSemester theExamSemester = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamSemester> criteria = builder.createQuery(ExamSemester.class);
		criteria.where(builder.equal(criteria.from(ExamSemester.class).get("examSemesterID"), ai_ExamSemesterID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamSemester = (ExamSemester) query.getSingleResult();
			if (theExamSemester != null) {
				return theExamSemester;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "GetByID", "[Not Found][ID:" + ai_ExamSemesterID + "]");
				throw new DataNotFoundException("ExamSemester [" + ai_ExamSemesterID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "GetByID", "[Not Found][ID:" + ai_ExamSemesterID + "]");
			throw new DataNotFoundException("ExamSemester [" + ai_ExamSemesterID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByNumber(int ai_CommandType,Integer ai_ExamSemesterNumber, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT EST.* ");
		}
		sb_SQLCommand.append("FROM ExamSemester EST ");
		sb_SQLCommand.append("WHERE EST.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamSemesterNumber != null){
			sb_SQLCommand.append("AND EST.ES_Number = "+ai_ExamSemesterNumber+" ");
		}
		
		return sb_SQLCommand.toString();
	}

	public static ExamSemester GetByNumber(Session MyHSs,Integer ai_ExamSemesterNumber,Integer SUID,Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetByNumber", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByNumber(20, ai_ExamSemesterNumber,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetByNumber", ls_SQLCommand);
			NativeQuery<ExamSemester> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSemester.class);
			
			List<ExamSemester> ExamSemesterList = query.list();
			if (ExamSemesterList.isEmpty() != true) {
				return ExamSemesterList.get(0);
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "GetByNumber", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSemester By ExamYearID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ES.* ");
		}
		sb_SQLCommand.append("FROM ExamSemester ES ");
		sb_SQLCommand.append("WHERE ES.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamSemester By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamSemester> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamSemester> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSemester.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSemester> ExamSemesterList = query.list();
			if (ExamSemesterList.isEmpty() != true) {
				return ExamSemesterList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSemester By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamYearID(int ai_CommandType,Integer ai_ExamYearID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT EST.* ");
		}
		sb_SQLCommand.append("FROM ExamSemester EST ");
		sb_SQLCommand.append("WHERE EST.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND EST.ExamSemesterID IN ( ");
				sb_SQLCommand.append("SELECT ES.ES_ExamSemesterID ");
				sb_SQLCommand.append("FROM ExamSchedule ES ");
				sb_SQLCommand.append("WHERE ES.ES_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_ExamYearID+" ");
			sb_SQLCommand.append(" ) ");
		}
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamYearID(Session MyHSs,Integer ai_ExamYearID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeByExamYearID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearID(10,ai_ExamYearID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeByExamYearID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "GetSizeByExamYearID", "[" + RowCount.intValue() + "] Of ExamSemester By ExamYearID["+ai_ExamYearID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamSemester> FindByExamYearID(Session MyHSs,Integer ai_ExamYearID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "FindByExamYearID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearID(20, ai_ExamYearID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamSemesterDAO", "FindByExamYearID", ls_SQLCommand);
			NativeQuery<ExamSemester> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamSemester.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamSemester> ExamSemesterList = query.list();
			if (ExamSemesterList.isEmpty() != true) {
				return ExamSemesterList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamSemesterDAO", "FindByExamYearID", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamSemester By ExamYearID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}