package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamTerm;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

public class ExamTermDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamTerm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTerm Add(Session MyHSs,ExamTerm ao_ExamTerm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTerm.getOwnerSUID(), ao_ExamTerm.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamTerm.setModifyTime(Common.GetCurrTime());
			ao_ExamTerm.setModifyUser(as_UserName);
			ao_ExamTerm.setCreateTime(Common.GetCurrTime());
			ao_ExamTerm.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamTerm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Add", "[Ready][ID:" + ao_ExamTerm.getExamTermID() + "]");
			return ao_ExamTerm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "Add", "[ID:" + ao_ExamTerm.getExamTermID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTerm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTerm Disable(Session MyHSs, ExamTerm ao_ExamTerm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTerm.getOwnerSUID(), ao_ExamTerm.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamTerm.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ObjectDAO.Disable(MyHSs, ao_ExamTerm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Disable", "[Ready][ID:" + ao_ExamTerm.getExamTermID() + "]");
			return ao_ExamTerm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "Disable", "[ID:" +ao_ExamTerm.getExamTermID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTerm
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTerm Delete(Session MyHSs, ExamTerm ao_ExamTerm, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTerm.getOwnerSUID(), ao_ExamTerm.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamTerm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Delete", "[ID:" + ao_ExamTerm.getExamTermID() + "]");
			return ao_ExamTerm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "Delete", "[ID:" + ao_ExamTerm.getExamTermID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTerm
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTerm Modify(Session MyHSs, ExamTerm ao_ExamTerm, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTerm.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamTerm.setModifyTime(Common.GetCurrTime());
			ao_ExamTerm.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamTerm);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "Modify", "[ID:" + ao_ExamTerm.getExamTermID() + "]");
			return ao_ExamTerm;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "Modify", "[ID:" + ao_ExamTerm.getExamTermID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamTermID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamTerm GetByID(Session MyHSs, Integer ai_ExamTermID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamTerm theExamTerm = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamTerm> criteria = builder.createQuery(ExamTerm.class);
		criteria.where(builder.equal(criteria.from(ExamTerm.class).get("examTermID"), ai_ExamTermID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamTerm = (ExamTerm) query.getSingleResult();
			if (theExamTerm != null) {
				return theExamTerm;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "GetByID", "[Not Found][ID:" + ai_ExamTermID + "]");
				throw new DataNotFoundException("ExamTerm [" + ai_ExamTermID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "GetByID", "[Not Found][ID:" + ai_ExamTermID + "]");
			throw new DataNotFoundException("ExamTerm [" + ai_ExamTermID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ET.* ");
		}
		sb_SQLCommand.append("FROM ExamTerm ET ");
		sb_SQLCommand.append("WHERE ET.ET_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamTerm By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamTerm> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamTerm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamTerm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamTerm> ExamTermList = query.list();
			if (ExamTermList.isEmpty() != true) {
				return ExamTermList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamTerm By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByNumber(int ai_CommandType,Integer ai_Number, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ET.* ");
		}
		sb_SQLCommand.append("FROM ExamTerm ET ");
		sb_SQLCommand.append("WHERE ET.ET_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_Number != null){
			sb_SQLCommand.append("AND ET.ET_Number = "+ai_Number+" ");
		}
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeByNumber(Session MyHSs,Integer ai_Number,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByNumber", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByNumber(10,ai_Number,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByNumber", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByNumber", "[" + RowCount.intValue() + "] Of ExamTerm By Number [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamTerm> FindByNumber(Session MyHSs,Integer ai_Number,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByNumber", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByNumber(20,ai_Number,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByNumber", ls_SQLCommand);
			NativeQuery<ExamTerm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamTerm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamTerm> ExamTermList = query.list();
			if (ExamTermList.isEmpty() != true) {
				return ExamTermList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "FindByNumber", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamTerm By Number is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamYearIDSubjectIDExaminationType(int ai_CommandType,Integer ai_YearID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(distinct ET.ExamTermID ) ");
		} else {
			sb_SQLCommand.append("SELECT distinct ET.* ");
		}
		sb_SQLCommand.append("FROM ExamTerm ET ");
		sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ES_ExamTermID = ET.ExamTermID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
		sb_SQLCommand.append("WHERE ET.ET_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_YearID != null){
			sb_SQLCommand.append("AND ES.ES_ExamYearID = "+ai_YearID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND ESD.ESD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ES.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeByExamYearIDSubjectIDExaminationType(Session MyHSs,Integer ai_YearID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByExamYearIDSubjectIDExaminationType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDSubjectIDExaminationType(10,ai_YearID,ai_SubjectID,ae_ExaminationType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByExamYearIDSubjectIDExaminationType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "GetSizeByExamYearIDSubjectIDExaminationType", "[" + RowCount.intValue() + "] Of ExamTerm By Number [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamTerm> FindByExamYearIDSubjectIDExaminationType(Session MyHSs,Integer ai_YearID,Integer ai_SubjectID,TYPE_EXAMINATION ae_ExaminationType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByExamYearIDSubjectIDExaminationType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDSubjectIDExaminationType(20,ai_YearID,ai_SubjectID,ae_ExaminationType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTermDAO", "FindByNumber", ls_SQLCommand);
			NativeQuery<ExamTerm> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamTerm.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamTerm> ExamTermList = query.list();
			if (ExamTermList.isEmpty() != true) {
				return ExamTermList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTermDAO", "FindByExamYearIDSubjectIDExaminationType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamTerm By Number is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}