package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamTimes;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamTimesDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamTimes
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTimes Add(Session MyHSs,ExamTimes ao_ExamTimes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Add", "[START] @@@");
		try {
		
			ao_ExamTimes.setModifyTime(Common.GetCurrTime());
			ao_ExamTimes.setModifyUser(as_UserName);
			ao_ExamTimes.setCreateTime(Common.GetCurrTime());
			ao_ExamTimes.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamTimes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Add", "[Ready][ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]");
			return ao_ExamTimes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "Add", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTimes
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTimes Disable(Session MyHSs, ExamTimes ao_ExamTimes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTimes.getOwnerSUID(), ao_ExamTimes.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamTimes.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamTimes.setDeletedUser(as_UserName);
			ao_ExamTimes.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamTimes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Disable", "[Ready][ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]");
			return ao_ExamTimes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "Disable", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTimes
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTimes Delete(Session MyHSs, ExamTimes ao_ExamTimes, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTimes.getOwnerSUID(), ao_ExamTimes.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamTimes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Delete", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]");
			return ao_ExamTimes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "Delete", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamTimes
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamTimes Modify(Session MyHSs, ExamTimes ao_ExamTimes, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamTimes.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamTimes.setModifyTime(Common.GetCurrTime());
			ao_ExamTimes.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamTimes);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "Modify", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]");
			return ao_ExamTimes;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "Modify", "[ExamSemesterID:" + ao_ExamTimes.getPK().getExamSemesterID() + "] ExamRoundID:" + ao_ExamTimes.getPK().getExamRoundID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamTimesID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamTimes GetByID(Session MyHSs, Integer ai_ExamSemesterID,Integer ai_ExamRoundID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamTimes theExamTimes = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamTimes> criteria = builder.createQuery(ExamTimes.class);
		Root<ExamTimes> root = criteria.from(ExamTimes.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("examSemesterID"), ai_ExamSemesterID),
						builder.equal(root.get("PK").get("examRoundID"), ai_ExamRoundID)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamTimes =  (ExamTimes) query.getSingleResult();
			if (theExamTimes != null) {
				return theExamTimes;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("examSemesterID [" + ai_ExamSemesterID +"] ,examRoundID ["+ai_ExamRoundID+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("examSemesterID [" + ai_ExamSemesterID +"] ,examRoundID ["+ai_ExamRoundID+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ET.* ");
		}
		sb_SQLCommand.append("FROM ExamTimes ET ");
		sb_SQLCommand.append("WHERE ET.ET_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamTimes By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamTimes> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamTimes> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamTimes.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamTimes> ExamTimesList = query.list();
			if (ExamTimesList.isEmpty() != true) {
				return ExamTimesList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamTimesDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamTimes By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
}