package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamYear;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ExamYearDAO {
	/**
	 * @param MyHSs
	 * @param ao_ExamYear
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamYear Add(Session MyHSs,ExamYear ao_ExamYear, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamYear.getOwnerSUID(), ao_ExamYear.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_ExamYear.setModifyTime(Common.GetCurrTime());
			ao_ExamYear.setModifyUser(as_UserName);
			ao_ExamYear.setCreateTime(Common.GetCurrTime());
			ao_ExamYear.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_ExamYear);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Add", "[Ready][ID:" + ao_ExamYear.getExamYearID() + "]");
			return ao_ExamYear;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "Add", "[ID:" + ao_ExamYear.getExamYearID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamYear
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamYear Disable(Session MyHSs, ExamYear ao_ExamYear, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamYear.getOwnerSUID(), ao_ExamYear.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_ExamYear.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_ExamYear.setDeletedUser(as_UserName);
			ao_ExamYear.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_ExamYear);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Disable", "[Ready][ID:" + ao_ExamYear.getExamYearID() + "]");
			return ao_ExamYear;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "Disable", "[ID:" +ao_ExamYear.getExamYearID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamYear
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamYear Delete(Session MyHSs, ExamYear ao_ExamYear, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamYear.getOwnerSUID(), ao_ExamYear.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_ExamYear);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Delete", "[ID:" + ao_ExamYear.getExamYearID() + "]");
			return ao_ExamYear;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "Delete", "[ID:" + ao_ExamYear.getExamYearID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_ExamYear
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static ExamYear Modify(Session MyHSs, ExamYear ao_ExamYear, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_ExamYear.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_ExamYear.setModifyTime(Common.GetCurrTime());
			ao_ExamYear.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_ExamYear);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "Modify", "[ID:" + ao_ExamYear.getExamYearID() + "]");
			return ao_ExamYear;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "Modify", "[ID:" + ao_ExamYear.getExamYearID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ExamYearID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static ExamYear GetByID(Session MyHSs, Integer ai_ExamYearID, Integer SUID, Integer SGID) throws DataNotFoundException {
		ExamYear theExamYear = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<ExamYear> criteria = builder.createQuery(ExamYear.class);
		criteria.where(builder.equal(criteria.from(ExamYear.class).get("examYearID"), ai_ExamYearID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theExamYear = (ExamYear) query.getSingleResult();
			if (theExamYear != null) {
				return theExamYear;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "GetByID", "[Not Found][ID:" + ai_ExamYearID + "]");
				throw new DataNotFoundException("ExamYear [" + ai_ExamYearID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "GetByID", "[Not Found][ID:" + ai_ExamYearID + "]");
			throw new DataNotFoundException("ExamYear [" + ai_ExamYearID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EY.* ");
		}
		sb_SQLCommand.append("FROM ExamYear EY ");
		sb_SQLCommand.append("WHERE EY.EY_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of ExamYear By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<ExamYear> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<ExamYear> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamYear.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamYear> ExamYearList = query.list();
			if (ExamYearList.isEmpty() != true) {
				return ExamYearList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamYear By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLInExamSchedule(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT EY.* ");
		}
		sb_SQLCommand.append("FROM ExamYear EY ");
		sb_SQLCommand.append("WHERE EY.EY_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		sb_SQLCommand.append("AND EY.ExamYearID IN ( ");
		sb_SQLCommand.append("SELECT ES.ES_ExamYearID ");
		sb_SQLCommand.append("FROM ExamSchedule ES ");
		sb_SQLCommand.append("WHERE ES.ES_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
	sb_SQLCommand.append(" ) ");
	if (ai_CommandType != 10) {
		sb_SQLCommand.append("ORDER BY EY.EY_Year ");
	}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeInExamSchedule(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeInExamSchedule", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLInExamSchedule(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeInExamSchedule", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeInExamSchedule", "[" + RowCount.intValue() + "] Of ExamYear InExamSchedule [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamYear> FindInExamSchedule(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindInExamSchedule", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLInExamSchedule(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindInExamSchedule", ls_SQLCommand);
			NativeQuery<ExamYear> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamYear.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamYear> ExamYearList = query.list();
			if (ExamYearList.isEmpty() != true) {
				return ExamYearList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "FindInExamSchedule", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamYear InExamSchedule is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByYear(int ai_CommandType, Integer ai_Year,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EY.* ");
		}
		sb_SQLCommand.append("FROM ExamYear EY ");
		sb_SQLCommand.append("WHERE EY.EY_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_Year != null){
			sb_SQLCommand.append("AND EY.EY_Year = "+ai_Year+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EY.EY_Year ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByYear(Session MyHSs,Integer ai_Year,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeByYear", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByYear(10,ai_Year,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeByYear", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "GetSizeByYear", "[" + RowCount.intValue() + "] Of ExamYear By Year [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamYear> FindByYear(Session MyHSs,Integer ai_Year,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindByYear", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByYear(20,ai_Year,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamYearDAO", "FindByYear", ls_SQLCommand);
			NativeQuery<ExamYear> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(ExamYear.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamYear> ExamYearList = query.list();
			if (ExamYearList.isEmpty() != true) {
				return ExamYearList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamYearDAO", "FindByYear", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamYear By Year is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}