package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Indicators;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class IndicatorsDAO {
	/**
	 * @param MyHSs
	 * @param ao_BehaviorLevel
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Indicators Add(Session MyHSs,Indicators ao_Indicators, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Indicators.getOwnerSUID(), ao_Indicators.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Indicators.setModifyTime(Common.GetCurrTime());
			ao_Indicators.setModifyUser(as_UserName);
			ao_Indicators.setCreateTime(Common.GetCurrTime());
			ao_Indicators.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_Indicators);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Add", "[Ready][ID:" + ao_Indicators.getIndicatorID() + "]");
			return ao_Indicators;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "Add", "[ID:" + ao_Indicators.getIndicatorID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Indicators
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Indicators Disable(Session MyHSs, Indicators ao_Indicators, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Indicators.getOwnerSUID(), ao_Indicators.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Indicators.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Indicators.setDeletedUser(as_UserName);
			ao_Indicators.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Indicators);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Disable", "[Ready][ID:" + ao_Indicators.getIndicatorID() + "]");
			return ao_Indicators;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "Disable", "[ID:" +ao_Indicators.getIndicatorID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Indicators
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Indicators Delete(Session MyHSs, Indicators ao_Indicators, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Indicators.getOwnerSUID(), ao_Indicators.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Indicators);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Delete", "[ID:" + ao_Indicators.getIndicatorID() + "]");
			return ao_Indicators;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "Delete", "[ID:" + ao_Indicators.getIndicatorID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Indicators
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Indicators Modify(Session MyHSs, Indicators ao_Indicators, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Indicators.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Indicators.setModifyTime(Common.GetCurrTime());
			ao_Indicators.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Indicators);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "Modify", "[ID:" + ao_Indicators.getIndicatorID() + "]");
			return ao_Indicators;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "Modify", "[ID:" + ao_Indicators.getIndicatorID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_IndicatorsID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Indicators GetByID(Session MyHSs, Integer ai_IndicatorsID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Indicators theIndicators = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Indicators> criteria = builder.createQuery(Indicators.class);
		criteria.where(builder.equal(criteria.from(Indicators.class).get("indicatorsID"), ai_IndicatorsID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theIndicators = (Indicators) query.getSingleResult();
			if (theIndicators != null) {
				return theIndicators;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "GetByID", "[Not Found][ID:" + ai_IndicatorsID + "]");
				throw new DataNotFoundException("Indicators [" + ai_IndicatorsID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "GetByID", "[Not Found][ID:" + ai_IndicatorsID + "]");
			throw new DataNotFoundException("Indicators [" + ai_IndicatorsID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT I.* ");
		}
		sb_SQLCommand.append("FROM Indicators I ");
		sb_SQLCommand.append("WHERE I.I_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Indicators By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Indicators> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Indicators> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Indicators.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Indicators> IndicatorsList = query.list();
			if (IndicatorsList.isEmpty() != true) {
				return IndicatorsList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Indicators By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByCurriculumAttributeID(int ai_CommandType, Integer ai_CurriculumAttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT I.* ");
		}
		sb_SQLCommand.append("FROM Indicators I ");
		sb_SQLCommand.append("WHERE I.I_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CurriculumAttributeID != null){
			sb_SQLCommand.append("AND I.I_CurriculumAttributeID = "+ai_CurriculumAttributeID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY I.I_Order , I.I_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumAttributeID(Session MyHSs,Integer ai_CurriculumAttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumAttributeID(10,ai_CurriculumAttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumAttributeID", "[" + RowCount.intValue() + "] Of Indicators By IndicatorsGroupID[CurriculumAttributeID :"+ai_CurriculumAttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Indicators> FindByCurriculumAttributeID(Session MyHSs,Integer ai_CurriculumAttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByCurriculumAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumAttributeID(20,ai_CurriculumAttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByCurriculumAttributeID", ls_SQLCommand);
			NativeQuery<Indicators> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Indicators.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Indicators> IndicatorsList = query.list();
			if (IndicatorsList.isEmpty() != true) {
				return IndicatorsList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "FindByCurriculumAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find Indicators By FindByCurriculumAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByCurriculumIDAttributeID(int ai_CommandType, Integer ai_CurriculumID ,Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT I.* ");
		}
		sb_SQLCommand.append("FROM Indicators I ");
		sb_SQLCommand.append("JOIN CurriculumAttribute CA ON I.I_CurriculumAttributeID = CA.CurriculumAttributeID ");
		sb_SQLCommand.append("WHERE I.I_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CurriculumID != null){
			sb_SQLCommand.append("AND CA.CA_CurriculumID = "+ai_CurriculumID+" ");
		}
		if(ai_AttributeID != null){
			sb_SQLCommand.append("AND CA.CA_AttributeID = "+ai_AttributeID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY I.I_Order , I.I_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByCurriculumIDAttributeID(Session MyHSs, Integer ai_CurriculumID ,Integer ai_AttributeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumIDAttributeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByCurriculumIDAttributeID(10,ai_CurriculumID,ai_AttributeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumIDAttributeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "GetSizeByCurriculumIDAttributeID", "[" + RowCount.intValue() + "] Of Indicators By IndicatorsGroupID[ai_CurriculumID :"+ai_CurriculumID +"] [ai_AttributeID :"+ai_AttributeID +"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Indicators> FindByCurriculumIDAttributeID(Session MyHSs, Integer ai_CurriculumID ,Integer ai_AttributeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByCurriculumIDAttributeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByCurriculumIDAttributeID(20,ai_CurriculumID,ai_AttributeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "IndicatorsDAO", "FindByCurriculumIDAttributeID", ls_SQLCommand);
			NativeQuery<Indicators> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Indicators.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Indicators> IndicatorsList = query.list();
			if (IndicatorsList.isEmpty() != true) {
				return IndicatorsList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "IndicatorsDAO", "FindByCurriculumIDAttributeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find Indicators By FindByCurriculumAttributeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
