package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.criterion.Restrictions;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.MainSelector;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class MainSelectorDAO {
	public static MainSelector Add(Session MyHSs,MainSelector ao_MainSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_MainSelector.getOwnerSUID(), ao_MainSelector.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_MainSelector.setModifyTime(Common.GetCurrTime());
			ao_MainSelector.setModifyUser(as_UserName);
			ao_MainSelector.setCreateTime(Common.GetCurrTime());
			ao_MainSelector.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_MainSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Add", "[Ready][MainSelector:" + ao_MainSelector.getMainSelectorID() + "] ");
			return ao_MainSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "Add", "[MainSelector:" + ao_MainSelector.getMainSelectorID() + "] " + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_MainSelector
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static MainSelector Disable(Session MyHSs, MainSelector ao_MainSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_MainSelector.getOwnerSUID(), ao_MainSelector.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_MainSelector.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_MainSelector.setDeletedUser(as_UserName);
			ao_MainSelector.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_MainSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Disable", "[Ready][MainSelectorID:" + ao_MainSelector.getMainSelectorID() + "]");
			return ao_MainSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "Disable", "[MainSelectorID:" + ao_MainSelector.getMainSelectorID() + "]" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_MainSelector
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static MainSelector Delete(Session MyHSs, MainSelector ao_MainSelector, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_MainSelector.getOwnerSUID(), ao_MainSelector.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_MainSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Delete", "[MainSelector:" + ao_MainSelector.getMainSelectorID() + "]");
			return ao_MainSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "Delete", "[MainSelector:" + ao_MainSelector.getMainSelectorID() + "]" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_MainSelector
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static MainSelector Modify(Session MyHSs, MainSelector ao_MainSelector, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_MainSelector.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_MainSelector.setModifyTime(Common.GetCurrTime());
			ao_MainSelector.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_MainSelector);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "Modify", "[MainSelectorID:" + ao_MainSelector.getMainSelectorID() + "]");
			return ao_MainSelector;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "Modify", "[MainSelectorID:" + ao_MainSelector.getMainSelectorID() + "]" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_MainSelectorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static MainSelector GetByID(Session MyHSs, Integer ai_MainSelectorID, Integer SUID, Integer SGID) throws DataNotFoundException {
		MainSelector theMainSelector = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<MainSelector> criteria = builder.createQuery(MainSelector.class);
		criteria.where(builder.equal(criteria.from(MainSelector.class).get("mainSelectorID"), ai_MainSelectorID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theMainSelector = (MainSelector) query.getSingleResult();
			if (theMainSelector != null) {
				return theMainSelector;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "GetByID", "[Not Found][ID:" + ai_MainSelectorID + "]");
				throw new DataNotFoundException("MainSelector [" + ai_MainSelectorID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "GetByID", "[Not Found][ID:" + ai_MainSelectorID + "]");
			throw new DataNotFoundException("MainSelector [" + ai_MainSelectorID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	public static MainSelector GetByID(Session MyHSs, Integer ai_ExamScheduleDetailID,Integer ai_PersonID,Integer ai_ExamLevel,Integer ai_UnitID, Integer SUID, Integer SGID) throws DataNotFoundException {
		MainSelector theMainSelector = null;
		List<MainSelector> MainSelectorList;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetByID", "[START] @@@");
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetByID", "[ExamScheduleDetailID] "+ai_ExamScheduleDetailID+"[PersonID] "+ai_PersonID+"[ExamLevel] "+ai_ExamLevel+"[UnitID] "+ai_UnitID);
		Criteria MyHC;
		MyHC = MyHSs.createCriteria(MainSelector.class).add(Restrictions.eq("MS_ExamScheduleDetailID", ai_ExamScheduleDetailID)).add(Restrictions.eq("MS_PersonID", ai_PersonID)).add(Restrictions.eq("MS_ExamLevel", ai_ExamLevel)).add(Restrictions.eq("MS_UnitID", ai_UnitID));
		MyHC.setFirstResult(0);
		MyHC.setMaxResults(1);
		MainSelectorList = MyHC.list();
		if (MainSelectorList.isEmpty() != true) {
			theMainSelector = MainSelectorList.get(0);
			return theMainSelector;
		} else {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("MainSelector [ExamScheduleDetailID:" + ai_ExamScheduleDetailID + "] is not found.");
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT MS.* ");
		}
		sb_SQLCommand.append("FROM MainSelector MS ");
		sb_SQLCommand.append("WHERE MS.MS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of MainSelector By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<MainSelector> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<MainSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(MainSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<MainSelector> MainSelectorList = query.list();
			if (MainSelectorList.isEmpty() != true) {
				return MainSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find MainSelector By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleDetailIDPersonIDExamLevelUnitID(int ai_CommandType,Integer ai_ExamScheduleDetailID,Integer ai_PersonID,Integer ai_ExamLevel,Integer ai_UnitID ,  Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT MS.* ");
		}
		sb_SQLCommand.append("FROM MainSelector MS ");
//		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = MS.MS_ExamScheduleDetailID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = ESD.ESD_SubjectID ");
//		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = MS.PersonID ");
		sb_SQLCommand.append("WHERE MS.MS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleDetailID != null){
			sb_SQLCommand.append("AND  MS.MS_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND  MS.MS_PersonID = "+ai_PersonID+" ");
		}
		if(ai_ExamLevel != null){
			sb_SQLCommand.append("AND  MS.MS_ExamLevel = "+ai_ExamLevel+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND  MS.MS_UnitID = "+ai_UnitID+" ");
		}
		if(ai_CommandType != 10){
//			sb_SQLCommand.append("ORDER BY SJ.SJ_Code , SJ.SJ_Name , PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailIDPersonIDExamLevelUnitID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_PersonID,Integer ai_ExamLevel,Integer ai_UnitID ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeByExamScheduleDetailIDPersonIDExamLevelUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailIDPersonIDExamLevelUnitID(10, ai_ExamScheduleDetailID, ai_PersonID, ai_ExamLevel, ai_UnitID  ,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeByExamScheduleDetailIDPersonIDExamLevelUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "GetSizeByExamScheduleDetailIDPersonIDExamLevelUnitID", "[" + RowCount.intValue() + "] Of MainSelector By ExamScheduleDetailID ["+ai_ExamScheduleDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<MainSelector> FindByExamScheduleDetailIDPersonIDExamLevelUnitID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_PersonID,Integer ai_ExamLevel,Integer ai_UnitID  ,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "FindByExamScheduleDetailIDPersonIDExamLevelUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailIDPersonIDExamLevelUnitID(20, ai_ExamScheduleDetailID, ai_PersonID, ai_ExamLevel, ai_UnitID ,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "MainSelectorDAO", "FindByExamScheduleDetailIDPersonIDExamLevelUnitID", ls_SQLCommand);
			NativeQuery<MainSelector> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(MainSelector.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<MainSelector> MainSelectorList = query.list();
			if (MainSelectorList.isEmpty() != true) {
				return MainSelectorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "MainSelectorDAO", "FindByExamScheduleDetailIDPersonIDExamLevelUnitID", "[Not Found] @@@");
				throw new DataNotFoundException("Find MainSelector By FindByExamScheduleDetailIDPersonIDExamLevelUnitID  is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
