package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Objective;
import esi.examwh.model.Topic;
import esi.examwh.model.TopicObjective;
import esi.examwh.model.TopicObjectivePK;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class ObjectiveDAO {
	/**
	 * @param MyHSs
	 * @param ao_Objective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Objective Add(Session MyHSs,Objective ao_Objective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Objective.getOwnerSUID(), ao_Objective.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Objective.setModifyTime(Common.GetCurrTime());
			ao_Objective.setModifyUser(as_UserName);
			ao_Objective.setCreateTime(Common.GetCurrTime());
			ao_Objective.setCreateUser(as_UserName);
			
		
			ObjectDAO.Add(MyHSs, ao_Objective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Add", "[Ready][ObjectiveID:" + ao_Objective.getObjectiveID()+"]");
			return ao_Objective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "Add", "[ObjectiveID:" + ao_Objective.getObjectiveID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	
	public static TopicObjective AddByTopic(Session MyHSs, Objective ao_Objective, Topic ao_Topic, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "AddByTopic", "[START] @@@");
		try {
			ao_Objective.setModifyTime(Common.GetCurrTime());
			ao_Objective.setModifyUser(as_UserName);
			ao_Objective.setCreateTime(Common.GetCurrTime());
			ao_Objective.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_Objective);
			TopicObjectivePK lo_TopicObjectivePK = new TopicObjectivePK(ao_Topic.getTopicID(), ao_Objective.getObjectiveID());
			TopicObjective lo_TopicObjective = new TopicObjective();
			lo_TopicObjective.setPK(lo_TopicObjectivePK);
			lo_TopicObjective.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			lo_TopicObjective.setOwnerUserID(null);
			lo_TopicObjective.setOwnerGroupID(null);
			TopicObjectiveDAO.Add(MyHSs, lo_TopicObjective, as_UserName, SUID, SGID);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "AddByTopic", "[ID:" + ao_Objective.getObjectiveID() + ",TopicID:" + ao_Topic.getTopicID() + "]");
			return lo_TopicObjective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "AddByTopic", "[ID:" + ao_Objective.getObjectiveID() + ",TopicID:" + ao_Topic.getTopicID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Objective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Objective Disable(Session MyHSs, Objective ao_Objective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Objective.getOwnerSUID(), ao_Objective.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Objective.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Objective.setDeletedUser(as_UserName);
			ao_Objective.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Objective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Disable", "[Ready][ObjectiveID:" + ao_Objective.getObjectiveID()+"]");
			return ao_Objective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "Disable", "[ObjectiveID:" + ao_Objective.getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Objective
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Objective Delete(Session MyHSs, Objective ao_Objective, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Objective.getOwnerSUID(), ao_Objective.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Objective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Delete", "[ObjectiveID:" + ao_Objective.getObjectiveID()+"]");
			return ao_Objective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "Delete", "[ObjectiveID:" + ao_Objective.getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Objective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Objective Modify(Session MyHSs, Objective ao_Objective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Objective.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Objective.setModifyTime(Common.GetCurrTime());
			ao_Objective.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Objective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "Modify", "[ObjectiveID:" + ao_Objective.getObjectiveID()+"]");
			return ao_Objective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "Modify", "[ObjectiveID:" + ao_Objective.getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_ObjectiveID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Objective GetByID(Session MyHSs, Integer ai_ObjectiveID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Objective theObjective = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Objective> criteria = builder.createQuery(Objective.class);
		criteria.where(builder.equal(criteria.from(Objective.class).get("objectiveID"), ai_ObjectiveID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theObjective = (Objective) query.getSingleResult();
			if (theObjective != null) {
				return theObjective;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "GetByID", "[Not Found][ID:" + ai_ObjectiveID + "]");
				throw new DataNotFoundException("Objective [" + ai_ObjectiveID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "GetByID", "[Not Found][ID:" + ai_ObjectiveID + "]");
			throw new DataNotFoundException("Objective [" + ai_ObjectiveID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Objective By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Objective> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySectionID(int ai_CommandType,Integer ai_SectionID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND OJ.OJ_SectionID = "+ai_SectionID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySectionID(Session MyHSs,Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySectionID(10,ai_SectionID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionID", "[" + RowCount.intValue() + "] Of Objective By SectionID [SectionID:"+ai_SectionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySectionID(Session MyHSs,Integer ai_SectionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByBySectionID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySectionID(20,ai_SectionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindBySectionID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindBySectionID[SectionID:"+ai_SectionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By SectionID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySectionIDNotUsedInAnyTopic(int ai_CommandType,Integer ai_SectionID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND OJ.OJ_SectionID = '"+ai_SectionID+"' ");
		}
		sb_SQLCommand.append("AND OJ.ObjectiveID NOT IN ( ");
			sb_SQLCommand.append("SELECT TPO.ObjectiveID ");
			sb_SQLCommand.append("FROM TopicObjective TPO ");
			sb_SQLCommand.append("WHERE TPO.TO_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
		sb_SQLCommand.append(" ) ");
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySectionIDNotUsedInAnyTopic(Session MyHSs,Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionIDNotUsedInAnyTopic", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySectionIDNotUsedInAnyTopic(10,ai_SectionID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionIDNotUsedInAnyTopic", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySectionIDNotUsedInAnyTopic", "[" + RowCount.intValue() + "] Of Objective By SectionID [SectionID:"+ai_SectionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySectionIDNotUsedInAnyTopic(Session MyHSs,Integer ai_SectionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByBySectionIDNotUsedInAnyTopic", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySectionIDNotUsedInAnyTopic(20,ai_SectionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindBySectionIDNotUsedInAnyTopic", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindBySectionID[SectionID:"+ai_SectionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By SectionID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectIDUnitID(int ai_CommandType,Integer ai_SubjectID,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = OJ.OJ_SectionID ");
		sb_SQLCommand.append("JOIN UNIT UN ON UN.UnitID = ST.ST_UnitID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}

		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDUnitID(Session MyHSs,Integer ai_SubjectID , Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDUnitID(10,ai_SubjectID,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitID", "[" + RowCount.intValue() + "] Of Objective By SubjectID ["+ai_SubjectID+"] UnitID ["+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySubjectIDUnitID(Session MyHSs,Integer ai_SubjectID , Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByBySubjectIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDUnitID(20,ai_SubjectID,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitID[SubjectID:"+ai_SubjectID+"] UnitID ["+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By SubjectID UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLByUnitID(int ai_CommandType,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("LEFT JOIN Section STT ON OJ.OJ_SectionID = STT.SectionID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = STT.ST_UnitID ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND  (  OJ.ObjectiveID IN ( ");
							sb_SQLCommand.append("SELECT OJ2.ObjectiveID  ");
							sb_SQLCommand.append("FROM Objective OJ2  ");
							sb_SQLCommand.append("LEFT JOIN Section ST ON OJ2.OJ_SectionID = ST.SectionID ");
							
							sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
							sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
							sb_SQLCommand.append(", ");
							sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
							sb_SQLCommand.append(") ");
							sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
					sb_SQLCommand.append(" ) ");
					sb_SQLCommand.append(" OR  ");
						sb_SQLCommand.append(" OJ.ObjectiveID IN ( ");
						sb_SQLCommand.append("SELECT OJ3.ObjectiveID  ");
						sb_SQLCommand.append("FROM TopicObjective TOB  ");
						sb_SQLCommand.append("LEFT JOIN Objective OJ3 ON OJ3.ObjectiveID = TOB.ObjectiveID ");
						sb_SQLCommand.append("LEFT JOIN Section ST ON OJ3.OJ_SectionID = ST.SectionID ");
						
						sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
						sb_SQLCommand.append(") ");
						sb_SQLCommand.append("AND TOB.TO_DataStatus NOT IN ( ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
						sb_SQLCommand.append(") ");
						sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
				sb_SQLCommand.append(" ) ");
			sb_SQLCommand.append(" ) ");
					
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order, STT.ST_Order, OJ.OJ_Order");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeByUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByUnitID(10,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeByUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeByUnitID", "[" + RowCount.intValue() + "] Of Objective By UnitID ["+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByByUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByUnitID(20,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindByUnitID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitID[UnitID ["+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By SubjectID UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySectionIDObjectiveOrder(int ai_CommandType,Integer ai_SectionID,Integer ai_ObjectiveOrder, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND OJ.OJ_SectionID = "+ai_SectionID+" ");
		}
		if(ai_ObjectiveOrder != null){
			sb_SQLCommand.append("AND OJ.OJ_Order = "+ai_ObjectiveOrder+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySectionIDObjectiveOrder(Session MyHSs,Integer ai_SectionID,Integer ai_ObjectiveOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySectionIDObjectiveOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySectionIDObjectiveOrder(10,ai_SectionID,ai_ObjectiveOrder, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySectionIDObjectiveOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySectionIDObjectiveOrder", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [SubjectID:"+ai_SectionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySectionIDObjectiveOrder(Session MyHSs,Integer ai_SectionID,Integer ai_ObjectiveOrder,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySectionIDObjectiveOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySectionIDObjectiveOrder(20,ai_SectionID,ai_ObjectiveOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySectionIDObjectiveOrder", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySectionIDObjectiveOrder[SubjectID:"+ai_SectionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SectionID, ObjectiveOrder is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("JOIN Section ST ON OJ.OJ_SectionID = ST.SectionID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
//		sb_SQLCommand.append("JOIN Section ST ON OJ.OJ_SectionID = ST.SectionID ");
//		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
//		if(ai_ExamFormConditionID != null){
//			sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID = UN.UN_SubjectID ");
//			sb_SQLCommand.append("JOIN ExamFormCondition EFCD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
//		}
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND OJ.ObjectiveID IN (SELECT EICD.EICD_ObjectiveID FROM ExamItemCondition EICD WHERE EICD.EICD_DataStatus NOT IN (411,511) AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EICD.EICD_NOFItem IS NOT NULL AND EICD.EICD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionID", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFFindByExamFormConditionIDInExamItemConditionormConditionID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamCreatorCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("JOIN Section ST ON OJ.OJ_SectionID = ST.SectionID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID = UN.UN_SubjectID ");
			sb_SQLCommand.append("JOIN ExamFormCondition EFCD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		}
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND OJ.ObjectiveID IN (SELECT ECCD.ECCD_ObjectiveID FROM ExamCreatorCondition ECCD WHERE ECCD.ECCD_DataStatus NOT IN (411,511) AND ECCD.ECCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND ECCD.ECCD_NOFItem IS NOT NULL AND ECCD.ECCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamCreatorCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamCreatorCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFFindByExamFormConditionIDInExamItemConditionormConditionID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectIDUnitIDFilterObjectiveOrderZero(int ai_CommandType,Integer ai_SubjectID,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = OJ.OJ_SectionID ");
		sb_SQLCommand.append("JOIN UNIT UN ON UN.UnitID = ST.ST_UnitID ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}

		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
		}
		sb_SQLCommand.append("AND OJ.OJ_Order > 0 ");
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDUnitIDFilterObjectiveOrderZero(Session MyHSs,Integer ai_SubjectID , Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitIDFilterObjectiveOrderZero", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDUnitIDFilterObjectiveOrderZero(10,ai_SubjectID,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitIDFilterObjectiveOrderZero", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "GetSizeBySubjectIDUnitIDFilterObjectiveOrderZero", "[" + RowCount.intValue() + "] Of Objective By SubjectID ["+ai_SubjectID+"] UnitID ["+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindBySubjectIDUnitIDFilterObjectiveOrderZero(Session MyHSs,Integer ai_SubjectID , Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitIDFilterObjectiveOrderZero", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDUnitIDFilterObjectiveOrderZero(20,ai_SubjectID,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitIDFilterObjectiveOrderZero", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ObjectiveDAO", "FindBySubjectIDUnitIDFilterObjectiveOrderZero[SubjectID:"+ai_SubjectID+"] UnitID ["+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Objective By SubjectID UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemSelectCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT OJ.* ");
		}
		sb_SQLCommand.append("FROM Objective OJ ");
		sb_SQLCommand.append("JOIN Section ST ON OJ.OJ_SectionID = ST.SectionID ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID = UN.UN_SubjectID ");
			sb_SQLCommand.append("JOIN ExamFormCondition EFCD ON EFCD.EFCD_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		}
		sb_SQLCommand.append("WHERE OJ.OJ_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND OJ.ObjectiveID IN (SELECT EISCD.EISCD_ObjectiveID FROM ExamItemSelectCondition EISCD WHERE EISCD.EISCD_DataStatus NOT IN (411,511) AND EISCD.EISCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EISCD.EISCD_NOFItem IS NOT NULL AND EISCD.EISCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemSelectCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Objective> FindByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemSelectCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFFindByExamFormConditionIDInExamItemConditionormConditionID", ls_SQLCommand);
			NativeQuery<Objective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Objective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Objective> ObjectiveList = query.list();
			if (ObjectiveList.isEmpty() != true) {
				return ObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
