package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.RemunerationCalculate;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class RemunerationCalculateDAO {
	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculate
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculate Add(Session MyHSs,RemunerationCalculate ao_RemunerationCalculate, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculate.getOwnerSUID(), ao_RemunerationCalculate.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_RemunerationCalculate.setModifyTime(Common.GetCurrTime());
			ao_RemunerationCalculate.setModifyUser(as_UserName);
			ao_RemunerationCalculate.setCreateTime(Common.GetCurrTime());
			ao_RemunerationCalculate.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_RemunerationCalculate);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Add", "[Ready][RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]");
			return ao_RemunerationCalculate;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "Add", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculate
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculate Disable(Session MyHSs, RemunerationCalculate ao_RemunerationCalculate, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculate.getOwnerSUID(), ao_RemunerationCalculate.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_RemunerationCalculate.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_RemunerationCalculate.setDeletedUser(as_UserName);
			ao_RemunerationCalculate.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_RemunerationCalculate);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Disable", "[Ready][RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]");
			return ao_RemunerationCalculate;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "Disable", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculate
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculate Delete(Session MyHSs, RemunerationCalculate ao_RemunerationCalculate, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculate.getOwnerSUID(), ao_RemunerationCalculate.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_RemunerationCalculate);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Delete", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]");
			return ao_RemunerationCalculate;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "Delete", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculate
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculate Modify(Session MyHSs, RemunerationCalculate ao_RemunerationCalculate, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculate.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_RemunerationCalculate.setModifyTime(Common.GetCurrTime());
			ao_RemunerationCalculate.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_RemunerationCalculate);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "Modify", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]");
			return ao_RemunerationCalculate;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "Modify", "[RemunerationCalculateID:" + ao_RemunerationCalculate.getRemunerationCalculateID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_RemunerationCalculateID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static RemunerationCalculate GetByID(Session MyHSs, Integer ai_RemunerationCalculateID, Integer SUID, Integer SGID) throws DataNotFoundException {
		RemunerationCalculate theRemunerationCalculate = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<RemunerationCalculate> criteria = builder.createQuery(RemunerationCalculate.class);
		criteria.where(builder.equal(criteria.from(RemunerationCalculate.class).get("remunerationCalculateID"), ai_RemunerationCalculateID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theRemunerationCalculate = (RemunerationCalculate) query.getSingleResult();
			if (theRemunerationCalculate != null) {
				return theRemunerationCalculate;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "GetByID", "[Not Found][ID:" + ai_RemunerationCalculateID + "]");
				throw new DataNotFoundException("RemunerationCalculate [" + ai_RemunerationCalculateID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "GetByID", "[Not Found][ID:" + ai_RemunerationCalculateID + "]");
			throw new DataNotFoundException("RemunerationCalculate [" + ai_RemunerationCalculateID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT RC.* ");
		}
		sb_SQLCommand.append("FROM RemunerationCalculate RC ");
		sb_SQLCommand.append("WHERE RC.RC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of RemunerationCalculate By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<RemunerationCalculate> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<RemunerationCalculate> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(RemunerationCalculate.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<RemunerationCalculate> RemunerationCalculateList = query.list();
			if (RemunerationCalculateList.isEmpty() != true) {
				return RemunerationCalculateList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find RemunerationCalculate By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByStandardRemunerationIDSubjectIDSubjectCodeSubjectName(int ai_CommandType,Integer ai_StandardRemunerationID,Integer ai_SubjectID,String as_SubjectCode,String as_SubjectName, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT RC.* ");
		}
		sb_SQLCommand.append("FROM RemunerationCalculate RC ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = RC.RC_SubjectID ");
//		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = RC.RC_PersonID ");
		sb_SQLCommand.append("WHERE RC.RC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_StandardRemunerationID != null){
			sb_SQLCommand.append("AND RC.RC_StandardRemunerationID = "+ai_StandardRemunerationID+" ");
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND RC.RC_SubjectID = "+ai_SubjectID+" ");
		}
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = "+as_SubjectCode+" ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '"+as_SubjectName+"' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeByStandardRemunerationIDSubjectIDSubjectCodeSubjectName(Session MyHSs,Integer ai_StandardRemunerationID,Integer ai_SubjectID,String as_SubjectCode,String as_SubjectName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByStandardRemunerationIDSubjectIDSubjectCodeSubjectName(10, ai_StandardRemunerationID, ai_SubjectID,as_SubjectCode, as_SubjectName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "GetSizeByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", "[" + RowCount.intValue() + "] Of RemunerationCalculate By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<RemunerationCalculate> FindByStandardRemunerationIDSubjectIDSubjectCodeSubjectName(Session MyHSs,Integer ai_StandardRemunerationID,Integer ai_SubjectID,String as_SubjectCode,String as_SubjectName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "FindByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByStandardRemunerationIDSubjectIDSubjectCodeSubjectName(20, ai_StandardRemunerationID, ai_SubjectID,as_SubjectCode, as_SubjectName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateDAO", "FindByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", ls_SQLCommand);
			NativeQuery<RemunerationCalculate> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(RemunerationCalculate.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<RemunerationCalculate> RemunerationCalculateList = query.list();
			if (RemunerationCalculateList.isEmpty() != true) {
				return RemunerationCalculateList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateDAO", "FindByStandardRemunerationIDSubjectIDSubjectCodeSubjectName", "[Not Found] @@@");
				throw new DataNotFoundException("Find RemunerationCalculate By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
