package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.RemunerationCalculateItem;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class RemunerationCalculateItemDAO {
	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculateItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculateItem Add(Session MyHSs,RemunerationCalculateItem ao_RemunerationCalculateItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculateItem.getOwnerSUID(), ao_RemunerationCalculateItem.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_RemunerationCalculateItem.setModifyTime(Common.GetCurrTime());
			ao_RemunerationCalculateItem.setModifyUser(as_UserName);
			ao_RemunerationCalculateItem.setCreateTime(Common.GetCurrTime());
			ao_RemunerationCalculateItem.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_RemunerationCalculateItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Add", "[Ready][RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]");
			return ao_RemunerationCalculateItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "Add", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculateItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculateItem Disable(Session MyHSs, RemunerationCalculateItem ao_RemunerationCalculateItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculateItem.getOwnerSUID(), ao_RemunerationCalculateItem.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_RemunerationCalculateItem.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_RemunerationCalculateItem.setDeletedUser(as_UserName);
			ao_RemunerationCalculateItem.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_RemunerationCalculateItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Disable", "[Ready][RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]");
			return ao_RemunerationCalculateItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "Disable", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculateItem
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculateItem Delete(Session MyHSs, RemunerationCalculateItem ao_RemunerationCalculateItem, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculateItem.getOwnerSUID(), ao_RemunerationCalculateItem.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_RemunerationCalculateItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Delete", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]");
			return ao_RemunerationCalculateItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "Delete", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_RemunerationCalculateItem
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static RemunerationCalculateItem Modify(Session MyHSs, RemunerationCalculateItem ao_RemunerationCalculateItem, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_RemunerationCalculateItem.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_RemunerationCalculateItem.setModifyTime(Common.GetCurrTime());
			ao_RemunerationCalculateItem.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_RemunerationCalculateItem);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "Modify", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]");
			return ao_RemunerationCalculateItem;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "Modify", "[RemunerationCalculateItemID:" + ao_RemunerationCalculateItem.getRemunerationCalculateItemID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_RemunerationCalculateItemID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static RemunerationCalculateItem GetByID(Session MyHSs, Integer ai_RemunerationCalculateItemID, Integer SUID, Integer SGID) throws DataNotFoundException {
		RemunerationCalculateItem theRemunerationCalculateItem = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<RemunerationCalculateItem> criteria = builder.createQuery(RemunerationCalculateItem.class);
		criteria.where(builder.equal(criteria.from(RemunerationCalculateItem.class).get("remunerationCalculateItemID"), ai_RemunerationCalculateItemID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theRemunerationCalculateItem = (RemunerationCalculateItem) query.getSingleResult();
			if (theRemunerationCalculateItem != null) {
				return theRemunerationCalculateItem;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "GetByID", "[Not Found][ID:" + ai_RemunerationCalculateItemID + "]");
				throw new DataNotFoundException("RemunerationCalculateItem [" + ai_RemunerationCalculateItemID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "GetByID", "[Not Found][ID:" + ai_RemunerationCalculateItemID + "]");
			throw new DataNotFoundException("RemunerationCalculateItem [" + ai_RemunerationCalculateItemID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT RCI.* ");
		}
		sb_SQLCommand.append("FROM RemunerationCalculateItem RCI ");
		sb_SQLCommand.append("WHERE RCI.RCI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of RemunerationCalculateItem By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<RemunerationCalculateItem> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<RemunerationCalculateItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(RemunerationCalculateItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<RemunerationCalculateItem> RemunerationCalculateItemList = query.list();
			if (RemunerationCalculateItemList.isEmpty() != true) {
				return RemunerationCalculateItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find RemunerationCalculateItem By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByRemunerationCalculateIDPersonIDPersonNamePersonLastName(int ai_CommandType,Integer ai_RemunerationCalculateID,String ai_PersonID,String as_PersonName,String as_PersonLastName, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT RCI.* ");
		}
		sb_SQLCommand.append("FROM RemunerationCalculateItem RCI ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = RCI.RCI_SubjectID ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = RCI.RCI_PersonID ");
		sb_SQLCommand.append("WHERE RCI.RCI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_RemunerationCalculateID != null){
			sb_SQLCommand.append("AND RCI.RCI_RemunerationCalculateID = "+ai_RemunerationCalculateID+" ");
		}
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND RCI.RCI_PersonID = "+ai_PersonID+" ");
		}
		if(as_PersonName != null){
			sb_SQLCommand.append("AND PS.PS_Name LIKE '"+as_PersonName+"' ");
		}
		if(as_PersonLastName != null){
			sb_SQLCommand.append("AND PS.PS_LastName LIKE '"+as_PersonLastName+"' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY PS.PS_Name , PS.PS_LastName ");
		}
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeByRemunerationCalculateIDPersonIDPersonNamePersonLastName(Session MyHSs,Integer ai_RemunerationCalculateID,String ai_PersonID,String as_PersonName,String as_PersonLastName,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeByRemunerationCalculateIDPersonIDPersonNamePersonLastName", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByRemunerationCalculateIDPersonIDPersonNamePersonLastName(10, ai_RemunerationCalculateID, ai_PersonID, as_PersonName, as_PersonLastName,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeByRemunerationCalculateIDPersonIDPersonNamePersonLastName", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "GetSizeByRemunerationCalculateIDPersonIDPersonNamePersonLastName", "[" + RowCount.intValue() + "] Of RemunerationCalculateItem By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<RemunerationCalculateItem> FindByRemunerationCalculateIDPersonIDPersonNamePersonLastName(Session MyHSs,Integer ai_RemunerationCalculateID,String ai_PersonID,String as_PersonName,String as_PersonLastName,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "FindByRemunerationCalculateIDPersonIDPersonNamePersonLastName", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByRemunerationCalculateIDPersonIDPersonNamePersonLastName(20, ai_RemunerationCalculateID, ai_PersonID, as_PersonName, as_PersonLastName,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "RemunerationCalculateItemDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<RemunerationCalculateItem> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(RemunerationCalculateItem.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<RemunerationCalculateItem> RemunerationCalculateItemList = query.list();
			if (RemunerationCalculateItemList.isEmpty() != true) {
				return RemunerationCalculateItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "RemunerationCalculateItemDAO", "FindByRemunerationCalculateIDPersonIDPersonNamePersonLastName", "[Not Found] @@@");
				throw new DataNotFoundException("Find RemunerationCalculateItem By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
