package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Section;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SectionDAO {
	/**
	 * @param MyHSs
	 * @param ao_Section
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Section Add(Session MyHSs,Section ao_Section, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Section.getOwnerSUID(), ao_Section.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Section.setModifyTime(Common.GetCurrTime());
			ao_Section.setModifyUser(as_UserName);
			ao_Section.setCreateTime(Common.GetCurrTime());
			ao_Section.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_Section);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Add", "[Ready][SectionID:" + ao_Section.getSectionID()+"]");
			return ao_Section;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "Add", "[SectionID:" + ao_Section.getSectionID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Section
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Section Disable(Session MyHSs, Section ao_Section, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Section.getOwnerSUID(), ao_Section.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Section.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Section.setDeletedUser(as_UserName);
			ao_Section.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Section);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Disable", "[Ready][SectionID:" + ao_Section.getSectionID()+"]");
			return ao_Section;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "Disable", "[SectionID:" + ao_Section.getSectionID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Section
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Section Delete(Session MyHSs, Section ao_Section, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Section.getOwnerSUID(), ao_Section.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Section);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Delete", "[SectionID:" + ao_Section.getSectionID()+"]");
			return ao_Section;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "Delete", "[SectionID:" + ao_Section.getSectionID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Section
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Section Modify(Session MyHSs, Section ao_Section, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Section.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Section.setModifyTime(Common.GetCurrTime());
			ao_Section.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Section);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "Modify", "[SectionID:" + ao_Section.getSectionID()+"]");
			return ao_Section;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "Modify", "[SectionID:" + ao_Section.getSectionID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SectionID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Section GetByID(Session MyHSs, Integer ai_SectionID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Section theSection = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Section> criteria = builder.createQuery(Section.class);
		criteria.where(builder.equal(criteria.from(Section.class).get("sectionID"), ai_SectionID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSection = (Section) query.getSingleResult();
			if (theSection != null) {
				return theSection;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "GetByID", "[Not Found][ID:" + ai_SectionID + "]");
				throw new DataNotFoundException("Section [" + ai_SectionID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "GetByID", "[Not Found][ID:" + ai_SectionID + "]");
			throw new DataNotFoundException("Section [" + ai_SectionID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Section By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Section> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByUnitID(int ai_CommandType,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = '"+ai_UnitID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByUnitID(10,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitID", "[" + RowCount.intValue() + "] Of Unit By UnitID [UnitID:"+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByByUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByUnitID(20,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByUnitID", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByUnitID[UnitID:"+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormIDUnitID(int ai_CommandType, Integer ai_ExamFormID,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID = UN.UN_SubjectID ");
		sb_SQLCommand.append("JOIN ExamForm EF ON EF.EF_ExamScheduleDetailID = ESD.ExamScheduleDetailID ");
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EF.ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order ,  ST.ST_Order ");
			
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormIDUnitID(Session MyHSs, Integer ai_ExamFormID, Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDUnitID(10,ai_ExamFormID,ai_UnitID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormIDUnitID", "[" + RowCount.intValue() + "] Of Section By ExamFormID ["+ai_ExamFormID+"],UnitID ["+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByExamFormIDUnitID(Session MyHSs, Integer ai_ExamFormID,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByExamFormIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDUnitID(20,ai_ExamFormID, ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByExamFormIDUnitID", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindByExamFormIDUnitID", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By ExamFormID And UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByUnitIDSectionOrder(int ai_CommandType,Integer ai_UnitID,Integer ai_SectionOrder, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
		}
		if(ai_SectionOrder != null){
			sb_SQLCommand.append("AND ST.ST_Order = "+ai_SectionOrder+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByUnitIDSectionOrder(Session MyHSs,Integer ai_UnitID,Integer ai_SectionOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitIDSectionOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByUnitIDSectionOrder(10,ai_UnitID,ai_SectionOrder, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitIDSectionOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByUnitIDSectionOrder", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [SubjectID:"+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByUnitIDSectionOrder(Session MyHSs,Integer ai_UnitID,Integer ai_SectionOrder,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByByUnitIDSectionOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByUnitIDSectionOrder(20,ai_UnitID,ai_SectionOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByUnitIDSectionOrder", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByUnitIDSectionOrder[SubjectID:"+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = '"+ai_SubjectID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of Unit By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND ST.SectionID IN (SELECT EICD.EICD_SectionID FROM ExamItemCondition EICD WHERE EICD.EICD_DataStatus NOT IN (411,511) AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EICD.EICD_NOFItem IS NOT NULL AND EICD.EICD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamItemCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamItemCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamCreatorCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND ST.SectionID IN (SELECT ECCD.ECCD_SectionID FROM ExamCreatorCondition ECCD WHERE ECCD.ECCD_DataStatus NOT IN (411,511) AND ECCD.ECCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND ECCD.ECCD_NOFItem IS NOT NULL AND ECCD.ECCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamCreatorCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamCreatorCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamCreatorCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamCreatorCondition", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamCreatorCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemSelectCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ST.* ");
		}
		sb_SQLCommand.append("FROM Section ST ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = ST.ST_UnitID ");
//		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		
		sb_SQLCommand.append("WHERE ST.ST_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND ST.SectionID IN (SELECT EISCD.EISCD_SectionID FROM ExamItemSelectCondition EISCD WHERE EISCD.EISCD_DataStatus NOT IN (411,511) AND EISCD.EISCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EISCD.EISCD_NOFItem IS NOT NULL AND EISCD.EISCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY ST.ST_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemSelectCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Section> FindByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamItemSelectCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemSelectCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemSelectCondition", ls_SQLCommand);
			NativeQuery<Section> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Section.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Section> SectionList = query.list();
			if (SectionList.isEmpty() != true) {
				return SectionList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SectionDAO", "FindByExamFormConditionIDInExamItemSelectCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Section By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}