package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.StandardRemuneration;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

public class StandardRemunerationDAO {
	public static StandardRemuneration Add(Session MyHSs,StandardRemuneration ao_StandardRemuneration, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_StandardRemuneration.getOwnerSUID(), ao_StandardRemuneration.getOwnerSGID(), SUID, SGID);
		try {
			ao_StandardRemuneration.setModifyTime(Common.GetCurrTime());
			ao_StandardRemuneration.setModifyUser(as_UserName);
			ao_StandardRemuneration.setCreateTime(Common.GetCurrTime());
			ao_StandardRemuneration.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_StandardRemuneration);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Add", "[Ready][StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]");
			return ao_StandardRemuneration;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "Add", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_StandardRemuneration
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static StandardRemuneration Disable(Session MyHSs, StandardRemuneration ao_StandardRemuneration, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_StandardRemuneration.getOwnerSUID(), ao_StandardRemuneration.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_StandardRemuneration.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_StandardRemuneration.setDeletedUser(as_UserName);
			ao_StandardRemuneration.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_StandardRemuneration);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Disable", "[Ready][StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]");
			return ao_StandardRemuneration;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "Disable", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_StandardRemuneration
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static StandardRemuneration Delete(Session MyHSs, StandardRemuneration ao_StandardRemuneration, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_StandardRemuneration.getOwnerSUID(), ao_StandardRemuneration.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_StandardRemuneration);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Delete", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]");
			return ao_StandardRemuneration;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "Delete", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_StandardRemuneration
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static StandardRemuneration Modify(Session MyHSs, StandardRemuneration ao_StandardRemuneration, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_StandardRemuneration.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_StandardRemuneration.setModifyTime(Common.GetCurrTime());
			ao_StandardRemuneration.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_StandardRemuneration);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "Modify", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]");
			return ao_StandardRemuneration;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "Modify", "[StandardRemunerationID:" + ao_StandardRemuneration.getStandardRemunerationID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_StandardRemunerationID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static StandardRemuneration GetByID(Session MyHSs, Integer ai_StandardRemunerationID, Integer SUID, Integer SGID) throws DataNotFoundException {
		StandardRemuneration theStandardRemuneration = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<StandardRemuneration> criteria = builder.createQuery(StandardRemuneration.class);
		criteria.where(builder.equal(criteria.from(StandardRemuneration.class).get("standardRemunerationID"), ai_StandardRemunerationID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theStandardRemuneration = (StandardRemuneration) query.getSingleResult();
			if (theStandardRemuneration != null) {
				return theStandardRemuneration;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "GetByID", "[Not Found][ID:" + ai_StandardRemunerationID + "]");
				throw new DataNotFoundException("StandardRemuneration [" + ai_StandardRemunerationID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "GetByID", "[Not Found][ID:" + ai_StandardRemunerationID + "]");
			throw new DataNotFoundException("StandardRemuneration [" + ai_StandardRemunerationID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SR.* ");
		}
		sb_SQLCommand.append("FROM StandardRemuneration SR ");
		sb_SQLCommand.append("WHERE SR.SR_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of StandardRemuneration By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<StandardRemuneration> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<StandardRemuneration> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(StandardRemuneration.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<StandardRemuneration> StandardRemunerationList = query.list();
			if (StandardRemunerationList.isEmpty() != true) {
				return StandardRemunerationList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find StandardRemuneration By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleID(int ai_CommandType,Integer ai_ExamScheduleID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SR.* ");
		}
		sb_SQLCommand.append("FROM StandardRemuneration SR ");
		sb_SQLCommand.append("WHERE SR.SR_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamScheduleID != null){
			sb_SQLCommand.append("AND SR.SR_ExamScheduleID = "+ai_ExamScheduleID+" ");
		}
		return sb_SQLCommand.toString();
	}
	public static int GetSizeByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleID(10,ai_ExamScheduleID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of StandardRemuneration By All [END] @@@");
		return RowCount.intValue();
	}
	public static List<StandardRemuneration> FindByExamScheduleID(Session MyHSs,Integer ai_ExamScheduleID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleID(20,ai_ExamScheduleID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<StandardRemuneration> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(StandardRemuneration.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<StandardRemuneration> StandardRemunerationList = query.list();
			if (StandardRemunerationList.isEmpty() != true) {
				return StandardRemunerationList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find StandardRemuneration By FindByExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamYearIDExamSemesterIDExamRoundExaminationStatusListExaminationType(int ai_CommandType,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SR.* ");
		}
		sb_SQLCommand.append("FROM StandardRemuneration SR ");
		sb_SQLCommand.append("JOIN ExamSchedule ESH ON ESH.ExamScheduleID = SR.SR_ExamScheduleID ");
		sb_SQLCommand.append("WHERE SR.SR_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamYearID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamYearID = "+ai_ExamYearID+" ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND ESH.ES_ExamSemesterID = "+ai_ExamSemesterID+" ");
		}
		if(ai_ExamRound != null){
			sb_SQLCommand.append("AND ESH.ES_ExamRoundID = "+ai_ExamRound+" ");
		}
		if(ae_ExaminationType != null){
			sb_SQLCommand.append("AND ESH.ES_ExaminationType = "+ae_ExaminationType.getValue()+" ");
		}
		if(ae_ExaminationStatusList != null){
			if(ae_ExaminationStatusList.size() > 0){
				sb_SQLCommand.append("AND ESH.ES_ExaminationStatus IN (  ");
				for(int i=0;i<ae_ExaminationStatusList.size();i++){
					if(i > 0){
						sb_SQLCommand.append(" , ");
					}
					sb_SQLCommand.append(ae_ExaminationStatusList.get(i).getValue());
				}
				sb_SQLCommand.append(" ) ");
			}
		}
		return sb_SQLCommand.toString();
	}
	public static int GetSizeByExamYearIDExamSemesterIDExamRoundExaminationStatusListExaminationType(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamYearIDExamSemesterIDExamRoundExaminationStatusListExaminationType(10,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRound,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "GetSizeByExamScheduleID", "[" + RowCount.intValue() + "] Of StandardRemuneration By All [END] @@@");
		return RowCount.intValue();
	}
	public static List<StandardRemuneration> FindByExamYearIDExamSemesterIDExamRoundExaminationStatusListExaminationType(Session MyHSs,Integer ai_ExamYearID , Integer ai_ExamSemesterID , Integer ai_ExamRound, TYPE_EXAMINATION ae_ExaminationType, List<TYPE_EXAMINATION_STATUS> ae_ExaminationStatusList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamYearIDExamSemesterIDExamRoundExaminationStatusListExaminationType(20,ai_ExamYearID,ai_ExamSemesterID,ai_ExamRound,ae_ExaminationType,ae_ExaminationStatusList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", ls_SQLCommand);
			NativeQuery<StandardRemuneration> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(StandardRemuneration.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<StandardRemuneration> StandardRemunerationList = query.list();
			if (StandardRemunerationList.isEmpty() != true) {
				return StandardRemunerationList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "StandardRemunerationDAO", "FindByExamScheduleID", "[Not Found] @@@");
				throw new DataNotFoundException("Find StandardRemuneration By FindByExamScheduleID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
