package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectCollator;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SubjectCollatorDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectCollator Add(Session MyHSs,SubjectCollator ao_SubjectCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectCollator.getOwnerSUID(), ao_SubjectCollator.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectCollator.setModifyTime(Common.GetCurrTime());
			ao_SubjectCollator.setModifyUser(as_UserName);
			ao_SubjectCollator.setCreateTime(Common.GetCurrTime());
			ao_SubjectCollator.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_SubjectCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Add", "[Ready][SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]");
			return ao_SubjectCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "Add", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectCollator Disable(Session MyHSs, SubjectCollator ao_SubjectCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectCollator.getOwnerSUID(), ao_SubjectCollator.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectCollator.setDeletedUser(as_UserName);
			ao_SubjectCollator.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Disable", "[Ready][SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]");
			return ao_SubjectCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "Disable", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectCollator
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectCollator Delete(Session MyHSs, SubjectCollator ao_SubjectCollator, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectCollator.getOwnerSUID(), ao_SubjectCollator.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Delete", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]");
			return ao_SubjectCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "Delete", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectCollator
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectCollator Modify(Session MyHSs, SubjectCollator ao_SubjectCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectCollator.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectCollator.setModifyTime(Common.GetCurrTime());
			ao_SubjectCollator.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectCollator);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "Modify", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]");
			return ao_SubjectCollator;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "Modify", "[SubjectID:" + ao_SubjectCollator.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectCollator.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectCollatorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectCollator GetByID(Session MyHSs, Integer ai_SubjectID, Integer ai_PersonID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectCollator theSubjectCollator = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectCollator> criteria = builder.createQuery(SubjectCollator.class);
		Root<SubjectCollator> root = criteria.from(SubjectCollator.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("subjectID"), ai_SubjectID),
						builder.equal(root.get("PK").get("personID"), ai_PersonID)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectCollator =  (SubjectCollator) query.getSingleResult();
			if (theSubjectCollator != null) {
				return theSubjectCollator;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AnswerSheetItemDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("SubjectID [" + ai_SubjectID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "AnswerSheetItemDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("SubjectID [" + ai_SubjectID +"] ,PersonID ["+ai_PersonID+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	
	
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJC.* ");
		}
		sb_SQLCommand.append("FROM SubjectCollator SJC ");
		sb_SQLCommand.append("WHERE SJC.SJC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectCollator By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectCollator> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectCollator> SubjectCollatorList = query.list();
			if (SubjectCollatorList.isEmpty() != true) {
				return SubjectCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectCollator By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJC.* ");
		}
		sb_SQLCommand.append("FROM SubjectCollator SJC ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = SJC.PersonID ");
		sb_SQLCommand.append("WHERE SJC.SJC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJC.SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of SubjectCollator By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectCollator> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "FindByBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<SubjectCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectCollator> SubjectCollatorList = query.list();
			if (SubjectCollatorList.isEmpty() != true) {
				return SubjectCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectCollator By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByPersonID(int ai_CommandType,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJC.* ");
		}
		sb_SQLCommand.append("FROM SubjectCollator SJC ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = SJC.PersonID ");
		sb_SQLCommand.append("WHERE SJC.SJC_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND SJC.PersonID = "+ai_PersonID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonID(Session MyHSs,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByPersonID(10,ai_PersonID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", "[" + RowCount.intValue() + "] Of PersonEditor By PersonID [PersonID:"+ai_PersonID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectCollator> FindByPersonID(Session MyHSs,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "FindByByPersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonID(20,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "FindByPersonID", ls_SQLCommand);
			NativeQuery<SubjectCollator> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectCollator.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectCollator> SubjectCollatorList = query.list();
			if (SubjectCollatorList.isEmpty() != true) {
				return SubjectCollatorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectCollatorDAO", "FindByPersonID[PersonID:"+ai_PersonID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find PersonEditor By PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}