package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectDocument;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SubjectDocumentDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectDocument Add(Session MyHSs,SubjectDocument ao_SubjectDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectDocument.getOwnerSUID(), ao_SubjectDocument.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectDocument.setModifyTime(Common.GetCurrTime());
			ao_SubjectDocument.setModifyUser(as_UserName);
			ao_SubjectDocument.setCreateTime(Common.GetCurrTime());
			ao_SubjectDocument.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_SubjectDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Add", "[Ready][SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]");
			return ao_SubjectDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "Add", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectDocument Disable(Session MyHSs, SubjectDocument ao_SubjectDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectDocument.getOwnerSUID(), ao_SubjectDocument.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectDocument.setDeletedUser(as_UserName);
			ao_SubjectDocument.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Disable", "[Ready][SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]");
			return ao_SubjectDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "Disable", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectDocument
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectDocument Delete(Session MyHSs, SubjectDocument ao_SubjectDocument, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectDocument.getOwnerSUID(), ao_SubjectDocument.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Delete", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]");
			return ao_SubjectDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "Delete", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectDocument
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectDocument Modify(Session MyHSs, SubjectDocument ao_SubjectDocument, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectDocument.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectDocument.setModifyTime(Common.GetCurrTime());
			ao_SubjectDocument.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectDocument);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "Modify", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]");
			return ao_SubjectDocument;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "Modify", "[SubjectDocumentID:" + ao_SubjectDocument.getSubjectDocumentID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectDocumentID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectDocument GetByID(Session MyHSs, Integer ai_SubjectDocumentID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectDocument theSubjectDocument = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectDocument> criteria = builder.createQuery(SubjectDocument.class);
		criteria.where(builder.equal(criteria.from(SubjectDocument.class).get("subjectDocumentID"), ai_SubjectDocumentID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectDocument = (SubjectDocument) query.getSingleResult();
			if (theSubjectDocument != null) {
				return theSubjectDocument;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "GetByID", "[Not Found][ID:" + ai_SubjectDocumentID + "]");
				throw new DataNotFoundException("SubjectDocument [" + ai_SubjectDocumentID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "GetByID", "[Not Found][ID:" + ai_SubjectDocumentID + "]");
			throw new DataNotFoundException("SubjectDocument [" + ai_SubjectDocumentID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJD.* ");
		}
		sb_SQLCommand.append("FROM SubjectDocument SJD ");
		sb_SQLCommand.append("WHERE SJD.SJD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectDocument By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectDocument> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<SubjectDocument> SubjectDocumentList = query.list();
			if (SubjectDocumentList.isEmpty() != true) {
				return SubjectDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectDocument By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectIDOrderNameNOFPageContentType(int ai_CommandType,Integer ai_SubjectID,Integer ai_Order,String as_Name,Integer ai_NOFPage,Integer ai_ContentType, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJD.* ");
		}
		sb_SQLCommand.append("FROM SubjectDocument SJD ");
		sb_SQLCommand.append("WHERE SJD.SJD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJD.SJD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_Order != null){
			sb_SQLCommand.append("AND SJD.SJD_Order = "+ai_Order+" ");
		}
		if(as_Name != null){
			sb_SQLCommand.append("AND SJD.SJD_Name LIKE '%"+as_Name+"%' ");
		}
		if(ai_NOFPage != null){
			sb_SQLCommand.append("AND SJD.SJD_NOFPage = "+ai_NOFPage+" ");
		}
		if(ai_ContentType != null){
			sb_SQLCommand.append("AND SJD.SJD_ContentType = "+ai_ContentType+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJD.SJD_Order , SJD.SJD_Name  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDOrderNameNOFPageContentType(Session MyHSs,Integer ai_SubjectID,Integer ai_Order,String as_Name,Integer ai_NOFPage,Integer ai_ContentType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderNameNOFPageContentType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDOrderNameNOFPageContentType(10,ai_SubjectID,ai_Order,as_Name, ai_NOFPage,ai_ContentType, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderNameNOFPageContentType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderNameNOFPageContentType", "[" + RowCount.intValue() + "] Of SubjectDocument By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectDocument> FindBySubjectIDOrderNameNOFPageContentType(Session MyHSs,Integer ai_SubjectID,Integer ai_Order,String as_Name,Integer ai_NOFPage,Integer ai_ContentType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindByBySubjectIDOrderNameNOFPageContentType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDOrderNameNOFPageContentType(20,ai_SubjectID,ai_Order,as_Name, ai_NOFPage,ai_ContentType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindBySubjectIDOrderNameNOFPageContentType", ls_SQLCommand);
			NativeQuery<SubjectDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectDocument> SubjectDocumentList = query.list();
			if (SubjectDocumentList.isEmpty() != true) {
				return SubjectDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "FindBySubjectIDOrderNameNOFPageContentType[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectDocument By SubjectIDOrderNameNOFPageContentType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
public static String GenSQLBySubjectIDOrderCodeNameNOFPageContentType(int ai_CommandType,Integer ai_SubjectID,Integer ai_Order,String as_Code,String as_Name,Integer ai_NOFPage,Integer ai_ContentType, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJD.* ");
		}
		sb_SQLCommand.append("FROM SubjectDocument SJD ");
		sb_SQLCommand.append("WHERE SJD.SJD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJD.SJD_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_Order != null){
			sb_SQLCommand.append("AND SJD.SJD_Order = "+ai_Order+" ");
		}
		if(as_Code != null){
			sb_SQLCommand.append("AND SJD.SJD_Code = '"+as_Code+"' ");
		}
		if(as_Name != null){
			sb_SQLCommand.append("AND SJD.SJD_Name LIKE '%"+as_Name+"%' ");
		}
		if(ai_NOFPage != null){
			sb_SQLCommand.append("AND SJD.SJD_NOFPage = "+ai_NOFPage+" ");
		}
		if(ai_ContentType != null){
			sb_SQLCommand.append("AND SJD.SJD_ContentType = "+ai_ContentType+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJD.SJD_Order  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDOrderCodeNameNOFPageContentType(Session MyHSs,Integer ai_SubjectID,Integer ai_Order,String as_Code,String as_Name,Integer ai_NOFPage,Integer ai_ContentType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderCodeNameNOFPageContentType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDOrderCodeNameNOFPageContentType(10,ai_SubjectID,ai_Order,as_Code,as_Name, ai_NOFPage,ai_ContentType, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderCodeNameNOFPageContentType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectIDOrderCodeNameNOFPageContentType", "[" + RowCount.intValue() + "] Of SubjectDocument By SubjectIDOrderCodeNameNOFPageContentType [SubjectID = "+ai_SubjectID+",Order = "+ai_Order+",Code = "+as_Code+",Name = "+as_Name+",ai_NOFPage = "+ai_NOFPage+",ContentType = "+ai_ContentType+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectDocument> FindBySubjectIDOrderCodeNameNOFPageContentType(Session MyHSs,Integer ai_SubjectID,Integer ai_Order,String as_Code,String as_Name,Integer ai_NOFPage,Integer ai_ContentType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindByBySubjectIDOrderCodeNameNOFPageContentType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDOrderCodeNameNOFPageContentType(20,ai_SubjectID,ai_Order,as_Code,as_Name, ai_NOFPage,ai_ContentType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindBySubjectIDOrderCodeNameNOFPageContentType", ls_SQLCommand);
			NativeQuery<SubjectDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectDocument> SubjectDocumentList = query.list();
			if (SubjectDocumentList.isEmpty() != true) {
				return SubjectDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "FindBySubjectIDOrderCodeNameNOFPageContentType[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectDocument By SubjectIDOrderCodeNameNOFPageContentType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
public static String GenSQLBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType(int ai_CommandType,String as_SubjectCode,String as_SubjectName,String as_SubjectDocumentCode,String as_SubjectDocumentName,Integer ai_AttachmentType, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJD.* ");
		}
		sb_SQLCommand.append("FROM SubjectDocument SJD ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = SJD.SJD_SubjectID ");
		sb_SQLCommand.append("WHERE SJD.SJD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		
		if(as_SubjectCode!= null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '"+as_SubjectCode+"' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%"+as_SubjectName+"%' ");
		}
		if(as_SubjectDocumentCode!= null){
			sb_SQLCommand.append("AND SJD.SJD_Code = '"+as_SubjectDocumentCode+"' ");
		}
		if(as_SubjectDocumentName != null){
			sb_SQLCommand.append("AND SJD.SJD_Name LIKE '%"+as_SubjectDocumentName+"%' ");
		}
		
		if(ai_AttachmentType != null){
			if(ai_AttachmentType == 1){
				sb_SQLCommand.append("AND SJD.SubjectDocumentID NOT IN ( ");
				sb_SQLCommand.append("SELECT EID.EID_SubjectDocumentID ");
					sb_SQLCommand.append("FROM ExamItemDocument EID ");
					sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" ) ");
				sb_SQLCommand.append("AND SJD.SubjectDocumentID NOT IN ( ");
				sb_SQLCommand.append("SELECT EID.EID_SubjectDocumentID ");
					sb_SQLCommand.append("FROM ExamFormDocument EFD ");
					sb_SQLCommand.append("JOIN ExamItemDocument EID ON EID.ExamItemDocumentID = EFD.EFD_CopiedExamItemDocumentID  ");
					sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					sb_SQLCommand.append("AND EID.EID_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" )  ");
				
				sb_SQLCommand.append("AND SJD.SubjectDocumentID NOT IN ( ");
				sb_SQLCommand.append("SELECT EIGD.EIGD_SubjectDocumentID ");
					sb_SQLCommand.append("FROM ExamFormDocument EFD ");
					sb_SQLCommand.append("JOIN ExamItemGroupDocument EIGD ON EIGD.ExamItemGroupDocumentID = EFD.EFD_CopiedExamItemGroupDocumentID  ");
					sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					sb_SQLCommand.append("AND EIGD.EIGD_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" ) ");
			}else if(ai_AttachmentType == 2){
				sb_SQLCommand.append("AND SJD.SubjectDocumentID  IN ( ");
				sb_SQLCommand.append("SELECT EID.EID_SubjectDocumentID ");
					sb_SQLCommand.append("FROM ExamItemDocument EID ");
					sb_SQLCommand.append("WHERE EID.EID_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" ) ");
			}else if(ai_AttachmentType == 3){
				sb_SQLCommand.append("AND ( ");
				sb_SQLCommand.append(" SJD.SubjectDocumentID  IN ( ");
				sb_SQLCommand.append("SELECT EID.EID_SubjectDocumentID ");
						sb_SQLCommand.append("FROM ExamFormDocument EFD ");
						sb_SQLCommand.append("JOIN ExamItemDocument EID ON EID.ExamItemDocumentID = EFD.EFD_CopiedExamItemDocumentID  ");
						sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
						sb_SQLCommand.append(") ");
						sb_SQLCommand.append("AND EID.EID_DataStatus NOT IN ( ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
						sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" ) ");
				sb_SQLCommand.append(" OR ");
				sb_SQLCommand.append(" SJD.SubjectDocumentID  IN ( ");
				sb_SQLCommand.append(" SELECT EIGD.EIGD_SubjectDocumentID  ");
					sb_SQLCommand.append("FROM ExamFormDocument EFD ");
					sb_SQLCommand.append("JOIN ExamItemGroupDocument EIGD ON EIGD.ExamItemGroupDocumentID = EFD.EFD_CopiedExamItemGroupDocumentID  ");
					sb_SQLCommand.append("WHERE EFD.EFD_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
					sb_SQLCommand.append("AND EIGD.EIGD_DataStatus NOT IN ( ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
					sb_SQLCommand.append(") ");
				sb_SQLCommand.append(" ) ");
			sb_SQLCommand.append(" ) ");
			}else{}
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY SJD.SJD_Order , SJD.SJD_Name  ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType(Session MyHSs,String as_SubjectCode,String as_SubjectName,String as_SubjectDocumentCode,String as_SubjectDocumentName,Integer ai_AttachmentType,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType(10,as_SubjectCode,as_SubjectName,as_SubjectDocumentCode,as_SubjectDocumentName, ai_AttachmentType, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "GetSizeBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType", "[" + RowCount.intValue() + "] Of SubjectDocument By [SubjectCode : "+as_SubjectCode+",SubjectName : "+as_SubjectName+",SubjectDocumentCode:"+as_SubjectDocumentCode+",SubjectDocumentName :"+as_SubjectDocumentName+",AttachmentType:"+ai_AttachmentType+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectDocument> FindBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType(Session MyHSs,String as_SubjectCode,String as_SubjectName,String as_SubjectDocumentCode,String as_SubjectDocumentName,Integer ai_AttachmentType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType(20,as_SubjectCode,as_SubjectName,as_SubjectDocumentCode,as_SubjectDocumentName, ai_AttachmentType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectDocumentDAO", "FindBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType", ls_SQLCommand);
			NativeQuery<SubjectDocument> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectDocument.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectDocument> SubjectDocumentList = query.list();
			if (SubjectDocumentList.isEmpty() != true) {
				return SubjectDocumentList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectDocumentDAO", "FindBySubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType[SubjectCode : "+as_SubjectCode+",SubjectName : "+as_SubjectName+",SubjectDocumentCode:"+as_SubjectDocumentCode+",SubjectDocumentName :"+as_SubjectDocumentName+",AttachmentType:"+ai_AttachmentType+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectDocument By SubjectCodeSubjectNameSubjectDocumentCodeSubjectDocumentNameAttachmentType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}