package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectEditor;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SubjectEditorDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectEditor Add(Session MyHSs,SubjectEditor ao_SubjectEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectEditor.getOwnerSUID(), ao_SubjectEditor.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectEditor.setModifyTime(Common.GetCurrTime());
			ao_SubjectEditor.setModifyUser(as_UserName);
			ao_SubjectEditor.setCreateTime(Common.GetCurrTime());
			ao_SubjectEditor.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_SubjectEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Add", "[Ready][SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]");
			return ao_SubjectEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "Add", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectEditor Disable(Session MyHSs, SubjectEditor ao_SubjectEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectEditor.getOwnerSUID(), ao_SubjectEditor.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectEditor.setDeletedUser(as_UserName);
			ao_SubjectEditor.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Disable", "[Ready][SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]");
			return ao_SubjectEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "Disable", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectEditor
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectEditor Delete(Session MyHSs, SubjectEditor ao_SubjectEditor, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectEditor.getOwnerSUID(), ao_SubjectEditor.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Delete", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]");
			return ao_SubjectEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "Delete", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectEditor
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectEditor Modify(Session MyHSs, SubjectEditor ao_SubjectEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectEditor.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectEditor.setModifyTime(Common.GetCurrTime());
			ao_SubjectEditor.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectEditor);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "Modify", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]");
			return ao_SubjectEditor;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "Modify", "[SubjectID:" + ao_SubjectEditor.getPK().getSubjectID()+ "][PersonID:"+ao_SubjectEditor.getPK().getPersonID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectEditorID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectEditor GetByID(Session MyHSs, Integer ai_SubjectID, Integer ai_PersonID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectEditor theSubjectEditor = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectEditor> criteria = builder.createQuery(SubjectEditor.class);
		criteria.where(builder.equal(criteria.from(SubjectEditor.class).get("subjectID"), ai_SubjectID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectEditor = (SubjectEditor) query.getSingleResult();
			if (theSubjectEditor != null) {
				return theSubjectEditor;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_SubjectID + "]");
				throw new DataNotFoundException("SubjectEditor [" + ai_SubjectID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ActionTypeDAO", "GetByID", "[Not Found][ID:" + ai_SubjectID + "]");
			throw new DataNotFoundException("SubjectEditor [" + ai_SubjectID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJE.* ");
		}
		sb_SQLCommand.append("FROM SubjectEditor SJE ");
		sb_SQLCommand.append("WHERE SJE.SJE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectEditor By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectEditor> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectEditor> SubjectEditorList = query.list();
			if (SubjectEditorList.isEmpty() != true) {
				return SubjectEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectEditor By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJE.* ");
		}
		sb_SQLCommand.append("FROM SubjectEditor SJE ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = SJE.PersonID ");
		sb_SQLCommand.append("WHERE SJE.SJE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SJE.SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of SubjectEditor By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectEditor> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "FindByBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<SubjectEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectEditor> SubjectEditorList = query.list();
			if (SubjectEditorList.isEmpty() != true) {
				return SubjectEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectEditor By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByPersonID(int ai_CommandType,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SJE.* ");
		}
		sb_SQLCommand.append("FROM SubjectEditor SJE ");
		sb_SQLCommand.append("JOIN Person PS ON PS.PersonID = SJE.PersonID ");
		sb_SQLCommand.append("WHERE SJE.SJE_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND SJE.PersonID = "+ai_PersonID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY PS.PS_Name ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonID(Session MyHSs,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByPersonID(10,ai_PersonID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "GetSizeByPersonID", "[" + RowCount.intValue() + "] Of PersonEditor By PersonID [PersonID:"+ai_PersonID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectEditor> FindByPersonID(Session MyHSs,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "FindByByPersonID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonID(20,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "PersonEditorDAO", "FindByPersonID", ls_SQLCommand);
			NativeQuery<SubjectEditor> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectEditor.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectEditor> SubjectEditorList = query.list();
			if (SubjectEditorList.isEmpty() != true) {
				return SubjectEditorList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectEditorDAO", "FindByPersonID[PersonID:"+ai_PersonID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find PersonEditor By PersonID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}