package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectFormPolicy;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_TMPCONDITION_STATUS;

public class SubjectFormPolicyDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicy
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicy Add(Session MyHSs,SubjectFormPolicy ao_SubjectFormPolicy, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicy.getOwnerSUID(), ao_SubjectFormPolicy.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectFormPolicy.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicy.setModifyUser(as_UserName);
			ao_SubjectFormPolicy.setCreateTime(Common.GetCurrTime());
			ao_SubjectFormPolicy.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_SubjectFormPolicy);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Add", "[Ready][SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]");
			return ao_SubjectFormPolicy;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "Add", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicy
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicy Disable(Session MyHSs, SubjectFormPolicy ao_SubjectFormPolicy, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicy.getOwnerSUID(), ao_SubjectFormPolicy.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectFormPolicy.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectFormPolicy.setDeletedUser(as_UserName);
			ao_SubjectFormPolicy.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectFormPolicy);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Disable", "[Ready][SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]");
			return ao_SubjectFormPolicy;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "Disable", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicy
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicy Delete(Session MyHSs, SubjectFormPolicy ao_SubjectFormPolicy, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicy.getOwnerSUID(), ao_SubjectFormPolicy.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectFormPolicy);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Delete", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]");
			return ao_SubjectFormPolicy;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "Delete", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicy
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicy Modify(Session MyHSs, SubjectFormPolicy ao_SubjectFormPolicy, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicy.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectFormPolicy.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicy.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectFormPolicy);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "Modify", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]");
			return ao_SubjectFormPolicy;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "Modify", "[SubjectFormPolicyID:" + ao_SubjectFormPolicy.getSubjectFormPolicyID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectFormPolicyID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectFormPolicy GetByID(Session MyHSs, Integer ai_SubjectFormPolicyID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectFormPolicy theSubjectFormPolicy = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectFormPolicy> criteria = builder.createQuery(SubjectFormPolicy.class);
		criteria.where(builder.equal(criteria.from(SubjectFormPolicy.class).get("subjectFormPolicyID"), ai_SubjectFormPolicyID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectFormPolicy = (SubjectFormPolicy) query.getSingleResult();
			if (theSubjectFormPolicy != null) {
				return theSubjectFormPolicy;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicyID + "]");
				throw new DataNotFoundException("SubjectFormPolicy [" + ai_SubjectFormPolicyID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicyID + "]");
			throw new DataNotFoundException("SubjectFormPolicy [" + ai_SubjectFormPolicyID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFP.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicy SFP ");
		sb_SQLCommand.append("WHERE SFP.SFP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectFormPolicy By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectFormPolicy> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectFormPolicy> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicy.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<SubjectFormPolicy> SubjectFormPolicyList = query.list();
			if (SubjectFormPolicyList.isEmpty() != true) {
				return SubjectFormPolicyList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicy By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFP.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicy SFP ");
		sb_SQLCommand.append("WHERE SFP.SFP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SFP.SFP_SubjectID = '"+ai_SubjectID+"' ");
		}
		
		
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of SubjectFormPolicy By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicy> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindByBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicy> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicy.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicy> SubjectFormPolicyList = query.list();
			if (SubjectFormPolicyList.isEmpty() != true) {
				return SubjectFormPolicyList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicy By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectIDExamSemesterIDExamRoundID(int ai_CommandType,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFP.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicy SFP ");
		sb_SQLCommand.append("WHERE SFP.SFP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SFP.SFP_SubjectID = '"+ai_SubjectID+"' ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND SFP.SFP_ExamSemesterID = '"+ai_ExamSemesterID+"' ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND SFP.SFP_ExamRoundID = '"+ai_ExamRoundID+"' ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDExamSemesterIDExamRoundID(10,ai_SubjectID, ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundID", "[" + RowCount.intValue() + "] Of SubjectFormPolicy By SubjectID ExamSemesterIDExamRoundID [SubjectID:"+ai_SubjectID+",ExamSemesterID : "+ai_ExamSemesterID+",ExamRoundID : "+ai_ExamRoundID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicy> FindBySubjectIDExamSemesterIDExamRoundID(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindByBySubjectIDExamSemesterIDExamRoundID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDExamSemesterIDExamRoundID(20,ai_SubjectID,ai_ExamSemesterID,ai_ExamRoundID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectIDExamSemesterIDExamRoundID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicy> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicy.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicy> SubjectFormPolicyList = query.list();
			if (SubjectFormPolicyList.isEmpty() != true) {
				return SubjectFormPolicyList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "FindBySubjectID[SubjectIDExamSemesterIDExamRoundID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicy By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus(int ai_CommandType,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_TMPCONDITION_STATUS ai_TmpConditionStatus, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFP.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicy SFP ");
		sb_SQLCommand.append("JOIN ExamSemester ES ON ES.ExamSemesterID = SFP.SFP_ExamSemesterID ");
		sb_SQLCommand.append("JOIN ExamRound ER ON ER.ExamRoundID = SFP.SFP_ExamRoundID ");
		sb_SQLCommand.append("WHERE SFP.SFP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND SFP.SFP_SubjectID = '"+ai_SubjectID+"' ");
		}
		if(ai_ExamSemesterID != null){
			sb_SQLCommand.append("AND SFP.SFP_ExamSemesterID = '"+ai_ExamSemesterID+"' ");
		}
		if(ai_ExamRoundID != null){
			sb_SQLCommand.append("AND SFP.SFP_ExamRoundID = '"+ai_ExamRoundID+"' ");
		}
		if(ai_TmpConditionStatus != null){
			sb_SQLCommand.append("AND SFP.SFP_TmpConditionStatus = '"+ai_TmpConditionStatus.getValue()+"' ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ES.ES_Number , ER.ER_Number ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_TMPCONDITION_STATUS ai_TmpConditionStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus(10,ai_SubjectID, ai_ExamSemesterID,ai_ExamRoundID,ai_TmpConditionStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDAO", "GetSizeBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus", "[" + RowCount.intValue() + "] Of SubjectFormPolicy By SubjectID ExamSemesterIDExamRoundID [SubjectID:"+ai_SubjectID+",ExamSemesterID : "+ai_ExamSemesterID+",ExamRoundID : "+ai_ExamRoundID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicy> FindBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus(Session MyHSs,Integer ai_SubjectID,Integer ai_ExamSemesterID,Integer ai_ExamRoundID,TYPE_TMPCONDITION_STATUS ai_TmpConditionStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus(20,ai_SubjectID,ai_ExamSemesterID,ai_ExamRoundID,ai_TmpConditionStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus", ls_SQLCommand);
			NativeQuery<SubjectFormPolicy> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicy.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicy> SubjectFormPolicyList = query.list();
			if (SubjectFormPolicyList.isEmpty() != true) {
				return SubjectFormPolicyList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDAO", "FindBySubjectIDExamSemesterIDExamRoundIDTmpConditionStatus[SubjectIDExamSemesterIDExamRoundID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicy By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}