package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectFormPolicyDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SubjectFormPolicyDetailDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicyDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicyDetail Add(Session MyHSs,SubjectFormPolicyDetail ao_SubjectFormPolicyDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicyDetail.getOwnerSUID(), ao_SubjectFormPolicyDetail.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectFormPolicyDetail.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicyDetail.setModifyUser(as_UserName);
			ao_SubjectFormPolicyDetail.setCreateTime(Common.GetCurrTime());
			ao_SubjectFormPolicyDetail.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_SubjectFormPolicyDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Add", "[Ready][SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]");
			return ao_SubjectFormPolicyDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "Add", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicyDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicyDetail Disable(Session MyHSs, SubjectFormPolicyDetail ao_SubjectFormPolicyDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicyDetail.getOwnerSUID(), ao_SubjectFormPolicyDetail.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectFormPolicyDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectFormPolicyDetail.setDeletedUser(as_UserName);
			ao_SubjectFormPolicyDetail.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectFormPolicyDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Disable", "[Ready][SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]");
			return ao_SubjectFormPolicyDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "Disable", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicyDetail
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicyDetail Delete(Session MyHSs, SubjectFormPolicyDetail ao_SubjectFormPolicyDetail, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicyDetail.getOwnerSUID(), ao_SubjectFormPolicyDetail.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectFormPolicyDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Delete", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]");
			return ao_SubjectFormPolicyDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "Delete", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicyDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicyDetail Modify(Session MyHSs, SubjectFormPolicyDetail ao_SubjectFormPolicyDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicyDetail.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectFormPolicyDetail.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicyDetail.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectFormPolicyDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "Modify", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]");
			return ao_SubjectFormPolicyDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "Modify", "[SubjectFormPolicyDetailID:" + ao_SubjectFormPolicyDetail.getSubjectFormPolicyDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectFormPolicyDetailID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectFormPolicyDetail GetByID(Session MyHSs, Integer ai_SubjectFormPolicyDetailID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectFormPolicyDetail theSubjectFormPolicyDetail = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectFormPolicyDetail> criteria = builder.createQuery(SubjectFormPolicyDetail.class);
		criteria.where(builder.equal(criteria.from(SubjectFormPolicyDetail.class).get("subjectFormPolicyDetailID"), ai_SubjectFormPolicyDetailID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectFormPolicyDetail = (SubjectFormPolicyDetail) query.getSingleResult();
			if (theSubjectFormPolicyDetail != null) {
				return theSubjectFormPolicyDetail;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicyDetailID + "]");
				throw new DataNotFoundException("SubjectFormPolicyDetail [" + ai_SubjectFormPolicyDetailID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicyDetailID + "]");
			throw new DataNotFoundException("SubjectFormPolicyDetail [" + ai_SubjectFormPolicyDetailID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPD.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicyDetail SFPD ");
		sb_SQLCommand.append("WHERE SFPD.SFPD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectFormPolicyDetail> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectFormPolicyDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicyDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<SubjectFormPolicyDetail> SubjectFormPolicyDetailList = query.list();
			if (SubjectFormPolicyDetailList.isEmpty() != true) {
				return SubjectFormPolicyDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicyDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectFormPolicyID(int ai_CommandType,Integer ai_SubjectFormPolicyID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPD.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicyDetail SFPD ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPD.SFPD_UnitID ");
		sb_SQLCommand.append("WHERE SFPD.SFPD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyID != null){
			sb_SQLCommand.append("AND SFPD.SubjectFormPolicyID = "+ai_SubjectFormPolicyID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyID(Session MyHSs,Integer ai_SubjectFormPolicyID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyID(10,ai_SubjectFormPolicyID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyID", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By SubjectFormPolicyID [SubjectFormPolicyID:"+ai_SubjectFormPolicyID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicyDetail> FindBySubjectFormPolicyID(Session MyHSs,Integer ai_SubjectFormPolicyID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "FindByBySubjectFormPolicyID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyID(20,ai_SubjectFormPolicyID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectFormPolicyID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicyDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicyDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicyDetail> SubjectFormPolicyDetailList = query.list();
			if (SubjectFormPolicyDetailList.isEmpty() != true) {
				return SubjectFormPolicyDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "FindBySubjectFormPolicyID[SubjectFormPolicyID:"+ai_SubjectFormPolicyID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicyDetail By SubjectFormPolicyID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectFormPolicyIDUnitID(int ai_CommandType,Integer ai_SubjectFormPolicyID,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPD.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicyDetail SFPD ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPD.SFPD_UnitID ");
		sb_SQLCommand.append("WHERE SFPD.SFPD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyID != null){
			sb_SQLCommand.append("AND SFPD.SubjectFormPolicyID = "+ai_SubjectFormPolicyID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND SFPD.SFPD_UnitID = "+ai_UnitID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyIDUnitID(Session MyHSs,Integer ai_SubjectFormPolicyID,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyIDUnitID(10,ai_SubjectFormPolicyID,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "GetSizeBySubjectFormPolicyIDUnitID", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By SubjectFormPolicyID [SubjectFormPolicyID:"+ai_SubjectFormPolicyID+",UnitID:"+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicyDetail> FindBySubjectFormPolicyIDUnitID(Session MyHSs,Integer ai_SubjectFormPolicyID,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailDAO", "FindByBySubjectFormPolicyIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyIDUnitID(20,ai_SubjectFormPolicyID,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyIDDAO", "FindBySubjectFormPolicyIDUnitID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicyDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicyDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicyDetail> SubjectFormPolicyDetailList = query.list();
			if (SubjectFormPolicyDetailList.isEmpty() != true) {
				return SubjectFormPolicyDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicyDetailDAO", "FindBySubjectFormPolicyIDUnitID[SubjectFormPolicyID:"+ai_SubjectFormPolicyID+",UnitID:"+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicyDetail By SubjectFormPolicyID And UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}