package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.SubjectFormPolicySubDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class SubjectFormPolicySubDetailDAO {
	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicySubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicySubDetail Add(Session MyHSs,SubjectFormPolicySubDetail ao_SubjectFormPolicySubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicySubDetail.getOwnerSUID(), ao_SubjectFormPolicySubDetail.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_SubjectFormPolicySubDetail.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicySubDetail.setModifyUser(as_UserName);
			ao_SubjectFormPolicySubDetail.setCreateTime(Common.GetCurrTime());
			ao_SubjectFormPolicySubDetail.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_SubjectFormPolicySubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Add", "[Ready][SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]");
			return ao_SubjectFormPolicySubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "Add", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicySubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicySubDetail Disable(Session MyHSs, SubjectFormPolicySubDetail ao_SubjectFormPolicySubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicySubDetail.getOwnerSUID(), ao_SubjectFormPolicySubDetail.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_SubjectFormPolicySubDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_SubjectFormPolicySubDetail.setDeletedUser(as_UserName);
			ao_SubjectFormPolicySubDetail.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_SubjectFormPolicySubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Disable", "[Ready][SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]");
			return ao_SubjectFormPolicySubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "Disable", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicySubDetail
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicySubDetail Delete(Session MyHSs, SubjectFormPolicySubDetail ao_SubjectFormPolicySubDetail, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicySubDetail.getOwnerSUID(), ao_SubjectFormPolicySubDetail.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_SubjectFormPolicySubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Delete", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]");
			return ao_SubjectFormPolicySubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "Delete", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_SubjectFormPolicySubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static SubjectFormPolicySubDetail Modify(Session MyHSs, SubjectFormPolicySubDetail ao_SubjectFormPolicySubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_SubjectFormPolicySubDetail.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_SubjectFormPolicySubDetail.setModifyTime(Common.GetCurrTime());
			ao_SubjectFormPolicySubDetail.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_SubjectFormPolicySubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "Modify", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]");
			return ao_SubjectFormPolicySubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "Modify", "[SubjectFormPolicySubDetailID:" + ao_SubjectFormPolicySubDetail.getSubjectFormPolicySubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_SubjectFormPolicySubDetailID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static SubjectFormPolicySubDetail GetByID(Session MyHSs, Integer ai_SubjectFormPolicySubDetailID, Integer SUID, Integer SGID) throws DataNotFoundException {
		SubjectFormPolicySubDetail theSubjectFormPolicySubDetail = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<SubjectFormPolicySubDetail> criteria = builder.createQuery(SubjectFormPolicySubDetail.class);
		criteria.where(builder.equal(criteria.from(SubjectFormPolicySubDetail.class).get("subjectFormPolicySubDetailID"), ai_SubjectFormPolicySubDetailID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theSubjectFormPolicySubDetail = (SubjectFormPolicySubDetail) query.getSingleResult();
			if (theSubjectFormPolicySubDetail != null) {
				return theSubjectFormPolicySubDetail;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicySubDetailID + "]");
				throw new DataNotFoundException("SubjectFormPolicySubDetail [" + ai_SubjectFormPolicySubDetailID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "GetByID", "[Not Found][ID:" + ai_SubjectFormPolicySubDetailID + "]");
			throw new DataNotFoundException("SubjectFormPolicySubDetail [" + ai_SubjectFormPolicySubDetailID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of SubjectFormPolicySubDetail By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<SubjectFormPolicySubDetail> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectFormPolicyDetailID(int ai_CommandType,Integer ai_SubjectFormPolicyDetailID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPS.SFPS_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = SFPS.SFPS_SectionID ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = SFPS.SFPS_ObjectiveID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyDetailID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_SubjectFormPolicyDetailID = "+ai_SubjectFormPolicyDetailID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyDetailID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyDetailID(10,ai_SubjectFormPolicyDetailID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailID", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By SubjectFormPolicyDetailID [SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicySubDetail> FindBySubjectFormPolicyDetailID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByBySubjectFormPolicyDetailID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyDetailID(20,ai_SubjectFormPolicyDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailID[SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By SubjectFormPolicyDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectFormPolicyDetailIDUnitID(int ai_CommandType,Integer ai_SubjectFormPolicyDetailID,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = SFPS.SFPS_SectionID ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = SFPS.SFPS_ObjectiveID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyDetailID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_SubjectFormPolicyDetailID = "+ai_SubjectFormPolicyDetailID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_UnitID = "+ai_UnitID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyDetailIDUnitID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyDetailIDUnitID(10,ai_SubjectFormPolicyDetailID,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDUnitID", "[" + RowCount.intValue() + "] Of SubjectFormPolicySubDetail By SubjectFormPolicyDetailID And UnitID [SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+",UnitID:"+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicySubDetail> FindBySubjectFormPolicyDetailIDUnitID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByBySubjectFormPolicyDetailIDUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyDetailIDUnitID(20,ai_SubjectFormPolicyDetailID,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailIDUnitID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailID[SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+",UnitID:"+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By SubjectFormPolicyDetailID And UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectFormPolicyDetailIDObjectiveID(int ai_CommandType,Integer ai_SubjectFormPolicyDetailID,Integer ai_ObjectiveID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPS.SFPS_UnitID ");
		sb_SQLCommand.append("JOIN Section ST ON ST.SectionID = SFPS.SFPS_SectionID ");
		sb_SQLCommand.append("JOIN Objective OJ ON OJ.ObjectiveID = SFPS.SFPS_ObjectiveID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyDetailID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_SubjectFormPolicyDetailID = "+ai_SubjectFormPolicyDetailID+" ");
		}
		if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order,ST.ST_Order,OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyDetailIDObjectiveID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer ai_ObjectiveID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDObjectiveID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyDetailIDObjectiveID(10,ai_SubjectFormPolicyDetailID,ai_ObjectiveID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDObjectiveID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyDetailIDObjectiveID", "[" + RowCount.intValue() + "] Of SubjectFormPolicySubDetail By SubjectFormPolicyDetailID And ObjectiveID [SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+",ObjectiveID:"+ai_ObjectiveID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicySubDetail> FindBySubjectFormPolicyDetailIDObjectiveID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer ai_ObjectiveID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByBySubjectFormPolicyDetailIDObjectiveID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyDetailIDObjectiveID(20,ai_SubjectFormPolicyDetailID,ai_ObjectiveID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailIDObjectiveID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyDetailIDObjectiveID[SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+",ObjectiveID:"+ai_ObjectiveID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By SubjectFormPolicyDetailID And ObjectiveID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByObjectiveID(int ai_CommandType,Integer ai_ObjectiveID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPS.SFPS_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = SFPS.SFPS_SectionID ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = SFPS.SFPS_ObjectiveID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByObjectiveID(Session MyHSs,Integer ai_ObjectiveID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeByObjectiveID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByObjectiveID(10,ai_ObjectiveID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeByObjectiveID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeByObjectiveID", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By ObjectiveID [ObjectiveID:"+ai_ObjectiveID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicySubDetail> FindByObjectiveID(Session MyHSs,Integer ai_ObjectiveID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByByObjectiveID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByObjectiveID(20,ai_ObjectiveID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByObjectiveID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindByObjectiveID:"+ai_ObjectiveID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By ObjectiveID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static Integer GetSumOfNOFItemRequireBySubjectFormPolicyDetailID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSumOfNOFItemRequireBySubjectFormPolicyDetailID", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT isNull(sum(SFPS.SFPS_NOFItemRequire),0) SumNOFItemRequire From SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_SubjectFormPolicyDetailID != null){
			sb_SQLCommand.append("AND SFPS.SFPS_SubjectFormPolicyDetailID = "+ai_SubjectFormPolicyDetailID+" ");
		}
		
		NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(SubjectFormPolicySubDetail.class);
		Object amount =  query.uniqueResult(); 
	    return (Integer)amount;   	
	}
	public static String GenSQLBySubjectFormPolicyID(int ai_CommandType,Integer ai_SubjectFormPolicyID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT SFPS.* ");
		}
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPS.SFPS_UnitID ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = SFPS.SFPS_SectionID ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = SFPS.SFPS_ObjectiveID ");
		sb_SQLCommand.append("JOIN SubjectFormPolicyDetail SFPD ON SFPD.SubjectFormPolicyDetailID = SFPS.SFPS_SubjectFormPolicyDetailID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectFormPolicyID != null){
			sb_SQLCommand.append("AND SFPD.SubjectFormPolicyID = "+ai_SubjectFormPolicyID+" ");
		}
		
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UN.UN_Order , ST.ST_Order , OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectFormPolicyID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectFormPolicyID(10,ai_SubjectFormPolicyDetailID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "GetSizeBySubjectFormPolicyID", "[" + RowCount.intValue() + "] Of SubjectFormPolicyDetail By SubjectFormPolicyDetailID [SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<SubjectFormPolicySubDetail> FindBySubjectFormPolicyID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectFormPolicyID(20,ai_SubjectFormPolicyDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyID", ls_SQLCommand);
			NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(SubjectFormPolicySubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<SubjectFormPolicySubDetail> SubjectFormPolicySubDetailList = query.list();
			if (SubjectFormPolicySubDetailList.isEmpty() != true) {
				return SubjectFormPolicySubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "SubjectFormPolicySubDetailDAO", "FindBySubjectFormPolicyID[SubjectFormPolicyDetailID:"+ai_SubjectFormPolicyDetailID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find SubjectFormPolicySubDetail By SubjectFormPolicyDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static Integer GetSumOfNOFItemRequireBySubjectFormPolicyID(Session MyHSs,Integer ai_SubjectFormPolicyID, Integer SUID, Integer SGID) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemDAO", "GetSumOfNOFItemRequireBySubjectFormPolicyDetailID", "[BEGIN] @@@");
		StringBuffer sb_SQLCommand = new StringBuffer();
		sb_SQLCommand.append("SELECT Sum(isNull(SFPS.SFPS_NOFItemRequire,0))  ");
		sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPS ");
		sb_SQLCommand.append("JOIN SubjectFormPolicyDetail SFPD ON SFPD.SubjectFormPolicyDetailID = SFPS.SFPS_SubjectFormPolicyDetailID ");
		sb_SQLCommand.append("WHERE SFPS.SFPS_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		sb_SQLCommand.append(") ");
		if(ai_SubjectFormPolicyID != null){
			sb_SQLCommand.append("AND SFPD.SubjectFormPolicyID = "+ai_SubjectFormPolicyID+" ");
		}
		NativeQuery<SubjectFormPolicySubDetail> query = MyHSs.createSQLQuery(sb_SQLCommand.toString()).addEntity(SubjectFormPolicySubDetail.class);
		Object amount =  query.uniqueResult(); 
	    return (Integer)amount;   	
	}
}