package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.TableMapping;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_MAPPING_DATA;

public class TableMappingDAO {
	/**
	 * @param MyHSs
	 * @param ao_TableMapping
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMapping Add(Session MyHSs,TableMapping ao_TableMapping, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMapping.getOwnerSUID(), ao_TableMapping.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_TableMapping.setModifyTime(Common.GetCurrTime());
			ao_TableMapping.setModifyUser(as_UserName);
			ao_TableMapping.setCreateTime(Common.GetCurrTime());
			ao_TableMapping.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_TableMapping);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Add", "[Ready][ID:" + ao_TableMapping.getTableMappingID() + "]");
			return ao_TableMapping;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "Add", "[ID:" + ao_TableMapping.getTableMappingID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMapping
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMapping Disable(Session MyHSs, TableMapping ao_TableMapping, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMapping.getOwnerSUID(), ao_TableMapping.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_TableMapping.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_TableMapping.setDeletedUser(as_UserName);
			ao_TableMapping.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_TableMapping);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Disable", "[Ready][ID:" + ao_TableMapping.getTableMappingID() + "]");
			return ao_TableMapping;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "Disable", "[ID:" +ao_TableMapping.getTableMappingID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMapping
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMapping Delete(Session MyHSs, TableMapping ao_TableMapping, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMapping.getOwnerSUID(), ao_TableMapping.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_TableMapping);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Delete", "[ID:" + ao_TableMapping.getTableMappingID() + "]");
			return ao_TableMapping;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "Delete", "[ID:" + ao_TableMapping.getTableMappingID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMapping
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMapping Modify(Session MyHSs, TableMapping ao_TableMapping, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMapping.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_TableMapping.setModifyTime(Common.GetCurrTime());
			ao_TableMapping.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_TableMapping);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "Modify", "[ID:" + ao_TableMapping.getTableMappingID() + "]");
			return ao_TableMapping;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "Modify", "[ID:" + ao_TableMapping.getTableMappingID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_TableMappingID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static TableMapping GetByID(Session MyHSs, Integer ai_TableMappingID, Integer SUID, Integer SGID) throws DataNotFoundException {
		TableMapping theTableMapping = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<TableMapping> criteria = builder.createQuery(TableMapping.class);
		criteria.where(builder.equal(criteria.from(TableMapping.class).get("tableMappingID"), ai_TableMappingID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theTableMapping = (TableMapping) query.getSingleResult();
			if (theTableMapping != null) {
				return theTableMapping;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingID + "]");
				throw new DataNotFoundException("TableMapping [" + ai_TableMappingID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingID + "]");
			throw new DataNotFoundException("TableMapping [" + ai_TableMappingID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TM.* ");
		}
		sb_SQLCommand.append("FROM TableMapping TM ");
		sb_SQLCommand.append("WHERE TM.TM_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of TableMapping By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<TableMapping> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<TableMapping> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMapping.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TableMapping> TableMappingList = query.list();
			if (TableMappingList.isEmpty() != true) {
				return TableMappingList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMapping By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByTableMappingType(int ai_CommandType,TYPE_MAPPING_DATA ai_Type, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TM.* ");
		}
		sb_SQLCommand.append("FROM TableMapping TM ");
		sb_SQLCommand.append("WHERE TM.TM_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_Type != null){
			sb_SQLCommand.append("AND TM.TM_Type = "+ai_Type.getValue()+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingType(Session MyHSs,TYPE_MAPPING_DATA ai_Type,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeByTableMappingType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingType(10,ai_Type, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeByTableMappingType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "GetSizeByTableMappingType", "[" + RowCount.intValue() + "] Of TableMapping By TableMappingType [TableMappingType:"+ai_Type+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMapping> FindByTableMappingType(Session MyHSs,TYPE_MAPPING_DATA ai_Type,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "FindByTableMappingType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingType(20,ai_Type,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDAO", "FindByTableMappingType", ls_SQLCommand);
			NativeQuery<TableMapping> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMapping.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TableMapping> TableMappingList = query.list();
			if (TableMappingList.isEmpty() != true) {
				return TableMappingList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDAO", "FindByTableMappingType[TableMappingType:"+ai_Type+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMapping By TableMappingType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}