package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.TableMappingDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class TableMappingDetailDAO {
	/**
	 * @param MyHSs
	 * @param ao_TableMappingDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingDetail Add(Session MyHSs,TableMappingDetail ao_TableMappingDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingDetail.getOwnerSUID(), ao_TableMappingDetail.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_TableMappingDetail.setModifyTime(Common.GetCurrTime());
			ao_TableMappingDetail.setModifyUser(as_UserName);
			ao_TableMappingDetail.setCreateTime(Common.GetCurrTime());
			ao_TableMappingDetail.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_TableMappingDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Add", "[Ready][TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]");
			return ao_TableMappingDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "Add", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingDetail Disable(Session MyHSs, TableMappingDetail ao_TableMappingDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingDetail.getOwnerSUID(), ao_TableMappingDetail.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_TableMappingDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_TableMappingDetail.setDeletedUser(as_UserName);
			ao_TableMappingDetail.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_TableMappingDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Disable", "[Ready][TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]");
			return ao_TableMappingDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "Disable", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingDetail
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingDetail Delete(Session MyHSs, TableMappingDetail ao_TableMappingDetail, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingDetail.getOwnerSUID(), ao_TableMappingDetail.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_TableMappingDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Delete", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]");
			return ao_TableMappingDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "Delete", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingDetail Modify(Session MyHSs, TableMappingDetail ao_TableMappingDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingDetail.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_TableMappingDetail.setModifyTime(Common.GetCurrTime());
			ao_TableMappingDetail.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_TableMappingDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "Modify", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]");
			return ao_TableMappingDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "Modify", "[TableMappingDetailID:" + ao_TableMappingDetail.getTableMappingDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_TableMappingDetailID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static TableMappingDetail GetByID(Session MyHSs, Integer ai_TableMappingDetailID, Integer SUID, Integer SGID) throws DataNotFoundException {
		TableMappingDetail theTableMappingDetail = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<TableMappingDetail> criteria = builder.createQuery(TableMappingDetail.class);
		criteria.where(builder.equal(criteria.from(TableMappingDetail.class).get("tableMappingDetailID"), ai_TableMappingDetailID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theTableMappingDetail = (TableMappingDetail) query.getSingleResult();
			if (theTableMappingDetail != null) {
				return theTableMappingDetail;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingDetailID + "]");
				throw new DataNotFoundException("TableMappingDetail [" + ai_TableMappingDetailID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingDetailID + "]");
			throw new DataNotFoundException("TableMappingDetail [" + ai_TableMappingDetailID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingDetail TMD ");
		sb_SQLCommand.append("WHERE TMD.TMD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of TableMappingDetail By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<TableMappingDetail> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<TableMappingDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<TableMappingDetail> TableMappingDetailList = query.list();
			if (TableMappingDetailList.isEmpty() != true) {
				return TableMappingDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByTableMappingID(int ai_CommandType,Integer ai_TableMappingID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingDetail TMD ");
		sb_SQLCommand.append("WHERE TMD.TMD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_TableMappingID != null){
			sb_SQLCommand.append("AND TMD.TMD_TableMappingID = "+ai_TableMappingID+" ");
		}

		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingID(Session MyHSs,Integer ai_TableMappingID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingID(10,ai_TableMappingID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingID", "[" + RowCount.intValue() + "] Of TableMappingDetail By TableMappingID [TableMappingID:"+ai_TableMappingID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMappingDetail> FindByTableMappingID(Session MyHSs,Integer ai_TableMappingID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByTableMappingID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingID(20,ai_TableMappingID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByTableMappingID", ls_SQLCommand);
			NativeQuery<TableMappingDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TableMappingDetail> TableMappingDetailList = query.list();
			if (TableMappingDetailList.isEmpty() != true) {
				return TableMappingDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "FindByTableMappingID[TableMappingID:"+ai_TableMappingID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingDetail By TableMappingID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByTableMappingIDPoitValueCondition(int ai_CommandType,Integer ai_TableMappingID,Double ai_PointValue,Integer ai_Condition, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingDetail TMD ");
		sb_SQLCommand.append("WHERE TMD.TMD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_TableMappingID != null){
			sb_SQLCommand.append("AND TMD.TMD_TableMappingID = "+ai_TableMappingID+" ");
		}
		if(ai_PointValue != null){
			sb_SQLCommand.append("AND TMD.TMD_PointValue = "+ai_PointValue+" ");
		}
		if(ai_Condition != null){
			sb_SQLCommand.append("AND TMD.TMD_Condition = "+ai_Condition+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingIDPoitValueCondition(Session MyHSs,Integer ai_TableMappingID,Double ai_PointValue,Integer ai_Condition,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingIDPoitValueCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingIDPoitValueCondition(10,ai_TableMappingID, ai_PointValue, ai_Condition, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingIDPoitValueCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "GetSizeByTableMappingIDPoitValueCondition", "[" + RowCount.intValue() + "] Of TableMappingDetail By TableMappingID [TableMappingID:"+ai_TableMappingID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMappingDetail> FindByTableMappingIDPoitValueCondition(Session MyHSs,Integer ai_TableMappingID,Double ai_PointValue,Integer ai_Condition,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByTableMappingIDPoitValueCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingIDPoitValueCondition(20,ai_TableMappingID, ai_PointValue, ai_Condition,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingDetailDAO", "FindByTableMappingID", ls_SQLCommand);
			NativeQuery<TableMappingDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TableMappingDetail> TableMappingDetailList = query.list();
			if (TableMappingDetailList.isEmpty() != true) {
				return TableMappingDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingDetailDAO", "FindByTableMappingIDPoitValueCondition[TableMappingID:"+ai_TableMappingID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingDetail By TableMappingID PoitValue Condition is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}