package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.TableMappingSubDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class TableMappingSubDetailDAO {
	/**
	 * @param MyHSs
	 * @param ao_TableMappingSubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingSubDetail Add(Session MyHSs,TableMappingSubDetail ao_TableMappingSubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingSubDetail.getOwnerSUID(), ao_TableMappingSubDetail.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_TableMappingSubDetail.setModifyTime(Common.GetCurrTime());
			ao_TableMappingSubDetail.setModifyUser(as_UserName);
			ao_TableMappingSubDetail.setCreateTime(Common.GetCurrTime());
			ao_TableMappingSubDetail.setCreateUser(as_UserName);
			
			
			ObjectDAO.Add(MyHSs, ao_TableMappingSubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Add", "[Ready][TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]");
			return ao_TableMappingSubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "Add", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingSubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingSubDetail Disable(Session MyHSs, TableMappingSubDetail ao_TableMappingSubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingSubDetail.getOwnerSUID(), ao_TableMappingSubDetail.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_TableMappingSubDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_TableMappingSubDetail.setDeletedUser(as_UserName);
			ao_TableMappingSubDetail.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_TableMappingSubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Disable", "[Ready][TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]");
			return ao_TableMappingSubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "Disable", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingSubDetail
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingSubDetail Delete(Session MyHSs, TableMappingSubDetail ao_TableMappingSubDetail, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingSubDetail.getOwnerSUID(), ao_TableMappingSubDetail.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_TableMappingSubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Delete", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]");
			return ao_TableMappingSubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "Delete", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TableMappingSubDetail
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TableMappingSubDetail Modify(Session MyHSs, TableMappingSubDetail ao_TableMappingSubDetail, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_TableMappingSubDetail.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_TableMappingSubDetail.setModifyTime(Common.GetCurrTime());
			ao_TableMappingSubDetail.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_TableMappingSubDetail);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "Modify", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]");
			return ao_TableMappingSubDetail;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "Modify", "[TableMappingSubDetailID:" + ao_TableMappingSubDetail.getTableMappingSubDetailID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_TableMappingSubDetailID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static TableMappingSubDetail GetByID(Session MyHSs, Integer ai_TableMappingSubDetailID, Integer SUID, Integer SGID) throws DataNotFoundException {
		TableMappingSubDetail theTableMappingSubDetail = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<TableMappingSubDetail> criteria = builder.createQuery(TableMappingSubDetail.class);
		criteria.where(builder.equal(criteria.from(TableMappingSubDetail.class).get("tableMappingSubDetailID"), ai_TableMappingSubDetailID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theTableMappingSubDetail = (TableMappingSubDetail) query.getSingleResult();
			if (theTableMappingSubDetail != null) {
				return theTableMappingSubDetail;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingSubDetailID + "]");
				throw new DataNotFoundException("TableMappingSubDetail [" + ai_TableMappingSubDetailID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "GetByID", "[Not Found][ID:" + ai_TableMappingSubDetailID + "]");
			throw new DataNotFoundException("TableMappingSubDetail [" + ai_TableMappingSubDetailID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMSD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingSubDetail TMSD ");
		sb_SQLCommand.append("WHERE TMSD.TMSD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of TableMappingSubDetail By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<TableMappingSubDetail> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<TableMappingSubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingSubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<TableMappingSubDetail> TableMappingSubDetailList = query.list();
			if (TableMappingSubDetailList.isEmpty() != true) {
				return TableMappingSubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingSubDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByTableMappingDetailID(int ai_CommandType,Integer ai_TableMappingDetailID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMSD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingSubDetail TMSD ");
		sb_SQLCommand.append("WHERE TMSD.TMSD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_TableMappingDetailID != null){
			sb_SQLCommand.append("AND TMSD.TMSD_TableMappingDetailID = "+ai_TableMappingDetailID+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingDetailID(Session MyHSs,Integer ai_TableMappingDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingDetailID(10,ai_TableMappingDetailID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of TableMappingSubDetail By TableMappingDetailID"+ai_TableMappingDetailID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMappingSubDetail> FindByTableMappingDetailID(Session MyHSs,Integer ai_TableMappingDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingDetailID(20,ai_TableMappingDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<TableMappingSubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingSubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<TableMappingSubDetail> TableMappingSubDetailList = query.list();
			if (TableMappingSubDetailList.isEmpty() != true) {
				return TableMappingSubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingSubDetail By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByTableMappingDetailIDPoitValueCondition(int ai_CommandType,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMSD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingSubDetail TMSD ");
		sb_SQLCommand.append("WHERE TMSD.TMSD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_TableMappingDetailID != null){
			sb_SQLCommand.append("AND TMSD.TMSD_TableMappingDetailID = "+ai_TableMappingDetailID+" ");
		}
		if(ai_PointValue != null){
			sb_SQLCommand.append("AND TMSD.TMSD_PointValue = "+ai_PointValue+" ");
		}
		if(ai_Condition != null){
			sb_SQLCommand.append("AND TMSD.TMSD_Condition = "+ai_Condition+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingDetailIDPoitValueCondition(Session MyHSs,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingDetailIDPoitValueCondition(10,ai_TableMappingDetailID, ai_PointValue, ai_Condition,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueCondition", "[" + RowCount.intValue() + "] Of TableMappingSubDetail By TableMappingDetailID"+ai_TableMappingDetailID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMappingSubDetail> FindByTableMappingDetailIDPoitValueCondition(Session MyHSs,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingDetailIDPoitValueCondition(20,ai_TableMappingDetailID, ai_PointValue, ai_Condition,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueCondition", ls_SQLCommand);
			NativeQuery<TableMappingSubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingSubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<TableMappingSubDetail> TableMappingSubDetailList = query.list();
			if (TableMappingSubDetailList.isEmpty() != true) {
				return TableMappingSubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueCondition", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingSubDetail By MappingDetailID PoitValue Condition is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag(int ai_CommandType,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition,Integer ai_PointValueInfinityFlag, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TMSD.* ");
		}
		sb_SQLCommand.append("FROM TableMappingSubDetail TMSD ");
		sb_SQLCommand.append("WHERE TMSD.TMSD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_TableMappingDetailID != null){
			sb_SQLCommand.append("AND TMSD.TMSD_TableMappingDetailID = "+ai_TableMappingDetailID+" ");
		}
		if(ai_PointValue != null){
			sb_SQLCommand.append("AND TMSD.TMSD_PointValue = "+ai_PointValue+" ");
		}
		if(ai_Condition != null){
			sb_SQLCommand.append("AND TMSD.TMSD_Condition = "+ai_Condition+" ");
		}
		if(ai_PointValueInfinityFlag != null){
			sb_SQLCommand.append("AND TMSD.TMSD_PointValueInfinityFlag = "+ai_PointValueInfinityFlag+" ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag(Session MyHSs,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition,Integer ai_PointValueInfinityFlag,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag(10,ai_TableMappingDetailID, ai_PointValue, ai_Condition,ai_PointValueInfinityFlag,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "GetSizeByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", "[" + RowCount.intValue() + "] Of TableMappingSubDetail By TableMappingDetailID"+ai_TableMappingDetailID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TableMappingSubDetail> FindByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag(Session MyHSs,Integer ai_TableMappingDetailID,Double ai_PointValue,Integer ai_Condition,Integer ai_PointValueInfinityFlag,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag(20,ai_TableMappingDetailID, ai_PointValue, ai_Condition,ai_PointValueInfinityFlag,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", ls_SQLCommand);
			NativeQuery<TableMappingSubDetail> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TableMappingSubDetail.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<TableMappingSubDetail> TableMappingSubDetailList = query.list();
			if (TableMappingSubDetailList.isEmpty() != true) {
				return TableMappingSubDetailList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TableMappingSubDetailDAO", "FindByTableMappingDetailIDPoitValueConditionPointValueInfinityFlag", "[Not Found] @@@");
				throw new DataNotFoundException("Find TableMappingSubDetail By MappingDetailID PoitValue Condition is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}