package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Topic;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class TopicDAO {
	/**
	 * @param MyHSs
	 * @param ao_Topic
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Topic Add(Session MyHSs,Topic ao_Topic, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Topic.getOwnerSUID(), ao_Topic.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Topic.setModifyTime(Common.GetCurrTime());
			ao_Topic.setModifyUser(as_UserName);
			ao_Topic.setCreateTime(Common.GetCurrTime());
			ao_Topic.setCreateUser(as_UserName);
			
			ObjectDAO.Add(MyHSs, ao_Topic);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Add", "[Ready][TopicID:" + ao_Topic.getTopicID()+"]");
			return ao_Topic;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "Add", "[TopicID:" + ao_Topic.getTopicID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Topic
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Topic Disable(Session MyHSs, Topic ao_Topic, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Topic.getOwnerSUID(), ao_Topic.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Topic.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Topic.setDeletedUser(as_UserName);
			ao_Topic.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Topic);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Disable", "[Ready][TopicID:" + ao_Topic.getTopicID()+"]");
			return ao_Topic;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "Disable", "[TopicID:" + ao_Topic.getTopicID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Topic
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Topic Delete(Session MyHSs, Topic ao_Topic, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Topic.getOwnerSUID(), ao_Topic.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Topic);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Delete", "[TopicID:" + ao_Topic.getTopicID()+"]");
			return ao_Topic;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "Delete", "[TopicID:" + ao_Topic.getTopicID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Topic
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Topic Modify(Session MyHSs, Topic ao_Topic, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Topic.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Topic.setModifyTime(Common.GetCurrTime());
			ao_Topic.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Topic);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "Modify", "[TopicID:" + ao_Topic.getTopicID()+"]");
			return ao_Topic;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "Modify", "[TopicID:" + ao_Topic.getTopicID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_TopicID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Topic GetByID(Session MyHSs, Integer ai_TopicID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Topic theTopic = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Topic> criteria = builder.createQuery(Topic.class);
		criteria.where(builder.equal(criteria.from(Topic.class).get("topicID"), ai_TopicID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theTopic = (Topic) query.getSingleResult();
			if (theTopic != null) {
				return theTopic;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "GetByID", "[Not Found][ID:" + ai_TopicID + "]");
				throw new DataNotFoundException("Topic [" + ai_TopicID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "GetByID", "[Not Found][ID:" + ai_TopicID + "]");
			throw new DataNotFoundException("Topic [" + ai_TopicID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TP.* ");
		}
		sb_SQLCommand.append("FROM Topic TP ");
		sb_SQLCommand.append("WHERE TP.TP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Topic By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Topic> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Topic> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Topic.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Topic> TopicList = query.list();
			if (TopicList.isEmpty() != true) {
				return TopicList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Topic By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySectionID(int ai_CommandType,Integer ai_SectionID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TP.* ");
		}
		sb_SQLCommand.append("FROM Topic TP ");
		sb_SQLCommand.append("WHERE TP.TP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SectionID != null){
			sb_SQLCommand.append("AND TP.TP_SectionID = "+ai_SectionID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY TP.TP_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySectionID(Session MyHSs,Integer ai_SectionID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeBySectionID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySectionID(10,ai_SectionID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeBySectionID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeBySectionID", "[" + RowCount.intValue() + "] Of Topic By SectionID [SectionID:"+ai_SectionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Topic> FindBySectionID(Session MyHSs,Integer ai_SectionID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindByBySectionID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySectionID(20,ai_SectionID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindBySectionID", ls_SQLCommand);
			NativeQuery<Topic> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Topic.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Topic> TopicList = query.list();
			if (TopicList.isEmpty() != true) {
				return TopicList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "FindBySectionID[SectionID:"+ai_SectionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Topic By SectionID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByUnitID(int ai_CommandType,Integer ai_UnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TP.* ");
		}
		sb_SQLCommand.append("FROM Topic TP ");
		sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = TP.TP_SectionID  ");
		sb_SQLCommand.append("WHERE TP.TP_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND ST.ST_UnitID = "+ai_UnitID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY TP.TP_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeByUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByUnitID(10,ai_UnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeByUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "GetSizeByUnitID", "[" + RowCount.intValue() + "] Of Topic By UnitID [UnitID:"+ai_UnitID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Topic> FindByUnitID(Session MyHSs,Integer ai_UnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindByByUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByUnitID(20,ai_UnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicDAO", "FindByUnitID", ls_SQLCommand);
			NativeQuery<Topic> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Topic.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Topic> TopicList = query.list();
			if (TopicList.isEmpty() != true) {
				return TopicList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicDAO", "FindByUnitID[UnitID:"+ai_UnitID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Topic By UnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
