package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.TopicObjective;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class TopicObjectiveDAO {
	/**
	 * @param MyHSs
	 * @param ao_TopicObjective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TopicObjective Add(Session MyHSs,TopicObjective ao_TopicObjective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_TopicObjective.getOwnerSUID(), ao_TopicObjective.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_TopicObjective.setModifyTime(Common.GetCurrTime());
			ao_TopicObjective.setModifyUser(as_UserName);
			ao_TopicObjective.setCreateTime(Common.GetCurrTime());
			ao_TopicObjective.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_TopicObjective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Add", "[Ready][TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]");
			return ao_TopicObjective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "Add", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TopicObjective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TopicObjective Disable(Session MyHSs, TopicObjective ao_TopicObjective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_TopicObjective.getOwnerSUID(), ao_TopicObjective.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_TopicObjective.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_TopicObjective.setDeletedUser(as_UserName);
			ao_TopicObjective.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_TopicObjective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Disable", "[Ready][TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]");
			return ao_TopicObjective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "Disable", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TopicObjective
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TopicObjective Delete(Session MyHSs, TopicObjective ao_TopicObjective, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_TopicObjective.getOwnerSUID(), ao_TopicObjective.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_TopicObjective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Delete", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]");
			return ao_TopicObjective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "Delete", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_TopicObjective
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static TopicObjective Modify(Session MyHSs, TopicObjective ao_TopicObjective, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_TopicObjective.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_TopicObjective.setModifyTime(Common.GetCurrTime());
			ao_TopicObjective.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_TopicObjective);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "Modify", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]");
			return ao_TopicObjective;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "Modify", "[TopicID:" + ao_TopicObjective.getPK().getTopicID()+ "][ObjectiveID:"+ao_TopicObjective.getPK().getObjectiveID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_TopicObjectiveID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static TopicObjective GetByID(Session MyHSs, Integer ai_TopicID, Integer ai_ObjectiveID, Integer SUID, Integer SGID) throws DataNotFoundException {
		TopicObjective theTopicObjective = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<TopicObjective> criteria = builder.createQuery(TopicObjective.class);
		Root<TopicObjective> root = criteria.from(TopicObjective.class);
		criteria.select(root);
		criteria.where(
				builder.and(
						builder.equal(root.get("PK").get("topicID"), ai_TopicID),
						builder.equal(root.get("PK").get("objectiveID"), ai_ObjectiveID)
						));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theTopicObjective =  (TopicObjective) query.getSingleResult();
			if (theTopicObjective != null) {
				return theTopicObjective;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "GetByID", "[Not Found] @@@");
				throw new DataNotFoundException("topicID [" + ai_TopicID +"] ,objectiveID ["+ai_ObjectiveID+ "] ,  is not found.");
			}
		}catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "GetByID", "[Not Found] @@@");
			throw new DataNotFoundException("topicID [" + ai_TopicID +"] ,objectiveID ["+ai_ObjectiveID+ "] ,  is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TPO.* ");
		}
		sb_SQLCommand.append("FROM TopicObjective TPO ");
		sb_SQLCommand.append("WHERE TPO.TO_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of TopicObjective By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<TopicObjective> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<TopicObjective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TopicObjective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TopicObjective> TopicObjectiveList = query.list();
			if (TopicObjectiveList.isEmpty() != true) {
				return TopicObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find TopicObjective By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByTopicID(int ai_CommandType,Integer ai_TopicID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT TPO.* ");
		}
		sb_SQLCommand.append("FROM TopicObjective TPO ");
		sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = TPO.ObjectiveID ");
		sb_SQLCommand.append("WHERE TPO.TO_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_TopicID != null){
			sb_SQLCommand.append("AND TPO.TopicID = '"+ai_TopicID+"' ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY OJ.OJ_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByTopicID(Session MyHSs,Integer ai_TopicID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeByTopicID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByTopicID(10,ai_TopicID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeByTopicID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "GetSizeByTopicID", "[" + RowCount.intValue() + "] Of TopicObjective By TopicID [TopicID:"+ai_TopicID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<TopicObjective> FindByTopicID(Session MyHSs,Integer ai_TopicID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "FindByByTopicID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByTopicID(20,ai_TopicID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveDAO", "FindByTopicID", ls_SQLCommand);
			NativeQuery<TopicObjective> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(TopicObjective.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<TopicObjective> TopicObjectiveList = query.list();
			if (TopicObjectiveList.isEmpty() != true) {
				return TopicObjectiveList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "TopicObjectiveDAO", "FindByTopicID[TopicID:"+ai_TopicID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find TopicObjective By TopicID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}