package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class UnitDAO {
	/**
	 * @param MyHSs
	 * @param ao_Unit
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Unit Add(Session MyHSs,Unit ao_Unit, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_Unit.getOwnerSUID(), ao_Unit.getOwnerSGID(), SUID, SGID);
		try {
		
			ao_Unit.setModifyTime(Common.GetCurrTime());
			ao_Unit.setModifyUser(as_UserName);
			ao_Unit.setCreateTime(Common.GetCurrTime());
			ao_Unit.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_Unit);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Add", "[Ready][UnitID:" + ao_Unit.getUnitID()+"]");
			return ao_Unit;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "Add", "[UnitID:" + ao_Unit.getUnitID()+ "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Unit
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Unit Disable(Session MyHSs, Unit ao_Unit, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_Unit.getOwnerSUID(), ao_Unit.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_Unit.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_Unit.setDeletedUser(as_UserName);
			ao_Unit.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_Unit);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Disable", "[Ready][UnitID:" + ao_Unit.getUnitID()+"]");
			return ao_Unit;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "Disable", "[UnitID:" + ao_Unit.getUnitID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Unit
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Unit Delete(Session MyHSs, Unit ao_Unit, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_Unit.getOwnerSUID(), ao_Unit.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_Unit);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Delete", "[UnitID:" + ao_Unit.getUnitID()+"]");
			return ao_Unit;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "Delete", "[UnitID:" + ao_Unit.getUnitID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	/**
	 * @param MyHSs
	 * @param ao_Unit
	 * @param as_UserName
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws Exception
	 */
	public static Unit Modify(Session MyHSs, Unit ao_Unit, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_Unit.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_Unit.setModifyTime(Common.GetCurrTime());
			ao_Unit.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_Unit);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "Modify", "[UnitID:" + ao_Unit.getUnitID()+"]");
			return ao_Unit;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "Modify", "[UnitID:" + ao_Unit.getUnitID()+"]>" + ex.toString());
			throw ex;
		} finally {
		}
	}
	/**
	 * @param MyHSs
	 * @param ai_UnitID
	 * @param SUID
	 * @param SGID
	 * @return
	 * @throws DataNotFoundException
	 */
	public static Unit GetByID(Session MyHSs, Integer ai_UnitID, Integer SUID, Integer SGID) throws DataNotFoundException {
		Unit theUnit = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<Unit> criteria = builder.createQuery(Unit.class);
		criteria.where(builder.equal(criteria.from(Unit.class).get("unitID"), ai_UnitID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theUnit = (Unit) query.getSingleResult();
			if (theUnit != null) {
				return theUnit;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "GetByID", "[Not Found][ID:" + ai_UnitID + "]");
				throw new DataNotFoundException("Unit [" + ai_UnitID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "GetByID", "[Not Found][ID:" + ai_UnitID + "]");
			throw new DataNotFoundException("Unit [" + ai_UnitID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	/**
	 * @param ai_CommandType
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 */
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of Unit By All [END] @@@");
		return RowCount.intValue();
	}
	/**
	 * @param MyHSs
	 * @param SUID
	 * @param SGID
	 * @param BeginRow
	 * @param MaxRow
	 * @param StatusList
	 * @return
	 * @throws DataNotFoundException
	 * @throws Exception
	 */
	public static List<Unit> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", "[" + RowCount.intValue() + "] Of Unit By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectID", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectIDInItemFormUnitID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID = UN.UN_SubjectID ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
				sb_SQLCommand.append("AND UN.UN_ItemFromUnitID IN ( ");
				sb_SQLCommand.append("SELECT A.UnitID ");
				sb_SQLCommand.append("FROM Unit A ");
				sb_SQLCommand.append("WHERE A.UN_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				if (StatusList.length > 0) {
					for (int i = 0; i < StatusList.length; i++) {
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(StatusList[i]);
					}
				}
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND A.UN_SubjectID = "+ai_SubjectID+" ");
				sb_SQLCommand.append(" ) ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order, SJ.SJ_Code ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDInItemFormUnitID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFormUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDInItemFormUnitID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFormUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFormUnitID", "[" + RowCount.intValue() + "] Of Unit By SubjectIDInItemFormUnitID[SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDInItemFormUnitID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectIDInItemFormUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDInItemFormUnitID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDInItemFormUnitID", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDInItemFormUnitID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectIDInItemFormUnitID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamScheduleDetailID(int ai_CommandType,Integer ai_ExamScheduleDetailID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID = UN.UN_SubjectID ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_ExamScheduleDetailID != null){
			sb_SQLCommand.append("AND ESD.ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamScheduleDetailID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamScheduleDetailID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamScheduleDetailID(10,ai_ExamScheduleDetailID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamScheduleDetailID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamScheduleDetailID", "[" + RowCount.intValue() + "] Of Unit By ExamScheduleDetailID [ExamScheduleDetailID:"+ai_ExamScheduleDetailID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindByExamScheduleDetailID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByByExamScheduleDetailID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamScheduleDetailID(20,ai_ExamScheduleDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamScheduleDetailID", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamScheduleDetailID[ExamScheduleDetailID:"+ai_ExamScheduleDetailID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By ExamScheduleDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByExamFormID(int ai_CommandType, Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
	
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID =  UN.UN_SubjectID ");
			sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ESD_SubjectID =  SJ.SubjectID ");
			sb_SQLCommand.append("JOIN ExamForm EF ON EF.EF_ExamScheduleDetailID =  ESD.ExamScheduleDetailID ");
		}
		sb_SQLCommand.append("WHERE UN.UN_CreateTime IS NOT NULL ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EF.ExamFormID = " + ai_ExamFormID + " ");
		}
		sb_SQLCommand.append("AND UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_CommandType != 10){
			sb_SQLCommand.append(" ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormID(Session MyHSs, Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(10, ai_ExamFormID, SUID, SGID, StatusList);
		Integer RowCount = ObjectDAO.GetSizeBySQL(MyHSs, ls_SQLCommand);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormID", "[" + RowCount.intValue() + "] Of Unit By ExamFormID [END] @@@");
		return RowCount.intValue();
	}
	public static List<Unit> FindAllByExamFormID(Session MyHSs, Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		return FindByExamFormID(MyHSs, ai_ExamFormID, SUID, SGID, 0, 0,  StatusList);
	}
	
	public static List<Unit> FindByExamFormID(Session MyHSs, Integer ai_ExamFormID, Integer SUID, Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormID", "[START] @@@");
		String ls_SQLCommand = GenSQLByExamFormID(20, ai_ExamFormID, SUID, SGID, StatusList);
		List<Unit> UnitList = ObjectDAO.FindBySQL(MyHSs, Unit.class, ls_SQLCommand, BeginRow, MaxRow);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamForm", "[End] @@@");
		return UnitList;
	}
	
	public static String GenSQLBySubjectIDItemFromUnitIDNotNull(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		sb_SQLCommand.append("AND UN.UnitID != UN.UN_ItemFromUnitID ");
		sb_SQLCommand.append("AND UN.UN_ItemFromUnitID IS NOT NULL ");
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDItemFromUnitIDNotNull(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDItemFromUnitIDNotNull", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDItemFromUnitIDNotNull(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDItemFromUnitIDNotNull", "[" + RowCount.intValue() + "] Of Unit By SubjectID ItemFromUnitIDNotNull[SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDItemFromUnitIDNotNull(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectIDItemFromUnitIDNotNull", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDItemFromUnitIDNotNull(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDItemFromUnitIDNotNull", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDItemFromUnitIDNotNull[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID ItemFromUnitIDNotNull is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectIDInItemFromUnitID(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT DISTINCT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		sb_SQLCommand.append("AND UN.UnitID IN ( ");
			sb_SQLCommand.append("SELECT UNO.UN_ItemFromUnitID ");
			sb_SQLCommand.append("FROM Unit UNO ");
			sb_SQLCommand.append("WHERE UNO.UN_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append("AND UNO.UN_ItemFromUnitID IS NOT NULL ");
		sb_SQLCommand.append(" ) ");
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDInItemFromUnitID(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDInItemFromUnitID(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitID", "[" + RowCount.intValue() + "] Of Unit InItemFromUnitID By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDInItemFromUnitID(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectIDInItemFromUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDInItemFromUnitID(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDInItemFromUnitID", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDInItemFromUnitID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	
	public static String GenSQLBySubjectIDInItemFromUnitIDAll(int ai_CommandType,Integer ai_SubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("JOIN Unit UNO ON UNO.UnitID = UN.UN_ItemFromUnitID ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UNO.UN_SubjectID = "+ai_SubjectID+" ");
		}
		
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UNO.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDInItemFromUnitIDAll(Session MyHSs,Integer ai_SubjectID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitIDAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDInItemFromUnitIDAll(10,ai_SubjectID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitIDAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDInItemFromUnitIDAll", "[" + RowCount.intValue() + "] Of Unit InItemFromUnitID By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDInItemFromUnitIDAll(Session MyHSs,Integer ai_SubjectID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectIDInItemFromUnitIDAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDInItemFromUnitIDAll(20,ai_SubjectID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDInItemFromUnitIDAll", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDInItemFromUnitIDAll[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("FindBySubjectIDInItemFromUnitIDAll is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLBySubjectCodeSubjectNameFilterSubjectID(int ai_CommandType,String as_SubjectCode ,String as_SubjectName,Integer ai_FilterSubjectID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
	
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("JOIN Subject SJ ON SJ.SubjectID =  UN.UN_SubjectID ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_SubjectCode != null){
			sb_SQLCommand.append("AND SJ.SJ_Code = '" + as_SubjectCode + "' ");
		}
		if(as_SubjectName != null){
			sb_SQLCommand.append("AND SJ.SJ_Name LIKE '%" + as_SubjectName + "%' ");
		}
		
		if(ai_FilterSubjectID != null){
			sb_SQLCommand.append("AND UN.UnitID NOT IN ( ");
				sb_SQLCommand.append("SELECT UN2.UnitID ");
				sb_SQLCommand.append("FROM Unit UN2 ");
				sb_SQLCommand.append("WHERE UN2.UN_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND UN2.UN_SubjectID = "+ai_FilterSubjectID+" ");
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append(" ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectCodeSubjectNameFilterSubjectID(Session MyHSs,String as_SubjectCode ,String as_SubjectName,Integer ai_FilterSubjectID, Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectCodeSubjectNameFilterSubjectID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFilterSubjectID(10,as_SubjectCode , as_SubjectName,ai_FilterSubjectID, SUID, SGID, StatusList);
		Integer RowCount = ObjectDAO.GetSizeBySQL(MyHSs, ls_SQLCommand);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectCodeSubjectNameFilterSubjectID", "[" + RowCount.intValue() + "] Of Unit By SubjectCode ["+as_SubjectCode+"] SubjectName ["+as_SubjectName+"] FilterSubjectID ["+ai_FilterSubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	public static List<Unit> FindAllBySubjectCodeSubjectName(Session MyHSs, String as_SubjectCode , String as_SubjectName,Integer ai_FilterSubjectID, Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		return FindBySubjectCodeSubjectNameFilterSubjectID(MyHSs,as_SubjectCode,as_SubjectName,ai_FilterSubjectID, SUID, SGID, 0, 0,  StatusList);
	}
	
	public static List<Unit> FindBySubjectCodeSubjectNameFilterSubjectID(Session MyHSs,String as_SubjectCode , String as_SubjectName,Integer ai_FilterSubjectID, Integer SUID, Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectCodeSubjectNameFilterSubjectID", "[START] @@@");
		String ls_SQLCommand = GenSQLBySubjectCodeSubjectNameFilterSubjectID(20, as_SubjectCode , as_SubjectName, ai_FilterSubjectID, SUID, SGID, StatusList);
		List<Unit> UnitList = ObjectDAO.FindBySQL(MyHSs, Unit.class, ls_SQLCommand, BeginRow, MaxRow);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectCodeSubjectNameFilterSubjectID", "[End] @@@");
		return UnitList;
	}
	
	public static String GenSQLBySubjectIDUnitOrder(int ai_CommandType,Integer ai_SubjectID,Integer ai_UnitOrder, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_UnitOrder != null){
			sb_SQLCommand.append("AND UN.UN_Order = "+ai_UnitOrder+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDUnitOrder(Session MyHSs,Integer ai_SubjectID,Integer ai_UnitOrder,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDUnitOrder", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDUnitOrder(10,ai_SubjectID,ai_UnitOrder, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDUnitOrder", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDUnitOrder", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDUnitOrder(Session MyHSs,Integer ai_SubjectID,Integer ai_UnitOrder,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByBySubjectIDUnitOrder", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDUnitOrder(20,ai_SubjectID,ai_UnitOrder,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDUnitOrder", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDUnitOrder[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectIDItemFromUnitID(int ai_CommandType,Integer ai_SubjectID,Integer ai_ItemFromUnitID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_ItemFromUnitID != null){
			sb_SQLCommand.append("AND UN.UN_ItemFromUnitID = "+ai_ItemFromUnitID+" ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDItemFromUnitID(Session MyHSs,Integer ai_SubjectID,Integer ai_ItemFromUnitID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDItemFromUnitID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDItemFromUnitID(10,ai_SubjectID,ai_ItemFromUnitID, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDItemFromUnitID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDItemFromUnitID", "[" + RowCount.intValue() + "] Of Unit UnitOrder By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDItemFromUnitID(Session MyHSs,Integer ai_SubjectID,Integer ai_ItemFromUnitID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDItemFromUnitID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDItemFromUnitID(20,ai_SubjectID,ai_ItemFromUnitID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDItemFromUnitID", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDItemFromUnitID[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLBySubjectIDFilterUnitIDList(int ai_CommandType,Integer ai_SubjectID,List<Integer> ai_UnitIDList, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND UN.UN_SubjectID = "+ai_SubjectID+" ");
		}
		if(ai_UnitIDList != null && ai_UnitIDList.size() > 0){
			sb_SQLCommand.append("AND UN.UnitID NOT IN ( ");
			for(int i=0;i<ai_UnitIDList.size();i++){
				if(i != 0){
					sb_SQLCommand.append(", ");
				}
				sb_SQLCommand.append(ai_UnitIDList.get(i));
			}
			sb_SQLCommand.append(") ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeBySubjectIDFilterUnitIDList(Session MyHSs,Integer ai_SubjectID,List<Integer> ai_UnitIDList,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDFilterUnitIDList", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLBySubjectIDFilterUnitIDList(10,ai_SubjectID,ai_UnitIDList, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDFilterUnitIDList", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeBySubjectIDFilterUnitIDList", "[" + RowCount.intValue() + "] Of Unit By SubjectID [SubjectID:"+ai_SubjectID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindBySubjectIDFilterUnitIDList(Session MyHSs,Integer ai_SubjectID,List<Integer> ai_UnitIDList,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDFilterUnitIDList", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLBySubjectIDFilterUnitIDList(20,ai_SubjectID,ai_UnitIDList,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindBySubjectIDFilterUnitIDList", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindBySubjectIDFilterUnitIDList[SubjectID:"+ai_SubjectID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND UN.UnitID IN (SELECT EICD.EICD_UnitID FROM ExamItemCondition EICD WHERE EICD.EICD_DataStatus NOT IN (411,511) AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EICD.EICD_NOFItem IS NOT NULL AND EICD.EICD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindByExamFormConditionIDInExamItemCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamCreatorCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND UN.UnitID IN (SELECT ECCD.ECCD_UnitID FROM ExamCreatorCondition ECCD WHERE ECCD.ECCD_DataStatus NOT IN (411,511) AND ECCD.ECCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND ECCD.ECCD_NOFItem IS NOT NULL AND ECCD.ECCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamCreatorCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamCreatorCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindByExamFormConditionIDInExamCreatorCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamCreatorCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamCreatorCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamCreatorCondition", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamCreatorCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDInExamItemSelectCondition(int ai_CommandType,Integer ai_ExamFormConditionID,boolean ab_AcceptZero, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UN.* ");
		}
		sb_SQLCommand.append("FROM Unit UN ");
		sb_SQLCommand.append("WHERE UN.UN_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		
		
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND UN.UnitID IN (SELECT EISCD.EISCD_UnitID FROM ExamItemSelectCondition EISCD WHERE EISCD.EISCD_DataStatus NOT IN (411,511) AND EISCD.EISCD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			if(!ab_AcceptZero){
				sb_SQLCommand.append(" AND EISCD.EISCD_NOFItem IS NOT NULL AND EISCD.EISCD_NOFItem > 0 ");
			}
			sb_SQLCommand.append(" ) ");
		}
		if(ai_CommandType != 10){
			sb_SQLCommand.append("ORDER BY UN.UN_Order ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDInExamItemSelectCondition(10,ai_ExamFormConditionID,ab_AcceptZero, SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "GetSizeByExamFormConditionIDInExamItemSelectCondition", "[" + RowCount.intValue() + "] Of Unit By SubjectID [ExamFormConditionID:"+ai_ExamFormConditionID+"] [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<Unit> FindByExamFormConditionIDInExamItemSelectCondition(Session MyHSs,Integer ai_ExamFormConditionID,boolean ab_AcceptZero,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemSelectCondition", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDInExamItemSelectCondition(20,ai_ExamFormConditionID,ab_AcceptZero,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemSelectCondition", ls_SQLCommand);
			NativeQuery<Unit> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(Unit.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<Unit> UnitList = query.list();
			if (UnitList.isEmpty() != true) {
				return UnitList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UnitDAO", "FindByExamFormConditionIDInExamItemSelectCondition[ExamFormConditionID:"+ai_ExamFormConditionID+"]", "[Not Found] @@@");
				throw new DataNotFoundException("Find Unit By SubjectID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}