package esi.examwh.dao;

import java.util.List;

import javax.persistence.NoResultException;
import javax.persistence.Query;
import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;

import org.hibernate.Session;
import org.hibernate.query.NativeQuery;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.UserActionLog;
import esi.examwh.model.common.TYPE_DATA_STATUS;

public class UserActionLogDAO {

	public static UserActionLog Add(Session MyHSs,UserActionLog ao_UserActionLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Add", "[START] @@@");
		//PermissionService.isAddPermission(ao_UserActionLog.getOwnerSUID(), ao_UserActionLog.getOwnerSGID(), SUID, SGID);
		try {
			ao_UserActionLog.setModifyTime(Common.GetCurrTime());
			ao_UserActionLog.setModifyUser(as_UserName);
			ao_UserActionLog.setCreateTime(Common.GetCurrTime());
			ao_UserActionLog.setCreateUser(as_UserName);
			ObjectDAO.Add(MyHSs, ao_UserActionLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Add", "[Ready][ID:" + ao_UserActionLog.getUserActionLogID() + "]");
			return ao_UserActionLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "Add", "[ID:" + ao_UserActionLog.getUserActionLogID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static UserActionLog Disable(Session MyHSs, UserActionLog ao_UserActionLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Disable", "[START] @@@");
		//PermissionService.isAddPermission(ao_UserActionLog.getOwnerSUID(), ao_UserActionLog.getOwnerSGID(), SUID, SGID);
		try {
			
			ao_UserActionLog.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ao_UserActionLog.setDeletedUser(as_UserName);
			ao_UserActionLog.setDeletedTime(Common.GetCurrTime());
			ObjectDAO.Disable(MyHSs, ao_UserActionLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Disable", "[Ready][ID:" + ao_UserActionLog.getUserActionLogID() + "]");
			return ao_UserActionLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "Disable", "[ID:" +ao_UserActionLog.getUserActionLogID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static UserActionLog Delete(Session MyHSs, UserActionLog ao_UserActionLog, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Delete", "[START] @@@");
		//PermissionService.isAddPermission(ao_UserActionLog.getOwnerSUID(), ao_UserActionLog.getOwnerSGID(), SUID, SGID);
		try {
			ObjectDAO.Delete(MyHSs, ao_UserActionLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Delete", "[ID:" + ao_UserActionLog.getUserActionLogID() + "]");
			return ao_UserActionLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "Delete", "[ID:" + ao_UserActionLog.getUserActionLogID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static UserActionLog Modify(Session MyHSs, UserActionLog ao_UserActionLog, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Modify", "[START] @@@");
		//PermissionService.isAddPermission(ao_UserActionLog.getOwnerSUID(), ao_Address.getOwnerSGID(), SUID, SGID);
		try {
			ao_UserActionLog.setModifyTime(Common.GetCurrTime());
			ao_UserActionLog.setModifyUser(as_UserName);
			ObjectDAO.Modify(MyHSs, ao_UserActionLog);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "Modify", "[ID:" + ao_UserActionLog.getUserActionLogID() + "]");
			return ao_UserActionLog;
		} catch (Exception ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "Modify", "[ID:" + ao_UserActionLog.getUserActionLogID() + "]>" + ex.toString());
			throw ex;
		} finally {
		}
	}

	public static UserActionLog GetByID(Session MyHSs, Integer ai_UserActionLogID, Integer SUID, Integer SGID) throws DataNotFoundException {
		UserActionLog theUserActionLog = null;
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetByID", "[START] @@@");
		CriteriaBuilder builder = MyHSs.getCriteriaBuilder();
		CriteriaQuery<UserActionLog> criteria = builder.createQuery(UserActionLog.class);
		criteria.where(builder.equal(criteria.from(UserActionLog.class).get("userActionLogID"), ai_UserActionLogID));	
		Query query = MyHSs.createQuery(criteria);
		query.setFirstResult(0);
		query.setMaxResults(1);
		try {
			theUserActionLog = (UserActionLog) query.getSingleResult();
			if (theUserActionLog != null) {
				return theUserActionLog;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "GetByID", "[Not Found][ID:" + ai_UserActionLogID + "]");
				throw new DataNotFoundException("UserActionLog [" + ai_UserActionLogID + "] is not found.");
			}
		} catch (DataNotFoundException ex) {
			throw ex;
		} catch (NoResultException ex) {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "GetByID", "[Not Found][ID:" + ai_UserActionLogID + "]");
			throw new DataNotFoundException("UserActionLog [" + ai_UserActionLogID + "] is not found.");
		} catch (Exception ex) {
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLALL(int ai_CommandType, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UAL.* ");
		}
		sb_SQLCommand.append("FROM UserActionLog UAL ");
		sb_SQLCommand.append("WHERE UAL.UAL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeAll(Session MyHSs,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeAll", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLALL(10,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeAll", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeAll", "[" + RowCount.intValue() + "] Of UserActionLog By All [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<UserActionLog> FindAll(Session MyHSs,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "FindByAll", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLALL(20,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "FindByAll", ls_SQLCommand);
			NativeQuery<UserActionLog> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(UserActionLog.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<UserActionLog> UserActionLogList = query.list();
			if (UserActionLogList.isEmpty() != true) {
				return UserActionLogList;
			} else {                                                                                  
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "FindByAll", "[Not Found] @@@");
				throw new DataNotFoundException("Find UserActionLog By All is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	
	public static String GenSQLByPersonIDActionTypeID(int ai_CommandType, Integer ai_PersonID, Integer ai_ActionTypeID, Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT UAL.* ");
		}
		sb_SQLCommand.append("FROM UserActionLog UAL ");
		sb_SQLCommand.append("WHERE UAL.UAL_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_PersonID != null){
			sb_SQLCommand.append("AND UAL.UAL_PersonID = "+ai_PersonID +" ");
		}
		if(ai_ActionTypeID != null){
			sb_SQLCommand.append("AND UAL.UAL_ActionTypeID = "+ai_ActionTypeID +" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY UAL.UAL_ModifyTime DESC, UAL.UserActionLogID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
	public static int GetSizeByPersonIDActionTypeID(Session MyHSs, Integer ai_PersonID, Integer ai_ActionTypeID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeByPersonIDActionTypeID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByPersonIDActionTypeID(10,ai_PersonID,ai_ActionTypeID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeByPersonIDActionTypeID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "GetSizeByPersonIDActionTypeID", "[" + RowCount.intValue() + "] Of UserActionLog By PersonID:"+ai_PersonID+", ActionTypeID:"+ai_ActionTypeID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<UserActionLog> FindByPersonIDActionTypeID(Session MyHSs, Integer ai_PersonID, Integer ai_ActionTypeID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "FindByPersonIDActionTypeID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByPersonIDActionTypeID(20,ai_PersonID,ai_ActionTypeID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogDAO", "FindByPersonIDActionTypeID", ls_SQLCommand);
			NativeQuery<UserActionLog> query = MyHSs.createSQLQuery(ls_SQLCommand).addEntity(UserActionLog.class);
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<UserActionLog> UserActionLogList = query.list();
			if (UserActionLogList.isEmpty() != true) {
				return UserActionLogList;
			} else {                                                                                  
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "UserActionLogDAO", "FindByPersonIDActionTypeID", "[Not Found] @@@");
				throw new DataNotFoundException("Find UserActionLog By PersonIDActionTypeID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
}
