package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "Attributes")
public class Attributes implements java.io.Serializable{

	private static final long serialVersionUID = 7184359101673089308L;
	private Integer AttributeID;
	private int Version;
	private String Code;
	private String Name;
	private String Detail;
	private int NOFIndicators;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public Attributes() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "AttributeID", unique = true, nullable = false)
	public Integer getAttributeID() {
		return AttributeID;
	}

	public void setAttributeID(Integer attributeID) {
		AttributeID = attributeID;
	}


	@Version
	@Column(name = "A_Version", nullable = false)
	public int getVersion() {
		return Version;
	}

	
	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "A_Name", nullable = false, length = 1024)
	public String getName() {
		return Name;
	}

	public void setName(String name) {
		Name = name;
	}

	@Column(name = "A_Detail", length = 1024)
	public String getDetail() {
		return Detail;
	}

	public void setDetail(String detail) {
		Detail = detail;
	}

	@Column(name = "A_NOFIndicators")
	public int getNOFIndicators() {
		return NOFIndicators;
	}

	public void setNOFIndicators(int nOFIndicators) {
		NOFIndicators = nOFIndicators;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "A_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "A_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "A_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "A_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "A_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "A_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "A_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "A_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "A_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	@Column(name = "A_Code", nullable = false, length = 16)
	public String getCode() {
		return Code;
	}

	public void setCode(String code) {
		Code = code;
	}

	public String toString() {
		return "Attributes [AttributesID=" + AttributeID + ", CreateTime="
				+ CreateTime + ", CreateUser=" + CreateUser + ", DataStatus="
				+ DataStatus + ", DeletedTime=" + DeletedTime
				+ ", DeletedUser=" + DeletedUser + ", Detail=" + Detail
				+ ", ModifyTime=" + ModifyTime + ", ModifyUser=" + ModifyUser
				+ ", Name=" + Name + ", OwnerGroupID=" + OwnerGroupID
				+ ", OwnerUserID=" + OwnerUserID + ", Version=" + Version
				+ ", nofIndicators=" + NOFIndicators + "]";
	}
	
}
