package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "Curriculum")
public class Curriculum implements java.io.Serializable {
	
	private static final long serialVersionUID = 8228974187700465766L;
	private Integer CurriculumID;
	private int Version;
	private String Code;
	private String Name;
	private String Detail;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;

	public Curriculum() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "CurriculumID", unique = true, nullable = false)
	public Integer getCurriculumID() {
		return CurriculumID;
	}

	public void setCurriculumID(Integer curriculumID) {
		CurriculumID = curriculumID;
	}

	@Version
	@Column(name = "C_Version", nullable = false)
	public int getVersion() {
		return Version;
	}

	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "C_Code", nullable = false, length = 16)
	public String getCode() {
		return Code;
	}

	public void setCode(String code) {
		Code = code;
	}

	@Column(name = "C_Name", nullable = false, length = 1024)
	public String getName() {
		return Name;
	}

	public void setName(String name) {
		Name = name;
	}

	@Column(name = "C_Detail", length = 1024)
	public String getDetail() {
		return Detail;
	}

	public void setDetail(String detail) {
		Detail = detail;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "C_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "C_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "C_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "C_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "C_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "C_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "C_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "C_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "C_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	public String toString() {
		return "Curriculum [Code=" + Code + ", CreateTime=" + CreateTime
				+ ", CreateUser=" + CreateUser + ", CurriculumID="
				+ CurriculumID + ", DataStatus=" + DataStatus
				+ ", DeletedTime=" + DeletedTime + ", DeletedUser="
				+ DeletedUser + ", Detail=" + Detail + ", ModifyTime="
				+ ModifyTime + ", ModifyUser=" + ModifyUser + ", Name=" + Name
				+ ", OwnerGroupID=" + OwnerGroupID + ", OwnerUserID="
				+ OwnerUserID + ", Version=" + Version + "]";
	}
	
}
