package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "CurriculumAttribute")
public class CurriculumAttribute implements java.io.Serializable{

	private static final long serialVersionUID = -3824276274952255591L;
	private Integer CurriculumAttributeID;
	private Curriculum OCurriculum;
	private Attributes OAttribute;
	private int Version;
	private int Order;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public CurriculumAttribute() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "CurriculumAttributeID", unique = true, nullable = false)
	public Integer getCurriculumAttributeID() {
		return CurriculumAttributeID;
	}

	public void setCurriculumAttributeID(Integer curriculumAttributeID) {
		CurriculumAttributeID = curriculumAttributeID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CA_CurriculumID", nullable = false)
	public Curriculum getOCurriculum() {
		return OCurriculum;
	}

	public void setOCurriculum(Curriculum oCurriculum) {
		OCurriculum = oCurriculum;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "CA_AttributeID", nullable = false)
	public Attributes getOAttribute() {
		return OAttribute;
	}

	public void setOAttribute(Attributes oAttribute) {
		OAttribute = oAttribute;
	}

	@Version
	@Column(name = "CA_Version")
	public int getVersion() {
		return Version;
	}

	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "CA_Order")
	public int getOrder() {
		return Order;
	}

	public void setOrder(int order) {
		Order = order;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "CA_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "CA_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CA_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "CA_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CA_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "CA_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "CA_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "CA_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "CA_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	@Override
	public String toString() {
		return "CurriculumAttribute [CreateTime=" + CreateTime
				+ ", CreateUser=" + CreateUser + ", CurriculumAttributeID="
				+ CurriculumAttributeID + ", DataStatus=" + DataStatus
				+ ", DeletedTime=" + DeletedTime + ", DeletedUser="
				+ DeletedUser + ", ModifyTime=" + ModifyTime + ", ModifyUser="
				+ ModifyUser + ", OAttribute=" + OAttribute + ", OCurriculum="
				+ OCurriculum + ", OwnerGroupID=" + OwnerGroupID
				+ ", OwnerUserID=" + OwnerUserID + ", Version=" + Version
				+ ", order=" + Order + "]";
	}
	
	
}
