package esi.examwh.model;

import java.util.Date;

import javax.persistence.AttributeOverride;
import javax.persistence.AttributeOverrides;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.ApplicationPolicy;
import esi.examwh.model.common.TYPE_CONFIG_VERIFY_STATUS;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

import com.plw.util.Common;
import com.plw.util.OutOfListException;
import com.plw.util.VerifyData;

@Entity
@Table(name = "DocumentNumber")
public class DocumentNumber implements java.io.Serializable {

	private static final long serialVersionUID = 2931041606597841777L;
	private DocumentNumberPK PK;
	private Integer LastNumber;
	private Date LastRequestTime;
	private TYPE_DATA_STATUS DataStatus;
	private Integer Version;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	
	public DocumentNumber() {
		this.CreateTime = Common.GetCurrTime();
		this.CreateUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
	}
	
	public DocumentNumber(DocumentNumberPK PK,int DataStatus, Date CreateTime) {
		this.PK = PK;
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateTime = CreateTime;
	}
	
	public DocumentNumber(DocumentNumberPK PK, Integer DataStatus,Date CreateTime,String CreateUser, Date ModifyTime, String ModifyUser) {
		this.PK = PK;
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateTime = CreateTime;
		this.CreateUser = CreateUser;
		this.ModifyTime = ModifyTime;
		this.ModifyUser = ModifyUser;
	}

	
	@EmbeddedId
	@AttributeOverrides( {
			@AttributeOverride(name = "YearNum", column = @Column(name = "YearNum", nullable = false)),
			@AttributeOverride(name = "PrefixDocumentType", column = @Column(name = "PrefixDocumentType", nullable = false))
	})
	public DocumentNumberPK getPK() {
		return this.PK;
	}

	public void setPK(DocumentNumberPK PK) {
		this.PK = PK;
	}
	
	@Version
	@Column(name = "DN_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	
	@Column(name = "DN_LastNumber")
	public Integer getLastNumber() {
		return this.LastNumber;
	}

	public void setLastNumber(Integer LastNumber) {
		this.LastNumber = LastNumber;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "DN_LastRequestTime", length = 23)
	public Date getLastRequestTime() {
		return this.LastRequestTime;
	}

	public void setLastRequestTime(Date LastRequestTime) {
		this.LastRequestTime = LastRequestTime;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "DN_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "DN_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "DN_CreateUser", length = 64, nullable = false)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "DN_ModifyTime", length = 23, nullable = false)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "DN_ModifyUser", length = 64, nullable = false)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "DN_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "DN_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("[> DocumentNumber <]\n");
		if (this.PK != null) {
			
			temp.append("	YearNum : [" + this.PK.getYearNum() + "]\n");		
			temp.append("	PrefixDocumentType : [" + this.PK.getPrefixDocumentType() + "]\n");		
		} else {
			temp.append("	YearNum : [null]\n");		
			temp.append("	ArchiveType : [null]\n");	
		}
		temp.append("[Begin Record]\n");
		temp.append("    LastNumber : " + this.LastNumber + "\n");
		temp.append("    LastRequestTime : " + this.LastRequestTime+ "\n");
		temp.append("    DataStatus : " + this.DataStatus + "\n");
		temp.append("    CreateUser : " + this.CreateUser + "\n");
		temp.append("    CreateTime : " + this.CreateTime + "\n");
		temp.append("    ModifyUser : " + this.ModifyUser + "\n");
		temp.append("    ModifyTime : " + this.ModifyTime + "\n");
		temp.append("   DeletedUser : " + this.DeletedUser + "\n");
		temp.append("   DeletedTime : " + this.DeletedTime + "\n");
		temp.append("       Version : " + this.Version + "\n");
		temp.append("[End Record]");
		return temp.toString();
	}
	
	

	

}
