package esi.examwh.model;

import java.util.Date;

import javax.persistence.AttributeOverride;
import javax.persistence.AttributeOverrides;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM_ITEM_SELECTED_STATUS;
import jakarta.validation.constraints.NotNull;

import com.plw.util.Common;

@Entity
@Table(name = "ESDItemSelector")
public class ESDItemSelector implements java.io.Serializable {

	private static final long serialVersionUID = 644812310285788225L;
	private ESDItemSelectorPK PK;
	private Integer Version;
	private ExamScheduleDetail OExamScheduleDetailID;
	private Person OPersonID;
	private Integer Order;
	private Date AssignBeginDate;
	private Date AssignEndDate;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private TYPE_EXAM_ITEM_SELECTED_STATUS SelectedStatus;
	public ESDItemSelector() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}
	public static ESDItemSelector getNewInstance(Integer ai_ExamScheduleDetailID,Integer ai_PersonID) {
		ESDItemSelector ESFE = new ESDItemSelector();
		ESDItemSelectorPK lo_PK = new ESDItemSelectorPK();
		lo_PK.setExamScheduleDetailID(ai_ExamScheduleDetailID);
		lo_PK.setPersonID(ai_PersonID);
		ESFE.setPK(lo_PK);
		ESFE.DataStatus = TYPE_DATA_STATUS.STATUS_USE;
		ESFE.CreateUser = "System User";
		ESFE.CreateTime = Common.GetCurrTime();
		ESFE.ModifyUser = "System User";
		ESFE.ModifyTime = Common.GetCurrTime();
		return ESFE;
	}
	@EmbeddedId
	@AttributeOverrides({
			@AttributeOverride(name = "ExamScheduleDetailID", column = @Column(name = "ExamScheduleDetailID", nullable = false)),
			@AttributeOverride(name = "PersonID", column = @Column(name = "PersonID", nullable = false)),
			@AttributeOverride(name = "ExamLevel", column = @Column(name = "ExamLevel", nullable = true))})
	public ESDItemSelectorPK getPK() {
		return this.PK;
	}

	public void setPK(ESDItemSelectorPK PK) {
		this.PK = PK;
	}

	@Version
	@Column(name = "ESDIS_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ExamScheduleDetailID", nullable = false, insertable = false, updatable = false)
	public ExamScheduleDetail getOExamScheduleDetailID() {
		return this.OExamScheduleDetailID;
	}

	public void setOExamScheduleDetailID(
			ExamScheduleDetail OExamScheduleDetailID) {
		this.OExamScheduleDetailID = OExamScheduleDetailID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "PersonID", nullable = false, insertable = false, updatable = false)
	public Person getOPersonID() {
		return this.OPersonID;
	}

	public void setOPersonID(Person OPersonID) {
		this.OPersonID = OPersonID;
	}

	@Column(name = "ESDIS_Order")
	public Integer getOrder() {
		return this.Order;
	}

	public void setOrder(Integer Order) {
		this.Order = Order;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDIS_AssignBeginDate", length = 23)
	public Date getAssignBeginDate() {
		return this.AssignBeginDate;
	}

	public void setAssignBeginDate(Date AssignBeginDate) {
		this.AssignBeginDate = AssignBeginDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDIS_AssignEndDate", length = 23)
	public Date getAssignEndDate() {
		return this.AssignEndDate;
	}

	public void setAssignEndDate(Date AssignEndDate) {
		this.AssignEndDate = AssignEndDate;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_EXAM_ITEM_SELECTED_STATUS")
	@Column(name = "ESDFC_SelectedStatus")
	public TYPE_EXAM_ITEM_SELECTED_STATUS getSelectedStatus() {
		return SelectedStatus;
	}
	public void setSelectedStatus(TYPE_EXAM_ITEM_SELECTED_STATUS selectedStatus) {
		SelectedStatus = selectedStatus;
	}
	
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "ESDIS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "ESDIS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDIS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "ESDIS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDIS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDIS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "ESDIS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "ESDIS_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "ESDIS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}

	//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("[Begin Record]\n");
		if(this.OExamScheduleDetailID != null){
			temp.append("ExamScheduleDetailID : ["+this.getOExamScheduleDetailID().getExamScheduleDetailID()+"]\n");
		}else{
			temp.append("ExamScheduleDetailID : [null]\n");
		} 
		if(this.OPersonID != null){
			temp.append("PersonID : ["+this.getOPersonID().getPersonID()+"]\n");
		}else{
			temp.append("PersonID : [null]\n");
		} 
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("Order : ["+this.Order+"]\n");
		temp.append("AssignBeginDate : ["+this.AssignBeginDate+"]\n");
		temp.append("AssignEndDate : ["+this.AssignEndDate+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}

	
}
