package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;
@Entity
@Table(name = "ExamAnalysisHistogram")
public class ExamAnalysisHistogram implements java.io.Serializable{

	private static final long serialVersionUID = 9123586866364554302L;
	private Integer ExamAnalysisHistogramID;
	private Integer Version;
	
	private Integer Mark;
	private Integer Frequency;
	private Integer AccumulativeFrequency;
	private Double Percentile;
	private Double TMark;
	private ExamAnalysis OExamAnalysis;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public ExamAnalysisHistogram() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamAnalysisHistogramID", unique = true, nullable = false)
	public Integer getExamAnalysisHistogramID() {
		return ExamAnalysisHistogramID;
	}

	public void setExamAnalysisHistogramID(Integer examAnalysisHistogramID) {
		ExamAnalysisHistogramID = examAnalysisHistogramID;
	}
	
	@Version
	@Column(name = "EAH_Version")
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@Column(name = "EAH_Mark")
	public Integer getMark() {
		return Mark;
	}

	public void setMark(Integer mark) {
		Mark = mark;
	}

	@Column(name = "EAH_Frequency")
	public Integer getFrequency() {
		return Frequency;
	}

	public void setFrequency(Integer frequency) {
		Frequency = frequency;
	}

	@Column(name = "EAH_AccumulativeFrequency")
	public Integer getAccumulativeFrequency() {
		return AccumulativeFrequency;
	}

	public void setAccumulativeFrequency(Integer accumulativeFrequency) {
		AccumulativeFrequency = accumulativeFrequency;
	}

	@Column(name = "EAH_Percentile")
	public Double getPercentile() {
		return Percentile;
	}

	public void setPercentile(Double percentile) {
		Percentile = percentile;
	}

	@Column(name = "EAH_TMark")
	public Double getTMark() {
		return TMark;
	}

	public void setTMark(Double tMark) {
		TMark = tMark;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EAH_ExamAnalysisID")
	public ExamAnalysis getOExamAnalysis() {
		return OExamAnalysis;
	}

	public void setOExamAnalysis(ExamAnalysis oExamAnalysis) {
		OExamAnalysis = oExamAnalysis;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EAH_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "EAH_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}
	
	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAH_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "EAH_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAH_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAH_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "EAH_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "EAH_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "EAH_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
}
