package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamAnalysisUnitStat")
public class ExamAnalysisUnitStat implements java.io.Serializable{
	
	private static final long serialVersionUID = 6976817073129151874L;
	private Integer ExamAnalysisUnitStatID;
	private Integer Version;
	
	private Integer NOFCorrectStudent;
	private Integer NOFItem;
	private Double SumOfPValue;
	private Double UBarMark;
	private Double PBarMark;
	private ExamAnalysis OExamAnalysis;
	private Unit OUnit;
	
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public ExamAnalysisUnitStat() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamAnalysisUnitStatID", unique = true, nullable = false)
	public Integer getExamAnalysisUnitStatID() {
		return ExamAnalysisUnitStatID;
	}

	public void setExamAnalysisUnitStatID(Integer examAnalysisUnitStatID) {
		ExamAnalysisUnitStatID = examAnalysisUnitStatID;
	}

	@Version
	@Column(name = "EAUS_Version")
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@Column(name = "EAUS_NOFCorrectStudent")
	public Integer getNOFCorrectStudent() {
		return NOFCorrectStudent;
	}

	public void setNOFCorrectStudent(Integer nOFCorrectStudent) {
		NOFCorrectStudent = nOFCorrectStudent;
	}

	@Column(name = "EAUS_NOFItem")
	public Integer getNOFItem() {
		return NOFItem;
	}

	public void setNOFItem(Integer nOFItem) {
		NOFItem = nOFItem;
	}

	@Column(name = "EAUS_SumOfPValue")
	public Double getSumOfPValue() {
		return SumOfPValue;
	}

	public void setSumOfPValue(Double sumOfPValue) {
		SumOfPValue = sumOfPValue;
	}

	@Column(name = "EAUS_UBarMark")
	public Double getUBarMark() {
		return UBarMark;
	}

	public void setUBarMark(Double uBarMark) {
		UBarMark = uBarMark;
	}

	@Column(name = "EAUS_PBarMark")
	public Double getPBarMark() {
		return PBarMark;
	}

	public void setPBarMark(Double pBarMark) {
		PBarMark = pBarMark;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EAUS_ExamAnalysisID")
	public ExamAnalysis getOExamAnalysis() {
		return OExamAnalysis;
	}

	public void setOExamAnalysis(ExamAnalysis oExamAnalysis) {
		OExamAnalysis = oExamAnalysis;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EAUS_UnitID")
	public Unit getOUnit() {
		return OUnit;
	}

	public void setOUnit(Unit oUnit) {
		OUnit = oUnit;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EAUS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "EAUS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAUS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "EAUS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAUS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EAUS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "EAUS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "EAUS_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "EAUS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	
}
