package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamCreatorCondition")
public class ExamCreatorCondition implements java.io.Serializable{

	private static final long serialVersionUID = -9131758607197110481L;
	private ExamFormCondition OExamFormCondition;
	private Person OPerson;
	private Unit OUnit;
	private Section OSection;
	private Objective OObjective;
	private Integer ExamCreatorConditionID;
	
	private Integer NOFItem;
	private Double ExamScore;
	private TYPE_CONDITION ConditionType;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private int Version;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ECCD_ExamFormConditionID")
	public ExamFormCondition getOExamFormCondition() {
		return OExamFormCondition;
	}
	public void setOExamFormCondition(ExamFormCondition oExamFormCondition) {
		OExamFormCondition = oExamFormCondition;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ECCD_PersonID")
	public Person getOPerson() {
		return OPerson;
	}
	public void setOPerson(Person oPerson) {
		OPerson = oPerson;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ECCD_UnitID")
	public Unit getOUnit() {
		return OUnit;
	}
	public void setOUnit(Unit oUnit) {
		OUnit = oUnit;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ECCD_SectionID")
	public Section getOSection() {
		return OSection;
	}
	public void setOSection(Section oSection) {
		OSection = oSection;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ECCD_ObjectiveID")
	public Objective getOObjective() {
		return OObjective;
	}
	public void setOObjective(Objective oObjective) {
		OObjective = oObjective;
	}
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamCreatorConditionID", unique = true, nullable = false)
	public Integer getExamCreatorConditionID() {
		return ExamCreatorConditionID;
	}
	public void setExamCreatorConditionID(Integer examCreatorConditionID) {
		ExamCreatorConditionID = examCreatorConditionID;
	}
	
	@Column(name = "ECCD_NOFItem")
	public Integer getNOFItem() {
		return NOFItem;
	}
	public void setNOFItem(Integer nOFItem) {
		NOFItem = nOFItem;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "ECCD_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "ECCD_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ECCD_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}
	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "ECCD_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}
	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ECCD_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}
	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ECCD_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}
	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}
	
	@Column(name = "ECCD_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}
	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}
	
	@Column(name = "ECCD_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}
	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "ECCD_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}
	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	@Version
	@Column(name = "ECCD_Version")
	public int getVersion() {
		return Version;
	}
	public void setVersion(int version) {
		Version = version;
	}
	
	@Column(name = "ECCD_ExamScore", precision = 53, scale = 0)
	public Double getExamScore() {
		return ExamScore;
	}
	public void setExamScore(Double examScore) {
		ExamScore = examScore;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_FLAG")
	@Column(name = "ECCD_ConditionType")
	public TYPE_CONDITION getConditionType() {
		return ConditionType;
	}
	public void setConditionType(TYPE_CONDITION conditionType) {
		ConditionType = conditionType;
	}
	
	
}
