package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamFormCondition")
public class ExamFormCondition implements java.io.Serializable{

	private static final long serialVersionUID = 4808622081333076798L;
	private ExamScheduleDetail OExamScheduleDetail;
	private Integer ExamFormConditionID;
	private int Version;
	private Integer ExamLevel;
	private Integer ExamTime;
	private Integer NOFObjectiveRequire;
	private Integer NOFSubjectiveRequire;
	private double ObjectiveScore;
	private double SubjectiveScore;
	private Integer NOFItemChoice;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFCD_ExamScheduleDetailID")
	public ExamScheduleDetail getOExamScheduleDetail() {
		return OExamScheduleDetail;
	}
	public void setOExamScheduleDetail(ExamScheduleDetail oExamScheduleDetail) {
		OExamScheduleDetail = oExamScheduleDetail;
	}
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamFormConditionID", unique = true, nullable = false)
	public Integer getExamFormConditionID() {
		return ExamFormConditionID;
	}
	public void setExamFormConditionID(Integer examFormConditionID) {
		ExamFormConditionID = examFormConditionID;
	}
	
	@Version
	@Column(name = "EFCD_Version")
	public int getVersion() {
		return Version;
	}
	public void setVersion(int version) {
		Version = version;
	}
	
	@Column(name = "EFCD_ExamLevel")
	public Integer getExamLevel() {
		return ExamLevel;
	}
	public void setExamLevel(Integer examLevel) {
		ExamLevel = examLevel;
	}
	
	@Column(name = "EFCD_ExamTime")
	public Integer getExamTime() {
		return ExamTime;
	}
	public void setExamTime(Integer examTime) {
		ExamTime = examTime;
	}
	
	@Column(name = "EFCD_NOFObjectiveRequire")
	public Integer getNOFObjectiveRequire() {
		return NOFObjectiveRequire;
	}
	public void setNOFObjectiveRequire(Integer nOFObjectiveRequire) {
		NOFObjectiveRequire = nOFObjectiveRequire;
	}
	
	@Column(name = "EFCD_NOFSubjectiveRequire")
	public Integer getNOFSubjectiveRequire() {
		return NOFSubjectiveRequire;
	}
	public void setNOFSubjectiveRequire(Integer nOFSubjectiveRequire) {
		NOFSubjectiveRequire = nOFSubjectiveRequire;
	}
	
	
	@Column(name = "EFCD_NOFItemChoice")
	public Integer getNOFItemChoice() {
		return NOFItemChoice;
	}
	public void setNOFItemChoice(Integer nOFItemChoice) {
		NOFItemChoice = nOFItemChoice;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EFCD_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "EFCD_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFCD_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}
	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "EFCD_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}
	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFCD_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}
	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFCD_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}
	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}
	
	@Column(name = "EFCD_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}
	
	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}
	
	@Column(name = "EFCD_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}
	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "EFCD_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}
	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	@Column(name = "EFCD_ObjectiveItemScore", precision = 53, scale = 0)
	public double getObjectiveScore() {
		return ObjectiveScore;
	}
	public void setObjectiveScore(double objectiveScore) {
		ObjectiveScore = objectiveScore;
	}
	
	@Column(name = "EFCD_SubjectiveItemScore", precision = 53, scale = 0)
	public double getSubjectiveScore() {
		return SubjectiveScore;
	}
	public void setSubjectiveScore(double subjectiveScore) {
		SubjectiveScore = subjectiveScore;
	}
	
	
}
