package esi.examwh.model;

// Generated Nov 22, 2012 9:13:58 AM by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_CONTENT;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

/**
 * ExamFormDocument generated by hbm2java
 */
@Entity
@Table(name = "ExamFormDocument")
public class ExamFormDocument implements java.io.Serializable {

	private static final long serialVersionUID = 2300578402270510283L;
	private Integer ExamFormDocumentID;
	private Integer Version;
	private ExamForm OExamForm;
	private ExamFormItem OExamFormItem;
	private ExamItemDocument OCopiedExamItemDocument;
	private ExamFormItemGroup OExamFormItemGroup;
	private ExamItemGroupDocument OCopiedExamItemGroupDocument;
	private int Order;
	private String Code;
	private String Name;
	private Integer NOFPage;
	private TYPE_CONTENT ContentType;
	private byte[] ContentImage;
	private byte[] PreviewDocument;
	private String ContentMD5;
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Date ContentModifyTime;
	private String ContentModifyUser;

	public ExamFormDocument() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamFormDocumentID", unique = true, nullable = false)
	public Integer getExamFormDocumentID() {
		return this.ExamFormDocumentID;
	}

	public void setExamFormDocumentID(Integer ExamFormDocumentID) {
		this.ExamFormDocumentID = ExamFormDocumentID;
	}

	@Version
	@Column(name = "EFD_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFD_ExamFormID")
	public ExamForm getOExamForm() {
		return this.OExamForm;
	}

	public void setOExamForm(ExamForm OExamForm) {
		this.OExamForm = OExamForm;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFD_ExamFormItemID")
	public ExamFormItem getOExamFormItem() {
		return this.OExamFormItem;
	}

	public void setOExamFormItem(ExamFormItem OExamFormItem) {
		this.OExamFormItem = OExamFormItem;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFD_CopiedExamItemDocumentID")
	public ExamItemDocument getOCopiedExamItemDocument() {
		return this.OCopiedExamItemDocument;
	}

	public void setOCopiedExamItemDocument(
			ExamItemDocument OCopiedExamItemDocument) {
		this.OCopiedExamItemDocument = OCopiedExamItemDocument;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFD_ExamFormItemGroupID")
	public ExamFormItemGroup getOExamFormItemGroup() {
		return this.OExamFormItemGroup;
	}

	public void setOExamFormItemGroup(ExamFormItemGroup OExamFormItemGroup) {
		this.OExamFormItemGroup = OExamFormItemGroup;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFD_CopiedExamItemGroupDocumentID")
	public ExamItemGroupDocument getOCopiedExamItemGroupDocument() {
		return this.OCopiedExamItemGroupDocument;
	}

	public void setOCopiedExamItemGroupDocument(
			ExamItemGroupDocument OCopiedExamItemGroupDocument) {
		this.OCopiedExamItemGroupDocument = OCopiedExamItemGroupDocument;
	}

	@Column(name = "EFD_Order", nullable = false)
	public int getOrder() {
		return this.Order;
	}

	public void setOrder(int Order) {
		this.Order = Order;
	}

	@Column(name = "EFD_Code", length = 16)
	public String getCode() {
		return this.Code;
	}

	public void setCode(String Code) {
		this.Code = Code;
	}

	@Column(name = "EFD_Name", nullable = false, length = 64)
	public String getName() {
		return this.Name;
	}

	public void setName(String Name) {
		this.Name = Name;
	}

	@Column(name = "EFD_NOFPage")
	public Integer getNOFPage() {
		return this.NOFPage;
	}

	public void setNOFPage(Integer NOFPage) {
		this.NOFPage = NOFPage;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_CONTENT")
	@Column(name = "EFD_ContentType")
	public TYPE_CONTENT getContentType() {
		return ContentType;
	}

	public void setContentType(TYPE_CONTENT contentType) {
		ContentType = contentType;
	}

	@Column(name = "EFD_ContentImage")
	public byte[] getContentImage() {
		return this.ContentImage;
	}

	public void setContentImage(byte[] ContentImage) {
		this.ContentImage = ContentImage;
	}

	@Column(name = "EFD_PreviewDocument")
	public byte[] getPreviewDocument() {
		return this.PreviewDocument;
	}

	public void setPreviewDocument(byte[] PreviewDocument) {
		this.PreviewDocument = PreviewDocument;
	}
	
	@Column(name = "EFD_ContentMD5", length = 64)
	public String getContentMD5() {
		return this.ContentMD5;
	}

	public void setContentMD5(String ContentMD5) {
		this.ContentMD5 = ContentMD5;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EFD_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFD_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "EFD_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFD_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "EFD_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFD_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "EFD_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "EFD_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "EFD_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFD_ContentModifyTime", length = 23)
	public Date getContentModifyTime() {
		return this.ContentModifyTime;
	}

	public void setContentModifyTime(Date ContentModifyTime) {
		this.ContentModifyTime = ContentModifyTime;
	}

	@Column(name = "EFD_ContentModifyUser", length = 32)
	public String getContentModifyUser() {
		return this.ContentModifyUser;
	}

	public void setContentModifyUser(String ContentModifyUser) {
		this.ContentModifyUser = ContentModifyUser;
	}
//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamFormDocumentID :["+this.ExamFormDocumentID+"]\n");
		
		temp.append("[Begin Record]\n");
		if(this.OExamForm != null){
			temp.append("ExamFormID : ["+this.getOExamForm().getExamFormID()+"]\n");
		}else{
			temp.append("ExamFormID : [null]\n");
		} 
		if(this.OExamFormItem != null){
			temp.append("ExamFormItemID : ["+this.getOExamFormItem().getExamFormItemID()+"]\n");
		}else{
			temp.append("ExamFormItemID : [null]\n");
		} 
		if(this.OCopiedExamItemDocument != null){
			temp.append("CopiedExamItemDocumentID : ["+this.getOCopiedExamItemDocument().getExamItemDocumentID()+"]\n");
		}else{
			temp.append("CopiedExamItemDocumentID : [null]\n");
		} 
		
		if(this.OExamFormItemGroup != null){
			temp.append("ExamFormItemGroupID : ["+this.getOExamFormItemGroup().getExamFormItemGroupID()+"]\n");
		}else{
			temp.append("ExamFormItemGroupID : [null]\n");
		} 
		if(this.OCopiedExamItemGroupDocument != null){
			temp.append("CopiedExamItemGroupDocumentID : ["+this.getOCopiedExamItemGroupDocument().getExamItemGroupDocumentID()+"]\n");
		}else{
			temp.append("CopiedExamItemGroupDocumentID : [null]\n");
		} 
		temp.append("Order :["+this.Order+"\n");
		temp.append("Code :["+this.Code+"\n");
		temp.append("Name :["+this.Name+"\n");
		temp.append("NOFPage :["+this.NOFPage+"\n");
		temp.append("ContentType :["+this.ContentType+"\n");
		temp.append("ContentImage :["+this.ContentImage+"\n");
		temp.append("PreviewDocument : ["+this.PreviewDocument+"]\n");
		temp.append("ContentMD5 :["+this.ContentMD5+"\n");
		temp.append("ContentModifyTime :["+this.ContentModifyTime+"\n");
		temp.append("ContentModifyUser :["+this.ContentModifyUser+"\n");
		
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		
		temp.append("[End Record]");
		return temp.toString();
	}
}
