package esi.examwh.model;

// Generated Nov 22, 2012 9:13:58 AM by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_SOURCE;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_MULTIMEDIA_STATUS;
import esi.examwh.model.common.TYPE_VERIFY_STATUS;
import jakarta.validation.constraints.NotNull;

/**
 * ExamFormItemGroup generated by hbm2java
 */
@Entity
@Table(name = "ExamFormItemGroup")
public class ExamFormItemGroup implements java.io.Serializable {

	private static final long serialVersionUID = -660487958797073102L;
	private Integer ExamFormItemGroupID;
	private Integer Version;
	private ExamItemGroup OCopiedExamItemGroup;
	private ExamForm OExamForm;
	private String QuestionText;
	private String Code;
	private byte[] QuestionImage;
	private byte[] QuestionMovie;
	private byte[] QuestionTextEditor;
	private String QuestionMD5;
	private byte[] QuestionWord;
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Date ImageGenTime;
	private Date DocModifyTime;
	private TYPE_MULTIMEDIA_STATUS MultimediaStatus;
	private TYPE_VERIFY_STATUS VerifyExamItemStatus;
	private TYPE_DATA_SOURCE DataSourceType;
	
	public ExamFormItemGroup() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamFormItemGroupID", unique = true, nullable = false)
	public Integer getExamFormItemGroupID() {
		return this.ExamFormItemGroupID;
	}

	public void setExamFormItemGroupID(Integer ExamFormItemGroupID) {
		this.ExamFormItemGroupID = ExamFormItemGroupID;
	}

	@Version
	@Column(name = "EFIG_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFIG_CopiedExamItemGroupID", nullable = false)
	public ExamItemGroup getOCopiedExamItemGroup() {
		return this.OCopiedExamItemGroup;
	}

	public void setOCopiedExamItemGroup(ExamItemGroup OCopiedExamItemGroup) {
		this.OCopiedExamItemGroup = OCopiedExamItemGroup;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFIG_ExamFormID", nullable = false)
	public ExamForm getOExamForm() {
		return this.OExamForm;
	}

	public void setOExamForm(ExamForm OExamForm) {
		this.OExamForm = OExamForm;
	}

	@Column(name = "EFIG_QuestionText")
	public String getQuestionText() {
		return this.QuestionText;
	}

	public void setQuestionText(String QuestionText) {
		this.QuestionText = QuestionText;
	}

	@Column(name = "EFIG_QuestionImage")
	public byte[] getQuestionImage() {
		return this.QuestionImage;
	}

	public void setQuestionImage(byte[] QuestionImage) {
		this.QuestionImage = QuestionImage;
	}

	@Column(name = "EFIG_QuestionMovie")
	public byte[] getQuestionMovie() {
		return this.QuestionMovie;
	}

	public void setQuestionMovie(byte[] QuestionMovie) {
		this.QuestionMovie = QuestionMovie;
	}

	@Column(name = "EFIG_QuestionMD5", length = 128)
	public String getQuestionMD5() {
		return this.QuestionMD5;
	}

	public void setQuestionMD5(String QuestionMD5) {
		this.QuestionMD5 = QuestionMD5;
	}

	@Column(name = "EFIG_QuestionWord")
	public byte[] getQuestionWord() {
		return this.QuestionWord;
	}

	public void setQuestionWord(byte[] QuestionWord) {
		this.QuestionWord = QuestionWord;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EFIG_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFIG_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "EFIG_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFIG_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "EFIG_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFIG_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "EFIG_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "EFIG_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "EFIG_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFIG_ImageGenTime", length = 23)
	public Date getImageGenTime() {
		return this.ImageGenTime;
	}

	public void setImageGenTime(Date ImageGenTime) {
		this.ImageGenTime = ImageGenTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFIG_DocModifyTime", length = 23)
	public Date getDocModifyTime() {
		return this.DocModifyTime;
	}

	public void setDocModifyTime(Date DocModifyTime) {
		this.DocModifyTime = DocModifyTime;
	}

	@Column(name = "EFIG_Code", length = 16)
	public String getCode() {
		return this.Code;
	}

	public void setCode(String Code) {
		this.Code = Code;
	}
	
	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_MULTIMEDIA_STATUS")
	@Column(name = "EFIG_MultimediaStatus")
	public TYPE_MULTIMEDIA_STATUS getMultimediaStatus() {
		return MultimediaStatus;
	}

	public void setMultimediaStatus(TYPE_MULTIMEDIA_STATUS multimediaStatus) {
		MultimediaStatus = multimediaStatus;
	}
	
	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_VERIFY_STATUS")
	@Column(name = "EFIG_VerifyExamItemStatus")
	public TYPE_VERIFY_STATUS getVerifyExamItemStatus() {
		return VerifyExamItemStatus;
	}

	public void setVerifyExamItemStatus(TYPE_VERIFY_STATUS verifyExamItemStatus) {
		VerifyExamItemStatus = verifyExamItemStatus;
	}
	
	@Column(name = "EFIG_QuestionTextEditor")
	public byte[] getQuestionTextEditor() {
		return this.QuestionTextEditor;
	}

	public void setQuestionTextEditor(byte[] questionTextEditor) {
		this.QuestionTextEditor = questionTextEditor;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_SOURCE")
	@Column(name = "EFIG_DataSourceType")
	public TYPE_DATA_SOURCE getDataSourceType() {
		return this.DataSourceType;
	}

	public void setDataSourceType(TYPE_DATA_SOURCE dataSourceType) {
		this.DataSourceType = dataSourceType;
	}

	//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamFormItemGroupID :["+this.ExamFormItemGroupID+"]\n");
		
		temp.append("[Begin Record]\n");
		temp.append("Code : ["+this.Code+"]\n");
		if(this.OCopiedExamItemGroup != null){
			temp.append("CopiedExamItemGroupID : ["+this.getOCopiedExamItemGroup().getExamItemGroupID()+"]\n");
		}else{
			temp.append("CopiedExamItemGroupID : [null]\n");
		} 
		if(this.OExamForm != null){
			temp.append("ExamFormID : ["+this.getOExamForm().getExamFormID()+"]\n");
		}else{
			temp.append("ExamFormID : [null]\n");
		} 
		temp.append("QuestionMD5 : ["+this.QuestionMD5+"]\n");
		temp.append("QuestionText : ["+this.QuestionText+"]\n");
		temp.append("QuestionImage : ["+this.QuestionImage+"]\n");
		temp.append("QuestionMovie : ["+this.QuestionMovie+"]\n");
		temp.append("QuestionWord : ["+this.QuestionWord+"]\n");
		temp.append("ImageGenTime : ["+this.ImageGenTime+"]\n");
		temp.append("DocModifyTime : ["+this.DocModifyTime+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("MultimediaStatus : ["+this.MultimediaStatus+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
}
