package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM_ITEM_SELECTED_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamFormSelected")
public class ExamFormSelected implements java.io.Serializable{

	private static final long serialVersionUID = 3563885395714588299L;
	private ExamFormCondition OExamFormCondition;
	private Integer ExamFormSelectedID;
	private ExamScheduleDetailSelected OExamScheduleDetailSelected;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private int Version;
	private TYPE_EXAM_ITEM_SELECTED_STATUS ExamFormSelectedStatus;
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFS_ExamFormConditionID")
	public ExamFormCondition getOExamFormCondition() {
		return OExamFormCondition;
	}
	public void setOExamFormCondition(ExamFormCondition oExamFormCondition) {
		OExamFormCondition = oExamFormCondition;
	}
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamFormSelectedID", unique = true, nullable = false)
	public Integer getExamFormSelectedID() {
		return ExamFormSelectedID;
	}
	public void setExamFormSelectedID(Integer examFormSelectedID) {
		ExamFormSelectedID = examFormSelectedID;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EFS_ExamScheduleDetailSelectedID")
	public ExamScheduleDetailSelected getOExamScheduleDetailSelected() {
		return OExamScheduleDetailSelected;
	}
	public void setOExamScheduleDetailSelected(
			ExamScheduleDetailSelected oExamScheduleDetailSelected) {
		OExamScheduleDetailSelected = oExamScheduleDetailSelected;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EFS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "EFS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}
	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "EFS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}
	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}
	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EFS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}
	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}
	
	@Column(name = "EFS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}
	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}
	
	@Column(name = "EFS_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}
	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "EFS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}
	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	@Version
	@Column(name = "EFS_Version")
	public int getVersion() {
		return Version;
	}
	public void setVersion(int version) {
		Version = version;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_EXAM_ITEM_SELECTED_STATUS")
	@Column(name = "EFS_ExamFormSelectedStatus")
	public TYPE_EXAM_ITEM_SELECTED_STATUS getExamFormSelectedStatus() {
		return ExamFormSelectedStatus;
	}
	
	public void setExamFormSelectedStatus(TYPE_EXAM_ITEM_SELECTED_STATUS examFormSelectedStatus) {
		ExamFormSelectedStatus = examFormSelectedStatus;
	}
	
	
	
}
