package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamItemAttribute")
public class ExamItemAttribute implements java.io.Serializable{

	private static final long serialVersionUID = 3449288893966909416L;
	private Integer ExamItemAttributeID;
	private ExamItem OExamItem;
	private Attributes OAttribute;
	private int Version;
	private int IndicatorLevel;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public ExamItemAttribute() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamItemAttributeID", unique = true, nullable = false)
	public Integer getExamItemAttributeID() {
		return ExamItemAttributeID;
	}

	public void setExamItemAttributeID(Integer examItemAttributeID) {
		ExamItemAttributeID = examItemAttributeID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIA_ExamItemID", nullable = false)
	public ExamItem getOExamItem() {
		return OExamItem;
	}

	public void setOExamItem(ExamItem oExamItem) {
		OExamItem = oExamItem;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIA_AttributeID", nullable = false)
	public Attributes getOAttribute() {
		return OAttribute;
	}

	public void setOAttribute(Attributes oAttribute) {
		OAttribute = oAttribute;
	}

	@Version
	@Column(name = "EIA_Version")
	public int getVersion() {
		return Version;
	}

	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "EIA_IndicatorLevel")
	public int getIndicatorLevel() {
		return IndicatorLevel;
	}

	public void setIndicatorLevel(int indicatorLevel) {
		IndicatorLevel = indicatorLevel;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EIA_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "EIA_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIA_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "EIA_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIA_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIA_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "EIA_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "EIA_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "EIA_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	
}
