package esi.examwh.model;

// Generated Nov 22, 2012 9:13:58 AM by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

/**
 * ExamItemDocument generated by hbm2java
 */
@Entity
@Table(name = "ExamItemDocument")
public class ExamItemDocument implements java.io.Serializable {

	private static final long serialVersionUID = -6500013781374201188L;
	private Integer ExamItemDocumentID;
	private Integer Version;
	private SubjectDocument OSubjectDocument;
	private ExamItem OExamItem;
	private int Order;
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Date ContentModifyTime;
	private String ContentModifyUser;

	public ExamItemDocument() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamItemDocumentID", unique = true, nullable = false)
	public Integer getExamItemDocumentID() {
		return this.ExamItemDocumentID;
	}

	public void setExamItemDocumentID(Integer ExamItemDocumentID) {
		this.ExamItemDocumentID = ExamItemDocumentID;
	}

	@Version
	@Column(name = "EID_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EID_SubjectDocumentID")
	public SubjectDocument getOSubjectDocument() {
		return this.OSubjectDocument;
	}

	public void setOSubjectDocument(SubjectDocument OSubjectDocument) {
		this.OSubjectDocument = OSubjectDocument;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EID_ExamItemID")
	public ExamItem getOExamItem() {
		return this.OExamItem;
	}

	public void setOExamItem(ExamItem OExamItem) {
		this.OExamItem = OExamItem;
	}

	@Column(name = "EID_Order", nullable = false)
	public int getOrder() {
		return this.Order;
	}

	public void setOrder(int Order) {
		this.Order = Order;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EID_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EID_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "EID_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EID_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "EID_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EID_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "EID_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "EID_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "EID_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EID_ContentModifyTime", length = 23)
	public Date getContentModifyTime() {
		return this.ContentModifyTime;
	}

	public void setContentModifyTime(Date ContentModifyTime) {
		this.ContentModifyTime = ContentModifyTime;
	}

	@Column(name = "EID_ContentModifyUser", length = 32)
	public String getContentModifyUser() {
		return this.ContentModifyUser;
	}

	public void setContentModifyUser(String ContentModifyUser) {
		this.ContentModifyUser = ContentModifyUser;
	}

//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamItemDocumentID :["+this.ExamItemDocumentID+"]\n");
		
		temp.append("[Begin Record]\n");
		if(this.OExamItem != null){
			temp.append("ExamItemID : ["+this.getOExamItem().getExamItemID()+"]\n");
		}else{
			temp.append("ExamItemID : [null]\n");
		} 
		if(this.OSubjectDocument != null){
			temp.append("SubjectDocumentID : ["+this.getOSubjectDocument().getSubjectDocumentID()+"]\n");
		}else{
			temp.append("SubjectDocumentID : [null]\n");
		} 
		
		temp.append("Order : ["+this.Order+"]\n");
		temp.append("ContentModifyUser : ["+this.ContentModifyUser+"]\n");
		temp.append("ContentModifyTime : ["+this.ContentModifyTime+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
}
