package esi.examwh.model;

// Generated Nov 22, 2012 9:13:58 AM by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

/**
 * ExamItemHistory generated by hbm2java
 */
@Entity
@Table(name = "ExamItemHistory")
public class ExamItemHistory implements java.io.Serializable {

	private static final long serialVersionUID = -546618746037287885L;
	private Integer ExamItemHistoryID;
	private Integer Version;
	private ExamForm OExamForm;
	private ExamItem OExamItem;
	private int Order;
	private String Name;
	private String Detail;
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;

	public ExamItemHistory() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamItemHistoryID", unique = true, nullable = false)
	public Integer getExamItemHistoryID() {
		return this.ExamItemHistoryID;
	}

	public void setExamItemHistoryID(Integer ExamItemHistoryID) {
		this.ExamItemHistoryID = ExamItemHistoryID;
	}

	@Version
	@Column(name = "EIH_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIH_ExamFormID")
	public ExamForm getOExamForm() {
		return this.OExamForm;
	}

	public void setOExamForm(ExamForm OExamForm) {
		this.OExamForm = OExamForm;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIH_ExamItemID")
	public ExamItem getOExamItem() {
		return this.OExamItem;
	}

	public void setOExamItem(ExamItem OExamItem) {
		this.OExamItem = OExamItem;
	}

	@Column(name = "EIH_Order", nullable = false)
	public int getOrder() {
		return this.Order;
	}

	public void setOrder(int Order) {
		this.Order = Order;
	}

	@Column(name = "EIH_Name", nullable = false, length = 64)
	public String getName() {
		return this.Name;
	}

	public void setName(String Name) {
		this.Name = Name;
	}

	@Column(name = "EIH_Detail", length = 512)
	public String getDetail() {
		return this.Detail;
	}

	public void setDetail(String Detail) {
		this.Detail = Detail;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EIH_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIH_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "EIH_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIH_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "EIH_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIH_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "EIH_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "EIH_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "EIH_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}
//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamItemHistoryID :["+this.ExamItemHistoryID+"]\n");
		
		temp.append("[Begin Record]\n");
		if(this.OExamItem != null){
			temp.append("ExamItemID : ["+this.getOExamItem().getExamItemID()+"]\n");
		}else{
			temp.append("ExamItemID : [null]\n");
		} 
		if(this.OExamForm != null){
			temp.append("ExamFormID : ["+this.getOExamForm().getExamFormID()+"]\n");
		}else{
			temp.append("ExamFormID : [null]\n");
		} 
		
		temp.append("Order : ["+this.Order+"]\n");
		temp.append("Name : ["+this.Name+"]\n");
		temp.append("Detail : ["+this.Detail+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
}
