package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamItemSelected")
public class ExamItemSelected implements java.io.Serializable {

	private static final long serialVersionUID = 8070636941188200175L;
	private Integer ExamItemSelectedID;
	private Person OPerson;
	private ExamScheduleDetailSelected OExamScheduleDetailSelected;
	private ExamScheduleDetail OExamScheduleDetail;
	private Integer Version;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Integer RatingRound;
	private ExamFormCondition OExamFormCondition;
	private ExamItem OExamItem;
	public ExamItemSelected() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamItemSelectedID", unique = true, nullable = false)
	public Integer getExamItemSelectedID() {
		return ExamItemSelectedID;
	}

	public void setExamItemSelectedID(Integer examItemSelectedID) {
		ExamItemSelectedID = examItemSelectedID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIS_PersonID", nullable = false)
	public Person getOPerson() {
		return OPerson;
	}

	public void setOPerson(Person oPerson) {
		OPerson = oPerson;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIS_ExamScheduleDetailSelectedID")
	public ExamScheduleDetailSelected getOExamScheduleDetailSelected() {
		return OExamScheduleDetailSelected;
	}

	public void setOExamScheduleDetailSelected(
			ExamScheduleDetailSelected oExamScheduleDetailSelected) {
		OExamScheduleDetailSelected = oExamScheduleDetailSelected;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIS_ExamFormConditionID")
	public ExamFormCondition getOExamFormCondition() {
		return OExamFormCondition;
	}

	public void setOExamFormCondition(ExamFormCondition oExamFormCondition) {
		OExamFormCondition = oExamFormCondition;
	}

	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	@Version
	@Column(name = "EIS_Version")
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "EIS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "EIS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "EIS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "EIS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "EIS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "EIS_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "EIS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	@Column(name = "EIS_RatingRound")
	public Integer getRatingRound() {
		return RatingRound;
	}

	public void setRatingRound(Integer ratingRound) {
		RatingRound = ratingRound;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIS_ExamItemID")
	public ExamItem getOExamItem() {
		return OExamItem;
	}

	public void setOExamItem(ExamItem oExamItem) {
		OExamItem = oExamItem;
	}

	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "EIS_ExamScheduleDetailID")
	public ExamScheduleDetail getOExamScheduleDetail() {
		return OExamScheduleDetail;
	}

	public void setOExamScheduleDetail(ExamScheduleDetail oExamScheduleDetail) {
		OExamScheduleDetail = oExamScheduleDetail;
	}
	
	
	
}
