package esi.examwh.model;

// Generated Nov 22, 2012 9:13:58 AM by Hibernate Tools 3.4.0.CR1

import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;
import esi.examwh.model.common.TYPE_OPERATION_STATUS;
import jakarta.validation.constraints.NotNull;

/**
 * ExamSchedule generated by hbm2java
 */
@Entity
@Table(name = "ExamSchedule")
public class ExamSchedule implements java.io.Serializable {

	private static final long serialVersionUID = 756115119812632279L;
	private Integer ExamScheduleID;
	private Integer Version;
	private ExamYear OExamYear;
	private ExamTerm OExamTerm;
	private ExamSemester OExamSemester;
	private ExamRound OExamRound;
	private TYPE_EXAMINATION ExaminationType;
	private TYPE_EXAMINATION_STATUS ExaminationStatus;
	private TYPE_OPERATION_STATUS OperationStatus;
	private Date ExamFormBeginDate;
	private Date ExamFormEndDate;
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Date ExamCreateBeginDate;
	private Date ExamCreateEndDate;
	private Date ExamSelectedBeginDate;
	private Date ExamSelectedEndDate;
	private Date ExamScheduleBeginDate;
	private Date ExamScheduleEndDate;
	public ExamSchedule() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamScheduleID", unique = true, nullable = false)
	public Integer getExamScheduleID() {
		return this.ExamScheduleID;
	}

	public void setExamScheduleID(Integer ExamScheduleID) {
		this.ExamScheduleID = ExamScheduleID;
	}

	@Version
	@Column(name = "ES_Version")
	public Integer getVersion() {
		return this.Version;
	}

	public void setVersion(Integer Version) {
		this.Version = Version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ES_ExamYearID")
	public ExamYear getOExamYear() {
		return this.OExamYear;
	}

	public void setOExamYear(ExamYear OExamYear) {
		this.OExamYear = OExamYear;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ES_ExamTermID", nullable = false)
	public ExamTerm getOExamTerm() {
		return this.OExamTerm;
	}

	public void setOExamTerm(ExamTerm OExamTerm) {
		this.OExamTerm = OExamTerm;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ES_ExamSemesterID")
	public ExamSemester getOExamSemester() {
		return this.OExamSemester;
	}

	public void setOExamSemester(ExamSemester OExamSemester) {
		this.OExamSemester = OExamSemester;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ES_ExamRoundID")
	public ExamRound getOExamRound() {
		return this.OExamRound;
	}

	public void setOExamRound(ExamRound OExamRound) {
		this.OExamRound = OExamRound;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_EXAMINATION")
	@Column(name = "ES_ExaminationType")
	public TYPE_EXAMINATION getExaminationType() {
		return ExaminationType;
	}

	public void setExaminationType(TYPE_EXAMINATION examinationType) {
		ExaminationType = examinationType;
	}
	
	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_EXAMINATION_STATUS")
	@Column(name = "ES_ExaminationStatus")
	public TYPE_EXAMINATION_STATUS getExaminationStatus() {
		return ExaminationStatus;
	}

	public void setExaminationStatus(TYPE_EXAMINATION_STATUS examinationStatus) {
		ExaminationStatus = examinationStatus;
	}

	@Enumerated(EnumType.ORDINAL)
	@Type(type = "esi.examwh.model.common.persistent.HB_TYPE_OPERATION_STATUS")
	@Column(name = "ES_OperationStatus")
	public TYPE_OPERATION_STATUS getOperationStatus() {
		return OperationStatus;
	}

	public void setOperationStatus(TYPE_OPERATION_STATUS operationStatus) {
		OperationStatus = operationStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamFormBeginDate", length = 23)
	public Date getExamFormBeginDate() {
		return this.ExamFormBeginDate;
	}

	public void setExamFormBeginDate(Date ExamFormBeginDate) {
		this.ExamFormBeginDate = ExamFormBeginDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamFormEndDate", length = 23)
	public Date getExamFormEndDate() {
		return this.ExamFormEndDate;
	}

	public void setExamFormEndDate(Date ExamFormEndDate) {
		this.ExamFormEndDate = ExamFormEndDate;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "ES_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return this.CreateTime;
	}

	public void setCreateTime(Date CreateTime) {
		this.CreateTime = CreateTime;
	}

	@Column(name = "ES_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return this.CreateUser;
	}

	public void setCreateUser(String CreateUser) {
		this.CreateUser = CreateUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return this.ModifyTime;
	}

	public void setModifyTime(Date ModifyTime) {
		this.ModifyTime = ModifyTime;
	}

	@Column(name = "ES_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return this.ModifyUser;
	}

	public void setModifyUser(String ModifyUser) {
		this.ModifyUser = ModifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return this.DeletedTime;
	}

	public void setDeletedTime(Date DeletedTime) {
		this.DeletedTime = DeletedTime;
	}

	@Column(name = "ES_DeletedUser", length = 64)
	public String getDeletedUser() {
		return this.DeletedUser;
	}

	public void setDeletedUser(String DeletedUser) {
		this.DeletedUser = DeletedUser;
	}

	@Column(name = "ES_OwnerUserID")
	public Integer getOwnerUserID() {
		return this.OwnerUserID;
	}

	public void setOwnerUserID(Integer OwnerUserID) {
		this.OwnerUserID = OwnerUserID;
	}

	@Column(name = "ES_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return this.OwnerGroupID;
	}

	public void setOwnerGroupID(Integer OwnerGroupID) {
		this.OwnerGroupID = OwnerGroupID;
	}
	
	

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamCreateBeginDate", length = 23)
	public Date getExamCreateBeginDate() {
		return ExamCreateBeginDate;
	}

	public void setExamCreateBeginDate(Date examCreateBeginDate) {
		ExamCreateBeginDate = examCreateBeginDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamCreateEndDate", length = 23)
	public Date getExamCreateEndDate() {
		return ExamCreateEndDate;
	}

	public void setExamCreateEndDate(Date examCreateEndDate) {
		ExamCreateEndDate = examCreateEndDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamSelectedBeginDate", length = 23)
	public Date getExamSelectedBeginDate() {
		return ExamSelectedBeginDate;
	}

	public void setExamSelectedBeginDate(Date examSelectedBeginDate) {
		ExamSelectedBeginDate = examSelectedBeginDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamSelectedEndDate", length = 23)
	public Date getExamSelectedEndDate() {
		return ExamSelectedEndDate;
	}

	public void setExamSelectedEndDate(Date examSelectedEndDate) {
		ExamSelectedEndDate = examSelectedEndDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamScheduleBeginDate", length = 23)
	public Date getExamScheduleBeginDate() {
		return ExamScheduleBeginDate;
	}

	public void setExamScheduleBeginDate(Date examScheduleBeginDate) {
		ExamScheduleBeginDate = examScheduleBeginDate;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ES_ExamScheduleEndDate", length = 23)
	public Date getExamScheduleEndDate() {
		return ExamScheduleEndDate;
	}

	public void setExamScheduleEndDate(Date examScheduleEndDate) {
		ExamScheduleEndDate = examScheduleEndDate;
	}

	//	public void PrintInfo() throws Exception {
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo", "[START] @@@");
//	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Consignee", "PrintInfo",this.toString());
//
//}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamScheduleID :["+this.ExamScheduleID+"]\n");
		
		temp.append("[Begin Record]\n");
		if(this.OExamYear != null){
			temp.append("ExamYearID : ["+this.getOExamYear().getExamYearID()+"]\n");
		}else{
			temp.append("ExamYearID : [null]\n");
		} 
		if(this.OExamSemester != null){
			temp.append("ExamSemesterID : ["+this.getOExamSemester().getExamSemesterID()+"]\n");
		}else{
			temp.append("ExamSemesterID : [null]\n");
		} 
		if(this.OExamRound != null){
			temp.append("ExamRoundID : ["+this.getOExamRound().getExamRoundID()+"]\n");
		}else{
			temp.append("ExamRoundID : [null]\n");
		} 
		if(this.OExamTerm != null){
			temp.append("ExamTermID : ["+this.getOExamTerm().getExamTermID()+"]\n");
		}else{
			temp.append("ExamTermID : [null]\n");
		} 
		temp.append("ExaminationType : ["+this.ExaminationType+"]\n");
		temp.append("ExaminationStatus : ["+this.ExaminationStatus+"]\n");
		temp.append("OperationStatus : ["+this.OperationStatus+"]\n");
		temp.append("ExamFormBeginDate : ["+this.ExamFormBeginDate+"]\n");
		temp.append("ExamFormEndDate : ["+this.ExamFormEndDate+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
}
