package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "ExamScheduleDetailSelected")
public class ExamScheduleDetailSelected implements java.io.Serializable {

	private static final long serialVersionUID = 6387392566508340646L;
	private Integer ExamScheduleDetailSelectedID;
	private ExamScheduleDetail OExamScheduleDetail;
	private ExamItem OExamItem;
	private Integer Version;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private int Score;
//	private Integer ExamFormSelectedStatus;
	
	public ExamScheduleDetailSelected() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "ExamScheduleDetailSelectedID", unique = true, nullable = false)
	public Integer getExamScheduleDetailSelectedID() {
		return ExamScheduleDetailSelectedID;
	}

	public void setExamScheduleDetailSelectedID(Integer examScheduleDetailSelectedID) {
		ExamScheduleDetailSelectedID = examScheduleDetailSelectedID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ESDS_ExamScheduleDetailID", nullable = false)
	public ExamScheduleDetail getOExamScheduleDetail() {
		return OExamScheduleDetail;
	}

	public void setOExamScheduleDetail(ExamScheduleDetail oExamScheduleDetail) {
		OExamScheduleDetail = oExamScheduleDetail;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "ESDS_ExamItemID", nullable = false)
	public ExamItem getOExamItem() {
		return OExamItem;
	}

	public void setOExamItem(ExamItem oExamItem) {
		OExamItem = oExamItem;
	}

	@Version
	@Column(name = "ESDS_Version")
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "ESDS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "ESDS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "ESDS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "ESDS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "ESDS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "ESDS_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "ESDS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	@Column(name = "ESDS_Score")
	public int getScore() {
		return Score;
	}

	public void setScore(int score) {
		Score = score;
	}
//
//	@Column(name = "ESDS_ExamFormSelectedStatus")
//	public Integer getExamFormSelectedStatus() {
//		return ExamFormSelectedStatus;
//	}
//
//	public void setExamFormSelectedStatus(Integer examFormSelectedStatus) {
//		ExamFormSelectedStatus = examFormSelectedStatus;
//	}
//	
	
}
