package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "Indicators")
public class Indicators implements java.io.Serializable{

	private static final long serialVersionUID = -6734362891580290535L;
	private Integer IndicatorID;
	private CurriculumAttribute OCurriculumAttribute;
	private int Version;
	private int Order;
	private String Name;
	private String Detail;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public Indicators() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "IndicatorID", unique = true, nullable = false)
	public Integer getIndicatorID() {
		return IndicatorID;
	}

	public void setIndicatorID(Integer indicatorID) {
		IndicatorID = indicatorID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "I_CurriculumAttributeID", nullable = false)
	public CurriculumAttribute getOCurriculumAttribute() {
		return OCurriculumAttribute;
	}

	public void setOCurriculumAttribute(CurriculumAttribute oCurriculumAttribute) {
		OCurriculumAttribute = oCurriculumAttribute;
	}

	@Version
	@Column(name = "I_Version")
	public int getVersion() {
		return Version;
	}

	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "I_Order")
	public int getOrder() {
		return Order;
	}
	
	public void setOrder(int order) {
		Order = order;
	}

	@Column(name = "I_Name", nullable = false, length = 1024)
	public String getName() {
		return Name;
	}

	public void setName(String name) {
		Name = name;
	}

	@Column(name = "I_Detail", length = 1024)
	public String getDetail() {
		return Detail;
	}

	public void setDetail(String detail) {
		Detail = detail;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "I_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Column(name = "I_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "I_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "I_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "I_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "I_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "I_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "I_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "I_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	@Override
	public String toString() {
		return "Indicators [CreateTime=" + CreateTime + ", CreateUser="
				+ CreateUser + ", DataStatus=" + DataStatus + ", DeletedTime="
				+ DeletedTime + ", DeletedUser=" + DeletedUser + ", Detail="
				+ Detail + ", IndicatorID=" + IndicatorID + ", ModifyTime="
				+ ModifyTime + ", ModifyUser=" + ModifyUser + ", Name=" + Name
				+ ", OCurriculumAttribute=" + OCurriculumAttribute
				+ ", OwnerGroupID=" + OwnerGroupID + ", OwnerUserID="
				+ OwnerUserID + ", Version=" + Version + ", order=" + Order
				+ "]";
	}
	
}
