package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "MainSelector")
public class MainSelector implements java.io.Serializable {

	private static final long serialVersionUID = -1640932938074899103L;
	private Integer MainSelectorID;
	private Unit OUnit;
	private ESDItemSelector OESDItemSelector;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	private Integer Version;
	
	public MainSelector() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "MainSelectorID", unique = true, nullable = false)
	public Integer getMainSelectorID() {
		return MainSelectorID;
	}

	public void setMainSelectorID(Integer mainSelectorID) {
		MainSelectorID = mainSelectorID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "MS_UnitID")
	public Unit getOUnit() {
		return OUnit;
	}
	public void setOUnit(Unit oUnit) {
		OUnit = oUnit;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumns( {
			@JoinColumn(name = "MS_ExamScheduleDetailID", referencedColumnName = "ExamScheduleDetailID", nullable = false),
			@JoinColumn(name = "MS_ExamLevel", referencedColumnName = "ExamLevel", nullable = false),
			@JoinColumn(name = "MS_PersonID", referencedColumnName = "PersonID", nullable = false) })
	public ESDItemSelector getOESDItemSelector() {
		return OESDItemSelector;
	}
	public void setOESDItemSelector(ESDItemSelector oESDItemSelector) {
		OESDItemSelector = oESDItemSelector;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "MS_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "MS_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "MS_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}
	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "MS_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}
	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "MS_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}
	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "MS_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}
	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}
	
	@Column(name = "MS_DeletedUser", length = 64)
	public String getDeletedUser() {
		return DeletedUser;
	}
	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}
	
	@Column(name = "MS_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}
	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "MS_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}
	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	@Version
	@Column(name = "MS_Version")
	public Integer getVersion() {
		return Version;
	}
	public void setVersion(Integer version) {
		Version = version;
	}
	
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("[Begin Record]\n");
		temp.append("MainSelectorID : ["+this.MainSelectorID+"]\n");
		if(this.OESDItemSelector != null){
			temp.append("ExamScheduleDetailID : ["+this.OESDItemSelector.getPK().getExamScheduleDetailID()+"]\n");
		}else{
			temp.append("ExamScheduleDetailID : [null]\n");
		} 
		if(this.OESDItemSelector != null){
			temp.append("PersonID : ["+this.OESDItemSelector.getPK().getPersonID()+"]\n");
		}else{
			temp.append("PersonID : [null]\n");
		} 
		if(this.OESDItemSelector != null){
			temp.append("ExamLevel : ["+this.OESDItemSelector.getPK().getExamLevel()+"]\n");
		}else{
			temp.append("ExamLevel : [null]\n");
		} 
		if(this.OUnit != null){
			temp.append("Unit : ["+this.OUnit.getUnitID()+"]\n");
		}else{
			temp.append("Unit : [null]\n");
		} 
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
	
}
