package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "RemunerationCalculate")
public class RemunerationCalculate implements java.io.Serializable {

	private static final long serialVersionUID = -8905054326664125979L;

	private Integer RemunerationCalculateID;
	private Subject OSubject;
	private StandardRemuneration OStandardRemuneration;
	private Integer NOFStudent;
	private Integer TotalNOFObjectiveItem;
	private Integer TotalNOFSubjectiveItem;
	private Integer TotalNOFObjectiveSelected;
	private Integer TotalNOFSubjectiveSelected;
	private Double ObjectiveRemuneration;
	private Double SubjectiveRemuneration;
	private Integer TotalNOFObjectiveNotSelect;
	private Integer TotalNOFSubjectiveNotSelect;
	private Double NotSelectObjecitveRemuneration;
	private Double NotSelectSubjecitveRemuneration;
	private Double TotalRemuneration;
	private Double Payment;
	private String Notation;
	private Integer RemunerationCalculateType;
	
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private String DeletedUser;
	private Date DeletedTime;
	private Integer Version;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public RemunerationCalculate() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "RemunerationCalculateID", unique = true, nullable = false)
	public Integer getRemunerationCalculateID() {
		return RemunerationCalculateID;
	}

	public void setRemunerationCalculateID(Integer remunerationCalculateID) {
		RemunerationCalculateID = remunerationCalculateID;
	}

	@Version
	@Column(name = "RC_Version", nullable = true)
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "RC_SubjectID", nullable = true)
	public Subject getOSubject() {
		return OSubject;
	}

	public void setOSubject(Subject oSubject) {
		OSubject = oSubject;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "RC_StandardRemunerationID", nullable = true)
	public StandardRemuneration getOStandardRemuneration() {
		return OStandardRemuneration;
	}

	public void setOStandardRemuneration(StandardRemuneration oStandardRemuneration) {
		OStandardRemuneration = oStandardRemuneration;
	}

	@Column(name = "RC_NOFStudent", nullable = true)
	public Integer getNOFStudent() {
		return NOFStudent;
	}

	public void setNOFStudent(Integer nOFStudent) {
		NOFStudent = nOFStudent;
	}
	
	@Column(name = "RC_TotalNOFObjectiveItem", nullable = true)
	public Integer getTotalNOFObjectiveItem() {
		return TotalNOFObjectiveItem;
	}

	public void setTotalNOFObjectiveItem(Integer totalNOFObjectiveItem) {
		TotalNOFObjectiveItem = totalNOFObjectiveItem;
	}
	
	@Column(name = "RC_TotalNOFSubjectiveItem", nullable = true)
	public Integer getTotalNOFSubjectiveItem() {
		return TotalNOFSubjectiveItem;
	}

	public void setTotalNOFSubjectiveItem(Integer totalNOFSubjectiveItem) {
		TotalNOFSubjectiveItem = totalNOFSubjectiveItem;
	}

	@Column(name = "RC_TotalNOFObjectiveSelected", nullable = true)
	public Integer getTotalNOFObjectiveSelected() {
		return TotalNOFObjectiveSelected;
	}

	public void setTotalNOFObjectiveSelected(Integer totalNOFObjectiveSelected) {
		TotalNOFObjectiveSelected = totalNOFObjectiveSelected;
	}

	@Column(name = "RC_TotalNOFSubjectiveSelected" , nullable = true)
	public Integer getTotalNOFSubjectiveSelected() {
		return TotalNOFSubjectiveSelected;
	}

	public void setTotalNOFSubjectiveSelected(Integer totalNOFSubjectiveSelected) {
		TotalNOFSubjectiveSelected = totalNOFSubjectiveSelected;
	}

	@Column(name = "RC_ObjectiveRemuneration", precision = 53, scale = 0 , nullable = true)
	public Double getObjectiveRemuneration() {
		return ObjectiveRemuneration;
	}

	public void setObjectiveRemuneration(Double objectiveRemuneration) {
		ObjectiveRemuneration = objectiveRemuneration;
	}

	@Column(name = "RC_SubjectiveRemuneration", precision = 53, scale = 0 , nullable = true)
	public Double getSubjectiveRemuneration() {
		return SubjectiveRemuneration;
	}

	public void setSubjectiveRemuneration(Double subjectiveRemuneration) {
		SubjectiveRemuneration = subjectiveRemuneration;
	}

	@Column(name = "RC_TotalNOFObjectiveNotSelect" , nullable = true)
	public Integer getTotalNOFObjectiveNotSelect() {
		return TotalNOFObjectiveNotSelect;
	}

	public void setTotalNOFObjectiveNotSelect(Integer totalNOFObjectiveNotSelect) {
		TotalNOFObjectiveNotSelect = totalNOFObjectiveNotSelect;
	}

	@Column(name = "RC_TotalNOFSubjectiveNotSelect" , nullable = true)
	public Integer getTotalNOFSubjectiveNotSelect() {
		return TotalNOFSubjectiveNotSelect;
	}

	public void setTotalNOFSubjectiveNotSelect(Integer totalNOFSubjectiveNotSelect) {
		TotalNOFSubjectiveNotSelect = totalNOFSubjectiveNotSelect;
	}

	@Column(name = "RC_NotSelectObjecitveRemuneration", precision = 53, scale = 0 , nullable = true)
	public Double getNotSelectObjecitveRemuneration() {
		return NotSelectObjecitveRemuneration;
	}

	public void setNotSelectObjecitveRemuneration(Double notSelectObjecitveRemuneration) {
		NotSelectObjecitveRemuneration = notSelectObjecitveRemuneration;
	}

	@Column(name = "RC_NotSelectSubjecitveRemuneration", precision = 53, scale = 0 , nullable = true)
	public Double getNotSelectSubjecitveRemuneration() {
		return NotSelectSubjecitveRemuneration;
	}

	public void setNotSelectSubjecitveRemuneration(Double notSelectSubjecitveRemuneration) {
		NotSelectSubjecitveRemuneration = notSelectSubjecitveRemuneration;
	}

	@Column(name = "RC_TotalRemuneration", precision = 53, scale = 0 , nullable = true)
	public Double getTotalRemuneration() {
		return TotalRemuneration;
	}

	public void setTotalRemuneration(Double totalRemuneration) {
		TotalRemuneration = totalRemuneration;
	}

	@Column(name = "RC_Payment", precision = 53, scale = 0 , nullable = true)
	public Double getPayment() {
		return Payment;
	}

	public void setPayment(Double payment) {
		Payment = payment;
	}

	@Column(name = "RC_Notation", length = 1024 , nullable = true)
	public String getNotation() {
		return Notation;
	}

	public void setNotation(String notation) {
		Notation = notation;
	}

	@Column(name = "RC_RemunerationCalculateType" , nullable = true)
	public Integer getRemunerationCalculateType() {
		return RemunerationCalculateType;
	}

	public void setRemunerationCalculateType(Integer remunerationCalculateType) {
		RemunerationCalculateType = remunerationCalculateType;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "RC_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RC_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "RC_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RC_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Column(name = "RC_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Column(name = "RC_DeletedUser", length = 64 , nullable = true)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RC_DeletedTime", length = 23 , nullable = true)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "RC_OwnerUserID" , nullable = true)
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "RC_OwnerGroupID" , nullable = true)
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}



	
}
