package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "RemunerationCalculateItem")
public class RemunerationCalculateItem implements java.io.Serializable{


	private static final long serialVersionUID = -8040362006111639976L;
	private Integer RemunerationCalculateItemID;
	private RemunerationCalculate ORemunerationCalculate;
	private Person OPerson;
	private Integer NOFStudent;
	private Integer TotalNOFObjectiveItem;
	private Integer TotalNOFSubjectiveItem;
	private Integer TotalNOFObjectiveSelected;
	private Integer TotalNOFSubjectiveSelected;
	private Double ObjectiveRemuneration;
	private Double SubjectiveRemuneration;
	private Integer TotalNOFObjectiveNotSelect;
	private Integer TotalNOFSubjectiveNotSelect;
	private Double NotSelectObjecitveRemuneration;
	private Double NotSelectSubjecitveRemuneration;
	private Double TotalRemuneration;
	private Double Payment;
	private String Notation;
	private Integer RemunerationCalculateType;

	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private String DeletedUser;
	private Date DeletedTime;
	private Integer Version;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	public RemunerationCalculateItem() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "RemunerationCalculateItemID", unique = true, nullable = false)
	public Integer getRemunerationCalculateItemID() {
		return RemunerationCalculateItemID;
	}

	public void setRemunerationCalculateItemID(Integer remunerationCalculateItemID) {
		RemunerationCalculateItemID = remunerationCalculateItemID;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "RCI_RemunerationCalculateID", nullable = true)
	public RemunerationCalculate getORemunerationCalculate() {
		return ORemunerationCalculate;
	}

	public void setORemunerationCalculate(RemunerationCalculate oRemunerationCalculate) {
		ORemunerationCalculate = oRemunerationCalculate;
	}

	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "RCI_PersonID", nullable = true)
	public Person getOPerson() {
		return OPerson;
	}

	public void setOPerson(Person oPerson) {
		OPerson = oPerson;
	}
	
	@Column(name = "RCI_NOFStudent", nullable = true)
	public Integer getNOFStudent() {
		return NOFStudent;
	}

	public void setNOFStudent(Integer nOFStudent) {
		NOFStudent = nOFStudent;
	}

	@Column(name = "RCI_TotalNOFObjectiveItem", nullable = true)
	public Integer getTotalNOFObjectiveItem() {
		return TotalNOFObjectiveItem;
	}

	public void setTotalNOFObjectiveItem(Integer totalNOFObjectiveItem) {
		TotalNOFObjectiveItem = totalNOFObjectiveItem;
	}

	@Column(name = "RCI_TotalNOFSubjectiveItem", nullable = true)
	public Integer getTotalNOFSubjectiveItem() {
		return TotalNOFSubjectiveItem;
	}

	public void setTotalNOFSubjectiveItem(Integer totalNOFSubjectiveItem) {
		TotalNOFSubjectiveItem = totalNOFSubjectiveItem;
	}

	@Column(name = "RCI_TotalNOFObjectiveSelected", nullable = true)
	public Integer getTotalNOFObjectiveSelected() {
		return TotalNOFObjectiveSelected;
	}

	public void setTotalNOFObjectiveSelected(Integer totalNOFObjectiveSelected) {
		TotalNOFObjectiveSelected = totalNOFObjectiveSelected;
	}

	@Column(name = "RCI_TotalNOFSubjectiveSelected", nullable = true)
	public Integer getTotalNOFSubjectiveSelected() {
		return TotalNOFSubjectiveSelected;
	}

	public void setTotalNOFSubjectiveSelected(Integer totalNOFSubjectiveSelected) {
		TotalNOFSubjectiveSelected = totalNOFSubjectiveSelected;
	}

	@Column(name = "RCI_ObjectiveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveRemuneration() {
		return ObjectiveRemuneration;
	}

	public void setObjectiveRemuneration(Double objectiveRemuneration) {
		ObjectiveRemuneration = objectiveRemuneration;
	}

	@Column(name = "RCI_SubjectiveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveRemuneration() {
		return SubjectiveRemuneration;
	}

	public void setSubjectiveRemuneration(Double subjectiveRemuneration) {
		SubjectiveRemuneration = subjectiveRemuneration;
	}

	@Column(name = "RCI_TotalNOFObjectiveNotSelect", nullable = true)
	public Integer getTotalNOFObjectiveNotSelect() {
		return TotalNOFObjectiveNotSelect;
	}

	public void setTotalNOFObjectiveNotSelect(Integer totalNOFObjectiveNotSelect) {
		TotalNOFObjectiveNotSelect = totalNOFObjectiveNotSelect;
	}

	@Column(name = "RCI_TotalNOFSubjectiveNotSelect", nullable = true)
	public Integer getTotalNOFSubjectiveNotSelect() {
		return TotalNOFSubjectiveNotSelect;
	}

	public void setTotalNOFSubjectiveNotSelect(Integer totalNOFSubjectiveNotSelect) {
		TotalNOFSubjectiveNotSelect = totalNOFSubjectiveNotSelect;
	}

	@Column(name = "RCI_NotSelectObjecitveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getNotSelectObjecitveRemuneration() {
		return NotSelectObjecitveRemuneration;
	}

	public void setNotSelectObjecitveRemuneration(Double notSelectObjecitveRemuneration) {
		NotSelectObjecitveRemuneration = notSelectObjecitveRemuneration;
	}

	@Column(name = "RCI_NotSelectSubjecitveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getNotSelectSubjecitveRemuneration() {
		return NotSelectSubjecitveRemuneration;
	}

	public void setNotSelectSubjecitveRemuneration(Double notSelectSubjecitveRemuneration) {
		NotSelectSubjecitveRemuneration = notSelectSubjecitveRemuneration;
	}

	@Column(name = "RCI_TotalRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getTotalRemuneration() {
		return TotalRemuneration;
	}

	public void setTotalRemuneration(Double totalRemuneration) {
		TotalRemuneration = totalRemuneration;
	}

	@Column(name = "RCI_Payment", precision = 53, scale = 0, nullable = true)
	public Double getPayment() {
		return Payment;
	}

	public void setPayment(Double payment) {
		Payment = payment;
	}

	@Column(name = "RCI_Notation", length = 1024, nullable = true)
	public String getNotation() {
		return Notation;
	}

	public void setNotation(String notation) {
		Notation = notation;
	}

	@Column(name = "RCI_RemunerationCalculateType", nullable = true)
	public Integer getRemunerationCalculateType() {
		return RemunerationCalculateType;
	}

	public void setRemunerationCalculateType(Integer remunerationCalculateType) {
		RemunerationCalculateType = remunerationCalculateType;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "RCI_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RCI_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "RCI_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RCI_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Column(name = "RCI_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Column(name = "RCI_DeletedUser", length = 64, nullable = true)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "RCI_DeletedTime", length = 23, nullable = true)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Version
	@Column(name = "RCI_Version", nullable = true)
	public Integer getVersion() {
		return Version;
	}

	public void setVersion(Integer version) {
		Version = version;
	}

	@Column(name = "RCI_OwnerUserID", nullable = true)
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "RCI_OwnerGroupID", nullable = true)
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	
}
