package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "StandardRemuneration")
public class StandardRemuneration implements java.io.Serializable {

	private static final long serialVersionUID = 2406988322791009759L;
	private Integer StandardRemunerationID;
	private ExamSchedule OExamSchedule;
	private Double ObjectiveSelectedRemuneration;
	private Double SubjectiveSelectedRemuneration;
	private Double ObjectiveNotSelectRemuneration;
	private Double SubjectiveNotSelectRemuneration;
	private Double ObjectiveSelectedRemunerationMix;
	private Double SubjectiveSelectedRemunerationMix;
	private Double ObjectiveNotSelectRemunerationMix;
	private Double SubjectiveNotSelectRemunerationMix;
	private Integer TotalNOFObjectiveItem;
	private Integer TotalNOFSubjectiveItem;
	private Integer TotalNOFObjectiveSelected;
	private Integer TotalNOFSubjectiveSelected;
	private Double ObjectiveRemuneration;
	private Double SubjectiveRemuneration;
	private Integer TotalNOFObjectiveNotSelect;
	private Integer TotalNOFSubjectiveNotSelect;
	private Double NotSelectObjecitveRemuneration;
	private Double NotSelectSubjecitveRemuneration;
	private Double TotalRemuneration;
	private Double Payment;
	private Double MinimumPayment;
	private Integer NOFStudent;
	
	private TYPE_DATA_STATUS DataStatus;
	private Date CreateTime;
	private String CreateUser;
	private Date ModifyTime;
	private String ModifyUser;
	private String DeletedUser;
	private Date DeletedTime;
	private Integer Version;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;
	
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "StandardRemunerationID", unique = true, nullable = false)
	public Integer getStandardRemunerationID() {
		return StandardRemunerationID;
	}
	public void setStandardRemunerationID(Integer standardRemunerationID) {
		StandardRemunerationID = standardRemunerationID;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "SR_ExamScheduleID", nullable = true)
	public ExamSchedule getOExamSchedule() {
		return OExamSchedule;
	}
	public void setOExamSchedule(ExamSchedule oExamSchedule) {
		OExamSchedule = oExamSchedule;
	}
	
	@Column(name = "SR_ObjectiveSelectedRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveSelectedRemuneration() {
		return ObjectiveSelectedRemuneration;
	}
	public void setObjectiveSelectedRemuneration(Double objectiveSelectedRemuneration) {
		ObjectiveSelectedRemuneration = objectiveSelectedRemuneration;
	}
	
	@Column(name = "SR_SubjectiveSelectedRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveSelectedRemuneration() {
		return SubjectiveSelectedRemuneration;
	}
	public void setSubjectiveSelectedRemuneration(Double subjectiveSelectedRemuneration) {
		SubjectiveSelectedRemuneration = subjectiveSelectedRemuneration;
	}
	
	@Column(name = "SR_ObjectiveNotSelectRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveNotSelectRemuneration() {
		return ObjectiveNotSelectRemuneration;
	}
	public void setObjectiveNotSelectRemuneration(Double objectiveNotSelectRemuneration) {
		ObjectiveNotSelectRemuneration = objectiveNotSelectRemuneration;
	}
	
	@Column(name = "SR_SubjectiveNotSelectRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveNotSelectRemuneration() {
		return SubjectiveNotSelectRemuneration;
	}
	public void setSubjectiveNotSelectRemuneration(Double subjectiveNotSelectRemuneration) {
		SubjectiveNotSelectRemuneration = subjectiveNotSelectRemuneration;
	}
	
	@Column(name = "SR_ObjectiveSelectedRemunerationMix", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveSelectedRemunerationMix() {
		return ObjectiveSelectedRemunerationMix;
	}
	public void setObjectiveSelectedRemunerationMix(Double objectiveSelectedRemunerationMix) {
		ObjectiveSelectedRemunerationMix = objectiveSelectedRemunerationMix;
	}
	
	@Column(name = "SR_SubjectiveSelectedRemunerationMix", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveSelectedRemunerationMix() {
		return SubjectiveSelectedRemunerationMix;
	}
	public void setSubjectiveSelectedRemunerationMix(Double subjectiveSelectedRemunerationMix) {
		SubjectiveSelectedRemunerationMix = subjectiveSelectedRemunerationMix;
	}
	
	@Column(name = "SR_ObjectiveNotSelectRemunerationMix", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveNotSelectRemunerationMix() {
		return ObjectiveNotSelectRemunerationMix;
	}
	public void setObjectiveNotSelectRemunerationMix(Double objectiveNotSelectRemunerationMix) {
		ObjectiveNotSelectRemunerationMix = objectiveNotSelectRemunerationMix;
	}
	
	@Column(name = "SR_SubjectiveNotSelectRemunerationMix", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveNotSelectRemunerationMix() {
		return SubjectiveNotSelectRemunerationMix;
	}
	public void setSubjectiveNotSelectRemunerationMix(Double subjectiveNotSelectRemunerationMix) {
		SubjectiveNotSelectRemunerationMix = subjectiveNotSelectRemunerationMix;
	}
	
	@Column(name = "SR_TotalNOFObjectiveItem", nullable = true)
	public Integer getTotalNOFObjectiveItem() {
		return TotalNOFObjectiveItem;
	}
	public void setTotalNOFObjectiveItem(Integer totalNOFObjectiveItem) {
		TotalNOFObjectiveItem = totalNOFObjectiveItem;
	}
	
	@Column(name = "SR_TotalNOFSubjectiveItem", nullable = true)
	public Integer getTotalNOFSubjectiveItem() {
		return TotalNOFSubjectiveItem;
	}
	public void setTotalNOFSubjectiveItem(Integer totalNOFSubjectiveItem) {
		TotalNOFSubjectiveItem = totalNOFSubjectiveItem;
	}
	
	@Column(name = "SR_TotalNOFObjectiveSelected", nullable = true)
	public Integer getTotalNOFObjectiveSelected() {
		return TotalNOFObjectiveSelected;
	}
	public void setTotalNOFObjectiveSelected(Integer totalNOFObjectiveSelected) {
		TotalNOFObjectiveSelected = totalNOFObjectiveSelected;
	}
	
	@Column(name = "SR_TotalNOFSubjectiveSelected", nullable = true)
	public Integer getTotalNOFSubjectiveSelected() {
		return TotalNOFSubjectiveSelected;
	}
	public void setTotalNOFSubjectiveSelected(Integer totalNOFSubjectiveSelected) {
		TotalNOFSubjectiveSelected = totalNOFSubjectiveSelected;
	}
	
	@Column(name = "SR_ObjectiveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getObjectiveRemuneration() {
		return ObjectiveRemuneration;
	}
	public void setObjectiveRemuneration(Double objectiveRemuneration) {
		ObjectiveRemuneration = objectiveRemuneration;
	}
	
	@Column(name = "SR_SubjectiveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getSubjectiveRemuneration() {
		return SubjectiveRemuneration;
	}
	public void setSubjectiveRemuneration(Double subjectiveRemuneration) {
		SubjectiveRemuneration = subjectiveRemuneration;
	}
	
	@Column(name = "SR_TotalNOFObjectiveNotSelect", nullable = true)
	public Integer getTotalNOFObjectiveNotSelect() {
		return TotalNOFObjectiveNotSelect;
	}
	public void setTotalNOFObjectiveNotSelect(Integer totalNOFObjectiveNotSelect) {
		TotalNOFObjectiveNotSelect = totalNOFObjectiveNotSelect;
	}
	
	@Column(name = "SR_TotalNOFSubjectiveNotSelect", nullable = true)
	public Integer getTotalNOFSubjectiveNotSelect() {
		return TotalNOFSubjectiveNotSelect;
	}
	public void setTotalNOFSubjectiveNotSelect(Integer totalNOFSubjectiveNotSelect) {
		TotalNOFSubjectiveNotSelect = totalNOFSubjectiveNotSelect;
	}
	
	@Column(name = "SR_NotSelectObjecitveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getNotSelectObjecitveRemuneration() {
		return NotSelectObjecitveRemuneration;
	}
	public void setNotSelectObjecitveRemuneration(Double notSelectObjecitveRemuneration) {
		NotSelectObjecitveRemuneration = notSelectObjecitveRemuneration;
	}
	
	@Column(name = "SR_NotSelectSubjecitveRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getNotSelectSubjecitveRemuneration() {
		return NotSelectSubjecitveRemuneration;
	}
	public void setNotSelectSubjecitveRemuneration(Double notSelectSubjecitveRemuneration) {
		NotSelectSubjecitveRemuneration = notSelectSubjecitveRemuneration;
	}
	
	@Column(name = "SR_TotalRemuneration", precision = 53, scale = 0, nullable = true)
	public Double getTotalRemuneration() {
		return TotalRemuneration;
	}
	public void setTotalRemuneration(Double totalRemuneration) {
		TotalRemuneration = totalRemuneration;
	}
	
	@Column(name = "SR_Payment", precision = 53, scale = 0, nullable = true)
	public Double getPayment() {
		return Payment;
	}
	public void setPayment(Double payment) {
		Payment = payment;
	}
	
	@Column(name = "SR_MinimumPayment", precision = 53, scale = 0, nullable = true)
	public Double getMinimumPayment() {
		return MinimumPayment;
	}
	public void setMinimumPayment(Double minimumPayment) {
		MinimumPayment = minimumPayment;
	}
	
	@Column(name = "SR_NOFStudent", nullable = true)
	public Integer getNOFStudent() {
		return NOFStudent;
	}
	public void setNOFStudent(Integer nOFStudent) {
		NOFStudent = nOFStudent;
	}
	
	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "SR_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "SR_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}
	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}
	
	@Column(name = "SR_CreateUser", nullable = false, length = 64)
	public String getCreateUser() {
		return CreateUser;
	}
	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "SR_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}
	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}
	
	@Column(name = "SR_ModifyUser", nullable = false, length = 64)
	public String getModifyUser() {
		return ModifyUser;
	}
	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}
	
	@Column(name = "SR_DeletedUser", length = 64, nullable = true)
	public String getDeletedUser() {
		return DeletedUser;
	}
	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "SR_DeletedTime", length = 23, nullable = true)
	public Date getDeletedTime() {
		return DeletedTime;
	}
	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}
	
	@Version
	@Column(name = "SR_Version", nullable = true)
	public Integer getVersion() {
		return Version;
	}
	public void setVersion(Integer version) {
		Version = version;
	}
	
	@Column(name = "SR_OwnerUserID", nullable = true)
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}
	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}
	
	@Column(name = "SR_OwnerGroupID", nullable = true)
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}
	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}
	
	
}
