//Supranee Leecharoen
package esi.examwh.model;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Version;

import org.hibernate.annotations.Type;

import com.plw.util.Common;

import esi.examwh.model.common.TYPE_DATA_STATUS;
import jakarta.validation.constraints.NotNull;

@Entity
@Table(name = "UserActionLog")
public class UserActionLog implements java.io.Serializable {

	private static final long serialVersionUID = -3084811261349508324L;
	private Integer UserActionLogID;
	private int Version;
	private Person OPerson;
	private ActionType OActionType;
	private String Detail;
	private TYPE_DATA_STATUS DataStatus;
	private String CreateUser;
	private Date CreateTime;
	private String ModifyUser;
	private Date ModifyTime;
	private Date DeletedTime;
	private String DeletedUser;
	private Integer OwnerUserID;
	private Integer OwnerGroupID;

	public UserActionLog() {
		this.DataStatus = TYPE_DATA_STATUS.STATUS_NEW;
		this.CreateUser = "System User";
		this.CreateTime = Common.GetCurrTime();
		this.ModifyUser = "System User";
		this.ModifyTime = Common.GetCurrTime();
	}

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "UserActionLogID", unique = true, nullable = false)
	public Integer getUserActionLogID() {
		return UserActionLogID;
	}

	public void setUserActionLogID(Integer UserActionLogID) {
		this.UserActionLogID = UserActionLogID;
	}

	@Version
	@Column(name = "UAL_Version", nullable = false)
	public int getVersion() {
		return Version;
	}

	public void setVersion(int version) {
		Version = version;
	}

	@Column(name = "UAL_Detail", length = 1024)
	public String getDetail() {
		return Detail;
	}

	public void setDetail(String detail) {
		Detail = detail;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "UAL_PersonID", nullable = false)
	public Person getOPerson() {
		return this.OPerson;
	}

	public void setOPerson(Person OPerson) {
		this.OPerson = OPerson;
	}
	
	@ManyToOne(fetch = FetchType.LAZY)
	@JoinColumn(name = "UAL_ActionTypeID", nullable = false)
	public ActionType getOActionType() {
		return this.OActionType;
	}

	public void setOActionType(ActionType OActionType) {
		this.OActionType = OActionType;
	}

	@NotNull
	@Enumerated(EnumType.ORDINAL)
    @Type(type = "esi.examwh.model.common.persistent.HB_TYPE_DATA_STATUS")
	@Column(name = "UAL_DataStatus", nullable = false)
	public TYPE_DATA_STATUS getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(TYPE_DATA_STATUS dataStatus) {
		DataStatus = dataStatus;
	}
	
	@Column(name = "UAL_CreateUser", nullable = false, length = 128)
	public String getCreateUser() {
		return CreateUser;
	}

	public void setCreateUser(String createUser) {
		CreateUser = createUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "UAL_CreateTime", nullable = false, length = 23)
	public Date getCreateTime() {
		return CreateTime;
	}

	public void setCreateTime(Date createTime) {
		CreateTime = createTime;
	}

	@Column(name = "UAL_ModifyUser", nullable = false, length = 128)
	public String getModifyUser() {
		return ModifyUser;
	}

	public void setModifyUser(String modifyUser) {
		ModifyUser = modifyUser;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "UAL_ModifyTime", nullable = false, length = 23)
	public Date getModifyTime() {
		return ModifyTime;
	}

	public void setModifyTime(Date modifyTime) {
		ModifyTime = modifyTime;
	}

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name = "UAL_DeletedTime", length = 23)
	public Date getDeletedTime() {
		return DeletedTime;
	}

	public void setDeletedTime(Date deletedTime) {
		DeletedTime = deletedTime;
	}

	@Column(name = "UAL_DeletedUser", length = 128)
	public String getDeletedUser() {
		return DeletedUser;
	}

	public void setDeletedUser(String deletedUser) {
		DeletedUser = deletedUser;
	}

	@Column(name = "UAL_OwnerUserID")
	public Integer getOwnerUserID() {
		return OwnerUserID;
	}

	public void setOwnerUserID(Integer ownerUserID) {
		OwnerUserID = ownerUserID;
	}

	@Column(name = "UAL_OwnerGroupID")
	public Integer getOwnerGroupID() {
		return OwnerGroupID;
	}

	public void setOwnerGroupID(Integer ownerGroupID) {
		OwnerGroupID = ownerGroupID;
	}

	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("UserActionLogID :["+this.UserActionLogID+"]\n");
		
		temp.append("[Begin Record]\n");
		if(this.OPerson != null){
			temp.append("PersonID : ["+this.getOPerson().getPersonID()+"]\n");
		}else{
			temp.append("PersonID : [null]\n");
		} 
		if(this.OActionType != null){
			temp.append("ActionTypeID : ["+this.getOActionType().getActionTypeID()+"]\n");
		}else{
			temp.append("ActionTypeID : [null]\n");
		} 
		temp.append("Detail : ["+this.Detail+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("CreateTime : ["+this.CreateTime+"]\n");
		temp.append("CreateUser : ["+this.CreateUser+"]\n");
		temp.append("ModifyTime : ["+this.ModifyTime+"]\n");
		temp.append("ModifyUser : ["+this.ModifyUser+"]\n");
		temp.append("DeletedTime : ["+this.DeletedTime+"]\n");
		temp.append("DeletedUser : ["+this.DeletedUser+"]\n");
		temp.append("OwnerUserID : ["+this.OwnerUserID+"]\n");
		temp.append("OwnerGroupID : ["+this.OwnerGroupID+"]\n");
		temp.append("Version : ["+this.Version+"]\n");
		temp.append("[End Record]");
		return temp.toString();
	}
	
}
