package esi.examwh.model.tools;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Properties;


import org.hibernate.cfg.reveng.AssociationInfo;
import org.hibernate.cfg.reveng.DelegatingReverseEngineeringStrategy;
import org.hibernate.cfg.reveng.ReverseEngineeringRuntimeInfo;
import org.hibernate.cfg.reveng.ReverseEngineeringSettings;
import org.hibernate.cfg.reveng.ReverseEngineeringStrategy;
import org.hibernate.cfg.reveng.TableIdentifier;
import org.hibernate.mapping.Column;
import org.hibernate.mapping.ForeignKey;
import org.hibernate.mapping.Table;

public class ExamWHStrategy extends DelegatingReverseEngineeringStrategy {
	private String PackageName = "esi.examwh.model";
	private String CompositeIdentityName = "PK";
	private String NonCompositeIdentityName = "ID";

	public ExamWHStrategy(ReverseEngineeringStrategy delegate) {
		super(delegate);
	}

	public String columnToPropertyName(TableIdentifier table, String column) {
		String ColumnName = "";
		String[] ColumnNameList = column.split("_");
		if (ColumnNameList.length > 1) {
			for (int i = 1; i < ColumnNameList.length; i++) {
				ColumnName += ColumnNameList[i];
			}
			return ColumnName;
		} else {
			return column;
			// return super.columnToPropertyName(table, column);
		}
	}

	public String tableToCompositeIdName(TableIdentifier identifier) {
		return this.PackageName + "." + identifier.getName() + CompositeIdentityName;
	}

	public boolean useColumnForOptimisticLock(TableIdentifier identifier, String column) {
		return column.contains("Version");
	}

	public String tableToIdentifierPropertyName(TableIdentifier tableIdentifier) {
		List<String> NameList = new ArrayList<String>();
		NameList.add("SubjectEditor");
		NameList.add("SubjectCollator");
		NameList.add("ESDFormEditor");
		NameList.add("ESDFormCollator");
		NameList.add("TopicObjective");
		NameList.add("UnitRelation");
		for (String Name : NameList) {
			if (Name.equals(tableIdentifier.getName())) {
				return (CompositeIdentityName);				
			}
		}
		return (tableIdentifier.getName() + NonCompositeIdentityName);
	}
	
	public String getTableIdentifierStrategyName(TableIdentifier identifier) {
		return "List";
	}

	@Override
	public String classNameToCompositeIdName(String className) {
		// TODO Auto-generated method stub
		return super.classNameToCompositeIdName(className);
	}

	@Override
	public void close() {
		// TODO Auto-generated method stub
		super.close();
	}

	@Override
	public String columnToHibernateTypeName(TableIdentifier table, String columnName, int sqlType, int length, int precision, int scale, boolean nullable, boolean generatedIdentifier) {
		// TODO Auto-generated method stub
		return super.columnToHibernateTypeName(table, columnName, sqlType, length, precision, scale, nullable, generatedIdentifier);
	}

	@Override
	public Map columnToMetaAttributes(TableIdentifier identifier, String column) {
		// TODO Auto-generated method stub
		return super.columnToMetaAttributes(identifier, column);
	}

	@Override
	public void configure(ReverseEngineeringRuntimeInfo runtimeInfo) {
		// TODO Auto-generated method stub
		super.configure(runtimeInfo);
	}

	@Override
	public boolean excludeColumn(TableIdentifier identifier, String columnName) {
		// TODO Auto-generated method stub
		return super.excludeColumn(identifier, columnName);
	}

	@Override
	public boolean excludeForeignKeyAsCollection(String keyname, TableIdentifier fromTable, List fromColumns, TableIdentifier referencedTable, List referencedColumns) {
		// TODO Auto-generated method stub
		return super.excludeForeignKeyAsCollection(keyname, fromTable, fromColumns, referencedTable, referencedColumns);
	}

	@Override
	public boolean excludeForeignKeyAsManytoOne(String keyname, TableIdentifier fromTable, List fromColumns, TableIdentifier referencedTable, List referencedColumns) {
		// TODO Auto-generated method stub
		return super.excludeForeignKeyAsManytoOne(keyname, fromTable, fromColumns, referencedTable, referencedColumns);
	}

	@Override
	public boolean excludeTable(TableIdentifier ti) {
		// TODO Auto-generated method stub
		return super.excludeTable(ti);
	}

	@Override
	public AssociationInfo foreignKeyToAssociationInfo(ForeignKey foreignKey) {
		// TODO Auto-generated method stub
		return super.foreignKeyToAssociationInfo(foreignKey);
	}

	@Override
	public String foreignKeyToCollectionName(String keyname, TableIdentifier fromTable, List fromColumns, TableIdentifier referencedTable, List referencedColumns, boolean uniqueReference) {
		// TODO Auto-generated method stub
//		return "List";
		return super.foreignKeyToCollectionName(keyname, fromTable, fromColumns, referencedTable, referencedColumns, uniqueReference);
	}

	@Override
	public AssociationInfo foreignKeyToInverseAssociationInfo(ForeignKey foreignKey) {
		// TODO Auto-generated method stub
		return super.foreignKeyToInverseAssociationInfo(foreignKey);
	}

	@Override
	public String foreignKeyToInverseEntityName(String keyname, TableIdentifier fromTable, List fromColumnNames, TableIdentifier referencedTable, List referencedColumnNames, boolean uniqueReference) {
		// TODO Auto-generated method stub
		return super.foreignKeyToInverseEntityName(keyname, fromTable, fromColumnNames, referencedTable, referencedColumnNames, uniqueReference);
	}

	@Override
	public String foreignKeyToManyToManyName(ForeignKey fromKey, TableIdentifier middleTable, ForeignKey toKey, boolean uniqueReference) {
		// TODO Auto-generated method stub
		return super.foreignKeyToManyToManyName(fromKey, middleTable, toKey, uniqueReference);
	}

	@Override
	public List getForeignKeys(TableIdentifier referencedTable) {
		// TODO Auto-generated method stub
		return super.getForeignKeys(referencedTable);
	}

	@Override
	public String getOptimisticLockColumnName(TableIdentifier identifier) {
		// TODO Auto-generated method stub
		return super.getOptimisticLockColumnName(identifier);
	}

	@Override
	public List getPrimaryKeyColumnNames(TableIdentifier identifier) {
		// TODO Auto-generated method stub
		return super.getPrimaryKeyColumnNames(identifier);
	}

	@Override
	public List getSchemaSelections() {
		// TODO Auto-generated method stub
		return super.getSchemaSelections();
	}

	@Override
	public Properties getTableIdentifierProperties(TableIdentifier identifier) {
		// TODO Auto-generated method stub
		return super.getTableIdentifierProperties(identifier);
	}

	@Override
	public boolean isForeignKeyCollectionInverse(String name, TableIdentifier foreignKeyTable, List columns, TableIdentifier foreignKeyReferencedTable, List referencedColumns) {
		// TODO Auto-generated method stub
		return super.isForeignKeyCollectionInverse(name, foreignKeyTable, columns, foreignKeyReferencedTable, referencedColumns);
	}

	@Override
	public boolean isForeignKeyCollectionLazy(String name, TableIdentifier foreignKeyTable, List columns, TableIdentifier foreignKeyReferencedTable, List referencedColumns) {
		// TODO Auto-generated method stub
		return super.isForeignKeyCollectionLazy(name, foreignKeyTable, columns, foreignKeyReferencedTable, referencedColumns);
	}

	@Override
	public boolean isManyToManyTable(Table table) {
		// TODO Auto-generated method stub
		return super.isManyToManyTable(table);
	}

	@Override
	public boolean isOneToOne(ForeignKey foreignKey) {
		// TODO Auto-generated method stub
		return super.isOneToOne(foreignKey);
	}

	@Override
	public void setSettings(ReverseEngineeringSettings settings) {
		// TODO Auto-generated method stub
		super.setSettings(settings);
	}

	@Override
	public String tableToClassName(TableIdentifier tableIdentifier) {
		// TODO Auto-generated method stub
		return super.tableToClassName(tableIdentifier);
	}

	@Override
	public Map tableToMetaAttributes(TableIdentifier tableIdentifier) {
		// TODO Auto-generated method stub
		return super.tableToMetaAttributes(tableIdentifier);
	}

	public String foreignKeyToEntityName(String keyname, TableIdentifier fromTable, List fromColumnNames, TableIdentifier referencedTable, List referencedColumnNames, boolean uniqueReference) {
		String OldColumnName = ((Column) fromColumnNames.get(0)).getName();
		String NewColumnName = "";
		String[] ColumnNameList = OldColumnName.split("_");
		if (ColumnNameList.length > 1) {
			for (int i = 1; i < ColumnNameList.length; i++) {
				NewColumnName += ColumnNameList[i];
			}
			if (NewColumnName.endsWith("ID") == true) {
				NewColumnName = NewColumnName.substring(0, NewColumnName.length() - 2);
			}
			return "O" + NewColumnName;
		} else {
			return "O" + OldColumnName;
		}
	}

}