package esi.examwh.service.runnumber;

import esi.examwh.model.common.TYPE_PREFIX_DOCUMENT;

public class CodeGenerator {
	
	private static RunNumberFactory ExamItemCodeGenerator = new RunNumberFactory( 2, 6);
	private static RunNumberFactory ExamItemChoiceCodeGenerator = new RunNumberFactory( 2, 5);
	private static RunNumberFactory ExamItemGroupCodeGenerator = new RunNumberFactory( 2, 4);
	private static RunNumberFactory ExamFormCodeGenerator = new RunNumberFactory( 2, 5);
	
	private CodeGenerator() {
	}
	
	public static synchronized String ExamItemChoiceNextCode(int YearID) throws DataNotGenerateException {
		return ExamItemChoiceCodeGenerator.getNextRunNumberCode(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM_CHOICE);
	}
	
	public static synchronized String ExamItemNextCode(int YearID) throws DataNotGenerateException {
		return ExamItemCodeGenerator.getNextRunNumberCode(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM);
	}
	
	public static synchronized String ExamItemGroupNextCode(int YearID) throws DataNotGenerateException {
		return ExamItemGroupCodeGenerator.getNextRunNumberCode(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM_GROUP);
	}
	public static synchronized String ExamFormNextCode(int YearID,String as_Prefix) throws DataNotGenerateException {
		return ExamFormCodeGenerator.getNextRunNumberCode(YearID, as_Prefix);
	}
}
