package esi.examwh.service.runnumber;

import java.util.Formatter;
import java.util.Locale;

import esi.examwh.model.common.TYPE_PREFIX_DOCUMENT;


public class RunNumber {
	private int YearNum = 10;
	private int CurrNum = 0;
	private TYPE_PREFIX_DOCUMENT PrefixType = TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM;
	
	
	private int YearDigit = 2;
	private int NumberDigit = 8;
	
	public RunNumber(int aiYearDigit, int aiNumberDigit) {
		this.YearDigit = aiYearDigit;
		this.NumberDigit = aiNumberDigit;
	} 


	public int getYearNum() {
		return YearNum;
	}

	public void setYearNum(int yearNum) {
		YearNum = yearNum;
	}

	public int getCurrNum() {
		return CurrNum;
	}

	public void setCurrNum(int currNum) {
		CurrNum = currNum;
	}

	public TYPE_PREFIX_DOCUMENT getPrefixType() {
		return PrefixType;
	}

	public void setPrefixType(TYPE_PREFIX_DOCUMENT prefixType) {
		PrefixType = prefixType;
	}

	
	public int getYearDigit() {
		return YearDigit;
	}

	public void setYearDigit(int yearDigit) {
		YearDigit = yearDigit;
	}

	public int getNumberDigit() {
		return NumberDigit;
	}

	public void setNumberDigit(int numberDigit) {
		NumberDigit = numberDigit;
	}

	public String getCurrCode() {
		StringBuilder SB = new StringBuilder();
		Formatter FM = new Formatter(SB, new Locale("en"));

		FM.format("%"+ "s", PrefixType.getValue());
		FM.format("%0" + YearDigit + "d",
				((this.YearNum) % (1 * (int) (Math.pow(10, YearDigit)))));

		
		if (NumberDigit > 0) {
			FM.format("%0" + NumberDigit + "d", CurrNum);
			
		}
		return FM.toString();
	}
	public String getCurrCode(String ls_PrefixType) {
		StringBuilder SB = new StringBuilder();
		Formatter FM = new Formatter(SB, new Locale("en"));

		FM.format("%"+ "s",ls_PrefixType);
//		FM.format("%0" + YearDigit + "d",
//				((this.YearNum) % (1 * (int) (Math.pow(10, YearDigit)))));

		
		if (NumberDigit > 0) {
			FM.format("%0" + NumberDigit + "d", CurrNum);
			
		}
		return FM.toString();
	}
	
}
