package esi.examwh.service.runnumber;

import java.util.Date;

import org.hibernate.Session;
import org.hibernate.Transaction;

import esi.examwh.dao.DocumentNumberDAO;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.DocumentNumber;
import esi.examwh.model.DocumentNumberPK;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_PREFIX_DOCUMENT;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;

public class RunNumberFactory {
	private RunNumber ioRN;
	public RunNumberFactory(int aiYearDigit, int aiNumberDigit) {
		ioRN = new RunNumber(aiYearDigit, aiNumberDigit);
	}
	
	public String getNextRunNumberCode(int YearID, TYPE_PREFIX_DOCUMENT aePrefixType) throws DataNotGenerateException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		DocumentNumber loON = null;
		boolean NewFlag = true;
		try {
			try {
				loON = DocumentNumberDAO.GetById(MyHSs, YearID, aePrefixType.getCode());
				NewFlag = false;
			} catch (DataNotFoundException e) {
				loON = new DocumentNumber();
				loON.setPK(new DocumentNumberPK());
				loON.getPK().setYearNum(YearID);
				loON.getPK().setPrefixDocumentType(aePrefixType.getCode());
				loON.setLastNumber(0);
				loON.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
				loON.setLastRequestTime(Common.GetCurrTime());
			}
			ioRN.setPrefixType(aePrefixType);
			ioRN.setYearNum(loON.getPK().getYearNum());
			loON.setLastNumber(loON.getLastNumber() + 1);
			ioRN.setCurrNum(loON.getLastNumber());
			loON.setLastRequestTime(Common.GetCurrTime());
			if (NewFlag == true) {
				DocumentNumberDAO.Add(MyHSs, loON, "RunNumberFactory");	
			} else {
				DocumentNumberDAO.Modify(MyHSs, loON, "RunNumberFactory");
			}
			MyHTs.commit();
			MyHSs.close();
			return ioRN.getCurrCode();
		} catch (Exception e) {
			e.printStackTrace();
			MyHTs.rollback();
			MyHSs.close();
			throw new DataNotGenerateException();
		} finally {
		}
	}
	
	public String getNextRunNumberCode(int YearID, String asPrefixType) throws DataNotGenerateException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		DocumentNumber loON = null;
		boolean NewFlag = true;
		try {
			try {
				loON = DocumentNumberDAO.GetById(MyHSs, YearID, asPrefixType);
				NewFlag = false;
			} catch (DataNotFoundException e) {
				loON = new DocumentNumber();
				loON.setPK(new DocumentNumberPK());
				loON.getPK().setYearNum(YearID);
				loON.getPK().setPrefixDocumentType(asPrefixType);
				loON.setLastNumber(0);
				loON.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
				loON.setLastRequestTime(Common.GetCurrTime());
			}
			//ioRN.setPrefixType(aePrefixType);
			ioRN.setYearNum(loON.getPK().getYearNum());
			loON.setLastNumber(loON.getLastNumber() + 1);
			ioRN.setCurrNum(loON.getLastNumber());
			loON.setLastRequestTime(Common.GetCurrTime());
			if (NewFlag == true) {
				DocumentNumberDAO.Add(MyHSs, loON, "RunNumberFactory");	
			} else {
				DocumentNumberDAO.Modify(MyHSs, loON, "RunNumberFactory");
			}
			MyHTs.commit();
			MyHSs.close();
			return ioRN.getCurrCode(asPrefixType);
		} catch (Exception e) {
			e.printStackTrace();
			MyHTs.rollback();
			MyHSs.close();
			throw new DataNotGenerateException();
		} finally {
		}
	}
	
	public String getLastRunNumberCode(int YearID, TYPE_PREFIX_DOCUMENT aePrefixType) throws DataNotGenerateException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		DocumentNumber loON = null;
		try {
			try {
				loON = DocumentNumberDAO.GetById(MyHSs,  YearID, aePrefixType.getCode());
			} catch (DataNotFoundException e) {
				MyHTs.rollback();
				MyHSs.close();
				throw new DataNotGenerateException();
			}
			ioRN.setPrefixType(aePrefixType);
			ioRN.setYearNum(loON.getPK().getYearNum());
			ioRN.setCurrNum(loON.getLastNumber());
			MyHTs.commit();
			MyHSs.close();
			return ioRN.getCurrCode();
		} catch (Exception e) {
			e.printStackTrace();
			MyHTs.rollback();
			MyHSs.close();
			throw new DataNotGenerateException();
		} finally {
		}
	}
	
	public Date getLastRequestTime(int YearID,TYPE_PREFIX_DOCUMENT aePrefixType) throws DataNotGenerateException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		DocumentNumber loON = null;
		try {
			try {
				loON = DocumentNumberDAO.GetById(MyHSs, YearID, aePrefixType.getCode());
			} catch (DataNotFoundException e) {
				MyHTs.rollback();
				MyHSs.close();
				throw new DataNotGenerateException();
			}
			MyHTs.commit();
			MyHSs.close();
			return loON.getLastRequestTime();
		} catch (Exception e) {
			e.printStackTrace();
			MyHTs.rollback();
			MyHSs.close();
			throw new DataNotGenerateException();
		} finally {
		}
	}

	public static void main(String args[]) throws DataNotGenerateException {
		RunNumberFactory loRNF = new RunNumberFactory( 2, 5);
		for (int i = 0;i < 1000;i++) {
			
//			System.out.println(loRNF.getNextRunNumberCode(2555, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM));
//			System.out.println(loRNF.getNextRunNumberCode(2555, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM_GROUP));	
			
			
		}
		System.out.println(loRNF.getNextRunNumberCode(2557, "P57399999"));	
	}
}
