package esi.examwh.service.runnumber;

import static org.junit.Assert.assertEquals;

import org.hibernate.Session;
import org.hibernate.Transaction;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import esi.examwh.dao.DocumentNumberDAO;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.DocumentNumber;
import esi.examwh.model.common.TYPE_PREFIX_DOCUMENT;

public class RunNumberTester {
	int YearID;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {	
		System.out.println("System Test Start");
		YearID = 2555;
	}

	@After
	public void tearDown() throws Exception {
		System.out.println("System Test Stop");
	}
	
	public int getCurrNumber(int YearID, TYPE_PREFIX_DOCUMENT PrefixType) throws Exception {	
		System.out.println("System Test Start");
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		try {
			DocumentNumber loON = DocumentNumberDAO.GetById(MyHSs, YearID, PrefixType.getCode());
			MyHTs.commit();
			return loON.getLastNumber();
		} catch (Exception e) {
			e.printStackTrace();
			MyHTs.rollback();
			throw new DataNotGenerateException();
		} finally {
		}
	}

	@Test
	public void Test1() throws DataNotGenerateException {
		int InitialNumber = 0;		
		RunNumberFactory loRNF = new RunNumberFactory(  2, 6);
		try {
			InitialNumber = getCurrNumber(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM);
			System.out.println("Initial Number : " + InitialNumber);
		} catch (Exception e) {
			InitialNumber = 0;
		}
		for (int i = 0;i < 1000;i++) {
			InitialNumber ++;
			String Temp = loRNF.getNextRunNumberCode( YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM);
			System.out.println("Doc Code : " + Temp + " - Init > " + InitialNumber);
			int ReceiveNumber = Integer.parseInt(Temp.substring(14));
			System.out.println("Doc Code : " + Temp + " - diff > " + (InitialNumber - ReceiveNumber));
			assertEquals("Target Code failed to generate ", InitialNumber, ReceiveNumber);
		}
	}
	
	@Test
	public void Test2() throws DataNotGenerateException {
		int InitialNumber = 0;		
		RunNumberFactory loRNF = new RunNumberFactory( 2, 4);
		try {
			InitialNumber = getCurrNumber(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM_GROUP);
		} catch (Exception e) {
			InitialNumber = 0;
		}
		for (int i = 0;i < 1000;i++) {
			InitialNumber ++;
			String Temp = loRNF.getNextRunNumberCode(YearID, TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM_GROUP);
			int ReceiveNumber = Integer.parseInt(Temp.substring(13));
			System.out.println("Doc Code : " + Temp + " - diff > " + (InitialNumber - ReceiveNumber));
			assertEquals("Target Code failed to generate ", InitialNumber, ReceiveNumber);
		}
	}

	
}
