package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ActionTypeDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ActionType;
import esi.examwh.model.common.TYPE_DATA_STATUS;


import org.hibernate.Session;
import org.hibernate.Transaction;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ActionTypeTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {

		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ActionType newActionType = new ActionType();

		try {
			
			newActionType.setCode("AT001");
			newActionType.setName("ExamForm Tracking");
			newActionType.setDetail("detail");
			newActionType.setVersion(1);
			newActionType.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ActionTypeDAO.Add(MyHSs,newActionType, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ActionType ActionType;

		try {
			
			ActionType = ActionTypeDAO.GetByID(MyHSs,2,null,null);
			
			ActionType.setCode("AT001");
			ActionType.setName("ExamForm Tracking (Modify)");
			ActionType.setDetail("Detail");
			ActionType.setVersion(ActionType.getVersion()+1);
			ActionType.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ActionTypeDAO.Modify(MyHSs, ActionType, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(int ai_ActionTypeID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ActionType ActionType;
		try {
			ActionType = ActionTypeDAO.GetByID(MyHSs, ai_ActionTypeID,null,null);
			
			ActionTypeDAO.Delete(MyHSs, ActionType, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(int ai_ActionTypeID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ActionType ActionType;
		try {
			ActionType = ActionTypeDAO.GetByID(MyHSs, ai_ActionTypeID,null,null);
			ActionType.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ActionTypeDAO.Disable(MyHSs, ActionType, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(int ai_ActionTypeID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ActionType lo_ActionType=ActionTypeDAO.GetByID(MyHSs, ai_ActionTypeID,null,null);
		System.out.print("ActionTypeTestDAO GETbyID="+ai_ActionTypeID+"\n Name="+lo_ActionType.getName());
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ActionTypeDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestFindAll","size="+li_size);
		List<ActionType> lo_List = ActionTypeDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ActionTypeTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
//		Session MyHSs = ExamWHDaoUtil.getSession();
		try{
			//Session MyHSs = ExamWHDaoUtil.getSession();
//			ActionTypeTestDAO.UTTestAdd();
			//ActionTypeTestDAO.UTTestModify();
			//ActionTypeTestDAO.UTTestDelete(3,"EXAMWH ENGINE");
			//ActionTypeTestDAO.UTTestDisable(2,"EXAMWH ENGINE");
			ActionTypeTestDAO.UTTestGetByID(1);
			//ActionTypeTestDAO.UTTestFindAll(0,0);
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
