package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.BehaviorLevelDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.BehaviorLevel;
import esi.examwh.model.common.TYPE_DATA_STATUS;


import org.hibernate.Session;
import org.hibernate.Transaction;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class BehaviorLevelTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {

		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		BehaviorLevel newBehaviorLevel = new BehaviorLevel();

		try {
			
			newBehaviorLevel.setCode("BV111");
			newBehaviorLevel.setName("Behavior Name 111");
			newBehaviorLevel.setDetail("detail");
			newBehaviorLevel.setVersion(1);
			newBehaviorLevel.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			BehaviorLevelDAO.Add(MyHSs,newBehaviorLevel, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		BehaviorLevel BehaviorLevel;

		try {
			
			BehaviorLevel = BehaviorLevelDAO.GetByID(MyHSs,2,null,null);
			
			BehaviorLevel.setCode("BV100");
			BehaviorLevel.setName("Behavior Name");
			BehaviorLevel.setDetail("Detail");
			BehaviorLevel.setVersion(BehaviorLevel.getVersion()+1);
			BehaviorLevel.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			BehaviorLevelDAO.Modify(MyHSs, BehaviorLevel, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(int ai_BehaviorLevelID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		BehaviorLevel BehaviorLevel;
		try {
			BehaviorLevel = BehaviorLevelDAO.GetByID(MyHSs, ai_BehaviorLevelID,null,null);
			
			BehaviorLevelDAO.Delete(MyHSs, BehaviorLevel, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(int ai_BehaviorLevelID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		BehaviorLevel BehaviorLevel;
		try {
			BehaviorLevel = BehaviorLevelDAO.GetByID(MyHSs, ai_BehaviorLevelID,null,null);
			BehaviorLevel.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			BehaviorLevelDAO.Disable(MyHSs, BehaviorLevel, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(int ai_BehaviorLevelID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		BehaviorLevel lo_BehaviorLevel=BehaviorLevelDAO.GetByID(MyHSs, ai_BehaviorLevelID,null,null);
		System.out.print("BehaviorLevelTestDAO GETbyID="+ai_BehaviorLevelID);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = BehaviorLevelDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestFindAll","size="+li_size);
		List<BehaviorLevel> lo_List = BehaviorLevelDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByBehaviorCodeBehaviorNameBehaviorDetail() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		String as_BehaviorCode = "";
		String as_BehaviorName = "";
		String as_BehaviorDetail = "";
		int li_size = BehaviorLevelDAO.GetSizeByBehaviorCodeBehaviorNameBehaviorDetail(MyHSs,as_BehaviorCode,as_BehaviorName,as_BehaviorDetail,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestFindByBehaviorCodeBehaviorNameBehaviorDetail","size="+li_size);
		List<BehaviorLevel> lo_List = BehaviorLevelDAO.FindByBehaviorCodeBehaviorNameBehaviorDetail(MyHSs,as_BehaviorCode,as_BehaviorName,as_BehaviorDetail,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "BehaviorLevelTestDAO", "UTTestFindByBehaviorCodeBehaviorNameBehaviorDetail",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		Session MyHSs = ExamWHDaoUtil.getSession();
		try{
			//Session MyHSs = ExamWHDaoUtil.getSession();
			//BehaviorLevelTestDAO.UTTestAdd();
			//BehaviorLevelTestDAO.UTTestModify();
			//BehaviorLevelTestDAO.UTTestDelete(3,"EXAMWH ENGINE");
			//BehaviorLevelTestDAO.UTTestDisable(2,"EXAMWH ENGINE");
			//BehaviorLevelTestDAO.UTTestGetByID(1);
			//BehaviorLevelTestDAO.UTTestFindAll(0,0);
//			BehaviorLevelTestDAO.UTTestFindByBehaviorCodeBehaviorNameBehaviorDetail();
			BehaviorLevel o_BehaviorLevel =BehaviorLevelDAO.GetByCode(MyHSs, "", null, null);
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
