package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.EsdformCollatorDAO;
import esi.examwh.dao.EsdformEditorDAO;
import esi.examwh.dao.ExamScheduleDetailDAO;
import esi.examwh.dao.PersonDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.EsdformCollator;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.Person;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_FLAG;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class EsdformCollatorTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamScheduleDetailID = null;
		Integer ai_PersonID=null;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformCollator newEsdformCollator = EsdformCollator.getNewInstance(2, 3);

		
		try {
			
//			if(ai_ExamScheduleDetailID != null){
//				ExamScheduleDetail lo_ExamScheduleDetail = ExamScheduleDetailDAO.GetByID(MyHSs, ai_ExamScheduleDetailID, null,null);
//				newEsdformCollator.setOExamScheduleDetailID(lo_ExamScheduleDetail);
//			}
//			if(ai_PersonID != null){
//				Person lo_Person = PersonDAO.GetByID(MyHSs,ai_PersonID, null,null);
//				newEsdformCollator.setOPersonID(lo_Person);
//			}
//			
			newEsdformCollator.setDraft1CollatorFlag(TYPE_FLAG.TYPE_NO);
			newEsdformCollator.setDraft2CollatorFlag(TYPE_FLAG.TYPE_YES);
			newEsdformCollator.setDraft3CollatorFlag(TYPE_FLAG.TYPE_YES);
			newEsdformCollator.setDraft4CollatorFlag(TYPE_FLAG.TYPE_YES);
			newEsdformCollator.setVersion(1);
			newEsdformCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			EsdformCollatorDAO.Add(MyHSs,newEsdformCollator, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformCollator EsdformCollator;

		try {
			EsdformCollator = EsdformCollatorDAO.GetByID(MyHSs,2,2,null,null);
		
			EsdformCollator.setOrder(1);
			EsdformCollator.setDraft1CollatorFlag(TYPE_FLAG.TYPE_YES);
			EsdformCollator.setDraft2CollatorFlag(TYPE_FLAG.TYPE_NO);
			EsdformCollator.setDraft3CollatorFlag(TYPE_FLAG.TYPE_YES);
			EsdformCollator.setDraft4CollatorFlag(TYPE_FLAG.TYPE_NO);
			EsdformCollator.setAssignBeginDate(Common.GetCurrTime());
			EsdformCollator.setAssignEndDate(Common.GetCurrTime());
			EsdformCollator.setVersion(EsdformCollator.getVersion()+1);
			EsdformCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			EsdformCollatorDAO.Modify(MyHSs, EsdformCollator, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ShipmentID,Integer ai_AirwayBillID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformCollator lo_EsdformCollator;
		try {
			lo_EsdformCollator = EsdformCollatorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
			EsdformCollatorDAO.Delete(MyHSs, lo_EsdformCollator, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ShipmentID,Integer ai_AirwayBillID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformCollator lo_EsdformCollator;
		try {
			lo_EsdformCollator = EsdformCollatorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
			
			EsdformCollatorDAO.Disable(MyHSs,lo_EsdformCollator, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ShipmentID,Integer ai_AirwayBillID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		EsdformCollator lo_EsdformCollator =  EsdformCollatorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = EsdformCollatorDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindAll","size="+li_size);
		List<EsdformCollator> lo_List = EsdformCollatorDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleIDPersonID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		Integer ai_PersonID = 1;
		int li_size = EsdformCollatorDAO.GetSizeByExamScheduleIDPersonID(MyHSs,ai_ExamScheduleID,ai_PersonID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDPersonID","size="+li_size);
		List<EsdformCollator> lo_List = EsdformCollatorDAO.FindByExamScheduleIDPersonID(MyHSs,ai_ExamScheduleID,ai_PersonID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDPersonID",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleIDSubjectCodeSubjectName() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		int li_size = EsdformCollatorDAO.GetSizeByExamScheduleIDSubjectCodeSubjectName(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectName","size="+li_size);
		List<EsdformCollator> lo_List = EsdformCollatorDAO.FindByExamScheduleIDSubjectCodeSubjectName(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectName",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_PersonID = 1;
		int li_size = EsdformCollatorDAO.GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_PersonID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID","size="+li_size);
		List<EsdformCollator> lo_List = EsdformCollatorDAO.FindByExamScheduleIDSubjectCodeSubjectNamePersonID(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_PersonID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindByExamScheduleIDSubjectID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		Integer ai_SubjectID = 1;
		int li_size = EsdformCollatorDAO.GetSizeByExamScheduleIDSubjectID(MyHSs,ai_ExamScheduleID,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectID","size="+li_size);
		List<EsdformCollator> lo_List = EsdformCollatorDAO.FindByExamScheduleIDSubjectID(MyHSs,ai_ExamScheduleID,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformCollatorTestDAO", "UTTestFindByExamScheduleIDSubjectID",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			EsdformCollatorTestDAO.UTTestAdd();
//			EsdformCollatorTestDAO.UTTestModify();
//			EsdformCollatorTestDAO.UTTestDelete(1,2,"EXAMWH ENGINE");
//			EsdformCollatorTestDAO.UTTestDisable(2,2,"EXAMWH ENGINE");
//			EsdformCollatorTestDAO.UTTestGetByID(1);
//			EsdformCollatorTestDAO.UTTestFindAll(0,0);
//			EsdformCollatorTestDAO.UTTestFindByExamScheduleIDPersonID();
//			EsdformCollatorTestDAO.UTTestFindByExamScheduleIDSubjectCodeSubjectName();
//			EsdformCollatorTestDAO.UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID();
//			EsdformCollatorTestDAO.UTTestFindByExamScheduleIDSubjectID();
			System.out.println(EsdformCollatorDAO.GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeCollectorNameCollectorLastName(20, "", "", 11, 1, 1, TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER, "", "", null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
