package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.EsdformCollatorDAO;
import esi.examwh.dao.EsdformEditorDAO;
import esi.examwh.dao.ExamScheduleDetailDAO;
import esi.examwh.dao.PersonDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.EsdformCollator;
import esi.examwh.model.EsdformEditor;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.Person;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class EsdformEditorTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamScheduleDetailID = null;
		Integer ai_PersonID=null;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformEditor newEsdformEditor = EsdformEditor.getNewInstance(1, 2);

		
		try {
			
//			if(ai_ExamScheduleDetailID != null){
//				ExamScheduleDetail lo_ExamScheduleDetail = ExamScheduleDetailDAO.GetByID(MyHSs, ai_ExamScheduleDetailID, null,null);
//				newEsdformEditor.setOExamScheduleDetailID(lo_ExamScheduleDetail);
//			}
//			if(ai_PersonID != null){
//				Person lo_Person = PersonDAO.GetByID(MyHSs,ai_PersonID, null,null);
//				newEsdformEditor.setOPersonID(lo_Person);
//			}
			
			newEsdformEditor.setAssignBeginDate(Common.GetCurrTime());
			newEsdformEditor.setAssignEndDate(Common.GetCurrTime());
			newEsdformEditor.setVersion(1);
			newEsdformEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			EsdformEditorDAO.Add(MyHSs,newEsdformEditor, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformEditor EsdformEditor;

		try {
			EsdformEditor = EsdformEditorDAO.GetByID(MyHSs,2,2,null,null);
		
			EsdformEditor.setOrder(1);
			EsdformEditor.setAssignBeginDate(Common.GetCurrTime());
			EsdformEditor.setAssignEndDate(Common.GetCurrTime());
			EsdformEditor.setVersion(EsdformEditor.getVersion()+1);
			EsdformEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			EsdformEditorDAO.Modify(MyHSs, EsdformEditor, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ShipmentID,Integer ai_AirwayBillID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformEditor lo_EsdformEditor;
		try {
			lo_EsdformEditor = EsdformEditorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
			EsdformEditorDAO.Delete(MyHSs, lo_EsdformEditor, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ShipmentID,Integer ai_AirwayBillID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		EsdformEditor lo_EsdformEditor;
		try {
			lo_EsdformEditor = EsdformEditorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
			
			EsdformEditorDAO.Disable(MyHSs,lo_EsdformEditor, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ShipmentID,Integer ai_AirwayBillID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		EsdformEditor lo_EsdformEditor =  EsdformEditorDAO.GetByID(MyHSs, ai_ShipmentID,ai_AirwayBillID,null,null);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = EsdformEditorDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindAll","size="+li_size);
		List<EsdformEditor> lo_List = EsdformEditorDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		int li_size = EsdformEditorDAO.GetSizeByExamScheduleID(MyHSs,ai_ExamScheduleID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindByExamScheduleID","size="+li_size);
		List<EsdformEditor> lo_List = EsdformEditorDAO.FindByExamScheduleID(MyHSs,ai_ExamScheduleID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindByExamScheduleID",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_PersonID = 1;
		int li_size = EsdformEditorDAO.GetSizeByExamScheduleIDSubjectCodeSubjectNamePersonID(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_PersonID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID","size="+li_size);
		List<EsdformEditor> lo_List = EsdformEditorDAO.FindByExamScheduleIDSubjectCodeSubjectNamePersonID(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_PersonID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "EsdformEditorTestDAO", "UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			EsdformEditorTestDAO.UTTestAdd();
//			EsdformEditorTestDAO.UTTestModify();
//			EsdformEditorTestDAO.UTTestDelete(2,3,"EXAMWH ENGINE");
//			EsdformEditorTestDAO.UTTestDisable(2,3,"EXAMWH ENGINE");
//			EsdformEditorTestDAO.UTTestGetByID(1);
//			EsdformEditorTestDAO.UTTestFindAll(0,0);
//			EsdformEditorTestDAO.UTTestFindByExamScheduleID();
//			EsdformEditorTestDAO.UTTestFindByExamScheduleIDSubjectCodeSubjectNamePersonID();
			System.out.println(EsdformEditorDAO.GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeEditorNameEditorLastName(20, "", "", 11, 1, 1, TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER, "", "", null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}