package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamAnalysisCttDAO;
import esi.examwh.dao.ExamAnalysisDAO;
import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamAnalysis;
import esi.examwh.model.ExamAnalysisCtt;
import esi.examwh.model.ExamItem;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_USED_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamAnalysisCttTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamAnalysisID = 1;
		Integer ai_ExamFormID= 1;
		Integer ai_ExamItemID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisCtt newExamAnalysisCtt = new ExamAnalysisCtt();
		try {
			if(ai_ExamAnalysisID != null){
				ExamAnalysis lo_ExamAnalysis = ExamAnalysisDAO.GetByID(MyHSs,ai_ExamAnalysisID, null,null);
				newExamAnalysisCtt.setOExamAnalysis(lo_ExamAnalysis);
			}
			
			if(ai_ExamItemID != null){
				ExamItem lo_ExamItem = ExamItemDAO.GetByID(MyHSs,ai_ExamItemID, null,null);
				newExamAnalysisCtt.setOExamItem(lo_ExamItem);
			}
			newExamAnalysisCtt.setCollectAnswer(1);
			newExamAnalysisCtt.setChoice1PValue(1.0);
			newExamAnalysisCtt.setChoice1RValue(1.0);
			newExamAnalysisCtt.setChoice2PValue(1.0);
			newExamAnalysisCtt.setChoice2RValue(1.0);
			newExamAnalysisCtt.setChoice3PValue(1.0);
			newExamAnalysisCtt.setChoice3RValue(1.0);
			newExamAnalysisCtt.setChoice4PValue(1.0);
			newExamAnalysisCtt.setChoice4RValue(1.0);
			newExamAnalysisCtt.setChoice5PValue(1.0);
			newExamAnalysisCtt.setChoice5RValue(1.0);
			newExamAnalysisCtt.setUsedStatus(TYPE_USED_STATUS.STATUS_USED);
			newExamAnalysisCtt.setNOFCorrectExaminer(10);
			newExamAnalysisCtt.setNOFWrongExaminer(10);
			newExamAnalysisCtt.setVersion(1);
			newExamAnalysisCtt.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamAnalysisCttDAO.Add(MyHSs,newExamAnalysisCtt, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisCtt ExamAnalysisCtt;

		try {
			
			ExamAnalysisCtt = ExamAnalysisCttDAO.GetByID(MyHSs,2,null,null);
			
			ExamAnalysisCtt.setCollectAnswer(5);
			ExamAnalysisCtt.setChoice1PValue(3.0);
			ExamAnalysisCtt.setChoice1RValue(3.0);
			ExamAnalysisCtt.setChoice2PValue(3.0);
			ExamAnalysisCtt.setChoice2RValue(3.0);
			ExamAnalysisCtt.setChoice3PValue(3.0);
			ExamAnalysisCtt.setChoice3RValue(3.0);
			ExamAnalysisCtt.setChoice4PValue(3.0);
			ExamAnalysisCtt.setChoice4RValue(2.0);
			ExamAnalysisCtt.setChoice5PValue(3.0);
			ExamAnalysisCtt.setChoice5RValue(4.0);
			ExamAnalysisCtt.setUsedStatus(TYPE_USED_STATUS.STATUS_USED);
			ExamAnalysisCtt.setNOFCorrectExaminer(20);
			ExamAnalysisCtt.setNOFWrongExaminer(20);
			ExamAnalysisCtt.setVersion(ExamAnalysisCtt.getVersion()+1);
			ExamAnalysisCtt.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamAnalysisCttDAO.Modify(MyHSs, ExamAnalysisCtt, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamAnalysisCtt,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisCtt ExamAnalysisCtt;
		try {
			ExamAnalysisCtt = ExamAnalysisCttDAO.GetByID(MyHSs, ai_ExamAnalysisCtt,null,null);
			
			ExamAnalysisCttDAO.Delete(MyHSs, ExamAnalysisCtt, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamAnalysisCtt,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisCtt ExamAnalysisCtt;
		try {
			ExamAnalysisCtt = ExamAnalysisCttDAO.GetByID(MyHSs, ai_ExamAnalysisCtt,null,null);
			ExamAnalysisCtt.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamAnalysisCttDAO.Disable(MyHSs, ExamAnalysisCtt, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamAnalysisCtt) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamAnalysisCtt lo_ExamAnalysisCtt=ExamAnalysisCttDAO.GetByID(MyHSs, ai_ExamAnalysisCtt,null,null);
		System.out.print("ExamAnalysisCttTestDAO GETbyID  ExamAnalysisCttID="+ai_ExamAnalysisCtt);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamAnalysisCttDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamAnalysisCtt> lo_List = ExamAnalysisCttDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	
	public static void UTTestFindByExamItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamAnalysisCttDAO.GetSizeByExamItemID(MyHSs,ai_ExamItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindByExamItemID","size="+li_size);
		List<ExamAnalysisCtt> lo_List = ExamAnalysisCttDAO.FindByExamItemID(MyHSs,ai_ExamItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindByExamItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	
	public static void UTTestFindByExamItemIDUsedStatus() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamAnalysisCttDAO.GetSizeByExamItemIDUsedStatus(MyHSs,ai_ExamItemID,TYPE_USED_STATUS.STATUS_UNUSE,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindByExamItemIDUsedStatus","size="+li_size);
		List<ExamAnalysisCtt> lo_List = ExamAnalysisCttDAO.FindByExamItemIDUsedStatus(MyHSs,ai_ExamItemID,TYPE_USED_STATUS.STATUS_UNUSE,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindByExamItemIDUsedStatus",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	
	public static void UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID = 1;
		Integer ai_ExamRoundID = 1;
		TYPE_EXAMINATION ae_TypeExamination = TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER;
		String as_ExamFormName = "";
		int li_size = ExamAnalysisCttDAO.GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(MyHSs,as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ae_TypeExamination,as_ExamFormName,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName","size="+li_size);
		List<ExamAnalysisCtt> lo_List = ExamAnalysisCttDAO.FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName(MyHSs,as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ae_TypeExamination,as_ExamFormName,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNames",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	public static void UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID = 1;
		Integer ai_ExamRoundID = 1;
		TYPE_EXAMINATION ae_TypeExamination = TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER;
		String as_ExamFormName = "";
		Integer ai_UnitOrder = 1;
		int li_size = ExamAnalysisCttDAO.GetSizeBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(MyHSs,as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ae_TypeExamination,as_ExamFormName,ai_UnitOrder,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder","size="+li_size);
		List<ExamAnalysisCtt> lo_List = ExamAnalysisCttDAO.FindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder(MyHSs,as_SubjectCode, as_SubjectName,ai_ExamYearID, ai_ExamSemesterID,ai_ExamRoundID,ae_TypeExamination,as_ExamFormName,ai_UnitOrder,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisCttTestDAO", "UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNamesUnitOrder",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamAnalysisCttTestDAO.UTTestAdd();
//			ExamAnalysisCttTestDAO.UTTestModify();
//			ExamAnalysisCttTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamAnalysisCttTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamAnalysisCttTestDAO.UTTestGetByID();
//			ExamAnalysisCttTestDAO.UTTestFindAll(0,0);
//			ExamAnalysisCttTestDAO.UTTestFindByExamItemID();
//			UTTestFindByExamItemIDUsedStatus();
//			UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormName();
//			UTTestFindBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormNameUnitOrder();
			System.out.println(ExamAnalysisCttDAO.GenSQLByExamAnalysisID(20, 163, null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
