package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamAnalysisCttDAO;
import esi.examwh.dao.ExamAnalysisIrtDAO;
import esi.examwh.dao.ExamAnalysisDAO;
import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamAnalysis;
import esi.examwh.model.ExamAnalysisCtt;
import esi.examwh.model.ExamAnalysisIrt;
import esi.examwh.model.ExamItem;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_USED_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamAnalysisIrtTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamAnalysisID = 1;
		Integer ai_ExamItemID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisIrt newExamAnalysisIrt = new ExamAnalysisIrt();
		try {
			if(ai_ExamAnalysisID != null){
				ExamAnalysis lo_ExamAnalysis = ExamAnalysisDAO.GetByID(MyHSs,ai_ExamAnalysisID, null,null);
				newExamAnalysisIrt.setOExamAnalysis(lo_ExamAnalysis);
			}
	
			if(ai_ExamItemID != null){
				ExamItem lo_ExamItem = ExamItemDAO.GetByID(MyHSs,ai_ExamItemID, null,null);
				newExamAnalysisIrt.setOExamItem(lo_ExamItem);
			}
			newExamAnalysisIrt.setAValue(10.0);
			newExamAnalysisIrt.setBValue(20.0);
			newExamAnalysisIrt.setCValue(30.0);
			newExamAnalysisIrt.setBiserialValue(29.88);
			newExamAnalysisIrt.setUsedStatus(TYPE_USED_STATUS.STATUS_UNUSE);
			newExamAnalysisIrt.setVersion(1);
			newExamAnalysisIrt.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamAnalysisIrtDAO.Add(MyHSs,newExamAnalysisIrt, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisIrt ExamAnalysisIrt;

		try {
			
			ExamAnalysisIrt = ExamAnalysisIrtDAO.GetByID(MyHSs,1,null,null);
			
			ExamAnalysisIrt.setAValue(10.1);
			ExamAnalysisIrt.setBValue(2.2);
			ExamAnalysisIrt.setCValue(3.3);
			ExamAnalysisIrt.setBiserialValue(55.1);
			ExamAnalysisIrt.setUsedStatus(TYPE_USED_STATUS.STATUS_USED);
			ExamAnalysisIrt.setVersion(ExamAnalysisIrt.getVersion()+1);
			ExamAnalysisIrt.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamAnalysisIrtDAO.Modify(MyHSs, ExamAnalysisIrt, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamAnalysisIrt,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisIrt ExamAnalysisIrt;
		try {
			ExamAnalysisIrt = ExamAnalysisIrtDAO.GetByID(MyHSs, ai_ExamAnalysisIrt,null,null);
			
			ExamAnalysisIrtDAO.Delete(MyHSs, ExamAnalysisIrt, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamAnalysisIrt,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysisIrt ExamAnalysisIrt;
		try {
			ExamAnalysisIrt = ExamAnalysisIrtDAO.GetByID(MyHSs, ai_ExamAnalysisIrt,null,null);
			ExamAnalysisIrt.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamAnalysisIrtDAO.Disable(MyHSs, ExamAnalysisIrt, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamAnalysisIrt) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamAnalysisIrt lo_ExamAnalysisIrt=ExamAnalysisIrtDAO.GetByID(MyHSs, ai_ExamAnalysisIrt,null,null);
		System.out.print("ExamAnalysisIrtTestDAO GETbyID  ExamAnalysisIrtID="+ai_ExamAnalysisIrt);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamAnalysisIrtDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamAnalysisIrt> lo_List = ExamAnalysisIrtDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamAnalysisIrtDAO.GetSizeByExamItemID(MyHSs,ai_ExamItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindByExamItemID","size="+li_size);
		List<ExamAnalysisIrt> lo_List = ExamAnalysisIrtDAO.FindByExamItemID(MyHSs,ai_ExamItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindByExamItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	public static void UTTestFindByExamItemIDUsedStatus() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamAnalysisIrtDAO.GetSizeByExamItemIDUsedStatus(MyHSs,ai_ExamItemID,TYPE_USED_STATUS.STATUS_UNUSE,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindByExamItemIDUsedStatus","size="+li_size);
		List<ExamAnalysisIrt> lo_List = ExamAnalysisIrtDAO.FindByExamItemIDUsedStatus(MyHSs,ai_ExamItemID,TYPE_USED_STATUS.STATUS_UNUSE,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisIrtTestDAO", "UTTestFindByExamItemIDUsedStatus",lo_List.get(i).toString());
		}
		MyHSs.close();
		
	}
	public static void main(String[] args) {
		try{
			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamAnalysisIrtTestDAO.UTTestAdd();
//			ExamAnalysisIrtTestDAO.UTTestModify();
//			ExamAnalysisIrtTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamAnalysisIrtTestDAO.UTTestDisable(3,"Pailin Lert");
//			ExamAnalysisIrtTestDAO.UTTestGetByID();
//			ExamAnalysisIrtTestDAO.UTTestFindAll(0,0);
//			ExamAnalysisIrtTestDAO.UTTestFindByExamItemID();
			ExamAnalysisIrtTestDAO.UTTestFindByExamItemIDUsedStatus();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
