package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamAnalysisDAO;
import esi.examwh.dao.ExamScheduleDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamAnalysis;
import esi.examwh.model.ExamSchedule;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamAnalysisTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamScheduleID = -1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysis newExamAnalysis = new ExamAnalysis();
		try {
		
			if(ai_ExamScheduleID != null){
				ExamSchedule lo_ExamSchedule = ExamScheduleDAO.GetByID(MyHSs,2, null,null);
				newExamAnalysis.setOExamSchedule(lo_ExamSchedule);
			}
			
			newExamAnalysis.setNOFStudent(359);
			newExamAnalysis.setVersion(1);
			newExamAnalysis.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamAnalysisDAO.Add(MyHSs,newExamAnalysis, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysis ExamAnalysis;

		try {
			
			ExamAnalysis = ExamAnalysisDAO.GetByID(MyHSs,2,null,null);
			
			ExamAnalysis.setNOFStudent(450);
			ExamAnalysis.setVersion(ExamAnalysis.getVersion()+1);
			ExamAnalysis.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamAnalysisDAO.Modify(MyHSs, ExamAnalysis, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamAnalysis,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysis ExamAnalysis;
		try {
			ExamAnalysis = ExamAnalysisDAO.GetByID(MyHSs, ai_ExamAnalysis,null,null);
			
			ExamAnalysisDAO.Delete(MyHSs, ExamAnalysis, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamAnalysis,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamAnalysis ExamAnalysis;
		try {
			ExamAnalysis = ExamAnalysisDAO.GetByID(MyHSs, ai_ExamAnalysis,null,null);
			ExamAnalysis.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamAnalysisDAO.Disable(MyHSs, ExamAnalysis, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamAnalysis) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamAnalysis lo_ExamAnalysis=ExamAnalysisDAO.GetByID(MyHSs, ai_ExamAnalysis,null,null);
		System.out.print("ExamAnalysisTestDAO GETbyID  ExamAnalysisID="+ai_ExamAnalysis);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamAnalysisDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamAnalysis> lo_List = ExamAnalysisDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamScheduleID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		int li_size = ExamAnalysisDAO.GetSizeByExamScheduleID(MyHSs,ai_ExamScheduleID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamScheduleID","size="+li_size);
		List<ExamAnalysis> lo_List = ExamAnalysisDAO.FindByExamScheduleID(MyHSs,ai_ExamScheduleID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamScheduleID",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindByExamFormID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		int li_size = ExamAnalysisDAO.GetSizeByExamFormID(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamFormID","size="+li_size);
		List<ExamAnalysis> lo_List = ExamAnalysisDAO.FindByExamFormID(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamFormID",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamAnalysisDAO.GetSizeByExamItemID(MyHSs,ai_ExamItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamItemID","size="+li_size);
		List<ExamAnalysis> lo_List = ExamAnalysisDAO.FindByExamItemID(MyHSs,ai_ExamItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAnalysisTestDAO", "UTTestFindByExamItemID",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamAnalysisTestDAO.UTTestAdd();
//			ExamAnalysisTestDAO.UTTestModify();
//			ExamAnalysisTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamAnalysisTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamAnalysisTestDAO.UTTestGetByID();
//			ExamAnalysisTestDAO.UTTestFindAll(0,0);
	//		UTTestFindByExamScheduleID();
	//		UTTestFindByExamFormID();
//			UTTestFindByExamItemID();
//			System.out.println(ExamAnalysisDAO.GenSQLBySubjectCodeSubjectNameExamYearIDExamSemesterIDExamRoundIDExaminationTypeExamFormCodeExamFormName(20, "", "", 1, 1, 1, TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER, null, "", null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}