package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamAnalysisHistogramDAO;
import esi.examwh.dao.ExamFormAnalysisHistoryDAO;
import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamFormAnalysisHistory;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamFormAnalysisHistoryTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamFormID = -1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormAnalysisHistory newExamFormAnalysisHistory = new ExamFormAnalysisHistory();
		try {
			if(ai_ExamFormID != null){
				ExamForm lo_ExamForm = ExamFormDAO.GetByID(MyHSs,1, null,null);
				newExamFormAnalysisHistory.setOExamForm(lo_ExamForm);
			}
			newExamFormAnalysisHistory.setAverageValue(10.0);
			newExamFormAnalysisHistory.setAverageValuePerUnit(1.1);
			newExamFormAnalysisHistory.setNOFExam(100);
			newExamFormAnalysisHistory.setNOFStudent(100);
			newExamFormAnalysisHistory.setNOFStudentAnalysis(80);
			newExamFormAnalysisHistory.setExamFormScore(100.0);
			newExamFormAnalysisHistory.setMaxStudentScore(100.0);
			newExamFormAnalysisHistory.setMinStudentScore(0.0);
			newExamFormAnalysisHistory.setDistance(0.0);
			newExamFormAnalysisHistory.setMedian(50.0);
			newExamFormAnalysisHistory.setMode(10.0);
			newExamFormAnalysisHistory.setSkewness(10.0);
			newExamFormAnalysisHistory.setStandardDeviation(10.0);
			newExamFormAnalysisHistory.setKurtosis(10.0);
			newExamFormAnalysisHistory.setKR20(20.1);
			newExamFormAnalysisHistory.setKR21(21.1);
			newExamFormAnalysisHistory.setVersion(1);
			newExamFormAnalysisHistory.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamFormAnalysisHistoryDAO.Add(MyHSs,newExamFormAnalysisHistory, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormAnalysisHistory ExamFormAnalysisHistory;
		try {
			
			ExamFormAnalysisHistory = ExamFormAnalysisHistoryDAO.GetByID(MyHSs,2,null,null);
			ExamFormAnalysisHistory.setAverageValue(20.0);
			ExamFormAnalysisHistory.setAverageValuePerUnit(1.2);
			ExamFormAnalysisHistory.setNOFExam(200);
			ExamFormAnalysisHistory.setNOFStudent(200);
			ExamFormAnalysisHistory.setNOFStudentAnalysis(200);
			ExamFormAnalysisHistory.setExamFormScore(100.0);
			ExamFormAnalysisHistory.setMaxStudentScore(100.0);
			ExamFormAnalysisHistory.setMinStudentScore(0.0);
			ExamFormAnalysisHistory.setDistance(0.0);
			ExamFormAnalysisHistory.setMedian(50.0);
			ExamFormAnalysisHistory.setMode(10.0);
			ExamFormAnalysisHistory.setSkewness(10.0);
			ExamFormAnalysisHistory.setStandardDeviation(10.0);
			ExamFormAnalysisHistory.setKurtosis(10.0);
			ExamFormAnalysisHistory.setKR20(20.2);
			ExamFormAnalysisHistory.setKR21(21.2);
			ExamFormAnalysisHistory.setVersion(ExamFormAnalysisHistory.getVersion()+1);
			ExamFormAnalysisHistory.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamFormAnalysisHistoryDAO.Modify(MyHSs, ExamFormAnalysisHistory, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamFormAnalysisHistory,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormAnalysisHistory ExamFormAnalysisHistory;
		try {
			ExamFormAnalysisHistory = ExamFormAnalysisHistoryDAO.GetByID(MyHSs, ai_ExamFormAnalysisHistory,null,null);
			
			ExamFormAnalysisHistoryDAO.Delete(MyHSs, ExamFormAnalysisHistory, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamFormAnalysisHistory,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormAnalysisHistory ExamFormAnalysisHistory;
		try {
			ExamFormAnalysisHistory = ExamFormAnalysisHistoryDAO.GetByID(MyHSs, ai_ExamFormAnalysisHistory,null,null);
			ExamFormAnalysisHistory.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamFormAnalysisHistoryDAO.Disable(MyHSs, ExamFormAnalysisHistory, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamFormAnalysisHistory) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamFormAnalysisHistory lo_ExamFormAnalysisHistory=ExamFormAnalysisHistoryDAO.GetByID(MyHSs, ai_ExamFormAnalysisHistory,null,null);
		System.out.print("ExamFormAnalysisHistoryTestDAO GETbyID  ExamFormAnalysisHistoryID="+ai_ExamFormAnalysisHistory);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamFormAnalysisHistoryDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamFormAnalysisHistory> lo_List = ExamFormAnalysisHistoryDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormAnalysisHistoryTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamFormAnalysisHistoryTestDAO.UTTestAdd();
//			ExamFormAnalysisHistoryTestDAO.UTTestModify();
//			ExamFormAnalysisHistoryTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamFormAnalysisHistoryTestDAO.UTTestDisable(3,"Pailin Lert");
//			ExamFormAnalysisHistoryTestDAO.UTTestGetByID();
//			ExamFormAnalysisHistoryTestDAO.UTTestFindAll(0,0);
			System.out.println(ExamAnalysisHistogramDAO.GenSQLByExamScheduleID(20, 37, null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}