package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamFormCommandDAO;
import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.ExamScheduleDetailDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamFormCommand;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamFormCommandTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamFormID = -1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormCommand newExamFormCommand = new ExamFormCommand();
		try {
			if(ai_ExamFormID != null){
				ExamForm lo_ExamForm = ExamFormDAO.GetByID(MyHSs,4, null,null);
				newExamFormCommand.setOExamForm(lo_ExamForm);
			}
			
		
			newExamFormCommand.setAboveItemOrder(10);
			newExamFormCommand.setText("TEXT");
			newExamFormCommand.setVersion(1);
			newExamFormCommand.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamFormCommandDAO.Add(MyHSs,newExamFormCommand, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormCommand ExamFormCommand;
		try {
			
			ExamFormCommand = ExamFormCommandDAO.GetByID(MyHSs,2,null,null);
			ExamFormCommand.setAboveItemOrder(5);
			ExamFormCommand.setText("�?ำสั�?�?�?ทร�?");
			ExamFormCommand.setVersion(ExamFormCommand.getVersion()+1);
			ExamFormCommand.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamFormCommandDAO.Modify(MyHSs, ExamFormCommand, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamFormCommand,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormCommand ExamFormCommand;
		try {
			ExamFormCommand = ExamFormCommandDAO.GetByID(MyHSs, ai_ExamFormCommand,null,null);
			
			ExamFormCommandDAO.Delete(MyHSs, ExamFormCommand, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamFormCommand,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormCommand ExamFormCommand;
		try {
			ExamFormCommand = ExamFormCommandDAO.GetByID(MyHSs, ai_ExamFormCommand,null,null);
			ExamFormCommand.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamFormCommandDAO.Disable(MyHSs, ExamFormCommand, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamFormCommand) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamFormCommand lo_ExamFormCommand=ExamFormCommandDAO.GetByID(MyHSs, ai_ExamFormCommand,null,null);
		System.out.print("ExamFormCommandTestDAO GETbyID  ExamFormCommandID="+ai_ExamFormCommand);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamFormCommandDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamFormCommand> lo_List = ExamFormCommandDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		int li_size = ExamFormCommandDAO.GetSizeByExamFormID(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindByExamFormID","size="+li_size);
		List<ExamFormCommand> lo_List = ExamFormCommandDAO.FindByExamFormID(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindByExamFormID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormIDAboveItemOrder() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		Integer ai_AboveItemOrder = 1;
		int li_size = ExamFormCommandDAO.GetSizeByExamFormIDAboveItemOrder(MyHSs,ai_ExamFormID,ai_AboveItemOrder,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindByExamFormIDAboveItemOrder","size="+li_size);
		List<ExamFormCommand> lo_List = ExamFormCommandDAO.FindByExamFormIDAboveItemOrder(MyHSs,ai_ExamFormID,ai_AboveItemOrder,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormCommandTestDAO", "UTTestFindByExamFormIDAboveItemOrder",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamFormCommandTestDAO.UTTestAdd();
//			ExamFormCommandTestDAO.UTTestModify();
//			ExamFormCommandTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamFormCommandTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamFormCommandTestDAO.UTTestGetByID();
//			ExamFormCommandTestDAO.UTTestFindAll(0,0);
//			ExamFormCommandTestDAO.UTTestFindByExamFormID();
			ExamFormCommandTestDAO.UTTestFindByExamFormIDAboveItemOrder();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
