package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.BehaviorLevelDAO;
import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.ExamFormDocumentDAO;
import esi.examwh.dao.ExamFormItemDAO;
import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.ExamItemDocumentDAO;
import esi.examwh.dao.ObjectiveDAO;
import esi.examwh.dao.SectionDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.TopicDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.BehaviorLevel;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamFormDocument;
import esi.examwh.model.ExamFormItem;
import esi.examwh.model.ExamItem;
import esi.examwh.model.ExamItemDocument;
import esi.examwh.model.Objective;
import esi.examwh.model.Section;
import esi.examwh.model.Subject;
import esi.examwh.model.Topic;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_CONTENT;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamFormDocumentTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamFormItemID = 3;
		Integer ai_ExamFormID = 1;
		Integer ai_ExamItemDocumentID =2;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormDocument newExamFormDocument = new ExamFormDocument();
		try {
			if(ai_ExamFormItemID != null){
				ExamFormItem lo_ExamFormItem = ExamFormItemDAO.GetByID(MyHSs,ai_ExamFormItemID, null,null);
				newExamFormDocument.setOExamFormItem(lo_ExamFormItem);
			}
			if(ai_ExamFormID != null){
				ExamForm lo_ExamForm = ExamFormDAO.GetByID(MyHSs,ai_ExamFormID, null,null);
				newExamFormDocument.setOExamForm(lo_ExamForm);
			}
			if(ai_ExamItemDocumentID != null){
				ExamItemDocument lo_ExamItemDocument = ExamItemDocumentDAO.GetByID(MyHSs,ai_ExamItemDocumentID, null,null);
				newExamFormDocument.setOCopiedExamItemDocument(lo_ExamItemDocument);
			}
			newExamFormDocument.setOrder(1);
			newExamFormDocument.setCode("4888");
			newExamFormDocument.setName("CN4888");
			newExamFormDocument.setNOFPage(129);
			newExamFormDocument.setContentMD5("ContentMD5");
			newExamFormDocument.setContentType(TYPE_CONTENT.TYPE_CONTENT_WORD);
			newExamFormDocument.setContentModifyTime(Common.GetCurrTime());
			newExamFormDocument.setContentModifyUser("ContentModifyUser");
			newExamFormDocument.setVersion(1);
			newExamFormDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamFormDocumentDAO.Add(MyHSs,newExamFormDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormDocument ExamFormDocument;
		try {
			
			ExamFormDocument = ExamFormDocumentDAO.GetByID(MyHSs,2,null,null);
			ExamFormDocument.setCode("4554");
			ExamFormDocument.setOrder(3);
			ExamFormDocument.setName("CN4554");
			ExamFormDocument.setNOFPage(129);
			ExamFormDocument.setContentMD5("ContentMD5 %%%");
			ExamFormDocument.setContentType(TYPE_CONTENT.TYPE_CONTENT_PDF);
			ExamFormDocument.setContentModifyTime(Common.GetCurrTime());
			ExamFormDocument.setContentModifyUser("ContentModifyUser");
			ExamFormDocument.setVersion(ExamFormDocument.getVersion()+1);
			ExamFormDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamFormDocumentDAO.Modify(MyHSs, ExamFormDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamFormDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormDocument ExamFormDocument;
		try {
			ExamFormDocument = ExamFormDocumentDAO.GetByID(MyHSs, ai_ExamFormDocument,null,null);
			
			ExamFormDocumentDAO.Delete(MyHSs, ExamFormDocument, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamFormDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormDocument ExamFormDocument;
		try {
			ExamFormDocument = ExamFormDocumentDAO.GetByID(MyHSs, ai_ExamFormDocument,null,null);
			ExamFormDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamFormDocumentDAO.Disable(MyHSs, ExamFormDocument, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamFormDocument) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamFormDocument lo_ExamFormDocument=ExamFormDocumentDAO.GetByID(MyHSs, ai_ExamFormDocument,null,null);
		System.out.print("ExamFormDocumentTestDAO GETbyID  ExamFormDocumentID="+ai_ExamFormDocument);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamFormDocumentDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		int li_size = ExamFormDocumentDAO.GetSizeByExamFormID(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormID","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindByExamFormID(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByCopiedExamItemDocumentID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_CopiedExamItemDocumentID = 1;
		int li_size = ExamFormDocumentDAO.GetSizeByCopiedExamItemDocumentID(MyHSs,ai_CopiedExamItemDocumentID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByCopiedExamItemDocumentID","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindByCopiedExamItemDocumentID(MyHSs,ai_CopiedExamItemDocumentID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByCopiedExamItemDocumentID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormIDExamFormItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		Integer ai_ExamFormItemID = 1;
		int li_size = ExamFormDocumentDAO.GetSizeByExamFormIDExamFormItemID(MyHSs,ai_ExamFormID, ai_ExamFormItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormID","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindByExamFormIDExamFormItemID(MyHSs,ai_ExamFormID,ai_ExamFormItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormIDExamFormItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormIDExamFormItemGroupID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		Integer ai_ExamFormItemGroupID = 1;
		int li_size = ExamFormDocumentDAO.GetSizeByExamFormIDExamFormItemGroupID(MyHSs,ai_ExamFormID, ai_ExamFormItemGroupID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormIDExamFormItemGroupID","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindByExamFormIDExamFormItemGroupID(MyHSs,ai_ExamFormID,ai_ExamFormItemGroupID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormIDExamFormItemGroupID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormIDInCopiedExamItemDocument() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 18;
		int li_size = ExamFormDocumentDAO.GetSizeByExamFormIDInCopiedExamItemDocument(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormIDInCopiedExamItemDocument","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindByExamFormIDInCopiedExamItemDocument(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindByExamFormIDInCopiedExamItemDocument",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestGetMaxOrderByExamFormID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 18;
		int li_size = ExamFormDocumentDAO.GetMaxOrderByExamFormID(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestGetMaxOrderByExamFormID","order="+li_size);
		
		MyHSs.close();
	}
	
	public static void UTTestFindBySubjectDocumentID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_SubjectDocumentID = 18;
		int li_size = ExamFormDocumentDAO.GetSizeBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindBySubjectDocumentID","size="+li_size);
		List<ExamFormDocument> lo_List = ExamFormDocumentDAO.FindBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormDocumentTestDAO", "UTTestFindBySubjectDocumentID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamFormDocumentTestDAO.UTTestAdd();
//			ExamFormDocumentTestDAO.UTTestModify();
//			ExamFormDocumentTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamFormDocumentTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamFormDocumentTestDAO.UTTestGetByID();
//			ExamFormDocumentTestDAO.UTTestFindAll(0,0);
//			ExamFormDocumentTestDAO.UTTestFindByExamFormID();
//			ExamFormDocumentTestDAO.UTTestFindByExamFormIDExamFormItemID();
//			ExamFormDocumentTestDAO.UTTestFindByExamFormIDExamFormItemGroupID();
//			ExamFormDocumentTestDAO.UTTestFindByCopiedExamItemDocumentID();
//			ExamFormDocumentTestDAO.UTTestFindByExamFormIDInCopiedExamItemDocument();
//			ExamFormDocumentTestDAO.UTTestGetMaxOrderByExamFormID();
			ExamFormDocumentTestDAO.UTTestFindBySubjectDocumentID() ;
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
