package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.BehaviorLevelDAO;
import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.ExamFormItemChoiceDAO;
import esi.examwh.dao.ExamFormItemDAO;
import esi.examwh.dao.ExamItemChoiceDAO;
import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.ObjectiveDAO;
import esi.examwh.dao.SectionDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.TopicDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.BehaviorLevel;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamFormItem;
import esi.examwh.model.ExamFormItemChoice;
import esi.examwh.model.ExamItem;
import esi.examwh.model.ExamItemChoice;
import esi.examwh.model.Objective;
import esi.examwh.model.Section;
import esi.examwh.model.Subject;
import esi.examwh.model.Topic;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_ANSWER_STATUS;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamFormItemChoiceTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		
		Integer ai_ExamItemChoiceID = 1;
		Integer ai_ExamFormItemID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormItemChoice newExamFormItemChoice = new ExamFormItemChoice();
		try {
			if(ai_ExamItemChoiceID != null){
				ExamItemChoice lo_ExamItemChoice = ExamItemChoiceDAO.GetByID(MyHSs,ai_ExamItemChoiceID, null,null);
				newExamFormItemChoice.setOExamItemChoice(lo_ExamItemChoice);
			}
			if(ai_ExamFormItemID != null){
				ExamFormItem lo_ExamFormItem = ExamFormItemDAO.GetByID(MyHSs,ai_ExamFormItemID, null,null);
				newExamFormItemChoice.setOExamFormItem(lo_ExamFormItem);
			}
			
			newExamFormItemChoice.setOrder(1);
			newExamFormItemChoice.setDisplayOrder(10);
			newExamFormItemChoice.setAnswerStatus(TYPE_ANSWER_STATUS.STATUS_ANSWER_CORRECT);
			newExamFormItemChoice.setPValue(10.0);
			newExamFormItemChoice.setRValue(100.0);
			newExamFormItemChoice.setImageGenTime(Common.GetCurrTime());
			newExamFormItemChoice.setDocModifyTime(Common.GetCurrTime());
			newExamFormItemChoice.setChoiceText("ChoiceText");
			newExamFormItemChoice.setChoiceMD5("ChoiceMD5");
			newExamFormItemChoice.setVersion(1);
			newExamFormItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamFormItemChoiceDAO.Add(MyHSs,newExamFormItemChoice, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormItemChoice ExamFormItemChoice;
		try {
			
			ExamFormItemChoice = ExamFormItemChoiceDAO.GetByID(MyHSs,2,null,null);
			ExamFormItemChoice.setOrder(3);
			ExamFormItemChoice.setDisplayOrder(5);
			ExamFormItemChoice.setAnswerStatus(TYPE_ANSWER_STATUS.STATUS_ANSWER_WRONG);
			ExamFormItemChoice.setPValue(20.0);
			ExamFormItemChoice.setRValue(200.0);
			ExamFormItemChoice.setImageGenTime(Common.GetCurrTime());
			ExamFormItemChoice.setDocModifyTime(Common.GetCurrTime());
			ExamFormItemChoice.setChoiceText("ChoiceText TTT");
			ExamFormItemChoice.setChoiceMD5("ChoiceMD5 TTT");
			ExamFormItemChoice.setVersion(ExamFormItemChoice.getVersion()+1);
			ExamFormItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamFormItemChoiceDAO.Modify(MyHSs, ExamFormItemChoice, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamFormItemChoice,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormItemChoice ExamFormItemChoice;
		try {
			ExamFormItemChoice = ExamFormItemChoiceDAO.GetByID(MyHSs, ai_ExamFormItemChoice,null,null);
			
			ExamFormItemChoiceDAO.Delete(MyHSs, ExamFormItemChoice, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamFormItemChoice,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormItemChoice ExamFormItemChoice;
		try {
			ExamFormItemChoice = ExamFormItemChoiceDAO.GetByID(MyHSs, ai_ExamFormItemChoice,null,null);
			ExamFormItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamFormItemChoiceDAO.Disable(MyHSs, ExamFormItemChoice, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamFormItemChoice) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamFormItemChoice lo_ExamFormItemChoice=ExamFormItemChoiceDAO.GetByID(MyHSs, ai_ExamFormItemChoice,null,null);
		System.out.print("ExamFormItemChoiceTestDAO GETbyID  ExamFormItemChoiceID="+ai_ExamFormItemChoice);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamFormItemChoiceDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamFormItemChoice> lo_List = ExamFormItemChoiceDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormItemID = 1;
		int li_size = ExamFormItemChoiceDAO.GetSizeByExamFormItemID(MyHSs,ai_ExamFormItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindByExamFormItemID","size="+li_size);
		List<ExamFormItemChoice> lo_List = ExamFormItemChoiceDAO.FindByExamFormItemID(MyHSs,ai_ExamFormItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindByExamFormItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	
	public static void UTTestFindByExamFormItemIDOrderByDisplayOrder() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormItemID = 1;
		int li_size = ExamFormItemChoiceDAO.GetSizeByExamFormItemIDOrderByDisplayOrder(MyHSs,ai_ExamFormItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindByExamFormItemIDOrderByDisplayOrder","size="+li_size);
		List<ExamFormItemChoice> lo_List = ExamFormItemChoiceDAO.FindByExamFormItemIDOrderByDisplayOrder(MyHSs,ai_ExamFormItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceTestDAO", "UTTestFindByExamFormItemIDOrderByDisplayOrder",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamFormItemChoiceTestDAO.UTTestAdd();
//			ExamFormItemChoiceTestDAO.UTTestModify();
//			ExamFormItemChoiceTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamFormItemChoiceTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamFormItemChoiceTestDAO.UTTestGetByID();
			ExamFormItemChoiceTestDAO.UTTestFindAll(0,0);
//			ExamFormItemChoiceTestDAO.UTTestFindByExamFormItemID();
//			ExamFormItemChoiceTestDAO.UTTestFindByExamFormItemIDOrderByDisplayOrder();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
