package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamFormDAO;
import esi.examwh.dao.ExamFormOperationLogDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamForm;
import esi.examwh.model.ExamFormOperationLog;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamFormOperationLogTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamFormID = -1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormOperationLog newExamFormOperationLog = new ExamFormOperationLog();
		try {
			if(ai_ExamFormID != null){
				ExamForm lo_ExamForm = ExamFormDAO.GetByID(MyHSs,1, null,null);
				newExamFormOperationLog.setOExamForm(lo_ExamForm);
			}
			newExamFormOperationLog.setCode("OC100");
			newExamFormOperationLog.setOrder(1);
			newExamFormOperationLog.setOperation("Operation");
			newExamFormOperationLog.setOperationDetail("OperationDetail");
			newExamFormOperationLog.setOperationUser("OperationUser");
			newExamFormOperationLog.setVersion(1);
			newExamFormOperationLog.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamFormOperationLogDAO.Add(MyHSs,newExamFormOperationLog, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormOperationLog ExamFormOperationLog;
		try {
			
			ExamFormOperationLog = ExamFormOperationLogDAO.GetByID(MyHSs,2,null,null);
			ExamFormOperationLog.setCode("OC200");
			ExamFormOperationLog.setOrder(2);
			ExamFormOperationLog.setOperation("Operation"+ExamFormOperationLog.getOrder());
			ExamFormOperationLog.setOperationDetail("OperationDetail"+ExamFormOperationLog.getOrder());
			ExamFormOperationLog.setOperationUser("OperationUser"+ExamFormOperationLog.getOrder());
			ExamFormOperationLog.setVersion(ExamFormOperationLog.getVersion()+1);
			ExamFormOperationLog.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamFormOperationLogDAO.Modify(MyHSs, ExamFormOperationLog, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamFormOperationLog,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormOperationLog ExamFormOperationLog;
		try {
			ExamFormOperationLog = ExamFormOperationLogDAO.GetByID(MyHSs, ai_ExamFormOperationLog,null,null);
			
			ExamFormOperationLogDAO.Delete(MyHSs, ExamFormOperationLog, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamFormOperationLog,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamFormOperationLog ExamFormOperationLog;
		try {
			ExamFormOperationLog = ExamFormOperationLogDAO.GetByID(MyHSs, ai_ExamFormOperationLog,null,null);
			ExamFormOperationLog.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamFormOperationLogDAO.Disable(MyHSs, ExamFormOperationLog, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamFormOperationLog) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamFormOperationLog lo_ExamFormOperationLog=ExamFormOperationLogDAO.GetByID(MyHSs, ai_ExamFormOperationLog,null,null);
		System.out.print("ExamFormOperationLogTestDAO GETbyID  ExamFormOperationLogID="+ai_ExamFormOperationLog);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamFormOperationLogDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamFormOperationLog> lo_List = ExamFormOperationLogDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 1;
		int li_size = ExamFormOperationLogDAO.GetSizeByExamFormID(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestFindByExamFormID","size="+li_size);
		List<ExamFormOperationLog> lo_List = ExamFormOperationLogDAO.FindByExamFormID(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormOperationLogTestDAO", "UTTestFindByExamFormID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamFormOperationLogTestDAO.UTTestAdd();
//			ExamFormOperationLogTestDAO.UTTestModify();
//			ExamFormOperationLogTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamFormOperationLogTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamFormOperationLogTestDAO.UTTestGetByID();
//			ExamFormOperationLogTestDAO.UTTestFindAll(0,0);
			ExamFormOperationLogTestDAO.UTTestFindByExamFormID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}