package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.ExamItemChoiceDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamItem;
import esi.examwh.model.ExamItemChoice;
import esi.examwh.model.common.TYPE_ANSWER_STATUS;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamItemChoiceTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamFormID= 1;
		Integer ai_ExamItemID = 1;
		Integer ai_Year = 2555;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemChoice newExamItemChoice = new ExamItemChoice();
		try {
			if(ai_ExamItemID != null){
				ExamItem lo_ExamItem = ExamItemDAO.GetByID(MyHSs,ai_ExamItemID, null,null);
				newExamItemChoice.setOExamItem(lo_ExamItem);
			}
			newExamItemChoice.setOrder(1);
			newExamItemChoice.setPValue(1.0);
			newExamItemChoice.setRValue(2.0);
			newExamItemChoice.setAnswerStatus(TYPE_ANSWER_STATUS.STATUS_ANSWER_CORRECT);
			newExamItemChoice.setChoiceMD5("ChoiceMD");
			newExamItemChoice.setChoiceText("ChoiceText");
			newExamItemChoice.setLastUsedTime(Common.GetCurrTime());
			newExamItemChoice.setDocModifyTime(Common.GetCurrTime());
			newExamItemChoice.setLastUsedTime(Common.GetCurrTime());
			newExamItemChoice.setVersion(1);
			newExamItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamItemChoiceDAO.Add(MyHSs,newExamItemChoice,ai_Year, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemChoice ExamItemChoice;

		try {
			
			ExamItemChoice = ExamItemChoiceDAO.GetByID(MyHSs,1,null,null);
			
			ExamItemChoice.setOrder(2);
			ExamItemChoice.setPValue(5.0);
			ExamItemChoice.setRValue(6.0);
			ExamItemChoice.setAnswerStatus(TYPE_ANSWER_STATUS.STATUS_ANSWER_CORRECT);
			ExamItemChoice.setChoiceMD5("ChoiceMD2");
			ExamItemChoice.setChoiceText("ChoiceText2");
			ExamItemChoice.setLastUsedTime(Common.GetCurrTime());
			ExamItemChoice.setDocModifyTime(Common.GetCurrTime());
			ExamItemChoice.setLastUsedTime(Common.GetCurrTime());
			ExamItemChoice.setVersion(ExamItemChoice.getVersion()+1);
			ExamItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamItemChoiceDAO.Modify(MyHSs, ExamItemChoice, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamItemChoice,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemChoice ExamItemChoice;
		try {
			ExamItemChoice = ExamItemChoiceDAO.GetByID(MyHSs, ai_ExamItemChoice,null,null);
			
			ExamItemChoiceDAO.Delete(MyHSs, ExamItemChoice, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamItemChoice,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemChoice ExamItemChoice;
		try {
			ExamItemChoice = ExamItemChoiceDAO.GetByID(MyHSs, ai_ExamItemChoice,null,null);
			ExamItemChoice.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamItemChoiceDAO.Disable(MyHSs, ExamItemChoice, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamItemChoice) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamItemChoice lo_ExamItemChoice=ExamItemChoiceDAO.GetByID(MyHSs, ai_ExamItemChoice,null,null);
		System.out.print("ExamItemChoiceTestDAO GETbyID  ExamItemChoiceID="+ai_ExamItemChoice);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamItemChoiceDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamItemChoice> lo_List = ExamItemChoiceDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		int li_size = ExamItemChoiceDAO.GetSizeByExamItemID(MyHSs,ai_ExamItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestFindByExamItemID","size="+li_size);
		List<ExamItemChoice> lo_List = ExamItemChoiceDAO.FindByExamItemID(MyHSs,ai_ExamItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemChoiceTestDAO", "UTTestFindByExamItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamItemChoiceTestDAO.UTTestAdd();
//			ExamItemChoiceTestDAO.UTTestModify();
//			ExamItemChoiceTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamItemChoiceTestDAO.UTTestDisable(2,"Pailin Lert");
//			ExamItemChoiceTestDAO.UTTestGetByID();
//			ExamItemChoiceTestDAO.UTTestFindAll(0,0);
			ExamItemChoiceTestDAO.UTTestFindByExamItemID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
}
