package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamItemDAO;
import esi.examwh.dao.ExamItemDocumentDAO;
import esi.examwh.dao.SubjectDocumentDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamItem;
import esi.examwh.model.ExamItemDocument;
import esi.examwh.model.SubjectDocument;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamItemDocumentTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamItemID =3;
		Integer ai_SubjectDocumentID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemDocument newExamItemDocument = new ExamItemDocument();
		try {
			if(ai_ExamItemID != null){
				ExamItem lo_ExamItem = ExamItemDAO.GetByID(MyHSs,ai_ExamItemID, null,null);
				newExamItemDocument.setOExamItem(lo_ExamItem);
			}
			if(ai_SubjectDocumentID != null){
				SubjectDocument lo_SubjectDocument = SubjectDocumentDAO.GetByID(MyHSs,ai_SubjectDocumentID, null,null);
				newExamItemDocument.setOSubjectDocument(lo_SubjectDocument);
			}
			newExamItemDocument.setOrder(1);
			newExamItemDocument.setContentModifyTime(Common.GetCurrTime());
			newExamItemDocument.setContentModifyUser("ModifyUser");
			newExamItemDocument.setVersion(1);
			newExamItemDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamItemDocumentDAO.Add(MyHSs,newExamItemDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemDocument ExamItemDocument;
		try {
			
			ExamItemDocument = ExamItemDocumentDAO.GetByID(MyHSs,3,null,null);
			ExamItemDocument.setOrder(3);
			ExamItemDocument.setContentModifyTime(Common.GetCurrTime());
			ExamItemDocument.setContentModifyUser("ModifyUser");
			ExamItemDocument.setVersion(ExamItemDocument.getVersion()+1);
			ExamItemDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamItemDocumentDAO.Modify(MyHSs, ExamItemDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamItemDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemDocument ExamItemDocument;
		try {
			ExamItemDocument = ExamItemDocumentDAO.GetByID(MyHSs, ai_ExamItemDocument,null,null);
			
			ExamItemDocumentDAO.Delete(MyHSs, ExamItemDocument, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamItemDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemDocument ExamItemDocument;
		try {
			ExamItemDocument = ExamItemDocumentDAO.GetByID(MyHSs, ai_ExamItemDocument,null,null);
			ExamItemDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamItemDocumentDAO.Disable(MyHSs, ExamItemDocument, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamItemDocument) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamItemDocument lo_ExamItemDocument=ExamItemDocumentDAO.GetByID(MyHSs, ai_ExamItemDocument,null,null);
		System.out.print("ExamItemDocumentTestDAO GETbyID  ExamItemDocumentID="+ai_ExamItemDocument);
		MyHSs.close();
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamItemDocumentDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamItemDocument> lo_List = ExamItemDocumentDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamItemIDSubjectID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		Integer ai_SubjectID = 1;
		int li_size = ExamItemDocumentDAO.GetSizeByExamItemIDSubjectID(MyHSs,ai_ExamItemID,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamItemIDSubjectID","size="+li_size);
		List<ExamItemDocument> lo_List = ExamItemDocumentDAO.FindByExamItemIDSubjectID(MyHSs,ai_ExamItemID,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamItemIDSubjectID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamItemID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemID = 1;
		Integer ai_SubjectID = 1;
		int li_size = ExamItemDocumentDAO.GetSizeByExamItemID(MyHSs,ai_ExamItemID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamItem","size="+li_size);
		List<ExamItemDocument> lo_List = ExamItemDocumentDAO.FindByExamItemID(MyHSs,ai_ExamItemID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamItemID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByExamFormIDNotInExamFormDocument() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamFormID = 18;
		int li_size = ExamItemDocumentDAO.GetSizeByExamFormIDNotInExamFormDocument(MyHSs,ai_ExamFormID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamFormIDNotInExamFormDocument","size="+li_size);
		List<ExamItemDocument> lo_List = ExamItemDocumentDAO.FindByExamFormIDNotInExamFormDocument(MyHSs,ai_ExamFormID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindByExamFormIDNotInExamFormDocument",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	
	public static void UTTestFindBySubjectDocumentID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_SubjectDocumentID = 1;
		int li_size = ExamItemDocumentDAO.GetSizeBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindBySubjectDocument","size="+li_size);
		List<ExamItemDocument> lo_List = ExamItemDocumentDAO.FindBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemDocumentTestDAO", "UTTestFindBySubjectDocumentID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamItemDocumentTestDAO.UTTestAdd();
//			ExamItemDocumentTestDAO.UTTestModify();
//			ExamItemDocumentTestDAO.UTTestDelete(3,"Pailin Lert");
//			ExamItemDocumentTestDAO.UTTestDisable(2,"Pailin Lert");
//			ExamItemDocumentTestDAO.UTTestGetByID();
//			ExamItemDocumentTestDAO.UTTestFindAll(0,0);
//			ExamItemDocumentTestDAO.UTTestFindByExamItemIDSubjectID();
//			ExamItemDocumentTestDAO.UTTestFindByExamItemID();
//			ExamItemDocumentTestDAO.UTTestFindByExamFormIDNotInExamFormDocument();
			ExamItemDocumentTestDAO.UTTestFindBySubjectDocumentID() ;
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}