package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamItemGroupDAO;
import esi.examwh.dao.ExamItemGroupDocumentDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamItemGroup;
import esi.examwh.model.ExamItemGroupDocument;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamItemGroupDocumentTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamItemGroupID = -1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemGroupDocument newExamItemGroupDocument = new ExamItemGroupDocument();
		try {
			if(ai_ExamItemGroupID != null){
				ExamItemGroup lo_ExamItemGroup = ExamItemGroupDAO.GetByID(MyHSs,2, null,null);
				newExamItemGroupDocument.setOExamItemGroup(lo_ExamItemGroup);
			}
			
			newExamItemGroupDocument.setOrder(2);
			newExamItemGroupDocument.setCode("OA1001");
			
			newExamItemGroupDocument.setContentModifyTime(Common.GetCurrTime());
			newExamItemGroupDocument.setContentModifyUser("ExamWH Engine");
			newExamItemGroupDocument.setVersion(1);
			newExamItemGroupDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamItemGroupDocumentDAO.Add(MyHSs,newExamItemGroupDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemGroupDocument ExamItemGroupDocument;
		try {
			
			ExamItemGroupDocument = ExamItemGroupDocumentDAO.GetByID(MyHSs,2,null,null);
			ExamItemGroupDocument.setOrder(3);
			ExamItemGroupDocument.setCode("OA1003");
			
			ExamItemGroupDocument.setContentModifyTime(Common.GetCurrTime());
			ExamItemGroupDocument.setContentModifyUser("ExamWH Engine");
			ExamItemGroupDocument.setVersion(ExamItemGroupDocument.getVersion()+1);
			ExamItemGroupDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamItemGroupDocumentDAO.Modify(MyHSs, ExamItemGroupDocument, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamItemGroupDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemGroupDocument ExamItemGroupDocument;
		try {
			ExamItemGroupDocument = ExamItemGroupDocumentDAO.GetByID(MyHSs, ai_ExamItemGroupDocument,null,null);
			
			ExamItemGroupDocumentDAO.Delete(MyHSs, ExamItemGroupDocument, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamItemGroupDocument,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamItemGroupDocument ExamItemGroupDocument;
		try {
			ExamItemGroupDocument = ExamItemGroupDocumentDAO.GetByID(MyHSs, ai_ExamItemGroupDocument,null,null);
			ExamItemGroupDocument.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamItemGroupDocumentDAO.Disable(MyHSs, ExamItemGroupDocument, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamItemGroupDocument) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamItemGroupDocument lo_ExamItemGroupDocument=ExamItemGroupDocumentDAO.GetByID(MyHSs, ai_ExamItemGroupDocument,null,null);
		System.out.print("ExamItemGroupDocumentTestDAO GETbyID  ExamItemGroupDocumentID="+ai_ExamItemGroupDocument);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamItemGroupDocumentDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamItemGroupDocument> lo_List = ExamItemGroupDocumentDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamItemGroupID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemGroupID = 1;
		int li_size = ExamItemGroupDocumentDAO.GetSizeByExamItemGroupID(MyHSs,ai_ExamItemGroupID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindByExamItemGroupID","size="+li_size);
		List<ExamItemGroupDocument> lo_List = ExamItemGroupDocumentDAO.FindByExamItemGroupID(MyHSs,ai_ExamItemGroupID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindByExamItemGroupID",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamItemGroupIDSubjectID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamItemGroupID = 1;
		Integer ai_SubjectID = 1;
		int li_size = ExamItemGroupDocumentDAO.GetSizeByExamItemGroupIDSubjectID(MyHSs,ai_ExamItemGroupID,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindByExamItemGroupIDSubjectID","size="+li_size);
		List<ExamItemGroupDocument> lo_List = ExamItemGroupDocumentDAO.FindByExamItemGroupIDSubjectID(MyHSs,ai_ExamItemGroupID,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindByExamItemGroupIDSubjectID",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindBySubjectDocumentID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_SubjectDocumentID = 1;
		int li_size = ExamItemGroupDocumentDAO.GetSizeBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindBySubjectDocumentID","size="+li_size);
		List<ExamItemGroupDocument> lo_List = ExamItemGroupDocumentDAO.FindBySubjectDocumentID(MyHSs,ai_SubjectDocumentID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGroupDocumentTestDAO", "UTTestFindBySubjectDocumentID",lo_List.get(i).toString());
		}
		
	}
	
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamItemGroupDocumentTestDAO.UTTestAdd();
//			ExamItemGroupDocumentTestDAO.UTTestModify();
//			ExamItemGroupDocumentTestDAO.UTTestDelete(1,"Pailin Lert");
//			ExamItemGroupDocumentTestDAO.UTTestDisable(2,"Pailin Lert");
//			ExamItemGroupDocumentTestDAO.UTTestGetByID();
//			ExamItemGroupDocumentTestDAO.UTTestFindAll(0,0);
//			ExamItemGroupDocumentTestDAO.UTTestFindByExamItemGroupID();
			ExamItemGroupDocumentTestDAO.UTTestFindBySubjectDocumentID();
//			ExamItemGroupDocumentTestDAO.UTTestFindByExamItemGroupIDSubjectID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
