package esi.examwh.testDAO;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.ExamScheduleDAO;
import esi.examwh.dao.ExamScheduleDetailDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamSchedule;
import esi.examwh.model.ExamScheduleDetail;
import esi.examwh.model.Subject;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamScheduleDetailTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamScheduleID = 1;
		Integer ai_SubjectID= 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamScheduleDetail newExamScheduleDetail = new ExamScheduleDetail();
		try {
			
			if(ai_ExamScheduleID != null){
				ExamSchedule lo_ExamSchedule = ExamScheduleDAO.GetByID(MyHSs,ai_ExamScheduleID, null,null);
				newExamScheduleDetail.setOCopiedExamSchedule(lo_ExamSchedule);
			}
			if(ai_SubjectID != null){
				Subject lo_Subject = SubjectDAO.GetByID(MyHSs,ai_SubjectID, null,null);
				newExamScheduleDetail.setOSubject(lo_Subject);
			}
			newExamScheduleDetail.setOrder(1);
			newExamScheduleDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamScheduleDetailDAO.Add(MyHSs,newExamScheduleDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamScheduleDetail ExamScheduleDetail;

		try {
			
			ExamScheduleDetail = ExamScheduleDetailDAO.GetByID(MyHSs,3,null,null);
			
			ExamScheduleDetail.setOrder(3);
			ExamScheduleDetail.setVersion(ExamScheduleDetail.getVersion()+1);
			ExamScheduleDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamScheduleDetailDAO.Modify(MyHSs, ExamScheduleDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamScheduleDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamScheduleDetail ExamScheduleDetail;
		try {
			ExamScheduleDetail = ExamScheduleDetailDAO.GetByID(MyHSs, ai_ExamScheduleDetail,null,null);
			
			ExamScheduleDetailDAO.Delete(MyHSs, ExamScheduleDetail, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamScheduleDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamScheduleDetail ExamScheduleDetail;
		try {
			ExamScheduleDetail = ExamScheduleDetailDAO.GetByID(MyHSs, ai_ExamScheduleDetail,null,null);
			ExamScheduleDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamScheduleDetailDAO.Disable(MyHSs, ExamScheduleDetail, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamScheduleDetail) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamScheduleDetail lo_ExamScheduleDetail=ExamScheduleDetailDAO.GetByID(MyHSs, ai_ExamScheduleDetail,null,null);
		System.out.print("ExamScheduleDetailTestDAO GETbyID  ExamScheduleDetailID="+ai_ExamScheduleDetail);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamScheduleDetailDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID = 1;
		Integer ai_ExamRoundID = 1;
		Integer ai_SubjectID = 1;
		TYPE_EXAMINATION ae_ExaminationType = TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER;
		int li_size = ExamScheduleDetailDAO.GetSizeByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(MyHSs,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType(MyHSs,ai_ExamYearID,ai_ExamSemesterID, ai_ExamRoundID,ai_SubjectID,ae_ExaminationType,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_FormCreateStatus = 20;
		int li_size = ExamScheduleDetailDAO.GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_FormCreateStatus,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus(MyHSs,ai_ExamScheduleID,as_SubjectCode,as_SubjectName,ai_FormCreateStatus,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByCopiedExamScheduleIDSubjectID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_CopiedExamScheduleID = 1;
		Integer ai_SubjectID = 1;
		int li_size = ExamScheduleDetailDAO.GetSizeByCopiedExamScheduleIDSubjectID(MyHSs,ai_CopiedExamScheduleID,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectID","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindByCopiedExamScheduleIDSubjectID(MyHSs,ai_CopiedExamScheduleID,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectID",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_CopiedExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_FilterPersonID = 1;
		int li_size = ExamScheduleDetailDAO.GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(MyHSs,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator(MyHSs,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_CopiedExamScheduleID = 1;
		String as_SubjectCode = "";
		String as_SubjectName = "";
		Integer ai_FilterPersonID = 1;
		int li_size = ExamScheduleDetailDAO.GetSizeByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(MyHSs,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor","size="+li_size);
		List<ExamScheduleDetail> lo_List = ExamScheduleDetailDAO.FindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor(MyHSs,ai_CopiedExamScheduleID,as_SubjectCode,as_SubjectName,ai_FilterPersonID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleDetailTestDAO", "UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamScheduleDetailTestDAO.UTTestAdd();
//			ExamScheduleDetailTestDAO.UTTestModify();
//			ExamScheduleDetailTestDAO.UTTestDelete(1,"Pailin Lert");
//			ExamScheduleDetailTestDAO.UTTestDisable(3,"Pailin Lert");
//			ExamScheduleDetailTestDAO.UTTestGetByID();
//			ExamScheduleDetailTestDAO.UTTestFindAll(0,0);
//			ExamScheduleDetailTestDAO.UTTestFindByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationType();
//			ExamScheduleDetailTestDAO.UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFormCreateStatus();
//			ExamScheduleDetailTestDAO.UTTestFindByCopiedExamScheduleIDSubjectID();
//			ExamScheduleDetailTestDAO.UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormCollator();
//			ExamScheduleDetailTestDAO.UTTestFindByCopiedExamScheduleIDSubjectCodeSubjectNameFilterPersonIDInESDFormEditor();
			List<TYPE_EXAMINATION_STATUS> i_TYPE_EXAMINATION_STATUSList = new ArrayList();
			i_TYPE_EXAMINATION_STATUSList.add(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_DISABLE);
			i_TYPE_EXAMINATION_STATUSList.add(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW);
			i_TYPE_EXAMINATION_STATUSList.add(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_CREATE_EXAM);
			System.out.println(ExamScheduleDetailDAO.GenSQLByExamYearIDExamSemesterIDExamRoundIDSubjectIDExaminationTypeExaminationStatus(20, 1, 1, 1, 1, TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER, null, null, null));
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}