package esi.examwh.testDAO;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.dao.ExamRoundDAO;
import esi.examwh.dao.ExamScheduleDAO;
import esi.examwh.dao.ExamSemesterDAO;
import esi.examwh.dao.ExamTermDAO;
import esi.examwh.dao.ExamYearDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamRound;
import esi.examwh.model.ExamSchedule;
import esi.examwh.model.ExamSemester;
import esi.examwh.model.ExamTerm;
import esi.examwh.model.ExamYear;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAMINATION;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;
import esi.examwh.model.common.TYPE_OPERATION_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.Common;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamScheduleTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID= 1;
		Integer ai_ExamRoundID = 1;
		Integer ai_ExamTermID= 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamSchedule newExamSchedule = new ExamSchedule();
		try {
			
			if(ai_ExamYearID != null){
				ExamYear lo_ExamYear = ExamYearDAO.GetByID(MyHSs, ai_ExamYearID, null,null);
				newExamSchedule.setOExamYear(lo_ExamYear);
			}
			if(ai_ExamSemesterID != null){
				ExamSemester lo_ExamSemester = ExamSemesterDAO.GetByID(MyHSs,ai_ExamSemesterID, null,null);
				newExamSchedule.setOExamSemester(lo_ExamSemester);
			}
			if(ai_ExamRoundID != null){
				ExamRound lo_ExamRound = ExamRoundDAO.GetByID(MyHSs, ai_ExamRoundID, null,null);
				newExamSchedule.setOExamRound(lo_ExamRound);
			}
			if(ai_ExamTermID != null){
				ExamTerm lo_ExamTerm = ExamTermDAO.GetByID(MyHSs, ai_ExamTermID, null,null);
				newExamSchedule.setOExamTerm(lo_ExamTerm);
			}
			newExamSchedule.setExaminationType(TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN);
			newExamSchedule.setExaminationStatus(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW);
			newExamSchedule.setOperationStatus(TYPE_OPERATION_STATUS.STATUS_OPERATION_ACTION);
			newExamSchedule.setExamFormBeginDate(Common.GetCurrTime());
			newExamSchedule.setExamFormEndDate(Common.GetCurrTime());
			newExamSchedule.setVersion(1);
			newExamSchedule.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamScheduleDAO.Add(MyHSs,newExamSchedule, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamSchedule ExamSchedule;

		try {
			
			ExamSchedule = ExamScheduleDAO.GetByID(MyHSs,2,null,null);
			
			ExamSchedule.setExaminationType(TYPE_EXAMINATION.TYPE_EXAMINATION_PAPER);
			ExamSchedule.setExaminationStatus(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_CREATE_EXAM);
			ExamSchedule.setOperationStatus(TYPE_OPERATION_STATUS.STATUS_OPERATION_ACTION);
			ExamSchedule.setVersion(ExamSchedule.getVersion()+1);
			ExamSchedule.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			ExamScheduleDAO.Modify(MyHSs, ExamSchedule, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_ExamSchedule,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamSchedule ExamSchedule;
		try {
			ExamSchedule = ExamScheduleDAO.GetByID(MyHSs, ai_ExamSchedule,null,null);
			
			ExamScheduleDAO.Delete(MyHSs, ExamSchedule, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_ExamSchedule,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamSchedule ExamSchedule;
		try {
			ExamSchedule = ExamScheduleDAO.GetByID(MyHSs, ai_ExamSchedule,null,null);
			ExamSchedule.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			ExamScheduleDAO.Disable(MyHSs, ExamSchedule, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_ExamSchedule) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		ExamSchedule lo_ExamSchedule=ExamScheduleDAO.GetByID(MyHSs, ai_ExamSchedule,null,null);
		System.out.print("ExamScheduleTestDAO GETbyID  ExamScheduleID="+ai_ExamSchedule);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = ExamScheduleDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindAll","size="+li_size);
		List<ExamSchedule> lo_List = ExamScheduleDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID =1;
		Integer ai_ExamRound = 1;
		TYPE_EXAMINATION ae_ExaminationType = TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN;
		TYPE_EXAMINATION_STATUS ae_ExaminationStatus = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW;
		int li_size = ExamScheduleDAO.GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(MyHSs, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ExaminationStatus,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus","size="+li_size);
		List<ExamSchedule> lo_List = ExamScheduleDAO.FindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus(MyHSs,ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, ae_ExaminationStatus,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer ai_ExamYearID = 1;
		Integer ai_ExamSemesterID =1;
		Integer ai_ExamRound = 1;
		List<TYPE_EXAMINATION_STATUS> lo_ListExaminationStatus = new ArrayList();
		TYPE_EXAMINATION ae_ExaminationType = TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN;
		 lo_ListExaminationStatus.add(TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW);
		int li_size = ExamScheduleDAO.GetSizeByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(MyHSs, ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, lo_ListExaminationStatus,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus","size="+li_size);
		List<ExamSchedule> lo_List = ExamScheduleDAO.FindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus(MyHSs,ai_ExamYearID ,  ai_ExamSemesterID , ai_ExamRound, ae_ExaminationType, lo_ListExaminationStatus,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamScheduleTestDAO", "UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus",lo_List.get(i).toString());
		}
		
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			ExamScheduleTestDAO.UTTestAdd();
//			ExamScheduleTestDAO.UTTestModify();
//			ExamScheduleTestDAO.UTTestDelete(1,"Pailin Lert");
//			ExamScheduleTestDAO.UTTestDisable(1,"Pailin Lert");
//			ExamScheduleTestDAO.UTTestGetByID();
//			ExamScheduleTestDAO.UTTestFindAll(0,0);
			ExamScheduleTestDAO.UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeExaminationStatus();
//			ExamScheduleTestDAO.UTTestFindByExamYearIDExamSemesterIDExamRoundExaminationTypeFilterExaminationStatus();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}