package esi.examwh.testDAO;

import java.util.List;


import esi.examwh.dao.SubjectCollatorDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.SubjectCollator;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_FLAG;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectCollatorTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_PersonID = 1;
		Integer ai_SubjectID= 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectCollator newSubjectCollator = SubjectCollator.getNewInstance(ai_SubjectID, ai_PersonID );
		try {
			
//			if(ai_SubjectID != null){
//				Subject lo_Subject = SubjectDAO.GetByID(MyHSs, ai_SubjectID, null,null);
//				newSubjectCollator.setOSubjectID(lo_Subject);
//			}
//			if(ai_PersonID != null){
//				Person lo_Person = PersonDAO.GetByID(MyHSs, ai_PersonID, null,null);
//				newSubjectCollator.setOPersonID(lo_Person);
//			}
//			newSubjectCollator.setOrder(1);
			newSubjectCollator.setDraft1CollatorFlag(TYPE_FLAG.TYPE_NO);
			newSubjectCollator.setDraft2CollatorFlag(TYPE_FLAG.TYPE_YES);
			newSubjectCollator.setDraft3CollatorFlag(TYPE_FLAG.TYPE_YES);
			newSubjectCollator.setDraft4CollatorFlag(TYPE_FLAG.TYPE_YES);
			newSubjectCollator.setVersion(1);
			newSubjectCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectCollatorDAO.Add(MyHSs,newSubjectCollator, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectCollator SubjectCollator;

		try {
			
			SubjectCollator = SubjectCollatorDAO.GetByID(MyHSs,3,2,null,null);
			
			SubjectCollator.setOrder(3);
			SubjectCollator.setDraft1CollatorFlag(TYPE_FLAG.TYPE_YES);
			SubjectCollator.setDraft2CollatorFlag(TYPE_FLAG.TYPE_NO);
			SubjectCollator.setDraft3CollatorFlag(TYPE_FLAG.TYPE_YES);
			SubjectCollator.setDraft4CollatorFlag(TYPE_FLAG.TYPE_NO);
			SubjectCollator.setVersion(SubjectCollator.getVersion()+1);
			SubjectCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			SubjectCollatorDAO.Modify(MyHSs, SubjectCollator, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectCollator SubjectCollator;
		try {
			SubjectCollator = SubjectCollatorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			
			SubjectCollatorDAO.Delete(MyHSs, SubjectCollator, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectCollator SubjectCollator;
		try {
			SubjectCollator = SubjectCollatorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			SubjectCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			SubjectCollatorDAO.Disable(MyHSs, SubjectCollator, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectID,Integer ai_PersonID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		SubjectCollator lo_SubjectCollator=SubjectCollatorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
		System.out.print("SubjectCollatorTestDAO GETbyID  SubjectID="+ai_SubjectID+"PersonID="+ai_PersonID);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectCollatorDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestFindAll","size="+li_size);
		List<SubjectCollator> lo_List = SubjectCollatorDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindBySubjectID() throws Exception {
		Integer ai_SubjectID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectCollatorDAO.GetSizeBySubjectID(MyHSs,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestFindBySubjectID","size="+li_size);
		List<SubjectCollator> lo_List = SubjectCollatorDAO.FindBySubjectID(MyHSs,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectCollatorTestDAO", "UTTestFindBySubjectID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
			SubjectCollatorTestDAO.UTTestAdd();
//			SubjectCollatorTestDAO.UTTestModify();
//			SubjectCollatorTestDAO.UTTestDelete(2,3,"Pailin Lert");
//			SubjectCollatorTestDAO.UTTestDisable(3,1,"Pailin Lert");
//			SubjectCollatorTestDAO.UTTestGetByID(3,3);
//			SubjectCollatorTestDAO.UTTestFindAll(0,0);
			UTTestFindBySubjectID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}