package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.PersonDAO;
import esi.examwh.dao.SubjectEditorDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.Person;
import esi.examwh.model.Subject;
import esi.examwh.model.SubjectEditor;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectEditorTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_PersonID = 1;
		Integer ai_SubjectID= 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectEditor newSubjectEditor = SubjectEditor.getNewInstance(ai_SubjectID,ai_PersonID);
		try {
			
			/*if(ai_SubjectID != null){
				Subject lo_Subject = SubjectDAO.GetByID(MyHSs, ai_SubjectID, null,null);
				newSubjectEditor.setOSubjectID(lo_Subject);
			}
			if(ai_PersonID != null){
				Person lo_Person = PersonDAO.GetByID(MyHSs, ai_PersonID, null,null);
				newSubjectEditor.setOPersonID(lo_Person);
			}*/
			newSubjectEditor.setOrder(4);
			newSubjectEditor.setVersion(1);
			newSubjectEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectEditorDAO.Add(MyHSs,newSubjectEditor, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectEditor SubjectEditor;

		try {
			
			SubjectEditor = SubjectEditorDAO.GetByID(MyHSs,3,2,null,null);
			
			SubjectEditor.setOrder(3);
			SubjectEditor.setVersion(SubjectEditor.getVersion()+1);
			SubjectEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			SubjectEditorDAO.Modify(MyHSs, SubjectEditor, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectEditor SubjectEditor;
		try {
			SubjectEditor = SubjectEditorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			
			SubjectEditorDAO.Delete(MyHSs, SubjectEditor, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectEditor SubjectEditor;
		try {
			SubjectEditor = SubjectEditorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			SubjectEditor.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			SubjectEditorDAO.Disable(MyHSs, SubjectEditor, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectID,Integer ai_PersonID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		SubjectEditor lo_SubjectEditor=SubjectEditorDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
		System.out.print("SubjectEditorTestDAO GETbyID  SubjectID="+ai_SubjectID+"PersonID="+ai_PersonID);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectEditorDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestFindAll","size="+li_size);
		List<SubjectEditor> lo_List = SubjectEditorDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindBySubjectID() throws Exception {
		Integer ai_SubjectID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectEditorDAO.GetSizeBySubjectID(MyHSs,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestFindBySubjectID","size="+li_size);
		List<SubjectEditor> lo_List = SubjectEditorDAO.FindBySubjectID(MyHSs,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectEditorTestDAO", "UTTestFindBySubjectID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			SubjectEditorTestDAO.UTTestAdd();
//			SubjectEditorTestDAO.UTTestModify();
//			SubjectEditorTestDAO.UTTestDelete(3,3,"Pailin Lert");
			SubjectEditorTestDAO.UTTestDisable(1,1,"Pailin Lert");
//			SubjectEditorTestDAO.UTTestGetByID(3,3);
//			SubjectEditorTestDAO.UTTestFindAll(0,0);
//			UTTestFindBySubjectID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}