package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.SubjectFormPolicyDAO;
import esi.examwh.dao.SubjectFormPolicyDetailDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.SubjectFormPolicy;
import esi.examwh.model.SubjectFormPolicyDetail;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectFormPolicyDetailTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_SubjectFormPolicyID = 1;
		Integer ai_UnitID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicyDetail newSubjectFormPolicyDetail = new SubjectFormPolicyDetail();
		try {
			if(ai_SubjectFormPolicyID != null){
				SubjectFormPolicy lo_SubjectFormPolicy= SubjectFormPolicyDAO.GetByID(MyHSs,ai_SubjectFormPolicyID, null,null);
				newSubjectFormPolicyDetail.setOSubjectFormPolicyID(lo_SubjectFormPolicy);
			}
			
			if(ai_UnitID != null){
				Unit lo_Unit = UnitDAO.GetByID(MyHSs,ai_UnitID, null,null);
				newSubjectFormPolicyDetail.setOUnit(lo_Unit);
			}
			newSubjectFormPolicyDetail.setPMax(1.0);
			newSubjectFormPolicyDetail.setPMin(0.0);
			newSubjectFormPolicyDetail.setRMax(1000000000.0);
			newSubjectFormPolicyDetail.setRMin(0.0);
			newSubjectFormPolicyDetail.setAMax(30.0);
			newSubjectFormPolicyDetail.setAMin(0.0);
			newSubjectFormPolicyDetail.setBMax(20.0);
			newSubjectFormPolicyDetail.setBMin(0.0);
			newSubjectFormPolicyDetail.setCMax(10.0);
			newSubjectFormPolicyDetail.setCMin(0.0);
			newSubjectFormPolicyDetail.setNOFItemRequire(120);
			newSubjectFormPolicyDetail.setVersion(1);
			newSubjectFormPolicyDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectFormPolicyDetailDAO.Add(MyHSs,newSubjectFormPolicyDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicyDetail SubjectFormPolicyDetail;
		try {
			
			SubjectFormPolicyDetail = SubjectFormPolicyDetailDAO.GetByID(MyHSs,2,null,null);
			SubjectFormPolicyDetail.setPMax(1.0);
			SubjectFormPolicyDetail.setPMin(0.0);
			SubjectFormPolicyDetail.setRMax(200000.0);
			SubjectFormPolicyDetail.setRMin(1.0);
			SubjectFormPolicyDetail.setAMax(10.0);
			SubjectFormPolicyDetail.setAMin(2.0);
			SubjectFormPolicyDetail.setBMax(20.0);
			SubjectFormPolicyDetail.setBMin(3.0);
			SubjectFormPolicyDetail.setCMax(30.0);
			SubjectFormPolicyDetail.setCMin(4.0);
			SubjectFormPolicyDetail.setNOFItemRequire(150);
			SubjectFormPolicyDetail.setVersion(SubjectFormPolicyDetail.getVersion()+1);
			SubjectFormPolicyDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			SubjectFormPolicyDetailDAO.Modify(MyHSs, SubjectFormPolicyDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectFormPolicyDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicyDetail SubjectFormPolicyDetail;
		try {
			SubjectFormPolicyDetail = SubjectFormPolicyDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicyDetail,null,null);
			
			SubjectFormPolicyDetailDAO.Delete(MyHSs, SubjectFormPolicyDetail, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectFormPolicyDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicyDetail SubjectFormPolicyDetail;
		try {
			SubjectFormPolicyDetail = SubjectFormPolicyDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicyDetail,null,null);
			SubjectFormPolicyDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			SubjectFormPolicyDetailDAO.Disable(MyHSs, SubjectFormPolicyDetail, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectFormPolicyDetail) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		SubjectFormPolicyDetail lo_SubjectFormPolicyDetail=SubjectFormPolicyDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicyDetail,null,null);
		System.out.print("SubjectFormPolicyDetailTestDAO GETbyID  SubjectFormPolicyDetailID="+ai_SubjectFormPolicyDetail);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDetailDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindAll","size="+li_size);
		List<SubjectFormPolicyDetail> lo_List = SubjectFormPolicyDetailDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindBySubjectFormPolicyID() throws Exception {
		Integer ai_SubjectFormPolicyID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDetailDAO.GetSizeBySubjectFormPolicyID(MyHSs,ai_SubjectFormPolicyID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindBySubjectFormPolicyID","size="+li_size);
		List<SubjectFormPolicyDetail> lo_List = SubjectFormPolicyDetailDAO.FindBySubjectFormPolicyID(MyHSs,ai_SubjectFormPolicyID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindBySubjectFormPolicyID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindBySubjectFormPolicyIDUnitID() throws Exception {
		Integer ai_SubjectFormPolicyID = 1;
		Integer ai_UnitID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDetailDAO.GetSizeBySubjectFormPolicyIDUnitID(MyHSs,ai_SubjectFormPolicyID,ai_UnitID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindBySubjectFormPolicyIDUnitID","size="+li_size);
		List<SubjectFormPolicyDetail> lo_List = SubjectFormPolicyDetailDAO.FindBySubjectFormPolicyIDUnitID(MyHSs,ai_SubjectFormPolicyID,ai_UnitID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyDetailTestDAO", "UTTestFindBySubjectFormPolicyIDUnitID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			SubjectFormPolicyDetailTestDAO.UTTestAdd();
//			SubjectFormPolicyDetailTestDAO.UTTestModify();
//			SubjectFormPolicyDetailTestDAO.UTTestDelete(1,"Pailin Lert");
//			SubjectFormPolicyDetailTestDAO.UTTestDisable(2,"Pailin Lert");
//			SubjectFormPolicyDetailTestDAO.UTTestGetByID();
//			SubjectFormPolicyDetailTestDAO.UTTestFindAll(0,0);
//			SubjectFormPolicyDetailTestDAO.UTTestFindBySubjectFormPolicyID();
			SubjectFormPolicyDetailTestDAO.UTTestFindBySubjectFormPolicyIDUnitID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}