package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ObjectiveDAO;
import esi.examwh.dao.SectionDAO;
import esi.examwh.dao.SubjectFormPolicyDetailDAO;
import esi.examwh.dao.SubjectFormPolicySubDetailDAO;
import esi.examwh.dao.UnitDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.Objective;
import esi.examwh.model.Section;
import esi.examwh.model.SubjectFormPolicyDetail;
import esi.examwh.model.SubjectFormPolicySubDetail;
import esi.examwh.model.Unit;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectFormPolicySubDetailTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_SubjectFormPolicyDetailID = 1;
		Integer ai_UnitID = 1;
		Integer ai_SectionID = 1;
		Integer ai_ObjectiveID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicySubDetail newSubjectFormPolicySubDetail = new SubjectFormPolicySubDetail();
		try {
			if(ai_SubjectFormPolicyDetailID != null){
				SubjectFormPolicyDetail lo_SubjectFormPolicyDetail = SubjectFormPolicyDetailDAO.GetByID(MyHSs,ai_SubjectFormPolicyDetailID , null,null);
				newSubjectFormPolicySubDetail.setOSubjectFormPolicyDetail(lo_SubjectFormPolicyDetail);
			}
			if(ai_UnitID != null){
				Unit lo_Unit = UnitDAO.GetByID(MyHSs,ai_UnitID, null,null);
				newSubjectFormPolicySubDetail.setOUnit(lo_Unit);
			}
			if(ai_SectionID != null){
				Section lo_Section = SectionDAO.GetByID(MyHSs,ai_SectionID, null,null);
				newSubjectFormPolicySubDetail.setOSection(lo_Section);
			}
			if(ai_ObjectiveID != null){
				Objective lo_Objective = ObjectiveDAO.GetByID(MyHSs,ai_ObjectiveID, null,null);
				newSubjectFormPolicySubDetail.setOObjective(lo_Objective);
			}
			newSubjectFormPolicySubDetail.setGroupNumber(2);
			newSubjectFormPolicySubDetail.setNOFItemRequire(150);
			newSubjectFormPolicySubDetail.setVersion(1);
			newSubjectFormPolicySubDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectFormPolicySubDetailDAO.Add(MyHSs,newSubjectFormPolicySubDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicySubDetail SubjectFormPolicySubDetail;
		try {
			
			SubjectFormPolicySubDetail = SubjectFormPolicySubDetailDAO.GetByID(MyHSs,1,null,null);
			SubjectFormPolicySubDetail.setGroupNumber(5);
			SubjectFormPolicySubDetail.setNOFItemRequire(120);
			SubjectFormPolicySubDetail.setVersion(SubjectFormPolicySubDetail.getVersion()+1);
			SubjectFormPolicySubDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			SubjectFormPolicySubDetailDAO.Modify(MyHSs, SubjectFormPolicySubDetail, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectFormPolicySubDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicySubDetail SubjectFormPolicySubDetail;
		try {
			SubjectFormPolicySubDetail = SubjectFormPolicySubDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicySubDetail,null,null);
			
			SubjectFormPolicySubDetailDAO.Delete(MyHSs, SubjectFormPolicySubDetail, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectFormPolicySubDetail,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicySubDetail SubjectFormPolicySubDetail;
		try {
			SubjectFormPolicySubDetail = SubjectFormPolicySubDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicySubDetail,null,null);
			SubjectFormPolicySubDetail.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			SubjectFormPolicySubDetailDAO.Disable(MyHSs, SubjectFormPolicySubDetail, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectFormPolicySubDetail) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		SubjectFormPolicySubDetail lo_SubjectFormPolicySubDetail=SubjectFormPolicySubDetailDAO.GetByID(MyHSs, ai_SubjectFormPolicySubDetail,null,null);
		System.out.print("SubjectFormPolicySubDetailTestDAO GETbyID  SubjectFormPolicySubDetailID="+ai_SubjectFormPolicySubDetail);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicySubDetailDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindAll","size="+li_size);
		List<SubjectFormPolicySubDetail> lo_List = SubjectFormPolicySubDetailDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	public static void UTTestFindBySubjectFormPolicyDetailID() throws Exception {
		Integer ai_SubjectFormPolicyDetailID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicySubDetailDAO.GetSizeBySubjectFormPolicyDetailID(MyHSs,ai_SubjectFormPolicyDetailID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailID","size="+li_size);
		List<SubjectFormPolicySubDetail> lo_List = SubjectFormPolicySubDetailDAO.FindBySubjectFormPolicyDetailID(MyHSs,ai_SubjectFormPolicyDetailID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	
	public static void UTTestFindBySubjectFormPolicyDetailIDUnitID() throws Exception {
		Integer ai_SubjectFormPolicyDetailID = 1;
		Integer ai_UnitID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicySubDetailDAO.GetSizeBySubjectFormPolicyDetailIDUnitID(MyHSs,ai_SubjectFormPolicyDetailID,ai_UnitID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailIDUnitID","size="+li_size);
		List<SubjectFormPolicySubDetail> lo_List = SubjectFormPolicySubDetailDAO.FindBySubjectFormPolicyDetailIDUnitID(MyHSs,ai_SubjectFormPolicyDetailID,ai_UnitID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailIDUnitID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindBySubjectFormPolicyDetailIDObjectiveID() throws Exception {
		Integer ai_SubjectFormPolicyDetailID = 1;
		Integer ai_ObjectiveID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicySubDetailDAO.GetSizeBySubjectFormPolicyDetailIDObjectiveID(MyHSs,ai_SubjectFormPolicyDetailID,ai_ObjectiveID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailIDObjectiveID","size="+li_size);
		List<SubjectFormPolicySubDetail> lo_List = SubjectFormPolicySubDetailDAO.FindBySubjectFormPolicyDetailIDObjectiveID(MyHSs,ai_SubjectFormPolicyDetailID,ai_ObjectiveID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindBySubjectFormPolicyDetailIDObjectiveID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByObjectiveID() throws Exception {
		Integer ai_ObjectiveID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicySubDetailDAO.GetSizeByObjectiveID(MyHSs,ai_ObjectiveID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindByObjectiveID","size="+li_size);
		List<SubjectFormPolicySubDetail> lo_List = SubjectFormPolicySubDetailDAO.FindByObjectiveID(MyHSs,ai_ObjectiveID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestFindByObjectiveID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestGetSumOfNOFItemRequireBySubjectFormPolicyDetailID(){
		Integer ai_SubjectFormPolicyDetailID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		try {
			int li_SumNofItem = SubjectFormPolicySubDetailDAO.GetSumOfNOFItemRequireBySubjectFormPolicyDetailID(MyHSs,ai_SubjectFormPolicyDetailID,null,null);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicySubDetailTestDAO", "UTTestGetSumOfNOFItemRequireBySubjectFormPolicyDetailID","Nof="+li_SumNofItem+"");
		}catch (Exception e) {
			e.printStackTrace();
		}
		
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			SubjectFormPolicySubDetailTestDAO.UTTestAdd();
//			SubjectFormPolicySubDetailTestDAO.UTTestModify();
//			SubjectFormPolicySubDetailTestDAO.UTTestDelete(1,"Pailin Lert");
//			SubjectFormPolicySubDetailTestDAO.UTTestDisable(2,"Pailin Lert");
//			SubjectFormPolicySubDetailTestDAO.UTTestGetByID(3);
//			SubjectFormPolicySubDetailTestDAO.UTTestFindAll(0,0);
//			SubjectFormPolicySubDetailTestDAO.UTTestFindBySubjectFormPolicyDetailID();
//			SubjectFormPolicySubDetailTestDAO.UTTestFindBySubjectFormPolicyDetailIDUnitID();
//			SubjectFormPolicySubDetailTestDAO.UTTestFindByObjectiveID();
			SubjectFormPolicySubDetailTestDAO.UTTestGetSumOfNOFItemRequireBySubjectFormPolicyDetailID();
//			SubjectFormPolicySubDetailTestDAO.UTTestFindBySubjectFormPolicyDetailIDObjectiveID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}