package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ExamRoundDAO;
import esi.examwh.dao.ExamSemesterDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.SubjectFormPolicyDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamRound;
import esi.examwh.model.ExamSemester;
import esi.examwh.model.Subject;
import esi.examwh.model.SubjectFormPolicy;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_STATISTICS_USED;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectFormPolicyTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_SubjectID = 1;
		Integer ai_ExamSemesterID = 1;
		Integer ai_ExamRoundID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicy newSubjectFormPolicy = new SubjectFormPolicy();
		try {
			if(ai_SubjectID != null){
				Subject lo_Subject = SubjectDAO.GetByID(MyHSs,ai_SubjectID, null,null);
				newSubjectFormPolicy.setOSubject(lo_Subject);
			}
			if(ai_ExamSemesterID != null){
				ExamSemester lo_ExamSemester = ExamSemesterDAO.GetByID(MyHSs,ai_ExamSemesterID, null,null);
				newSubjectFormPolicy.setOExamSemester(lo_ExamSemester);
			}
			if(ai_ExamRoundID != null){
				ExamRound lo_ExamRound = ExamRoundDAO.GetByID(MyHSs,1, null,null);
				newSubjectFormPolicy.setOExamRound(lo_ExamRound);
			}
			newSubjectFormPolicy.setNOFExamItem(60);
			newSubjectFormPolicy.setNOFObjectiveItem(50);
			newSubjectFormPolicy.setNOFSubjectiveItem(10);
			newSubjectFormPolicy.setUnUsedNOFTimes(0);
			newSubjectFormPolicy.setStatisticsUsedType(TYPE_STATISTICS_USED.TYPE_UNUSE);
			newSubjectFormPolicy.setVersion(1);
			newSubjectFormPolicy.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectFormPolicyDAO.Add(MyHSs,newSubjectFormPolicy, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicy SubjectFormPolicy;
		try {
			
			SubjectFormPolicy = SubjectFormPolicyDAO.GetByID(MyHSs,3,null,null);
			SubjectFormPolicy.setNOFExamItem(65);
			SubjectFormPolicy.setNOFObjectiveItem(50);
			SubjectFormPolicy.setNOFSubjectiveItem(15);
			SubjectFormPolicy.setUnUsedNOFTimes(0);
			SubjectFormPolicy.setStatisticsUsedType(TYPE_STATISTICS_USED.TYPE_USE_FOR_IRT);
			SubjectFormPolicy.setVersion(SubjectFormPolicy.getVersion()+1);
			SubjectFormPolicy.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			SubjectFormPolicyDAO.Modify(MyHSs, SubjectFormPolicy, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectFormPolicy,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicy SubjectFormPolicy;
		try {
			SubjectFormPolicy = SubjectFormPolicyDAO.GetByID(MyHSs, ai_SubjectFormPolicy,null,null);
			
			SubjectFormPolicyDAO.Delete(MyHSs, SubjectFormPolicy, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectFormPolicy,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectFormPolicy SubjectFormPolicy;
		try {
			SubjectFormPolicy = SubjectFormPolicyDAO.GetByID(MyHSs, ai_SubjectFormPolicy,null,null);
			SubjectFormPolicy.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			SubjectFormPolicyDAO.Disable(MyHSs, SubjectFormPolicy, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectFormPolicy) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		SubjectFormPolicy lo_SubjectFormPolicy=SubjectFormPolicyDAO.GetByID(MyHSs, ai_SubjectFormPolicy,null,null);
		System.out.print("SubjectFormPolicyTestDAO GETbyID  SubjectFormPolicyID="+ai_SubjectFormPolicy);
		
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindAll","size="+li_size);
		List<SubjectFormPolicy> lo_List = SubjectFormPolicyDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindBySubjectID() throws Exception {
		Integer ai_SubjectID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDAO.GetSizeBySubjectID(MyHSs,ai_SubjectID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindBySubjectID","size="+li_size);
		List<SubjectFormPolicy> lo_List = SubjectFormPolicyDAO.FindBySubjectID(MyHSs,ai_SubjectID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindBySubjectID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindBySubjectIDExamSemesterIDExamRoundID() throws Exception {
		Integer ai_SubjectID = 1;
		Integer ai_ExamSemesterID = 1;
		Integer ai_ExamRoundID = 1;
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = SubjectFormPolicyDAO.GetSizeBySubjectIDExamSemesterIDExamRoundID(MyHSs,ai_SubjectID,ai_ExamSemesterID,ai_ExamRoundID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindBySubjectIDExamSemesterIDExamRoundID","size="+li_size);
		List<SubjectFormPolicy> lo_List = SubjectFormPolicyDAO.FindBySubjectIDExamSemesterIDExamRoundID(MyHSs,ai_SubjectID,ai_ExamSemesterID,ai_ExamRoundID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "SubjectFormPolicyTestDAO", "UTTestFindBySubjectIDExamSemesterIDExamRoundID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			SubjectFormPolicyTestDAO.UTTestAdd();
//			SubjectFormPolicyTestDAO.UTTestModify();
//			SubjectFormPolicyTestDAO.UTTestDelete(1,"Pailin Lert");
//			SubjectFormPolicyTestDAO.UTTestDisable(2,"Pailin Lert");
//			SubjectFormPolicyTestDAO.UTTestGetByID();
//			SubjectFormPolicyTestDAO.UTTestFindAll(0,0);
//			SubjectFormPolicyTestDAO.UTTestFindBySubjectID();
			SubjectFormPolicyTestDAO.UTTestFindBySubjectIDExamSemesterIDExamRoundID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}