package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ObjectiveDAO;
import esi.examwh.dao.TopicDAO;
import esi.examwh.dao.TopicObjectiveDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.Objective;
import esi.examwh.model.Topic;
import esi.examwh.model.TopicObjective;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class TopicObjectiveTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_TopicID = null;
		Integer ai_ObjectiveID= null;
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		TopicObjective newTopicObjective = TopicObjective.getNewInstance(1, 1);
//		TopicObjective newTopicObjective = new TopicObjective();
		try {
//			
//			if(ai_TopicID != null){
//				Topic lo_Topic = TopicDAO.GetByID(MyHSs, ai_TopicID, null,null);
//				newTopicObjective.setOTopicID(lo_Topic);
//			}
//			if(ai_ObjectiveID != null){
//				Objective lo_Objective = ObjectiveDAO.GetByID(MyHSs, ai_ObjectiveID, null,null);
//				newTopicObjective.setOObjectiveID(lo_Objective);
//			}
			newTopicObjective.setOrder(1);
			newTopicObjective.setVersion(1);
			newTopicObjective.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			TopicObjectiveDAO.Add(MyHSs,newTopicObjective, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		TopicObjective TopicObjective;

		try {
			
			TopicObjective = TopicObjectiveDAO.GetByID(MyHSs,2,2,null,null);
			
			TopicObjective.setOrder(2);
			TopicObjective.setVersion(TopicObjective.getVersion()+1);
			TopicObjective.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			TopicObjectiveDAO.Modify(MyHSs, TopicObjective, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		TopicObjective TopicObjective;
		try {
			TopicObjective = TopicObjectiveDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			
			TopicObjectiveDAO.Delete(MyHSs, TopicObjective, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(Integer ai_SubjectID,Integer ai_PersonID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		TopicObjective TopicObjective;
		try {
			TopicObjective = TopicObjectiveDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
			TopicObjective.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			TopicObjectiveDAO.Disable(MyHSs, TopicObjective, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(Integer ai_SubjectID,Integer ai_PersonID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		TopicObjective lo_TopicObjective=TopicObjectiveDAO.GetByID(MyHSs, ai_SubjectID,ai_PersonID,null,null);
		System.out.print("TopicObjectiveTestDAO GETbyID  SubjectID="+ai_SubjectID+"PersonID="+ai_PersonID);
		MyHSs.close();
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = TopicObjectiveDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestFindAll","size="+li_size);
		List<TopicObjective> lo_List = TopicObjectiveDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void UTTestFindByTopicID() throws Exception {
		Integer ai_TopicID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = TopicObjectiveDAO.GetSizeByTopicID(MyHSs,ai_TopicID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TpoicObjectiveTestDAO", "UTTestFindByTopicID","size="+li_size);
		List<TopicObjective> lo_List = TopicObjectiveDAO.FindByTopicID(MyHSs,ai_TopicID,null,null,0,0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "TopicObjectiveTestDAO", "UTTestFindByTopicID",lo_List.get(i).toString());
		}
		MyHSs.close();
	}
	public static void main(String[] args) {
		try{
//			Session MyHSs = ExamWHDaoUtil.getSession();
//			TopicObjectiveTestDAO.UTTestAdd();
//			TopicObjectiveTestDAO.UTTestModify();
//			TopicObjectiveTestDAO.UTTestDelete(2,3,"Pailin Lert");
//			TopicObjectiveTestDAO.UTTestDisable(1,1,"Pailin Lert");
//			TopicObjectiveTestDAO.UTTestGetByID(3,3);
//			TopicObjectiveTestDAO.UTTestFindAll(0,0);
			TopicObjectiveTestDAO.UTTestFindByTopicID();
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}