package esi.examwh.testDAO;

import java.util.List;

import esi.examwh.dao.ActionTypeDAO;
import esi.examwh.dao.PersonDAO;
import esi.examwh.dao.UserActionLogDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ActionType;
import esi.examwh.model.Person;
import esi.examwh.model.UserActionLog;
import esi.examwh.model.common.TYPE_DATA_STATUS;


import org.hibernate.Session;
import org.hibernate.Transaction;
import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class UserActionLogTestDAO {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {

		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		UserActionLog newUserActionLog = new UserActionLog();

		try {
			
			Person o_Person = PersonDAO.GetByID(MyHSs, 5, null, null);
			ActionType o_ActionType = ActionTypeDAO.GetByID(MyHSs, 1, null, null);
			newUserActionLog.setOPerson(o_Person);
			newUserActionLog.setOActionType(o_ActionType);
			newUserActionLog.setDetail("detail");
			newUserActionLog.setVersion(1);
			newUserActionLog.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			UserActionLogDAO.Add(MyHSs,newUserActionLog, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}



	public static void UTTestModify() throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		UserActionLog UserActionLog;

		try {
			
			UserActionLog = UserActionLogDAO.GetByID(MyHSs,1,null,null);
			
			UserActionLog.setDetail("Detail");
			UserActionLog.setVersion(UserActionLog.getVersion()+1);
			UserActionLog.setDataStatus(TYPE_DATA_STATUS.STATUS_USE);
			UserActionLogDAO.Modify(MyHSs, UserActionLog, "EXAMWH ENGINE", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestModify", "@Can't modify@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}

	public static void UTTestDelete(int ai_UserActionLogID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		UserActionLog UserActionLog;
		try {
			UserActionLog = UserActionLogDAO.GetByID(MyHSs, ai_UserActionLogID,null,null);
			
			UserActionLogDAO.Delete(MyHSs, UserActionLog, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestDelete", "@Can't Delete@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestDisable(int ai_UserActionLogID,String as_CommandUser) throws OutOfListException {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		UserActionLog UserActionLog;
		try {
			UserActionLog = UserActionLogDAO.GetByID(MyHSs, ai_UserActionLogID,null,null);
			UserActionLog.setDataStatus(TYPE_DATA_STATUS.STATUS_DISABLE);
			UserActionLogDAO.Disable(MyHSs, UserActionLog, as_CommandUser, null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestDisable","@Can't Disable@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
	}
	public static void UTTestGetByID(int ai_UserActionLogID) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		UserActionLog lo_UserActionLog=UserActionLogDAO.GetByID(MyHSs, ai_UserActionLogID,null,null);
		System.out.print("UserActionLogTestDAO GETbyID="+ai_UserActionLogID+"\n Name="+lo_UserActionLog.getDetail());
	}
	public static void UTTestFindAll(int BeginRow, int MaxRow) throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		int li_size = UserActionLogDAO.GetSizeAll(MyHSs,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestFindAll","size="+li_size);
		List<UserActionLog> lo_List = UserActionLogDAO.FindAll(MyHSs,null,null,BeginRow, MaxRow);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	
	public static void UTTestFindByPersonIDActionTypeID() throws Exception {
		Session MyHSs = ExamWHDaoUtil.getSession();
		Integer li_PersonID = 5;
		Integer li_ActionTypeID = 1;
		int li_size = UserActionLogDAO.GetSizeByPersonIDActionTypeID(MyHSs,li_PersonID,li_ActionTypeID,null,null);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestFindAll","size="+li_size);
		List<UserActionLog> lo_List = UserActionLogDAO.FindByPersonIDActionTypeID(MyHSs,li_PersonID,li_ActionTypeID,null,null,0, 0);
		for (int i = 0; i < lo_List.size(); i++) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "UserActionLogTestDAO", "UTTestFindAll",lo_List.get(i).toString());
		}
		
	}
	
	public static void main(String[] args) {
//		Session MyHSs = ExamWHDaoUtil.getSession();
		try{
//			UserActionLogTestDAO.UTTestAdd();
//			UserActionLogTestDAO.UTTestGetByID(1);
			UTTestFindByPersonIDActionTypeID();
			//UserActionLogTestDAO.UTTestFindAll(0,0);
		}catch(Exception ex){
			ex.printStackTrace();
		}
	}
	
}
